{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 BE@2ch Manager Unit                                               }
{                                                                             }
{ 2001-05 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Be2chModule;

interface

uses
  SysUtils, Classes, IniFiles, HttpProt, ZonuClass;

type
  //OCpO
  EBeLoginError = class(Exception)
  end;

  //̃vtB[
  TBe2chProfile = record
    beMoritapo: string;
    beRank: string;
    beName: string;
    beMemo: string;
  end;

  TBe2chManager = class(TDataModule)
    HttpCli1: THttpCli;
    procedure DataModuleCreate(Sender: TObject);
  private
    { Private 錾 }
    FConnected: boolean;
    FConnectedEvt: TNotifyEvent;
    FDisconnectedEvt: TNotifyEvent;
    FSite: TSite; //18
    procedure InitHttpSetting;
  public
    { Public 錾 }
    function IsBE(Board: TBoard): boolean;
    function GetCookie: string;
    function Login: boolean;
    function GivePoint(ABeID, AReadCgiPath: string; AResNo: integer): string;
    function GetProfile(ABeID, AThreadURL: string): string;
    function ShowProfile(ABeID, AThreadURL: string): string;
    function GetMyProfile(out AProfile: TBe2chProfile): string;
    function SetMyProfile(AProfile: TBe2chProfile): boolean;
    procedure Logout;
    property  Site: TSite read  FSite write FSite; //2ch  //18
    property  Connected: boolean  read  FConnected;
    property  OnConneced: TNotifyEvent  read  FConnectedEvt write FConnectedEvt;
    property  OnDisconneced: TNotifyEvent  read  FDisconnectedEvt write FDisconnectedEvt;
  end;

var
  Be2chManager: TBe2chManager;

implementation

{$R *.dfm}

uses
  Hzbconst, ZonuConf, LogindlgBe, Zonutils, MonaUtils, Errdlg;

const
  BE_URL = 'http://be.2ch.net/';
  BE_LOGIN_ERROR   = 'pX[h[AhXȂ悤łB';
  BE_LOGIN_SUCCESS = '</head><body>OC';
  BE_PROFILE_EDIT_SUCCESS = 'done';


{ TBe2chManager }

//
//  
//
procedure TBe2chManager.DataModuleCreate(Sender: TObject);
begin
  FConnected  :=  False;
end;

//
//  Be@2chɃOC
//
function TBe2chManager.Login(): boolean;
var
  FSendStream:  TStringStream;
  FResponseStream:  TStringStream;
  s: string;
begin
  Result          :=  False;
  FConnected      :=  False;
  
  //OCp_CAO쐬
  LoginDialogBe   :=  TLoginDialogBe.Create(Self);
  if  (ZonuConfig.BeShowDialog) or (ZonuConfig.BeUserName = '')  then  begin
    if  (LoginDialogBe.ShowModal <> 1) then  begin
      LoginDialogBe.Release;
      Exit;
    end;
  end;
  //OCAj[VĐ
  LoginDialogBe.Animate1.Active  :=  True;
  LoginDialogBe.Edit1.Enabled    :=  False;
  LoginDialogBe.Edit2.Enabled    :=  False;
  LoginDialogBe.Edit3.Enabled    :=  False;
  LoginDialogBe.Button1.Enabled  :=  False;
  LoginDialogBe.Button2.Enabled  :=  False;
  LoginDialogBe.Show;
  LoginDialogBe.Update;

  //Me
  s :=  'm=' + ZonuConfig.BeUserName +
        '&p=' + ZonuConfig.BePassword +
        '&submit=o^';

  //HTTPʐM̏(PROXYȂ)
  InitHttpSetting;

  FSendStream               :=  TStringStream.Create(JConvOut(csEUC, s));
  FResponseStream           :=  TStringStream.Create('');

  //MNbL[̓e擾(MDMD=xxxxxxxxx)
  HttpCli1.Cookie           :=  GetCookie + '; LEVEL&=';

  HttpCli1.Accept           :=  'text/xml,application/xml,application/xhtml+xml,text/html;q=0.9,text/plain;q=0.8,image/png,*/*;q=0.5';
  HttpCli1.AcceptEncoding   :=  'gzip,deflate';

  //Mp̃Xg[Ƃ
  HttpCli1.SendStream       :=  FSendStream;
  HttpCli1.RcvdStream       :=  FResponseStream;
  HttpCli1.Reference        :=  BE_URL + 'test/login.php';

  //MURL
  HttpCli1.URL              :=  BE_URL + 'test/login.php';

  //M (񓯊)
  HttpCli1.Post;
  LoginDialogBe.Release;

  //ʎ擾 (EUCSJISϊ)
  s :=  JConv(csEUC, FResponseStream.DataString);
  
  //G[
  if  (AnsiPos(BE_LOGIN_SUCCESS, s) > 0)  then  begin
    //OC
    FConnected  :=  True;
    Result      :=  True;
    if  (Assigned(FConnectedEvt)) then  begin
      FConnectedEvt(Self);
    end;
  end else begin
    //OCs
    Logout;
    raise EBeLoginError.Create(BE_LOGIN_ERROR);
    Result  :=  False;
  end;
end;

//
//  OAEg
//
procedure TBe2chManager.Logout;
begin
  if  (Connected) then  begin
    if  (Assigned(FDisconnectedEvt)) then  begin
      FConnected  :=  False;
      FDisconnectedEvt(Self);
    end;
  end;
end;

//
//  œnꂽ Be@2ch ǂ
//
function TBe2chManager.IsBE(Board: TBoard): boolean;
var
  ini: TMemIniFile;
begin
  ini :=  TMemIniFile.Create(FSite.ConfigPath + 'be.ini');
  Result  :=  ini.ReadBool('be', Board.BoardID, False);
  ini.Free;
end;

//
//  Be@2chpNbL[쐬
//
function TBe2chManager.GetCookie: string;
begin
  Result  :=  'MDMD=' +   ZonuConfig.BeMdMdCode + '; ' +
              'DMDM=' +   ZonuConfig.BeUserName;
  {
  if  (Connected) then  begin //19
    Result  :=  'MDMD=' +   ZonuConfig.BeMdMdCode + '; ' +
                'DMDM=' +   ZonuConfig.BeUserName;
  end else begin
    Result  :=  '';
  end;
  }
end;

//
//  HTTPʐM̏
//
procedure TBe2chManager.InitHttpSetting;
begin
  if  (ZonuConfig.ProxyUse) then  begin
    HttpCli1.Proxy          :=  ZonuConfig.Proxy;
    HttpCli1.ProxyPort      :=  ZonuConfig.ProxyPort;
    HttpCli1.ProxyUsername  :=  ZonuConfig.ProxyUserName;
    HttpCli1.ProxyPassword  :=  ZonuConfig.ProxyPassword;
  end;
  HttpCli1.Agent            :=  USER_AGENT;
  HttpCli1.NoCache          :=  True;
end;

//
//  w胆[UɃ|Cg𑗂
//
function TBe2chManager.GivePoint(ABeID, AReadCgiPath: string;
  AResNo: integer): string;
var
  FHttpStream: TStringStream;
  ErrorHtml: TStringList;
begin
  //HTTPʐM̏
  InitHttpSetting;

  //M
  FHttpStream               :=  TStringStream.Create('');
  FHttpStream.Position      :=  0;
  FHttpStream.Size          :=  0;
  HttpCli1.RcvdStream       :=  FHttpStream;
  HttpCli1.Cookie           :=  GetCookie;

  //MURL
  HttpCli1.URL              :=  BE_URL + 'test/givep.php' +
                                '?i=' + ABeID +
                                '&d=d:' + AReadCgiPath +
                                '/' + IntToStr(AResNo);
  //M
  HttpCli1.Get;

  //Mʂ_CAO\
  ErrorDialog     :=  TErrorDialog.Create(nil);
  ErrorHtml       :=  TStringList.Create;
  ErrorHtml.Text  :=  FHttpStream.DataString;
  ErrorHtml.SaveToFile(ZonuConfig.TempPath + 'Error.htm');
  ErrorHtml.Free;
  ErrorDialog.EmbeddedWB1.Navigate(ZonuConfig.TempPath + 'Error.htm');
  ErrorDialog.Caption :=  'Be@2ch';
  ErrorDialog.ShowModal;
  ErrorDialog.Release;
  DeleteFile(ZonuConfig.TempPath + 'Error.htm');

  //
  Result  :=  JConv(csEUC, FHttpStream.DataString);
end;

function TBe2chManager.GetProfile(ABeID, AThreadURL: string): string;
var
  FHttpStream: TStringStream;
  s: string;
begin
  //HTTPʐM̏
  InitHttpSetting;

  //M
  FHttpStream               :=  TStringStream.Create('');
  FHttpStream.Position      :=  0;
  FHttpStream.Size          :=  0;
  HttpCli1.RcvdStream       :=  FHttpStream;
  HttpCli1.Cookie           :=  GetCookie;

  //MURL
  HttpCli1.URL              :=  BE_URL + 'test/p.php' +
                                '?i=' + ABeID +
                                '&u=d:' + AThreadURL;
  //M
  HttpCli1.Get;

  //ʎ擾
  s :=  JConv(csEUC, FHttpStream.DataString);


  //vtB[̓eo(<hr>ň͂܂Ă)
  s :=  Copy(s, AnsiPos('<hr>', s) + 4, Length(s));
  //24
  if  (AnsiPos('<hr>', s) > 0) then begin
    s :=  Copy(s, 1,   AnsiPos('<hr>', s) - 1); //hrȂ肷
  end;

  Result  :=  s;
end;


//
//  w胆[ŨvtB[\
//
function TBe2chManager.ShowProfile(ABeID, AThreadURL: string): string;
var
  ErrorHtml: TStringList;
  s: string;
begin
  s :=  GetProfile(ABeID, AThreadURL);
  
  //e_CAO\
  ErrorDialog   :=  TErrorDialog.Create(nil);
  ErrorHtml     :=  TStringList.Create;
  ErrorHtml.Text  :=  s;
  ErrorHtml.SaveToFile(ZonuConfig.TempPath + 'Error.htm');
  ErrorHtml.Free;
  ErrorDialog.EmbeddedWB1.Navigate(ZonuConfig.TempPath + 'Error.htm');
  ErrorDialog.Caption :=  'Be@2ch';
  ErrorDialog.ShowModal;
  ErrorDialog.Release;
  DeleteFile(ZonuConfig.TempPath + 'Error.htm');

  //
  Result  := s;
end;

//
//  ̃vtB[擾
//
function TBe2chManager.GetMyProfile(out AProfile: TBe2chProfile): string;
var
  FHttpStream: TStringStream;
  s, sw: string;
begin
  //HTTPʐM̏
  InitHttpSetting;

  //M
  FHttpStream               :=  TStringStream.Create('');
  FHttpStream.Position      :=  0;
  FHttpStream.Size          :=  0;
  HttpCli1.RcvdStream       :=  FHttpStream;
  HttpCli1.Cookie           :=  GetCookie;

  //MURL
  HttpCli1.URL              :=  BE_URL + 'test/editprof.php';

  //M
  HttpCli1.Get;

  //ʎ擾
  s :=  JConv(csEUC, FHttpStream.DataString);

  //eo
  s :=  Copy(s, 1, AnsiPos('</form>', s) - 1);
  s :=  Copy(s, AnsiPos('method=post>', s) + 12, Length(s));

  //c胂^|
  sw  :=  ChooseString(s, '<br>', 0);
  sw  :=  Copy(sw, 5, Length(sw));
  sw  :=  Copy(sw, 1, AnsiPos('^|', sw) - 1);
  AProfile.beMoritapo :=  sw;

  //]
  sw  :=  ChooseString(s, '<br>', 1);
  sw  :=  Copy(sw, 5, Length(sw));
  sw  :=  Copy(sw, 1, AnsiPos('|Cg', sw) - 1);
  AProfile.beRank :=  sw;

  //O
  sw  :=  ChooseString(s, '<br>', 2);
  sw  :=  Copy(sw, AnsiPos('value=', sw) + 6, Length(sw));
  AProfile.beName :=  Copy(sw, 1, Length(sw) - 1);

  //Rg
  sw  :=  ChooseString(s, '<br>', 4);
  sw  :=  TrimTag(sw);
  AProfile.beMemo :=  sw;

end;

function TBe2chManager.SetMyProfile(AProfile: TBe2chProfile): boolean;
var
  FSendStream:  TStringStream;
  FResponseStream:  TStringStream;
  s: string;
begin
  //Me
  s :=  'user_handle=' + AProfile.beName +
        '&user_intro=' + AProfile.beMemo +
        '&submit=C';

  //HTTPʐM̏(PROXYȂ)
  InitHttpSetting;

  FSendStream               :=  TStringStream.Create(s);
  FResponseStream           :=  TStringStream.Create('');

  //MNbL[̓e擾(MDMD=xxxxxxxxx)
  HttpCli1.Cookie           :=  GetCookie;

  //Mp̃Xg[Ƃ
  HttpCli1.SendStream       :=  FSendStream;
  HttpCli1.RcvdStream       :=  FResponseStream;
  HttpCli1.Reference        :=  BE_URL + 'test/editprof.php';

  //MURL
  HttpCli1.URL              :=  BE_URL + 'test/editprof.php';

  //M (񓯊)
  HttpCli1.Post;
  LoginDialogBe.Release;

  //ʎ擾 (EUCSJISϊ)
  s :=  JConv(csEUC, FResponseStream.DataString);

  //G[
  if  (AnsiPos(BE_PROFILE_EDIT_SUCCESS, s) > 0)  then  begin
    //
    Result      :=  True;
  end else begin
    //s
    Result      :=  False;
  end;
end;

end.
