{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Chotto Browser Unit                                               }
{                                                                             }
{ 2001-05 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Chotto2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ToolWin, StdCtrls, ExtCtrls, OleCtrls, SHDocVw,
  EmbeddedWB, ImgList, MSHTML, ActnList, Main, Menus;

type
  //TOpenMode = (omZonu, omBrowser);

  TChottoBrowser  = class;
  TChottoTabSheet = class;

  TCallbackOpen = procedure (Sender: TObject; const URL: string; OpenMode: integer) of object;

  TChottoBrowser = class(TEmbeddedWB)
  private
    FTabSheet: TChottoTabSheet;
    FURL: string;
  public
    property  TabSheet: TChottoTabSheet   read  FTabSheet   write FTabSheet;
    property  URL: string   read  FURL  write FURL;
  end;

  TChottoTabSheet = class(TTabSheet)
  private
    FBrowser: TChottoBrowser;
  public
    property  Browser: TChottoBrowser read  FBrowser  write FBrowser;
  end;

  TChottoWindow2 = class(TForm)
    PageControl1: TPageControl;
    StatusBar1: TStatusBar;
    ImageList1: TImageList;
    ActionList1: TActionList;
    actOpenZonu: TAction;
    actOpenBrowser: TAction;
    actOpen: TAction;
    HeaderPanel: TPanel;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    ComboBox1: TComboBox;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolBar2: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    Animate1: TAnimate;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    PopupMenu1: TPopupMenu;
    actCloseTab: TAction;
    actCloseAllTab: TAction;
    C1: TMenuItem;
    A1: TMenuItem;
    N1: TMenuItem;
    Open1: TMenuItem;
    N2: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure actOpenZonuExecute(Sender: TObject);
    procedure actOpenExecute(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure PageControl1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDeactivate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure PageControl1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure actCloseTabExecute(Sender: TObject);
    procedure actCloseAllTabExecute(Sender: TObject);
  private
    { Private 錾 }
    FProgressBar: TProgressBar;
    FCallbackOpenEvt: TCallbackOpen;
    FProcCount: integer;
    FSaveHeight: integer;
    procedure BrowserTitleChange(Sender: TObject; const Text: WideString);
    procedure BrowserStatusTextChange(Sender: TObject;
      const Text: WideString);
    procedure BrowserDocumentComplete(Sender: TObject;
      const pDisp: IDispatch; var URL: OleVariant);
    procedure BrowserBeforeNavigate2(Sender: TObject;
      const pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
      Headers: OleVariant; var Cancel: WordBool);
    procedure BrowserNewWindow2(Sender: TObject; var ppDisp: IDispatch;
      var Cancel: WordBool);
    procedure BrowserProgressChange(Sender: TObject; Progress,
      ProgressMax: Integer);
    procedure StartProc;
    procedure EndProc;
    procedure CloseTab;
    procedure CloseAllTab;
  public
    { Public 錾 }
    procedure Open(const URL: string);
    property  OnCallbackOpen: TCallbackOpen read  FCallbackOpenEvt  write FCallbackOpenEvt;
  end;

var
  ChottoWindow2: TChottoWindow2;

implementation

{$R *.dfm}

uses
  ZonuConf, Hzbconst, Zonutils, MonaUtils;

procedure TChottoWindow2.FormCreate(Sender: TObject);
begin
  FProgressBar          :=  TProgressBar.Create(Self);
  FProgressBar.Parent   :=  StatusBar1;
  FProgressBar.Top      :=  2;
  FProgressBar.Height   :=  StatusBar1.Height - 2;
  FProgressBar.Width    :=  StatusBar1.Panels[0].Width - 2;
  FProgressBar.Show;
  FProgressBar.Smooth         :=  True;

  if  (FileExists(ZonuConfig.AppPath + FILE_ANIMATE))  then  begin
    Animate1.FileName       :=  ZonuConfig.AppPath + FILE_ANIMATE;
  end else begin
    Animate1.Height         :=  0;
    Animate1.Width          :=  0;
    CoolBar1.Width          :=  HeaderPanel.Width;
  end;

  FSaveHeight :=  ZonuConfig.ChottoHeight;
end;

procedure TChottoWindow2.FormDestroy(Sender: TObject);
begin
  //
end;

procedure TChottoWindow2.Open(const URL: string);
var
  Browser: TChottoBrowser;
  Tab: TChottoTabSheet;
begin
  Tab               :=  TChottoTabSheet.Create(PageControl1);
  Tab.PageControl   :=  PageControl1;
  Tab.Caption       :=  ExtractUrlName(URL);
  Tab.ImageIndex    :=  0;

  Browser           :=  TChottoBrowser.Create(Self);
  TOleControl(Browser).Parent  :=  Tab;
  Browser.URL       :=  URL;
  Browser.Align     :=  alClient;
  Browser.TabSheet  :=  Tab;
  Tab.Browser       :=  Browser;

  Browser.OnTitleChange       :=  BrowserTitleChange;
  Browser.OnStatusTextChange  :=  BrowserStatusTextChange;
  Browser.OnDocumentComplete  :=  BrowserDocumentComplete;
  Browser.OnBeforeNavigate2   :=  BrowserBeforeNavigate2;
  Browser.OnNewWindow2        :=  BrowserNewWindow2;
  Browser.OnProgressChange    :=  BrowserProgressChange;

  Browser.Navigate(URL);
  ComboBox1.Text  :=  URL;
  PageControl1.ActivePage     :=  TTabSheet(tab);
  
end;

procedure TChottoWindow2.BrowserTitleChange(Sender: TObject;
  const Text: WideString);
begin
  TChottoBrowser(Sender).TabSheet.Caption  :=  Text;
end;

procedure TChottoWindow2.BrowserStatusTextChange(Sender: TObject;
  const Text: WideString);
begin
  StatusBar1.Panels[1].Text :=  Text;
end;

procedure TChottoWindow2.BrowserDocumentComplete(Sender: TObject;
  const pDisp: IDispatch; var URL: OleVariant);
begin
  TChottoBrowser(Sender).TabSheet.ImageIndex  :=  -1;
  EndProc;
end;

procedure TChottoWindow2.BrowserBeforeNavigate2(Sender: TObject;
  const pDisp: IDispatch; var URL, Flags, TargetFrameName, PostData,
  Headers: OleVariant; var Cancel: WordBool);
begin
  TChottoBrowser(Sender).TabSheet.ImageIndex  :=  0;
  StartProc;
end;

procedure TChottoWindow2.BrowserNewWindow2(Sender: TObject;
  var ppDisp: IDispatch; var Cancel: WordBool);
var
  Url: string;
begin
  Cancel  :=  True;
  Url     :=  ExtractHrefUrl(IHTMLDocument2(TWebBrowser(Sender).Document).activeElement.Get_outerHTML);
  if  (AnsiPos('/', Url) = 1) or (AnsiPos('.', Url) = 1)  then  begin
    Url :=  MargeUrl(ExtractUrlPath(TWebBrowser(Sender).LocationURL), Url);
  end;
  Open(Url);
end;

procedure TChottoWindow2.PageControl1Change(Sender: TObject);
begin
  if  (PageControl1.PageCount > 0)  then  begin
    if  (PageControl1.TabIndex > -1)  then  begin
      ComboBox1.Text  :=  TChottoTabSheet(PageControl1.ActivePage).Browser.URL;
    end;
  end;
end;

procedure TChottoWindow2.BrowserProgressChange(Sender: TObject;
  Progress, ProgressMax: Integer);
begin
  FProgressBar.Min      :=  0;
  FProgressBar.Max      :=  ProgressMax;
  FProgressBar.Position :=  Progress;
end;

procedure TChottoWindow2.actOpenZonuExecute(Sender: TObject);
var
  m: integer;
begin
  if  (PageControl1.PageCount > 0)  then  begin
    if  (Sender = actOpenZonu)  then  begin
      m :=  1;
    end else begin
      m :=  0;
    end;
    if  (Assigned(FCallbackOpenEvt)) then  begin
      FCallbackOpenEvt(
        TChottoTabSheet(PageControl1.ActivePage).Browser,
        TChottoTabSheet(PageControl1.ActivePage).Browser.LocationURL,
        m);
    end;
  end;
end;

procedure TChottoWindow2.actOpenExecute(Sender: TObject);
begin
  Open(ComboBox1.Text);
end;

procedure TChottoWindow2.FormResize(Sender: TObject);
begin
  if  (WindowState <> wsMinimized)  then  begin
    if  (Animate1.Visible)  then  begin
      CoolBar1.Width  :=  ClientWidth - Animate1.Width - 8;
      Animate1.Left   :=  ClientWidth - Animate1.Width - 4;
    end else begin
      CoolBar1.Width  :=  ClientWidth;
    end;
  end;
end;

procedure TChottoWindow2.EndProc;
begin
  Dec(FProcCount);
  if  (FProcCount < 1)  then  begin
    Animate1.Stop;
    FProcCount := 0;
  end;
end;

procedure TChottoWindow2.StartProc;
begin
  Inc(FProcCount);
  if  (Animate1.FileName <> '') then  Animate1.Play(2, Animate1.FrameCount, 1024);
end;

procedure TChottoWindow2.PageControl1MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if  (Button = mbMiddle) then  begin
    CloseTab;
  end;
end;

procedure TChottoWindow2.CloseTab;
begin
  if  (PageControl1.PageCount > 0)  then  begin
    if  (TChottoTabSheet(PageControl1.ActivePage).Browser.Busy)  then  begin
      EndProc;
    end;
    TOleControl(TChottoTabSheet(PageControl1.ActivePage).FBrowser).Free;
    PageControl1.ActivePage.Free;
  end;
end;

procedure TChottoWindow2.CloseAllTab;
var
  i: integer;
begin
  PageControl1.ActivePage.PageIndex :=  0;
  for i :=  PageControl1.PageCount - 1  downto  1 do  begin
    TOleControl(TChottoTabSheet(PageControl1.Pages[i]).FBrowser).Free;
    PageControl1.Pages[i].Free;
  end;
end;

procedure TChottoWindow2.FormActivate(Sender: TObject);
begin
  SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  AlphaBlend  :=  False;
  Height  :=  FSaveHeight;
end;

procedure TChottoWindow2.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
end;

procedure TChottoWindow2.FormDeactivate(Sender: TObject);
begin
  if  (ZonuConfig.ChottoTrans)  then
  begin
    //TransWindow(True);
    AlphaBlend  :=  True;
    AlphaBlendValue :=  128;
  end;
  FSaveHeight :=  Height;
  if  (ZonuConfig.ChottoExpand) then  begin
    Height      :=  0;
  end;
end;

procedure TChottoWindow2.FormShow(Sender: TObject);
begin
  SetBounds(
    ZonuConfig.ChottoPosLeft,
    ZonuConfig.ChottoPosTop,
    ZonuConfig.ChottoWidth,
    ZonuConfig.ChottoHeight);
end;

procedure TChottoWindow2.FormHide(Sender: TObject);
begin
  ZonuConfig.ChottoPosTop     :=  Top;
  ZonuConfig.ChottoPosLeft    :=  Left;
  ZonuConfig.ChottoWidth      :=  Width;
  ZonuConfig.ChottoHeight     :=  Height;
end;

procedure TChottoWindow2.PageControl1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  n: integer;
begin
  n :=  PageControl1.IndexOfTabAt(X,Y);
  if  (n > -1) and (n < PageControl1.PageCount) then  begin
    PageControl1.ActivePageIndex := n;
  end;
end;

procedure TChottoWindow2.actCloseTabExecute(Sender: TObject);
begin
  CloseTab;
end;

procedure TChottoWindow2.actCloseAllTabExecute(Sender: TObject);
begin
  CloseAllTab;
end;

end.
