{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 ToolBar Customize Dialog Unit                                     }
{                                                                             }
{ 2001-05 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Custmbar;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Main, ToolWin, ComCtrls, IniFiles, ActnList,
  Menus, ExtCtrls, Dlghead;

type
  TCustomToolbarDialog = class(TForm)
    Button1: TButton;
    Button2: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    SpeedButton1: TSpeedButton;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ListView1: TListView;
    ListView2: TListView;
    ActionList1: TActionList;
    actAdd: TAction;
    actDelete: TAction;
    actAddSeparator: TAction;
    actMoveUp: TAction;
    actMoveDown: TAction;
    PopupMenu1: TPopupMenu;
    A1: TMenuItem;
    PopupMenu2: TPopupMenu;
    S1: TMenuItem;
    N1: TMenuItem;
    U1: TMenuItem;
    D1: TMenuItem;
    N2: TMenuItem;
    S2: TMenuItem;
    Button3: TButton;
    Button4: TButton;
    Button6: TButton;
    Button5: TButton;
    HeaderFrame1: THeaderFrame;
    Button7: TButton;
    Button8: TButton;
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure actAddExecute(Sender: TObject);
    procedure actDeleteExecute(Sender: TObject);
    procedure actAddSeparatorExecute(Sender: TObject);
    procedure actMoveUpExecute(Sender: TObject);
    procedure actMoveDownExecute(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
    procedure RefreshToolButtons(const RefreshActions: boolean);
    { Private 錾 }
  public
    { Public 錾 }
  end;

  TZonuToolBarList = class(TStringList)
  private
    FToolBar: TToolBar;
  public
    property  ToolBar: TToolBar   read  FToolBar  write FToolBar;
  end;

var
  CustomToolbarDialog: TCustomToolbarDialog;

implementation

{$R *.dfm}

uses
  HzbClass, Hzbfunc, ZonuConf, ZonuClass, Hzbconst;

procedure TCustomToolbarDialog.FormCreate(Sender: TObject);
  procedure AddComboBox(ToolBar: TToolBar);
  var
    i, x : integer;
    StringList : TZonuToolBarList;
  begin
    x :=  ComboBox2.Items.Add(ToolBar.Caption);
    StringList := TZonuToolBarList.Create;
    for i :=  0 to  ToolBar.ButtonCount - 1 do  begin
      if  (ToolBar.Buttons[i].Style = tbsSeparator)  then  begin
        StringList.Add('-');
      end else begin
        try
          StringList.Add(ToolBar.Buttons[i].Action.Name);
        except
          //8
        end;
      end;
    end;
    StringList.ToolBar  :=  ToolBar;
    ComboBox2.Items.Objects[x] := StringList;
  end;
var
  i : integer;
  s : string;
begin
  AddComboBox(HotzonuWindow.MainActToolBar);
  AddComboBox(HotzonuWindow.ThreadListActToolBar);
  AddComboBox(HotzonuWindow.BrowserActToolBar);
  AddComboBox(HotzonuWindow.AppActToolBar);
  AddComboBox(HotzonuWindow.GaishutuToolBar);

  s := '';
  for i :=  0 to  HotzonuWindow.ActionList1.ActionCount - 1 do  begin
    if  (s <> HotzonuWindow.ActionList1.Actions[i].Category)  then  begin
      s :=  HotzonuWindow.ActionList1.Actions[i].Category;
      if  (ComboBox1.Items.IndexOf(s) < 0)  then  begin
        if  (s <> 'IX') and
            (s <> '') and
            (s <> 'uEUI') then
        begin
          ComboBox1.Items.Add(s);
        end;
      end;
    end;
  end;
  ComboBox2.ItemIndex :=  0;
  ComboBox2.OnChange(ComboBox2);
  ComboBox1.ItemIndex :=  0;
  ComboBox1.OnChange(ComboBox1);
end;

procedure TCustomToolbarDialog.ComboBox1Change(Sender: TObject);
var
  Item : TListItem;
  i : integer;
begin
  ListView1.Items.BeginUpdate;
  ListView1.Items.Clear;
  for i :=  0 to  HotzonuWindow.ActionList1.ActionCount - 1 do  begin
    if  (HotzonuWindow.ActionList1.Actions[i].Category = ComboBox1.Text)  then  begin
      if  (TStringList(ComboBox2.Items.Objects[ComboBox2.ItemIndex]).IndexOf(TAction(HotzonuWindow.ActionList1.Actions[i]).Name) < 0) then
      begin
        Item  :=  ListView1.Items.Add;
        Item.Caption    :=  '[' + HotzonuWindow.ActionList1.Actions[i].Category + ']' + 
                            TAction(HotzonuWindow.ActionList1.Actions[i]).Caption;
        Item.ImageIndex :=  TAction(HotzonuWindow.ActionList1.Actions[i]).ImageIndex;
        Item.Data       :=  HotzonuWindow.ActionList1.Actions[i];
      end;
    end;
  end;
  ListView1.Items.EndUpdate;
end;

procedure TCustomToolbarDialog.ComboBox2Change(Sender: TObject);
begin
  RefreshToolButtons(True);
end;

procedure TCustomToolbarDialog.RefreshToolButtons(const RefreshActions: boolean);
var
  Action  : TAction;
  Item : TListItem;
  sl : TStringList;
  i : integer;
begin
  sl  :=  TStringList(ComboBox2.Items.Objects[ComboBox2.ItemIndex]);
  ListView2.Items.BeginUpdate;
  ListView2.Items.Clear;
  for i :=  0 to  sl.Count - 1  do  begin
    if  (sl[i] = '-') then  begin
      Item    :=  ListView2.Items.Add;
      Item.Caption    :=  '<؂>';
      Item.ImageIndex :=  -1;
      Item.Data       :=  nil;
    end else begin
      Action  :=  FindAction(sl[i]);
      Item    :=  ListView2.Items.Add;
      Item.Caption    :=  '[' + Action.Category + ']' + Action.Caption;
      Item.ImageIndex :=  Action.ImageIndex;
      Item.Data       :=  Action;
    end;
  end;
  if  (Showing) and (RefreshActions) then  begin
    ComboBox1.OnChange(ComboBox1);
  end;
  ListView2.Items.EndUpdate;
end;

procedure TCustomToolbarDialog.Button2Click(Sender: TObject);
begin
  ModalResult :=  mrCancel;
end;

procedure TCustomToolbarDialog.Button1Click(Sender: TObject);
var
  ini : TMemIniFile;
  i, x : integer;
  sl: TZonuToolBarList;
  ToolBar : TToolBar;
begin
  ini :=  TMemIniFile.Create(ZonuConfig.UsersPath + FILE_TOOLBAR_INI);
  for i :=  0 to  ComboBox2.Items.Count - 1 do  begin
    sl  :=  TZonuToolBarList(ComboBox2.Items.Objects[i]);
    ToolBar :=  sl.ToolBar;
    ini.EraseSection(ToolBar.Name);
    ini.WriteInteger(ToolBar.Name, 'COUNT', sl.Count);
    for x :=  0 to  sl.Count - 1  do  begin
      ini.WriteString(ToolBar.Name, 'BUTTON' + IntToStr(x + 1), sl[x]);
    end;
  end;
  ini.UpdateFile;
  ini.Free;
  ModalResult :=  mrOk;
end;

procedure TCustomToolbarDialog.actAddExecute(Sender: TObject);
var
  sl : TStringList;
  a : TAction;
  i : integer;
begin
  for i :=  0 to  ListView1.Items.Count - 1 do  begin
    if  (ListView1.Items[i].Selected) then  begin
      a   :=  TAction(ListView1.Items[i].Data);
      sl  :=  TStringList(ComboBox2.Items.Objects[ComboBox2.ItemIndex]);
      sl.Add(a.Name);
    end;
  end;
  ComboBox2.OnChange(ComboBox2);
end;

procedure TCustomToolbarDialog.actDeleteExecute(Sender: TObject);
var
  sl : TStringList;
  i : integer;
begin
  sl  :=  TStringList(ComboBox2.Items.Objects[ComboBox2.ItemIndex]);
  for i :=  ListView2.Items.Count - 1 downto  0 do  begin
    if  (ListView2.Items[i].Selected) then  begin
      sl.Delete(i);
    end;
  end;
  ComboBox2.OnChange(ComboBox2);
end;

procedure TCustomToolbarDialog.actAddSeparatorExecute(Sender: TObject);
var
  sl : TStringList;
  Item : TListItem;
begin
  sl  :=  TStringList(ComboBox2.Items.Objects[ComboBox2.ItemIndex]);
  sl.Add('-');
  Item    :=  ListView2.Items.Add;
  Item.Caption    :=  '<؂>';
  Item.ImageIndex :=  -1;
  Item.Data       :=  nil;
end;

procedure TCustomToolbarDialog.actMoveUpExecute(Sender: TObject);
var
  i, n : integer;
  sl : TStringList;
begin
  n   :=  -1;
  sl  :=  TStringList(ComboBox2.Items.Objects[ComboBox2.ItemIndex]);
  for i :=  1 to  ListView2.Items.Count - 1 do  begin
    if  (ListView2.Items[i].Selected) then  begin
      sl.Move(i, i - 1);
      if  (n < 0) then  n :=  i - 1;
    end;
  end;
  RefreshToolButtons(False);
  if  (n > -1)  then  ListView2.Selected  :=  ListView2.Items[n];
end;

procedure TCustomToolbarDialog.actMoveDownExecute(Sender: TObject);
var
  i, n : integer;
  sl : TStringList;
begin
  n   :=  -1;
  sl  :=  TStringList(ComboBox2.Items.Objects[ComboBox2.ItemIndex]);
  for i :=  ListView2.Items.Count - 2 downto  0 do  begin
    if  (ListView2.Items[i].Selected) then  begin
      sl.Move(i, i + 1);
      if  (n < 0) then  n :=  i + 1;
    end;
  end;
  RefreshToolButtons(False);
  if  (n > -1)  then  ListView2.Selected  :=  ListView2.Items[n];
end;

procedure TCustomToolbarDialog.FormDestroy(Sender: TObject);
var
  i : integer;
begin
  for i :=  ComboBox2.Items.Count - 1 downto  0 do  begin
    if  (ComboBox2.Items.Objects[i] <> nil) then  begin
      TStringList(ComboBox2.Items.Objects[i]).Free;
    end;
  end;
end;

procedure TCustomToolbarDialog.Button7Click(Sender: TObject);
var
  i, x:  integer;
  sl: TZonuToolBarList;
  ini: TMemIniFile;
begin
  if  (Sender = Button7)  then  begin
    ini :=  TMemIniFile.Create(ZonuConfig.AppPath + PATH_DEF + 'toolbar_simple.ini');
  end else begin
    ini :=  TMemIniFile.Create(ZonuConfig.AppPath + PATH_DEF + 'toolbar_full.ini');
  end;
  for i :=  0 to  ComboBox2.Items.Count - 1 do  begin
    sl  :=  TZonuToolBarList(ComboBox2.Items.Objects[ComboBox2.ItemIndex]);
    sl.Clear;
    for x :=  0 to  ini.ReadInteger(sl.ToolBar.Name, 'COUNT', 0) - 1 do  begin
      sl.Add(ini.ReadString(sl.ToolBar.Name, 'BUTTON' + IntToStr(x + 1), ''));
    end;
  end;
  ini.Free;
  RefreshToolButtons(True);
end;

end.
