{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Export Dialog Unit                                                }
{                                                                             }
{ 2001-04 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Expdlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Dlghead, ComCtrls, ExtCtrls, StdCtrls, FileCtrl, ShellCtrls,
  Buttons, ZonuClass, Main, IniFiles;

type
  TExportDialog = class(TForm)
    HeaderFrame1: THeaderFrame;
    StatusBar1: TStatusBar;
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter1: TSplitter;
    Panel3: TPanel;
    Label1: TLabel;
    Panel4: TPanel;
    Label2: TLabel;
    Panel7: TPanel;
    ScrollBox1: TScrollBox;
    Label3: TLabel;
    Edit1: TEdit;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioGroup1: TRadioGroup;
    SpeedButton1: TSpeedButton;
    GroupBox2: TGroupBox;
    Edit3: TEdit;
    Button6: TButton;
    Button7: TButton;
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    Edit2: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
  private
    { Private 錾 }
    FList: TList;
    FResLists: TList;
    FThreadItem: TThreadItem;
    FProgressBar: TProgressBar;
    procedure SetThreadItem(const Value: TThreadItem);
  public
    { Public 錾 }
    property  ThreadList: TList read  FList write FList;
    property  ResLists: TList  read  FResLists  write FResLists;
    property  ThreadItem: TThreadItem read  FThreadItem write SetThreadItem;
  end;

var
  ExportDialog: TExportDialog;

implementation

{$R *.dfm}

uses
  Skindlg2, Hzbfunc, ZonuConf, Hzbclass, Hzbconst;

var
  {
  FSkinPath:  string;
  FKatjushaSkin:  boolean;
  FHotzonuSKin: boolean;
  } 
  ini: TMemIniFile;

procedure TExportDialog.FormCreate(Sender: TObject);
begin
  ini   :=  TMemIniFile.Create(ZonuConfig.UsersPath + INI_SKIN);
  FList :=  TList.Create;
  FResLists :=  TList.Create;
  FThreadItem :=  nil;
  RadioButton1.Checked  :=  (ZonuConfig.ExportFormat = 0);
  RadioButton2.Checked  :=  (ZonuConfig.ExportFormat = 1);
  Edit1.Text            :=  ini.ReadString('export_dialog', 'SKINPATH', ''); //ZonuConfig.ExportSkinName;
  Edit2.Text            :=  ZonuConfig.ExportSeparator;
  RadioButton1.OnClick(Self);
  //CheckBox1.Checked     :=  ZonuConfig.ExportWithIDText;
  RadioGroup1.ItemIndex :=  ZonuConfig.ExportFileNameType;
  if  (DirectoryExists(ZonuConfig.ExportPath)) then  begin
    //ShellTreeView1.Path :=  ZonuConfig.ExportPath;
    DriveComboBox1.Drive        :=  ZonuConfig.ExportPath[1];
    DirectoryListBox1.Directory :=  ZonuConfig.ExportPath;
  end;
  {
  FSkinPath             :=  ZonuConfig.ExportSkinName;
  FKatjushaSkin         :=  ZonuConfig.ExportSkinKatjusha;
  FHotzonuSkin          :=  ZonuConfig.ExportSkinHotzonu;
  }
  FProgressBar          :=  TProgressBar.Create(Self);
  FProgressBar.Parent   :=  StatusBar1;
  FProgressBar.Top      :=  2;
  FProgressBar.Height   :=  StatusBar1.Height - 2;
  FProgressBar.Show;
  FProgressBar.Smooth         :=  True;
  StatusBar1.Panels[0].Width  :=  FProgressBar.Width;
end;

procedure TExportDialog.FormDestroy(Sender: TObject);
begin
  FList.Free;
  FResLists.Free;
  if  (FThreadItem <> nil)  then  FThreadItem.ReleaseRef;
  ini.UpdateFile;
  ini.Free;
end;

procedure TExportDialog.SpeedButton1Click(Sender: TObject);
begin
  ini.UpdateFile;
  ini.Free;
  SkinDialog2     :=  TSkinDialog2.Create(Self);
  SkinDialog2.Key :=  'export_dialog';
  if  (SkinDialog2.ShowModal  = mrOk) then  begin
    Edit1.Text            :=  SkinDialog2.SkinPath;
    {
    FSkinPath             :=  SkinDialog2.SkinPath;
    FKatjushaSkin         :=  SkinDialog2.KatjushaSkin;
    FHotzonuSkin          :=  SkinDialog2.HotzonuSkin;
    }
  end;
  SkinDialog2.Release;
  ini   :=  TMemIniFile.Create(ZonuConfig.UsersPath + INI_SKIN);
end;

procedure TExportDialog.Button7Click(Sender: TObject);
begin
  Close;
end;

procedure TExportDialog.Button6Click(Sender: TObject);
var
  DatStrings:  TZonuDatStrings;
  HtmlStrings: TZonuHtmlStrings;
  ThreadItem: TThreadItem;
  AResList: TResList;
  i: integer;
  s: string;
  procedure ZonuExport(ThreadItem: TThreadItem; ResList: TResList);
  var
    x: integer;
  begin
    if  (ThreadItem.ReadCount > 0) then  begin
      if  (RadioButton1.Checked)  then  begin
        HtmlStrings  :=  TZonuHtmlStrings.Create;
        HtmlStrings._SkinPath        :=  ini.ReadString('export_dialog', 'SKINPATH', 'default'); //FSkinPath;
        HtmlStrings._KatjushaSkin    :=  ini.ReadBool('export_dialog', 'KATJUSHA', False); //FKatjushaSKin;
        HtmlStrings._HotzonuSkin     :=  ini.ReadBool('export_dialog', 'HOTZONU', False);
        //11
        HtmlStrings._IDPopup         :=  ini.ReadBool('export_dialog', 'IDPOPUP', False);
        //13
        HtmlStrings._RenderImage     :=  ini.ReadBool('export_dialog', 'RENDERIMAGE', False);
        HtmlStrings._ImageSize       :=  ini.ReadInteger('export_dialog', 'IMAGESIZE', 24);
        HtmlStrings.ResList          :=  ResList;
        HtmlStrings.Site             :=  ThreadItem.Site;
        HtmlStrings.BoardID          :=  ThreadItem.BoardID;
        HotzonuWindow.InitOutputRes(HtmlStrings, ResList);

        for x :=  0 to  ResList.Count - 1 do  begin
          if  (ResList[x].Visible)  then  begin
            ResList[x].Showing  :=  True;
            HotzonuWindow.OutputRes(HtmlStrings, HtmlStrings, ResList[x], ResList);
          end;
        end;
        HotzonuWindow.EndOutputRes(HtmlStrings);

        //s :=  IncludeTrailingPathDelimiter(ShellTreeView1.Path);
        s :=  IncludeTrailingPathDelimiter(DirectoryListBox1.Directory);
        if  (RadioGroup1.ItemIndex = 0) then  begin
          s :=  s + ThreadItem.DatNo;
        end else begin
          s :=  s + ThreadItem.Title;
        end;
        s :=  s + Edit3.Text;
        s :=  StringReplace(s, '/', '', [rfReplaceAll]);
        s :=  StringReplace(s, ',', '', [rfReplaceAll]);
        s :=  StringReplace(s, ';', '', [rfReplaceAll]);
        s :=  StringReplace(s, '?', '', [rfReplaceAll]);
        s :=  StringReplace(s, '<', '', [rfReplaceAll]);
        s :=  StringReplace(s, '>', '', [rfReplaceAll]);
        s :=  StringReplace(s, '|', '', [rfReplaceAll]);
        HtmlStrings.SaveToFile(s);

        HtmlStrings.Free;
      end else begin
        DatStrings   :=  TZonuDatStrings.Create;
        DatStrings.Site             :=  ThreadItem.Site;
        DatStrings.BoardID          :=  ThreadItem.BoardID;

        HotzonuWindow.InitOutputRes(DatStrings, ResList);

        for x :=  0 to  ResList.Count - 1 do  begin
          HotzonuWindow.OutputRes(DatStrings, DatStrings, ResList[x], ResList);
        end;
        HotzonuWindow.EndOutputRes(DatStrings);

        //s :=  IncludeTrailingPathDelimiter(ShellTreeView1.Path);
        s :=  IncludeTrailingPathDelimiter(DirectoryListBox1.Directory);
        if  (RadioGroup1.ItemIndex = 0) then  begin
          s :=  s + ThreadItem.DatNo;
        end else begin
          s :=  s + Trim(ThreadItem.Title);
        end;
        s :=  s + Edit3.Text;
        s :=  StringReplace(s, '/', '', [rfReplaceAll]);
        s :=  StringReplace(s, ',', '', [rfReplaceAll]);
        s :=  StringReplace(s, ';', '', [rfReplaceAll]);
        s :=  StringReplace(s, '?', '', [rfReplaceAll]);
        s :=  StringReplace(s, '<', '', [rfReplaceAll]);
        s :=  StringReplace(s, '>', '', [rfReplaceAll]);
        s :=  StringReplace(s, '|', '', [rfReplaceAll]);
        DatStrings.SaveToFile(s);

        DatStrings.Free;
      end;
    end;
  end;
begin
  Screen.Cursor :=  crHourGlass;
  if  (RadioButton1.Checked)  then  begin
    ZonuConfig.ExportFormat :=  0;
    if  (Edit1.Text = '') then  begin
      MessageDlg('XLw肵ĂB', mtError, [mbOk], 0);
      Edit1.SetFocus;
      Exit;
    end;
  end else begin
    ZonuConfig.ExportFormat :=  1;
  end;
  {
  ZonuConfig.ExportSkinName     :=  FSkinPath;
  ZonuConfig.ExportSkinKatjusha :=  FKatjushaSkin;
  ZonuConfig.ExportSkinHotzonu  :=  FHotzonuSkin;
  }
  ZonuConfig.ExportSeparator    :=  Edit2.Text;
  //ZonuConfig.ExportWithIDText   :=  CheckBox1.Checked;
  ZonuConfig.ExportFileNameType :=  RadioGroup1.ItemIndex;
  if  (RadioButton1.Checked)  then  begin
    ZonuConfig.ExportHtmlExt    :=  Edit3.Text;
  end else begin
    ZonuConfig.ExportDatExt    :=  Edit3.Text;
  end;
  //ZonuConfig.ExportPath         :=  ShellTreeView1.Path;
  ZonuConfig.ExportPath         :=  DirectoryListBox1.Directory;
  //
  if  (FList.Count > 0) then  begin
    FProgressBar.Min      :=  0;
    FProgressBar.Max      :=  FList.Count;
    FProgressBar.Position :=  0;
    FProgressBar.Step     :=  1;
    for i :=  0 to  FList.Count - 1 do  begin
      FProgressBar.StepIt;
      StatusBar1.Panels[1].Text :=
        Format('[%d/%d] %s', [i + 1, FList.Count, TThreadItem(FList[i]).Title]);
      StatusBar1.Refresh;
      if  (FList.Count = 1) and (FResLists.Count = 1) then  begin
        ThreadItem  :=  TThreadItem(FList[i]);
        AResList    :=  TResList(FResLists[i]);
        ZonuExport(ThreadItem, AResList);
      end else begin
        ThreadItem  :=  TThreadItem(FList[i]);
        AResList    :=  TResList.Create(ThreadItem);
        ThreadItem.LoadFromFile(AResList);
        ZonuExport(ThreadItem, AResList);
        AResList.Free;
      end;
    end;
    FProgressBar.Position     :=  0;
    StatusBar1.Panels[1].Text :=  '';
  end else begin
    for i :=  0 to  FResLists.Count - 1 do  begin
      ZonuExport(FThreadItem, TResList(FResLists[i]));
    end;
  end;
  Screen.Cursor :=  crDefault;
  Close;
end;

procedure TExportDialog.SetThreadItem(const Value: TThreadItem);
begin
  FThreadItem := Value;
  FThreadItem.AddRef;
end;

procedure TExportDialog.RadioButton1Click(Sender: TObject);
begin
  if  (RadioButton1.Checked)  then  begin
    Edit3.Text            :=  ZonuConfig.ExportHtmlExt;
  end else begin
    Edit3.Text            :=  ZonuConfig.ExportDatExt;
  end;
end;

end.
