{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Favorite Window Unit                                              }
{                                                                             }
{ 2001-05 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Favdlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ComCtrls, StdCtrls, Main, ZonuClass, Buttons, Menus, IniFiles,
  Dlghead;

type
  TFavoriteDialog = class(TForm)
    TreeView1: TTreeView;
    Panel1: TPanel;
    Label1: TLabel;
    Edit1: TEdit;
    Panel2: TPanel;
    Button1: TButton;
    Button2: TButton;
    Image1: TImage;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    Button3: TButton;
    HeaderFrame1: THeaderFrame;
    chkAddAfterEdit: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure D1Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure Rename1Click(Sender: TObject);
    procedure TreeView1Edited(Sender: TObject; Node: TTreeNode;
      var S: String);
    procedure FormShow(Sender: TObject);
    procedure TreeView1Change(Sender: TObject; Node: TTreeNode);
  private
    { Private 錾 }
    FList: TList;
    FIsBoard: boolean;
    FIsApplication: boolean;
    FIsThreadItem: boolean;
    FIsWebPage: boolean;
    FUrl: string;
    FTitle: string;
    FBoard: TBoard;
  public
    { Public 錾 }
    property  TargetList: TList read  FList write FList;  {TFavClass}
    property  TargetWebPageUrl: string read  FUrl  write FUrl;
    property  TargetWebPageTitle: string read  FTitle  write FTitle;
    property  TargetBoard: TBoard read  FBoard  write FBoard;
    property  IsThreadItem: boolean read  FIsThreadItem write FIsThreadItem;
    property  IsBoard : boolean read  FIsBoard  write FIsBoard;
    property  IsWebPage:  boolean read  FIsWebPage  write FIsWebPage;
    //property  IsApplication:  boolean read  FIsApplication  write FIsApplication;
  end;

var
  FavoriteDialog: TFavoriteDialog;

implementation

uses
  Hzbclass, ZonuConf, Hzbconst, Hzbfunc, MonaUtils, Zonutils, Boardedt;

{$R *.DFM}

{ TFavoriteDialog }

procedure TFavoriteDialog.FormCreate(Sender: TObject);
begin
  FList           :=  TList.Create;
  FIsBoard        :=  False;
  FIsApplication  :=  False;
  FIsThreadItem   :=  False;
  FIsWebPage      :=  False;

  Hzbfunc.BuildBoardList(TreeView1, ZonuEnviron.FavoritesSite);
  TreeView1.FullCollapse;
  chkAddAfterEdit.Checked :=  ZonuConfig.FavoriteAddAfterEdit;  //32

  {
  if  (TreeView1.Items.Count > 0) then  begin
    TreeView1.Items[0].Expand(False);
    TreeView1.Selected  :=  TreeView1.Items[0];
  end;
  }
end;

procedure TFavoriteDialog.FormDestroy(Sender: TObject);
//var
//  i : integer;
begin
  {
  for i :=  FList.Count - 1 downto  0 do  begin
    Dispose(FList[i]);
  end;
  }
  FList.Free;
  //ReleaseFavorites(TreeView1);
end;

procedure TFavoriteDialog.Button1Click(Sender: TObject);
var
  ThreadItem  : TThreadItem;
  ABoard      : TBoard;
  InsPos      : integer;
  ini : TMemIniFile;
  sl  : TStringList;
  s   : string;
  d   : string;
  i, x   : integer;
  www : integer;
begin
  if  (TreeView1.Selected <> nil) then  begin
    if  (IsThreadItem)  then  begin
      //
      //  Xbho^
      //
      if  (TreeView1.Selected.Data <> nil)  then  begin
        ABoard  :=  TBoard(TreeView1.Selected.Data);
        sl      :=  TStringList.Create;
        s       :=  ABoard.CachePath + ABoard.BoardID + '.txt';
        if  (FileExists(s)) then  begin
          sl.LoadFromFile(s);
        end else begin
          sl.Add(ABoard.Name);
        end;
        for i :=  0 to  FList.Count - 1 do  begin
          //Xbh
          ThreadItem  :=  TThreadItem(FList[i]);
          d   :=  ThreadItem.Site.SiteID + #9 +
                  ThreadItem.BoardID + #9  +
                  ThreadItem.DatNo + #9  +
                  ThreadItem.Title + #9  +
                  '1';
          if  (SpeedButton2.Down) and (sl.Count > 0) then  begin
            sl.Add(d);
          end else begin
            sl.Insert(1, d);
          end;
          ThreadItem.InFavorites  :=  True;
          ThreadItem.SaveConfig;
        end;
        sl.SaveToFile(s);
        sl.Free;
        ModalResult :=  mrOk;
      end;
    end else
    if  (IsBoard) or (IsWebPage)  then  begin
      //
      //  EFuy[Wo^
      //
      sl  :=  TStringList.Create;
      s   :=  ZonuConfig.UsersPath + PATH_CONFIG + PATH_FAVORITES + FILE_BOARD;
      if  (FileExists(s)) then  begin
        sl.LoadFromFile(s);
      end else begin
        sl.Add('2');
      end;
      InsPos  :=  sl.Count - 1;
      for i :=  1 to  sl.Count - 1  do  begin
        if  (Length(sl[i]) > 0) then  begin
          if  (sl[i][1] <> #9)  then  begin
            if  (TreeView1.Selected.Text = ChooseString(sl[i], #9, 0)) then  begin
              InsPos  :=  i + 1;
              if  (SpeedButton2.Down) then  begin
                for x :=  i + 1 to  sl.Count - 1  do  begin
                  if  (Length(sl[x]) > 0) then  begin
                    if  (sl[x][1] = #9)  then  begin
                      InsPos := x + 1;
                    end else begin
                      Break;
                    end;
                  end;
                end;
              end;
              Break;
            end;
          end;
        end;
      end;
      //
      if  (IsBoard) then  begin
        s :=  #9  + FBoard.BoardPath + #9;
        if  (FBoard.BoardID <> FBoard.RemoteBoardID)  then  begin
          s :=  s + FBoard.RemoteBoardID + '>' + FBoard.BoardID;
        end else begin
          s :=  s + FBoard.RemoteBoardID;
        end;
        s :=  s + #9  +   FBoard.Name;
        {
        if  (FBoard.Site  = ZonuEnviron.UserSite) then  begin
          s :=  s + #9  + FBoard.BBS.ScriptName +
                    #9  + ExtractRelativePath(ZonuConfig.CachePath, FBoard.CachePath) +  #9;
          if  (FBoard.CharSet = csSJIS) then  begin
            s :=  s + 'SJIS';
          end else begin
            s :=  s + 'EUC';
          end;
        end;
        }
      end else begin
        ini   :=  TMemIniFile.Create(ZonuConfig.UsersPath + PATH_CONFIG + PATH_FAVORITES + INI_SITE);
        www   :=  ini.ReadInteger('WWW', 'USED', 0);
        www   :=  www + 1;
        s :=  #9  + FUrl  + #9 + Format('www%.5d', [www]) + #9 + Edit1.Text + #9 + 'www';
        ini.WriteInteger('WWW', 'USED', www);
        ini.UpdateFile;
        ini.Free;
      end;
      sl.Insert(InsPos, s);
      sl.SaveToFile(ZonuConfig.UsersPath + PATH_CONFIG + PATH_FAVORITES + FILE_BOARD);
      sl.Free;
      ModalResult :=  mrOk;
    end;
    ZonuConfig.FavoriteAddAfterEdit :=  chkAddAfterEdit.Checked;  //32
  end;
{
var
  FavFolder : TFavFolder;
  FavBoard  : TFavBoard;
  FavWebPage: TFavWebPage;
  FavApp    : TFavApplication;
  ThreadItem: TThreadItem;
  Node      : TTreeNode;
  sl: TStringList;
  s, d : string;
  i : integer;
begin
  if  (TreeView1.Selected <> nil) then  begin
    if  (TObject(TreeView1.Selected.Data) is TFavFolder) then  begin
      FavFolder :=  TFavFolder(TreeView1.Selected.Data);
      if  (IsThreadItem)  then  begin
        sl  :=  TStringList.Create;
        s   :=  ZonuConfig.UsersPath + PATH_FAVORITES + FavFolder.DirectoryName + '.txt';
        if  (FileExists(s)) then  begin
          sl.LoadFromFile(s);
        end else begin
          sl.Add(FavFolder.Title);
        end;
        for i :=  0 to  FList.Count - 1 do  begin
          if  (TObject(FList[i]) is  TFavThreadItem) then  begin
            //Xbh
            ThreadItem  :=  TFavThreadItem(FList[i]).ThreadItem;
            d   :=  ThreadItem.Site.SiteID + #9 +
                    ThreadItem.BoardID + #9  +
                    ThreadItem.DatNo + #9  +
                    ThreadItem.Title + #9  +
                    '1';
          end;
          if  (SpeedButton2.Down) and (sl.Count > 0) then  begin
            sl.Add(d);
          end else begin
            sl.Insert(1, d);
          end;
        end;
        sl.SaveToFile(s);
        sl.Free;
      end else  begin
        for i :=  0 to  FList.Count - 1 do  begin
          TreeView1.Tag := TreeView1.Tag + 1;
          Node          := TreeView1.Items.AddChild(TreeView1.Selected, TFavClass(FList[i]).Title);
          Node.Data     :=  FList[i];
        end;
      end;
      SaveFavorites(TreeView1);
      ModalResult :=  mrOk;
    end else begin
      MessageDlg('tH_IĂB', mtError, [mbOk], 0);
      TreeView1.SetFocus;
    end;
  end else begin
    MessageDlg('ۑ̃tH_IĂB', mtError, [mbOk], 0);
    TreeView1.SetFocus;
  end;
}
end;

procedure TFavoriteDialog.N1Click(Sender: TObject);
var
  ABoard: TBoard;
  Board: TBoard;
  b : boolean;
  i : integer;  
begin
  ABoard :=  nil;
  if  (TreeView1.Selected <> nil)  then  begin
    if  (TreeView1.Selected.Data <> nil)  then  begin
      if  (TObject(TreeView1.Selected.Data) is TBoard)  then  begin
        ABoard :=  TBoard(TreeView1.Selected.Data);
      end;
    end;
  end;
  BoardEditor               :=  TBoardEditor.Create(Self);
  BoardEditor.Site          :=  ZonuEnviron.FavoritesSite;
  if  (ABoard <> nil)  then  begin
    BoardEditor.CategoryName  :=  ABoard.CategoryName;
  end else begin
    if  (TreeView1.Selected <> nil) then  begin
      BoardEditor.CategoryName  :=  TreeView1.Selected.Text;
    end else begin
      BoardEditor.CategoryName  :=  '';
    end;
  end;
  BoardEditor.EditMode      :=  emNew;

  BoardEditor.grpCharSet.Enabled  :=  False;  //7

  if  (BoardEditor.ShowModal = mrOk)  then  begin
    Board               :=  TBoard.Create;
    Board.Site          :=  ZonuEnviron.FavoritesSite;
    Board.Name          :=  BoardEditor.BoardName;
    Board.BoardPath     :=  BoardEditor.BoardPath;
    Board.BoardID       :=  BoardEditor.BoardID;
    Board.Url           :=  BoardEditor.Path;
    Board.Key           :=  BoardEditor.BoardID;
    Board.Expanded      :=  True;
    Board.CategoryName  :=  BoardEditor.CategoryName;
    Board.BBS           :=  ZonuEnviron.FavoritesSite.BBS;
    Board.CharSet       :=  ZonuEnviron.FavoritesSite.CharSet;
    Board.Gaishutu      :=  False;
    b :=  False;
    for i :=  ZonuEnviron.FavoritesSite.BoardList.Count - 1  downto  0 do  begin
      if  (ZonuEnviron.FavoritesSite.BoardList[i].CategoryName = Board.CategoryName) then  begin
        ZonuEnviron.FavoritesSite.BoardList.Insert(i + 1, Board);
        b :=  True;
        Break;
      end;
    end;
    if  (not b) then  ZonuEnviron.FavoritesSite.BoardList.Add(Board);
    ZonuEnviron.FavoritesSite.BoardList.SaveToFile(ZonuEnviron.FavoritesSite.ConfigPath + FILE_BOARD);
    ZonuEnviron.FavoritesSite.BoardList.Clear;
    ZonuEnviron.FavoritesSite.LoadBoardList;
    SaveBoardListSetting(TreeView1, ZonuEnviron.FavoritesSite);
    BuildBoardList(TreeView1, ZonuEnviron.FavoritesSite);
  end;
  BoardEditor.Release;
{
var
  FavFolder	:	TFavFolder;
  Node : TTreeNode;
begin
  TreeView1.SetFocus;
  TreeView1.Tag := TreeView1.Tag + 1;
  Node  :=  TreeView1.Items.AddChild(TreeView1.Selected, 'VtH_');
  TreeView1.Selected.Expand(False);
  FavFolder                 :=  TFavFolder.Create;
  FavFolder.Title           :=  Node.Text;
  FavFolder.DirectoryName   :=  Format('fav%.5d', [TreeView1.Tag]);
  Node.Data           :=  FavFolder;
  Node.ImageIndex     :=  7;
  Node.SelectedIndex  :=  8;
  Node.EditText;
}
end;

procedure TFavoriteDialog.D1Click(Sender: TObject);
begin
  {
  if  (TreeView1.Selected <> nil) then  begin
    TFavFolder(TreeView1.Selected.Data).Free;
    TreeView1.Selected.Delete;
  end;
  }
end;

procedure TFavoriteDialog.N3Click(Sender: TObject);
begin
  {
  if  (TreeView1.Selected <> nil) then  begin
    if  (TreeView1.Selected.GetPrevSibling <> nil)  then  begin
      if  (TreeView1.Selected) = (TreeView1.Selected.Parent.GetLastChild) then  begin
        TreeView1.Selected.GetPrevSibling.MoveTo(TreeView1.Selected, naAdd);
      end else begin
        TreeView1.Selected.GetPrevSibling.MoveTo(TreeView1.Selected.GetNextSibling, naInsert);
      end;
    end;
  end;
  }
end;

procedure TFavoriteDialog.N4Click(Sender: TObject);
begin
  {
  if  (TreeView1.Selected <> nil) then  begin
    if  (TreeView1.Selected.GetNextSibling <> nil)  then  begin
      TreeView1.Selected.GetNextSibling.MoveTo(TreeView1.Selected, naInsert);
    end;
  end;
  }
end;

procedure TFavoriteDialog.Rename1Click(Sender: TObject);
begin
  {
  if  (TreeView1.Selected <> nil) then  begin
    TreeView1.Selected.EditText;
  end;
  }
end;

procedure TFavoriteDialog.TreeView1Edited(Sender: TObject; Node: TTreeNode;
  var S: String);
begin
  {
var
  FavFolder	:	TFavFolder;
begin
  FavFolder                 :=  TFavFolder(Node.Data);
  FavFolder.Title           :=  S;
  }
end;

procedure TFavoriteDialog.FormShow(Sender: TObject);
begin
  if  (IsThreadItem)  then  begin
    if  (FList.Count > 0) then  begin
      Edit1.Text  :=  TThreadItem(FList[0]).Title;
      if  (FList.Count > 1) then  begin
        Edit1.Text  :=  Edit1.Text + '...';
      end;
    end else begin
      Edit1.Text  :=  '';
    end;
    Edit1.ReadOnly  :=  True;
    Label1.Caption  :=  '̃XbhCɓɓo^܂B';
  end else
  if  (IsWebPage)  then  begin
    Edit1.Text      :=  FTitle;
    Edit1.ReadOnly  :=  False;
    Label1.Caption  :=  '̃y[WCɓɓo^܂B';
  end else
  if  (IsBoard) then  begin
    Edit1.Text      :=  FBoard.Name;
    Edit1.ReadOnly  :=  True;
    Label1.Caption  :=  '̔Cɓɓo^܂B';
  end;
end;

procedure TFavoriteDialog.TreeView1Change(Sender: TObject;
  Node: TTreeNode);
begin
  if  (Node = nil)  then  begin
    Button1.Enabled :=  False;
  end else begin
    if  (IsThreadItem)  then  begin
      Button1.Enabled :=  False;
      if  (Node.Data <> nil)  then  begin
        if  (TBoard(Node.Data).BoardType = btFavorites)  then  begin
          Button1.Enabled :=  True;
        end;
      end;
    end else
    if  (IsWebPage) or (IsBoard)  then  begin
      Button1.Enabled :=  (Node.Data = nil);
    end;
  end;
end;

end.
