{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Hee Dialog Unit                                                   }
{                                                                             }
{ 2001-04 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Heedlg;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Dlghead, StdCtrls, HttpProt, ExtCtrls;

type
  THeeDialog = class(TForm)
    HeaderFrame1: THeaderFrame;
    HttpCli1: THttpCli;
    Panel1: TPanel;
    Button3: TButton;
    lblTitle: TLabel;
    lblScore: TLabel;
    lblUrl: TLabel;
    Bevel1: TBevel;
    Label3: TLabel;
    Label4: TLabel;
    procedure Label4Click(Sender: TObject);
    procedure lblUrlClick(Sender: TObject);
  private
    { Private 錾 }
    FHttpStream : TStringStream;
    FThreadUrl: string;
    FThreadTitle: string;
  public
    { Public 錾 }
    procedure Init(const AThreadTitle, AThreadUrl: string);
    procedure ExecHee;
  end;

var
  HeeDialog: THeeDialog;

implementation

{$R *.dfm}

uses
  ZonuConf, ZonuClass, MonaUtils, Hzbconst, jconvert, Hzbfunc;
  
procedure THeeDialog.Init(const AThreadTitle, AThreadUrl: string);
begin
  FThreadTitle    :=  AThreadTitle;
  FThreadUrl      :=  AThreadUrl;
  lblTitle.Caption    :=  AThreadTitle;
  lblUrl.Caption      :=  AThreadUrl;
  lblScore.Caption    :=  '';
end;

procedure THeeDialog.ExecHee;
var
  sl: TStringList;
  s: string;
  i: integer;
begin
  Screen.Cursor :=  crHourGlass;
  FHttpStream   :=  TStringStream.Create('');
  if  (ZonuConfig.ProxyUse) then  begin
    HttpCli1.Proxy          :=  ZonuConfig.Proxy;
    HttpCli1.ProxyPort      :=  ZonuConfig.ProxyPort;
    HttpCli1.ProxyUsername  :=  ZonuConfig.ProxyUserName;
    HttpCli1.ProxyPassword  :=  ZonuConfig.ProxyPassword;
  end;
  HttpCli1.Agent            :=  USER_AGENT;
  FHttpStream.Position      :=  0;
  FHttpStream.Size          :=  0;
  HttpCli1.RcvdStream       :=  FHttpStream;
  s   :=  ZonuConfig.HeeUrl;
  s   :=  StringReplace(s, '<THREADURL/>',  FThreadUrl,   [rfReplaceAll, rfIgnoreCase]);
  s   :=  StringReplace(s, '<THREADNAME/>', FThreadTitle, [rfReplaceAll, rfIgnoreCase]);
  HttpCli1.URL              :=  s;

  HttpCli1.Get;

  if  (HttpCli1.StatusCode = 200) then  begin
    sl      :=  TStringList.Create;
    sl.Text :=  jconvert.ConvertJCode(FHttpStream.DataString, SJIS_OUT);
    for i :=  0 to  sl.Count - 1  do  begin
      if  (Pos('ւ</td></tr>', sl[i]) > 0)  then  begin
        s :=  Copy(sl[i], AnsiPos('</a>', sl[i]) + 4, Length(sl[i]));
        s :=  Copy(s, 1, AnsiPos('</td></tr>', s) - 1);
        lblScore.Caption  :=  s;
      end;
    end;
  end;

  Screen.Cursor     :=  crDefault;
end;

procedure THeeDialog.Label4Click(Sender: TObject);
begin
  Open(URL_HEE);
end;

procedure THeeDialog.lblUrlClick(Sender: TObject);
begin
  Open(FThreadUrl);
end;

end.
