{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Update Checker Unit                                               }
{                                                                             }
{ 2001-04 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Hzbchk;

interface

uses
  Classes, SysUtils, HttpProt;

type
  THZbCommand = (zcNow, zcUpdate, zcUpdateForce, zcStop, zcError, zcOffline);
  THzbCheck = class(TThread)
  private
    { Private 錾 }
    HttpCli1: THTTPCli;
    FCheckedEvt: TNotifyEvent;
    FCommand: THzbCommand;
    FHttpStream : TStringStream;
    procedure AfterCheck;
  protected
    procedure Execute; override;
  public
    property  OnChecked: TNotifyEvent read  FCheckedEvt  write  FCheckedEvt;
    property  Command: THzbCommand  read  FCommand  write FCommand;
  end;

implementation

uses
  Hzbconst, Zonuconf, ZonuClass;

{ THzbCheck }

procedure THzbCheck.Execute;
var
  s : string;
begin
  if  (ZonuEnviron.State = asOnline)  then  begin
    FCommand      :=  zcNow;
    HttpCli1      :=  THTTPCli.Create(nil);
    FHttpStream   :=  TStringStream.Create('');
    if  (ZonuConfig.ProxyUse) then  begin
      HttpCli1.Proxy          :=  ZonuConfig.Proxy;
      HttpCli1.ProxyPort      :=  ZonuConfig.ProxyPort;
      HttpCli1.ProxyUsername  :=  ZonuConfig.ProxyUserName;
      HttpCli1.ProxyPassword  :=  ZonuConfig.ProxyPassword;
    end;
    HttpCli1.Agent            :=  USER_AGENT;
    FHttpStream.Position      :=  0;
    FHttpStream.Size          :=  0;
    HttpCli1.RcvdStream       :=  FHttpStream;
    HttpCli1.NoCache          :=  True;
    HttpCli1.URL              :=  URL_HOTZONU_INFO + HOTZONU_VERSION + '.txt';
    try
      HttpCli1.Get;
      if  (HttpCli1.StatusCode = 200) then  begin
        s :=  FHttpStream.DataString;
        if  (s = 'now') then  begin
          //݂̃o[W
          FCommand  :=  zcNow;
        end else
        if  (s = 'stop') then  begin
          //IR}h
          FCommand  :=  zcStop
        end else
        if  (s = 'update') then  begin
          //Vo[WoĂ
          FCommand  :=  zcUpdate;
        end else
        if  (s = 'updateforce') then  begin
          //Vo[WoĂ|I
          FCommand  :=  zcUpdateForce;
        end;
        Synchronize(AfterCheck);
      end else begin
        FCommand  :=  zcError;
        Synchronize(AfterCheck);
      end;
    finally
      HttpCli1.Free;
      FHttpStream.Free;
    end;
  end else begin
    FCommand  :=  zcOffline;
    Synchronize(AfterCheck);
  end;
end;

procedure THzbCheck.AfterCheck;
begin
  if  (Assigned(FCheckedEvt)) then  begin
    FCheckedEvt(Self);
  end;
end;

end.
