{ *************************************************************************** }
{                                                                             }
{ Hotzonu Class Library                                                       }
{                                                                             }
{ 2001-04 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Hzbclass;

interface

uses
  Classes, ComCtrls, SysUtils, EmbeddedWB, StdCtrls, ZonuClass, Forms, Controls,
  Types, Graphics, Windows, MSHTML, OleCtrls, EnhListView, ExtListView, HTTPApp,
  Menus, ShellApi, IniFiles, ActnList, ZonuHttp, {Ngword,} ZonuShortcutBar,
  Dialogs, ZonuAction;

type
  TThreadListToolButton = class;
  TBrowserToolButton    = class;
  TThreadListMenuItem   = class;
  TBrowserMenuItem      = class;
  TZonuListDoc          = class;
  TZonuBrowser          = class;
  TTabData = class;
  TShortcutData = class;

  TListDocKind  = (lkThreadList, lkFavorites, lkFindPage, lkFilter, lkHeadline);
  TBrowserKind  = (bkThreadItem, bkFilter);
  TViewState    = (vsReady, vsDownloading, vsCacheLoading);

  TZonuToolButton = class(TToolButton)
  private
    FExecCloseEvt: TNotifyEvent;
    FExecReloadEvt: TNotifyEvent;
  public
    procedure FireExecReload;
    procedure FireExecClose;
    property  OnExecReload: TNotifyEvent  read  FExecReloadEvt  write FExecReloadEvt;
    property  OnExecClose: TNotifyEvent  read FExecCloseEvt  write FExecCloseEvt;
  end;
  
  //
  //  Xbhꗗpc[{^
  //
  TThreadListToolButton = class(TZonuToolButton)
  private
    FListDoc: TZonuListDoc;
    FSeparator: TToolButton;
  public
    property  ListDoc: TZonuListDoc read  FListDoc  write FListDoc;
    property  Separator: TToolButton  read  FSeparator  write FSeparator;
  end;

  //
  //  uEUpc[{^
  //
  TBrowserToolButton = class(TZonuToolButton)
  private
    FBrowser: TZonuBrowser;
    FSeparator: TToolButton;
  public
    property  Browser: TZonuBrowser read  FBrowser  write FBrowser;
    property  Separator: TToolButton  read  FSeparator  write FSeparator;
  end;

  TThreadListMenuItem   = class(TMenuItem)
  private
    FListDoc: TZonuListDoc;
  public
    procedure Clicked(Sender: TObject);
    property  ListDoc: TZonuListDoc read  FListDoc  write FListDoc;
  end;

  TBrowserMenuItem      = class(TMenuItem)
  private
    FBrowser: TZonuBrowser;
  public
    procedure Clicked(Sender: TObject);
    property  Browser: TZonuBrowser read  FBrowser  write FBrowser;
  end;

  TSearchEngineMenuItem   = class(TMenuItem)
  private
    FUrl: string;
  public
    property  Url: string read  FUrl  write FUrl;
  end;

  TGaishutuMenuItem = class(TMenuItem)
  private
    FBoardID: string;
    FBBS: TBBS;
    FSite: TSite;
  public
    property  BBS : TBBS  read  FBBS  write FBBS;
    property  Site: TSite read  FSite write FSite;
    property  BoardID : string  read  FBoardID  write FBoardID;
  end;

  TThreadMenuItem   = class(TMenuItem)
  private
    FThreadItem: TThreadItem;
  public
    //procedure Clicked(Sender: TObject);
    property  ThreadItem: TThreadItem   read  FThreadItem write FThreadItem;
  end;

  TRecentMenuItem   = class(TMenuItem)
  private
    //FThreadItem: TThreadItem;
    FSiteID: string;
    FDatNo: string;
    FBoardID: string;
    FTitle: string;
  public
    //procedure Clicked(Sender: TObject);
    property  SiteID: string  read  FSiteID   write FSiteID;
    property  BoardID: string read  FBoardID  write FBoardID;
    property  DatNo: string   read  FDatNo    write FDatNo;
    property  Title: string   read  FTitle    write FTitle;
  end;

  {
  }

  //
  //  Oo̓C^[tFCX
  //
  IZonuStream = interface
    procedure InitOutputRes;
    procedure WriteRes(Res: TRes);
    procedure EndOutputRes;
    procedure NgData(Res: TRes; Action: TZonuAction);
    function  GetBoard: TBoard;
    function  GetShowAll: boolean;
    function  ForceCurrentThradItem: boolean; //12
  end;

  //
  //  Xo̓NX
  //
  TZonuResWriter = class(TObject)
  private
    FSkinHeader : TStringList;
    FSkinRes  : TStringList;
    FSkinNewRes  : TStringList;
    FSkinFooter  : TStringList;
    FSkinToday  : TStringList;
    FSkinSiori  : TStringList;
    FSkinReadPoint  : TStringList;
    FSkinSioriBegin  : TStringList;
    FSkinSioriEnd  : TStringList;
    FSkinTodayBegin  : TStringList;
    FSkinTodayEnd  : TStringList;
    FSkinNewMark: TStringList;  //age16
    FKatjushaSkin: boolean;
    FSkinPath: string;
    FSkinUrl: string;
    FModulePath: string;
    FModuleUrl: string;
    FResList : TResList;
    FHotzonuSkin: boolean;
    FHelpPath: string;
    FHelpUrl: string;
    FNew: boolean;
    FIDPopup: boolean;  //10
    FRenderImage: boolean; //13
    FImageSize: integer; //13
    FBoard: TBoard; //26
    FRenderImageNewOnly: boolean; //37
    procedure ReplaceSkinTag(var S: string);
    procedure SetSkinPath(const Value: string);
    procedure SetKatjushaSkin(const Value: boolean);
    procedure SetHotzonuSkin(const Value: boolean);
    procedure ConvertKatjushaSkin;
    procedure ConvertHotzonuSkin;
    procedure ConvertStdSkin;
  public
    constructor Create(ResList: TResList);
    destructor  Destroy; override;
    function  WriteRes(Res: TRes): string;
    function  WriteHeader: string;
    function  WriteFooter: string;
    property  SkinPath: string  read  FSkinPath write SetSkinPath;
    property  KatjushaSkin: boolean read  FKatjushaSkin write SetKatjushaSkin;
    property  HotzonuSkin: boolean read  FHotzonuSkin write SetHotzonuSkin;
    property  IDPopup: boolean  read  FIDPopup  write FIDPopup;
    property  RenderImage: boolean  read  FRenderImage  write FRenderImage; //13
    property  ImageSize: integer  read  FImageSize  write FImageSize; //13
    property  Board: TBoard read  FBoard  write FBoard; //26
    property  RenderImageNewOnly: boolean read FRenderImageNewOnly write FRenderImageNewOnly; //37
  end;

  //
  //  t@Co̓NX
  //
  TZonuStrings  = class(TStringList)
  private
    FBoardID: string;
    FSite: TSite;
  protected
    function QueryInterface(const IID: TGUID; out Obj): HResult; stdcall;
    function _AddRef: Integer; stdcall;
    function _Release: Integer; stdcall;
  public
    property  BoardID: string read  FBoardID  write FBoardID;
    property  Site: TSite read  FSite write FSite;
  end;

  //
  //  DATt@Co̓NX
  //
  TZonuDatStrings  = class(TZonuStrings, IZonuStream)
  private
    FSeparator: string;
    FShowAll: boolean;
  public
    constructor Create;
    procedure InitOutputRes;  {IZonuStream}
    procedure WriteRes(Res: TRes); {IZonuStream}
    procedure EndOutputRes;  {IZonuStream}
    procedure NgData(Res: TRes; Action: TZonuAction);  {IZonuStream}
    function  GetBoard: TBoard;
    function  GetShowAll: boolean;
    function  ForceCurrentThradItem: boolean; //12
    property  Board: TBoard read  GetBoard;
    property  Separator: string read  FSeparator  write FSeparator;
    property  ShowAll: boolean  read  GetShowAll  write FShowAll;
  end;

  //
  //  HTMLt@Co̓NX
  //
  TZonuHtmlStrings  = class(TZonuStrings, IZonuStream)
  private
    FResWriter: TZonuResWriter;
    FResList: TResList;
    FKatjushaSkin: boolean;
    FSkinPath: string;
    FHotzonuSkin: boolean;
    FShowAll: boolean;
    FIDPopup: boolean;  //10
    FRenderImage: boolean; //13
    FImageSize: integer; //13
    XBoard: TBoard; //26
    FRenderImageNewOnly: boolean; //37
  public
    constructor Create;
    destructor  Destroy; override;
    function  GetBoard: TBoard;
    function  GetShowAll: boolean;
    function  ForceCurrentThradItem: boolean; //12
    procedure InitOutputRes;  {IZonuStream}
    procedure WriteRes(Res: TRes); {IZonuStream}
    procedure EndOutputRes;  {IZonuStream}
    procedure EndOutputResNoFooter;
    procedure NgData(Res: TRes; Action: TZonuAction);  {IZonuStream}
    procedure InitSkin(ABoard: TBoard);
    property  Board: TBoard read  GetBoard;
    property  ResList: TResList read  FResList  write FResList;
    property  _SkinPath: string  read  FSkinPath write FSkinPath;
    property  _KatjushaSkin: boolean read  FKatjushaSkin write FKatjushaSkin;
    property  _HotzonuSkin: boolean read  FHotzonuSkin write FHotzonuSkin;
    property  _IDPopup: boolean read  FIDPopup write FIDPopup; //10
    property  _RenderImage: boolean  read  FRenderImage  write FRenderImage; //13
    property  _ImageSize: integer  read  FImageSize  write FImageSize; //13
    property  _RenderImageNewOnly: boolean read FRenderImageNewOnly write FRenderImageNewOnly; //37
    property  ShowAll: boolean  read  GetShowAll  write FShowAll;
  end;

  //
  //  qg
  //
  TZonuHintWindow = class(THintWindow, IZonuStream)
  private
    FRes: string;
    FBoard: TBoard;
    FShowAll: boolean;
    function GetShowAll: boolean;
  protected
    procedure Paint; override;
  public
    constructor Create(AOwner: TComponent); override;
    function _AddRef: Integer; stdcall;
    function _Release: Integer; stdcall;
    function  ForceCurrentThradItem: boolean; //12
    procedure ShowAtCursorPos(const Text: string);
    procedure Show(const Text: string; const p: TPoint);
    procedure ShowThreadInfo(const SiteName, BoardName, ThreadName: string); overload;
    procedure ShowThreadInfo(const SiteName, BoardName, ThreadName: string;
      ResList: TResList); overload;
    procedure ShowRangeRes(ResList: TResList; Prefix: string = ''); //WriteResŎgp
    procedure InitOutputRes;  {IZonuStream}
    procedure WriteRes(Res: TRes); {IZonuStream}
    procedure EndOutputRes;  {IZonuStream}
    procedure NgData(Res: TRes; Action: TZonuAction);  {IZonuStream}
    function  GetBoard: TBoard;
    property  ShowAll: boolean  read  GetShowAll  write FShowAll;
    property  Board: TBoard read  FBoard  write FBoard;
  end;

  //
  //  uEUo̓NX
  //
  TZonuBrowser  = class(TEmbeddedWB, IZonuStream)
  private
    FResList: TResList;
    FThreadItem: TThreadItem;
    FResNo: integer;
    FSkinPath: string;
    {
    FSkinHeader : TStringList;
    FSkinRes  : TStringList;
    FSkinNewRes  : TStringList;
    FSkinFooter  : TStringList;
    FSkinToday  : TStringList;
    }
    FKatjushaSkin: boolean;
    FFiltered: boolean;
    FNode: TTreeNode;
    FOldTop: integer;
    FIsWebPage: boolean;
    FLoaded: boolean;
    FTitle: string;
    FUrlComboBox: TComboBox;
    FUrl: string;
    FPopupResNo: integer;
    FResWriter: TZonuResWriter;
    FWriteCount: integer;
    FNavigateLock: boolean;
    FThreadInfoLabel: TLabel;
    FActiveEvt: TNotifyEvent;
    FPageKill: boolean;
    FBoardID: string;
    FToolButton: TBrowserToolButton;
    FState: TViewState;
    FKind: TBrowserKind;
    FMenuItem: TBrowserMenuItem;
    FHotzonuSkin: boolean;
    FShowAll: boolean;
    FIDPopup: boolean;  //10
    FRenderImage: boolean; //13
    FImageSize: integer; //13
    FPopupResID: string; //10
    FPopupResBE: string; //11
    FReleased: boolean; //14
    FIgnoreNavigateDialog: boolean;
    FFilterCount: integer;
    FFilterText: string;
    FRenderImageNewOnly: boolean; //14
    procedure SetIsWebPage(const Value: boolean);
    procedure SetFiltered(const Value: boolean);
  public
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;
    function GetBoard: TBoard;
    function  ForceCurrentThradItem: boolean; //12
    procedure Init;
    procedure Release;
    procedure WriteHeader;
    procedure InitOutputRes;  {IZonuStream}
    procedure WriteRes(Res: TRes); {IZonuStream}
    procedure EndOutputRes;  {IZonuStream}
    procedure WriteFooter; //7
    procedure NgData(Res: TRes; Action: TZonuAction);  {IZonuStream}
    procedure CancelDownload;
    procedure ScrollTo(ResNo: integer);
    procedure Active;
    procedure ResetTabImage;
    procedure FireActive;
    procedure Clear;
    procedure InitSkin(ABoard: TBoard); overload;
    procedure InitSkin(const ASiteID, ABoardID: string); overload;
    procedure SetBrowserMode; //age16
    function GetCheckRes(AResList: TResList): boolean;
    function GetTopResNo: integer;
    function GetResTopPosition(const Index: integer): integer;
    function StrToResNo(const ZonuLink: string): integer;
    function GetSelectedText: string;
    function  GetShowAll: boolean;
    property  Board: TBoard read  GetBoard;
    property  BoardID: string read  FBoardID  write FBoardID;
    property  ResList:  TResList  read  FResList  write FResList;
    property  ThreadItem : TThreadItem  read  FThreadItem write FThreadItem;
    property  State: TViewState  read  FState write FState;
    property  ThreadInfoLabel: TLabel read  FThreadInfoLabel  write FThreadInfoLabel;
    property  UrlComboBox: TComboBox  read  FUrlComboBox  write FUrlComboBox;
    property  ResNo: integer  read  FResNo  write FResNo; //[hWv
    property  _SkinPath: string  read  FSkinPath write FSkinPath;
    property  _KatjushaSkin: boolean read  FKatjushaSkin write FKatjushaSkin;
    property  _HotzonuSkin: boolean read  FHotzonuSkin write FHotzonuSkin;
    property  _IDPopup: boolean read  FIDPopup write FIDPopup;  //10
    property  _RenderImage: boolean  read  FRenderImage  write FRenderImage; //13
    property  _ImageSize: integer  read  FImageSize  write FImageSize; //13
    property  _RenderImageNewOnly: boolean read FRenderImageNewOnly write FRenderImageNewOnly; //37
    property  Node: TTreeNode read  FNode write FNode;  //{[hm[h
    property  OldTop: integer read  FOldTop write FOldTop;
    property  Filtered: boolean read  FFiltered write SetFiltered;
    property  IsWebPage: boolean  read  FIsWebPage  write SetIsWebPage;
    property  Title: string read  FTitle  write FTitle; //WebPagê
    property  Url: string read  FUrl  write FUrl;
    property  PopupResNo: integer read  FPopupResNo write FPopupResNo;
    property  PopupResID: string  read  FPopupResID write FPopupResID; //10
    property  PopupResBE: string  read  FPopupResBE write FPopupResBE; //11
    property  WriteCount: integer read  FWriteCount write FWriteCount; //o͂X̐
    property  NavigateLock: boolean read FNavigateLock  write FNavigateLock;
    property  PageKill: boolean read  FPageKill write FPageKill;  //|bvAbv}~ΏۂɂȂ
    property  ToolButton: TBrowserToolButton  read  FToolButton  write FToolButton;
    property  MenuItem: TBrowserMenuItem  read  FMenuItem  write FMenuItem;
    property  Kind: TBrowserKind  read  FKind write FKind;
    property  ShowAll: boolean  read  GetShowAll  write FShowAll;
    property  IgnoreNavigateDialog: boolean read  FIgnoreNavigateDialog write FIgnoreNavigateDialog; //14  
    property  OnActive: TNotifyEvent  read  FActiveEvt  write FActiveEvt;
    property  FilterText: string  read FFilterText write FFilterText;
    property  FilterCount: integer read FFilterCount write FFilterCount; 
  end;

  //
  //  Xbhꗗ\NX
  //
  TZonuListDoc = class(TObject)
  private
    FAscend: boolean;
    FNavigateLock: boolean;
    FSortIndex: integer;
    FPageIndex: integer;
    FSelectedIndex: integer;
    FTopIndex: integer;
    FDefaultShowCount: integer;
    FShowCount: integer;
    FOldSubjectTxt: TStringList;
    FTitle: string;
    FBoardID: string;
    FListView: TdfsExtListView;
    FActiveEvt: TNotifyEvent;
    FThreadItemList: TThreadItemList;
    FNode: TTreeNode;
    FToolButton: TThreadListToolButton;
    FKind: TListDocKind;
    FState: TViewState;
    FMenuItem: TThreadListMenuItem;
    FRounding: boolean;
    FCheckObject: TObject;
    FAllThreadItemList: TThreadItemList;
    FInfFileList: TStringList;
    function GetBoard: TBoard;
    procedure SetShowCount(const Value: integer);
    procedure SetNavigateLock(const Value: boolean);
    function GetNewCount: integer;
  public
    constructor Create;
    destructor  Destroy; override;
    procedure Active;
    procedure FireActive;
    procedure AddThreadItem(ThreadItem: TThreadItem;
       const LoadFromCache: boolean = True);
    procedure LoadOldSubjectTxt;
    procedure LoadFromFile(const FileName: string = '');
    procedure SaveSubjectTxt;
    procedure SaveToFile(const FileName: string = '');
    procedure CancelDownload;
    procedure ResetTabImage;
    procedure LoadInfFileList;
    procedure orzSave(const Path: string);
    procedure orzLoad(const Path: string);
    property  Title: string read  FTitle  write FTitle;
    property  Board: TBoard read  GetBoard;
    property  BoardID: string read  FBoardID  write FBoardID;
    property  ThreadItemList: TThreadItemList read  FThreadItemList write FThreadItemList;
    property  AllThreadItemList: TThreadItemList read  FAllThreadItemList write FAllThreadItemList;
    property  State: TViewState read  FState  write FState;
    property  Rounding: boolean  read  FRounding  write FRounding;
    property  ListView: TdfsExtListView read  FListView write FListView;
    property  ShowCount: integer  read  FShowCount  write SetShowCount;
    property  DefaultShowCount: integer  read  FDefaultShowCount  write FDefaultShowCount;
    property  PageIndex: integer  read  FPageIndex  write FPageIndex;
    property  TopIndex : integer  read  FTopIndex   write FTopIndex;
    property  SelectedIndex: integer  read  FSelectedIndex  write FSelectedIndex;
    property  Ascend: boolean read  FAscend write FAscend;
    property  SortIndex: integer  read  FSortIndex  write FSortIndex;
    property  Node: TTreeNode read  FNode write FNode;  //{[hm[h
    property  NavigateLock: boolean read  FNavigateLock write SetNavigateLock;
    property  ToolButton: TThreadListToolButton  read  FToolButton  write FToolButton;
    property  MenuItem: TThreadListMenuItem read  FMenuItem write FMenuItem;
    property  Kind: TListDocKind  read  FKind write FKind;
    property  CheckObject: TObject read  FCheckObject  write FCheckObject; //IuWFNg
    property  NewCount: integer read  GetNewCount;
    property  OnActive: TNotifyEvent read FActiveEvt  write FActiveEvt;
  end;

  //
  //  :TResCacheLoader
  //
  TResCacheLoader = class(TThread)
  private
    FViewObject: TObject;
    FThreadItem: TThreadItem;
    FEndEvt: TNotifyEvent;
    FDownloader: TResDownloader;
    FResList: TResList;
    NewHtmlStrings: TZonuHtmlStrings;
    FProgressEvt: TNotifyEvent;
    procedure FireEndEvt;
    procedure FireProgressEvt;
  protected
    procedure Execute; override;
  public
    constructor Create(CreateSuspended: Boolean; AResList: TResList);
    destructor Destroy; override;
    property  ViewObject: TObject   read  FViewObject   write FViewObject;
    property  ThreadItem: TThreadItem read  FThreadItem write FThreadItem;
    property  ResList:  TResList  read  FResList  write FResList;
    property  Downloader: TResDownloader  read  FDownloader write FDownloader;
    property  Strings:  TZonuHtmlStrings  read  NewHtmlStrings  write NewHtmlStrings;
    property  OnProgress: TNotifyEvent  read  FProgressEvt   write FProgressEvt;
    property  OnEnd:  TNotifyEvent  read  FEndEvt   write FEndEvt;
  end;

  TToolMenuItem = class(TMenuItem)
  private
    FTitle: string;
    FFilePath: string;
    FWorkDir: string;
    FParams: string;
    FParamUrl: boolean;
  public
    property  Title: string read  FTitle  write FTitle;
    property  FilePath : string read  FFilePath   write FFilePath;
    property  WorkDir : string  read  FWorkDir  write FWorkDir;
    property  Params: string  read  FParams write FParams;
    property  ParamUrl: boolean  read  FParamUrl write FParamUrl;
  end;

  TZonuMenuItem = class(TMenuItem)
  private
    FData: Pointer;
  public
    property  Data: Pointer  read  FData write FData;
  end;

  TTabData = class(TPersistent)
  private
    FTitle: string;
    FBitmapFileName: string;
    FColor: TColor;
    FList: TList;
    FBitmap: Graphics.TBitmap;
    function GetShortcuts(Index: integer): TShortcutData;
    procedure SetShotcuts(Index: integer; const Value: TShortcutData);
    function GetShortcutCount: integer;
    procedure SetBitmapFileName(const Value: string);
  public
    constructor Create;
    destructor  Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function  Add: TShortcutData;
    function  Insert(const Index: integer): TShortcutData;
    procedure Delete(Index: integer);
    property  Title: string   read  FTitle    write FTitle;
    property  Color: TColor   read  FColor    write FColor;
    property  BitmapFileName: string  read  FBitmapFileName   write SetBitmapFileName;
    property  Shortcuts[Index: integer]: TShortcutData  read  GetShortcuts  write SetShotcuts;
    property  ShortcutCount: integer  read  GetShortcutCount;
    property  Bitmap: Graphics.TBitmap read  FBitmap write FBitmap;
  end;

  TShortcutData = class(TPersistent)
  private
    FParam1: string;
    FTitle: string;
    FParam2: string;
    FParam3: string;
    FObjectType: TObjectType;
  public
    procedure Assign(Source: TPersistent); override;
    property  Title: string read  FTitle  write FTitle;
    property  Param1: string  read  FParam1 write FParam1;
    property  Param2: string  read  FParam2 write FParam2;
    property  Param3: string  read  FParam3 write FParam3;
    property  ObjectType: TObjectType read  FObjectType write FObjectType;
  end;

  TBBSToolButton = class(TToolButton)
  private
    FSite: TSite;
  public
    property  Site: TSite read  FSite write FSite;
  end;


implementation

{ TZonuListDoc }

uses
  Main, Hzbconst, ZonuCommon, ZonuConf, MonaUtils, Zonutils, Hzbfunc,
  HzbDatConv, ActiveX;

constructor TZonuListDoc.Create;
begin
  FThreadItemList   :=  nil;
  FAllThreadItemList:=  nil;
  FOldSubjectTxt    :=  TStringList.Create;
  FRounding         :=  False;
  FCheckObject      :=  nil;
  FInfFileList      :=  TStringList.Create;
end;

destructor TZonuListDoc.Destroy;
begin
  if  (FThreadItemList <> nil)  then  begin
    FreeAndNil(FThreadItemList)
  end;
  if  (FAllThreadItemList <> nil)  then  begin
    FreeAndNil(FAllThreadItemList)
  end;
  FOldSubjectTxt.Free;
  FInfFileList.Free;
  inherited;
end;

procedure TZonuListDoc.LoadOldSubjectTxt;
var
  FileName : string;
begin
  FileName  :=  Board.CachePath + 'subject.dat';
  if  (FileExists(FileName))  then  begin
    FOldSubjectTxt.LoadFromFile(FileName);
    FOldSubjectTxt.Sort;
  end;
end;

procedure TZonuListDoc.LoadFromFile(const FileName: string);
var
  ADatNo, ATitle  : string;
  ACount          : integer;
  ThreadItem      : TThreadItem;
  ActiveListDoc   : TZonuListDoc;
  sl  : TStringList;
  i   : integer;
  s   : string;
  procedure Reset;
  begin
    if  (ThreadItemList.Count < ZonuConfig.ThreadListCount + 1) then  begin
      ShowCount :=  ThreadItemList.Count;
    end else begin
      ShowCount :=  ZonuConfig.ThreadListCount;
    end;
    if  (HotzonuWindow.GetActiveListDoc(ActiveListDoc))  then  begin
      if  (ActiveListDoc = Self)  then  begin
        HotzonuWindow.ThreadListVIew.Items.Count := ShowCount;
      end;
    end;
  end;
begin
  LoadOldSubjectTxt;
  if  (FileName = '') then  begin
    s :=  Board.CachePath + 'subject.txt';
  end else begin
    s :=  FileName;
  end;
  if  (FileExists(s)) then  begin
    sl  :=  TStringList.Create;
    sl.LoadFromFile(s);
    for i :=  0 to  sl.Count - 1  do  begin
      ZonuCommon.Parse2chSubject(sl[i], ADatNo, ATitle, ACount);
      ThreadItem  :=  TThreadItem.Create;
      ThreadItem.CreateThreadItem(Board.Site.SiteID,
                                  Board.BoardID,
                                  ADatNo,
                                  ATitle);
      if  (not ThreadItem.IsAboned) then  begin
        ThreadItem.AgeCount :=  ACount;
        ThreadItem.No       :=  i + 1;
        ThreadItemList.Add(ThreadItem);
        AllThreadItemList.Add(ThreadItem);
        ThreadItem.AddRef;
      end else begin
        ThreadItem.ReleaseRef;
      end;
      if  (i mod 100 = 0) then  begin
        Reset;
        Application.ProcessMessages;
      end;
    end;
    Reset;
    sl.Free;
    Application.ProcessMessages;
  end;
end;

procedure TZonuListDoc.AddThreadItem(ThreadItem: TThreadItem;
  const LoadFromCache: boolean = True);
  function  SearchOlDat(const DatFileName: string): integer;
  var
    Min, Max, Mid : integer;
    DatNo: string;
  begin
    Result  :=  -1;
    if  (FOldSubjectTxt.Count = 0)  then  Exit;
    Min :=  0;
    Max :=  FOldSubjectTxt.Count - 1;
    while (True)  do  begin
      Mid   :=  (Max - Min) div 2 + Min;

      //DatNo :=  Copy(FOldSubjectTxt[Mid], 1, AnsiPos('=', FOldSubjectTxt[Mid]) - 1);
      DatNo :=  Pickup(FOldSubjectTxt[Mid], '=');

      if  (DatFileName = DatNo) then  begin
        Result  :=  Mid;
        Break;
      end else begin
        if   (Min >= Max)  then  break;
        if  (DatFileName > DatNo) then  begin
          Min :=  Mid + 1;
        end else
        if  (DatFileName < DatNo) then  begin
          Max :=  Mid - 1;
        end;
      end;
    end;
  end;
var
  i : integer;
  Count, Age : integer;
  Exists: boolean;
  ActiveListDoc : TZonuListDoc;
  Action : TZonuAction;
  sl: TStringList;
  s: string;
  ABoard: TBoard;
begin
  Exists  :=  False;
  i :=  SearchOlDat(ThreadItem.DatNo);
  if  (i > -1) then begin
    Count :=  StrToIntDef(Copy(FOldSubjectTxt[i],
                            AnsiPos('=',
                                    FOldSubjectTxt[i]) + 1,
                                    Length(FOldSubjectTxt[i])),
                                    0);
    if  (Count <  ThreadItem.AgeCount) and
        (Count <> ThreadItem.ReadCount) then
    begin
      ThreadItem.Updated  :=  True;
    end;
    Exists  :=  True;
  end;
  {
  for i :=  0 to  FOldSubjectTxt.Count - 1  do  begin
    if  (AnsiPos(ThreadItem.DatNo, FOldSubjectTxt[i]) > 0)  then  begin
      DatNo :=  Copy(FOldSubjectTxt[i], 1, AnsiPos('=', FOldSubjectTxt[i]) - 1);
      if  (DatNo = ThreadItem.DatNo)  then  begin
        Count :=  StrToIntDef(Copy(FOldSubjectTxt[i],
                                AnsiPos('=',
                                        FOldSubjectTxt[i]) + 1,
                                        Length(FOldSubjectTxt[i])),
                                        0);
        if  (Count <  ThreadItem.AgeCount) and
            (Count <> ThreadItem.ReadCount) then
        begin
          ThreadItem.Updated  :=  True;
        end;
        Exists  :=  True;
        Break;
      end;
    end;
  end;
  }
  if  (not Exists)  then  begin
    ThreadItem.IsNew  :=  True;
  end;

  Age :=  ThreadItem.AgeCount;
  if  (FInfFileList.IndexOf(ChangeFileExt(ThreadItem.DatFileName, '.inf')) > -1)   then  begin
    ThreadItem.LoadConfig;
  end;
  ThreadItem.AgeCount :=  Age;

  //////////////////////////////////////////////////////////////////////////////
  //
  //  ANṼ`FbN
  //

  if  (not ThreadItem.InLocalFolder) and (not ThreadItem.IsKakoLog) then begin //33
    //age16
    for i :=  0 to  HotzonuWindow.ThreadActionList.Count - 1  do  begin

    if  (HotzonuWindow.ThreadActionList.CheckThread(ThreadItem,
                                                    ThreadItem.Site.SiteID,
                                                    ThreadItem.Board.BoardID,
                                                    //age16 Action)) then
                                                    Action, i)) then
    begin
      if  (Action.ActionType = atAbone) then  begin
        //ځ[
        ThreadItem.IsAboned :=  True;
        HotzonuWindow.Memo1.Lines.Add('EANV쓮Fw\x@' + IntToStr(ThreadItem.No));
      end else
      if  (Action.ActionType = atReplace) then  begin
        //^Cgu
        if  (atThreadTitle in Action.Target)  then  begin
          ThreadItem.Title  :=  StringReplace(ThreadItem.Title, Action.Param1, Action.Param2, [rfReplaceAll]);
          HotzonuWindow.Memo1.Lines.Add('EANV쓮Fwux@@' + IntToStr(ThreadItem.No));
        end;
      end else
      if  (Action.ActionType = atPopup) then  begin
        //m点
        HotzonuWindow.PopupInfo(Action.Param1, 2, ThreadItem);
        HotzonuWindow.Memo1.Lines.Add('EANV쓮Fwm点x' + IntToStr(ThreadItem.No) + ':' + ThreadItem.Title);
      end else
      if  (Action.ActionType = atAddToFav) and (not ThreadItem.InFavorites) and (ZonuEnviron.Cached) then  begin
        //Cɓo^
        CreateDefaultFavFolder;
        if  (GetDefaultFavFolder(ABoard))  then  begin
          sl  :=  TStringList.Create;
          s   :=  ABoard.CachePath + ABoard.BoardID + '.txt';
          if  (FileExists(s))  then  begin
            sl.LoadFromFile(s);
          end else begin
            sl.Add(ABoard.Name);
          end;
          sl.Add(ThreadItem.Site.SiteID + #9 +
                 ThreadItem.BoardID + #9  +
                 ThreadItem.DatNo + #9  +
                 ThreadItem.Title + #9  +
                 '1');
          sl.SaveToFile(s);
          sl.Free;
        end;
        ThreadItem.InFavorites  :=  True;
        RefreshThreadListEx(ThreadItem);
        HotzonuWindow.Memo1.Lines.Add('EANV쓮FwCɓx' + IntToStr(ThreadItem.No) + ':' + ThreadItem.Title);
        HotzonuWindow.PopupInfo(Action.Param1, 3, ThreadItem);
      end else
      if  (Action.ActionType = atMoveToLocal) then  begin
        //[JtH_ֈړ
      end else
      if  (Action.ActionType = atSetColor) then  begin
        //Fݒ
        ThreadItem.Color  :=  StringToColor(Action.Param2);
        HotzonuWindow.Memo1.Lines.Add('EANV쓮FwFݒx@' + IntToStr(ThreadItem.No) + ':' + ThreadItem.Title);
      end else
      if  (Action.ActionType = atSetReverse) and (not ThreadItem.Reverse) then  begin
        //]
        ThreadItem.Reverse  :=  True;
        HotzonuWindow.Memo1.Lines.Add('EANV쓮Fw]x@@' + IntToStr(ThreadItem.No) + ':' + ThreadItem.Title);
      end else
      if  (Action.ActionType = atSetBold) and (not ThreadItem.Bold) then  begin
        //
        ThreadItem.Bold     :=  True;
        HotzonuWindow.Memo1.Lines.Add('EANV쓮Fwx@@' + IntToStr(ThreadItem.No) + ':' + ThreadItem.Title);
      end else
      if  (Action.ActionType = atSetKakoLog) and (not ThreadItem.IsKakoLog) then  begin
        //ߋOݒ
        ThreadItem.IsKakoLog  :=  True;
        RefreshThreadListEx(ThreadItem);
        HotzonuWindow.Memo1.Lines.Add('EANV쓮FwߋOx' + IntToStr(ThreadItem.No) + ':' + ThreadItem.Title);
      end else
      if  (Action.ActionType = atSetPriority) then  begin
        //dvxݒ
        ThreadItem.Priority   :=  StrToIntDef(Action.Param2, 0);
        HotzonuWindow.Memo1.Lines.Add('EANV쓮Fwdvxx@' + IntToStr(ThreadItem.No) + ':' + ThreadItem.Title);
      end;

      ThreadItem.SaveConfig;

    end;
  end;
  //age16
  end;

  //////////////////////////////////////////////////////////////////////////////

  if  (not ThreadItem.IsAboned)  then  begin
    if  (HotzonuWindow.GetActiveListDoc(ActiveListDoc))  then  begin
      if  (ActiveListDoc = Self)  then  begin
        if  (FDefaultShowCount > 0) then  begin
          if  (ThreadItemList.Count < FDefaultShowCount + 1) then  begin
            //*!*
            //HotzonuWindow.ThreadListVIew.Items.Count := ThreadItemList.Count;
            //if  ((ThreadItemList.Count = 30) or ((ThreadItemList.Count mod 100) = 0))  then
            if  (LoadFromCache) or
                (ThreadItem.BBS.ThreadDownlaodMode = dmCGI) or
                (ZonuConfig.ThreadListDownloadMode = dmRealtime)  then
            begin
              HotzonuWindow.ThreadListVIew.Items.Count := ThreadItemList.Count;
            end else begin
              if  ((ThreadItemList.Count mod ZonuConfig.ThreadListRefreshCount) = 0)  then
                HotzonuWindow.ThreadListView.SetItemCountEx(ThreadItemList.Count, [lvsicfNoScroll]);
            end;
          end;
        end else begin
          //*!*
          //HotzonuWindow.ThreadListVIew.Items.Count := ThreadItemList.Count;
          //if  ((ThreadItemList.Count = 30) or ((ThreadItemList.Count mod 100) = 0))  then
          if  (LoadFromCache) or
              (ThreadItem.BBS.ThreadDownlaodMode = dmCGI) or
              (ZonuConfig.ThreadListDownloadMode = dmRealtime)  then
          begin
              HotzonuWindow.ThreadListVIew.Items.Count := ThreadItemList.Count;
          end else begin
            if  ((ThreadItemList.Count mod ZonuConfig.ThreadListRefreshCount) = 0)  then
              HotzonuWindow.ThreadListView.SetItemCountEx(ThreadItemList.Count, [lvsicfNoScroll]);
          end;
        end;
      end;
    end;
  end else begin
    for i :=  ThreadItemList.Count - 1  downto  0 do  begin
      if  (ThreadItemList[i]  = ThreadItem) then  begin
        ThreadItemList.Delete(i);
      end;
    end;
  end;
end;

procedure TZonuListDoc.SaveSubjectTxt;
var
  FileName    : string;
  FSubjectTxt : TStringList;
  i : integer;
begin
  if  (ZonuEnviron.Cached)  then  begin
    FSubjectTxt :=  TStringList.Create;
    FSubjectTxt.BeginUpdate;
    FileName  :=  Board.CachePath + 'subject.dat';
    if  (Board.BBS.ThreadListType = tlLump) then  begin
      //ꊇ_E[hBBS͏㏑
      for i :=  0 to  ThreadItemList.Count - 1 do  begin
        FSubjectTxt.Add(ThreadItemList[i].DatNo + '=' + IntToStr(ThreadItemList[i].AgeCount));
      end;
    end else begin
      if  (FileExists(FileName))  then  begin
        FSubjectTxt.LoadFromFile(FileName);
      end;
      for i :=  0 to  ThreadItemList.Count - 1 do  begin
        FSubjectTxt.Values[ThreadItemList[i].DatNo] :=  IntToStr(ThreadItemList[i].AgeCount);
      end;
    end;
    FSubjectTxt.EndUpdate;
    ForceDirectories(ExtractFilePath(FileName));
    FSubjectTxt.SaveToFile(FileName);
    FSubjectTxt.Free;
  end;
end;


procedure TZonuListDoc.SaveToFile(const FileName: string);
var
  sl  : TStringList;
  s   : string;
  i   : integer;
begin
  if  (ZonuEnviron.Cached)  then  begin
    if  (FileName = '') then  begin
      s :=  Board.CachePath + 'subject.txt';
    end else begin
      s :=  FileName;
    end;
    sl  :=  TStringList.Create;
    sl.BeginUpdate;
    for i :=  0 to  ThreadItemList.Count - 1 do  begin
      sl.Add(   ThreadItemList[i].DatNo +
                '<>'  +
                ThreadItemList[i].Title +
                '(' +
                IntToStr(ThreadItemList[i].AgeCount) +
                ')' );
    end;
    sl.EndUpdate;
    if  (not DirectoryExists(ExtractFilePath(s))) then  begin
      ForceDirectories(ExtractFilePath(s));
    end;
    sl.SaveToFile(s);
    sl.Free;
  end;
end;

procedure TZonuListDoc.CancelDownload;
var
  ZonuHttp  : TZonuHttp;
begin
  if  (State = vsDownloading)  then  begin
    if  (ZonuHttpList.FindHttp(Board.BBS.GetSubjectUrl(Board), ZonuHttp)) then
    begin
      ZonuHttp.Abort;
    end;
  end;
end;

function TZonuListDoc.GetBoard: TBoard;
var
  Board: TBoard;
begin
  Result  :=  nil;
  if  (FThreadItemList <> nil)  then  begin
    if  (FThreadItemList.Site <> nil)  then  begin
      if  (FThreadItemList.Site.BoardList.FindBoard(FBoardID, Board)) then  begin
        Result  :=  Board;
      end;
    end;
  end;
end;

procedure TZonuListDoc.SetShowCount(const Value: integer);
begin
  FShowCount := Value;
  if  (FShowCount > ThreadItemList.Count) then  begin
    FShowCount  :=  ThreadItemList.Count;
  end;
end;

procedure TZonuListDoc.Active;
begin
  ToolButton.Down  :=  True;
  ToolButton.OnClick(ToolButton);
  HotzonuWindow.ThreadListView.Invalidate;
  //HotzonuWindow.ThreadListTabClick(ToolButton);
  if  (MenuItem <> nil) then  MenuItem.Checked  :=  True;
end;

procedure TZonuListDoc.FireActive;
begin
  if  (Assigned(FActiveEvt)) then  begin
    FActiveEvt(Self);
  end;
end;

procedure TZonuListDoc.SetNavigateLock(const Value: boolean);
begin
  FNavigateLock := Value;
end;

procedure TZonuListDoc.ResetTabImage;
begin
  ToolButton.AutoSize    :=  False;
  ToolButton.ImageIndex  :=  -1;
  if  (State = vsDownloading) then  begin
    ToolButton.ImageIndex     :=  33;
  end else
  if  (State = vsCacheLoading) then  begin
    ToolButton.ImageIndex     :=  34;
  end else begin
    if  (NavigateLock)  then  begin
      ToolButton.ImageIndex   :=  25;
    end else begin
      case  Kind  of
        lkThreadList  : ToolButton.ImageIndex  :=  -1;
        lkFavorites   : ToolButton.ImageIndex  :=  -1;
        lkFindPage    : ToolButton.ImageIndex  :=  -1;
        lkFilter      : ToolButton.ImageIndex  :=  32;
        lkHeadline    : ToolButton.ImageIndex  :=  -1;
      end;
    end;
  end;
  ToolButton.AutoSize    :=  True;
end;



function TZonuListDoc.GetNewCount: integer;
var
  i, n: integer;
begin
  n :=  0;
  for i :=  0 to  ThreadItemList.Count - 1  do  begin
    if  (ThreadItemList[i].IsNew) then  Inc(n);
  end;
  Result  :=  n;
end;

procedure TZonuListDoc.LoadInfFileList;
var
  rec: TSearchRec;
  Path: string;
begin
  FInfFileList.Clear;
  if  (Board <> nil)  then  begin
    Path  :=  Self.Board.CachePath;
    if (FindFirst(Path + '*.inf' , faAnyFile, Rec) = 0)  then begin
      repeat
        FInfFileList.Add(rec.Name);
      until (FindNext(Rec) <> 0);
    end;
    SysUtils.FindClose(rec);
  end;
end;

procedure TZonuListDoc.orzSave(const Path: string);
var
  s: string;
  n: integer;
begin
  s :=  Title + #13#10;
  for n :=  0 to  ThreadItemList.Count - 1  do  begin
//    s :=  s + ThreadItem
  end;
end;

procedure TZonuListDoc.orzLoad(const Path: string);
begin

end;

{ TZonuResWriter }

constructor TZonuResWriter.Create(ResList: TResList);
begin
  FSkinHeader     :=  TStringList.Create;
  FSkinRes        :=  TStringList.Create;
  FSkinNewRes     :=  TStringList.Create;
  FSkinFooter     :=  TStringList.Create;
  FSkinToday      :=  TStringList.Create;
  FSkinSiori      :=  TStringList.Create;
  FSkinReadPoint  :=  TStringList.Create;
  FSkinSioriBegin :=  TStringList.Create;
  FSkinSioriEnd   :=  TStringList.Create;
  FSkinTodayBegin :=  TStringList.Create;
  FSkinTodayEnd   :=  TStringList.Create;
  FSkinNewMark    :=  TStringList.Create; //age16
  FResList        :=  ResList;
  FNew            :=  False;  //age16
  FIDPopup        :=  True;   //10
  FRenderImage    :=  False;  //13
  FImageSize      :=  24;     //13
  FRenderImageNewOnly := False; //37
end;

destructor TZonuResWriter.Destroy;
begin
  FSkinHeader.Free;
  FSkinRes.Free;
  FSkinNewRes.Free;
  FSkinFooter.Free;
  FSkinToday.Free;
  FSkinSiori.Free;
  FSkinReadPoint.Free;
  FSkinSioriBegin.Free;
  FSkinSioriEnd.Free;
  FSkinTodayBegin.Free;
  FSkinTodayEnd.Free;
  FSkinNewMark.Free;  //age16
  inherited;
end;

procedure TZonuResWriter.ConvertKatjushaSkin;
  function ReplaceKatjushaSkin(Text: string): string;
  var
    S : string;
  begin
    S :=  Text;
    S :=  StringReplace(S, '&NUMBER',       '<NUMBER/>',      [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '&PLAINNUMBER',  '<PLAINNUMBER/>', [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '&CHECKBOX',     '<CHECKBOX/>',    [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '&MAILNAME',     '<MAILNAME/>',    [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '&NAME',         '<NAME/>',        [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '&MAIL',         '<MAIL/>',        [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '&MESSAGE',      '<MESSAGE/>',     [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '&DATE',         '<DATE/>',        [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '&TODAY',        '<TODAY/>',       [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '&SIORI',        '<SIORI/>',       [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '&PATH',         '<SKINPATH/>',    [rfIgnoreCase, rfReplaceAll]);
    Result  :=  S;
  end;
begin
  FSkinHeader.Text  :=  ReplaceKatjushaSkin(FSkinHeader.Text);
  FSkinRes.Text     :=  ReplaceKatjushaSkin(FSkinRes.Text);
  FSkinNewRes.Text  :=  ReplaceKatjushaSkin(FSkinNewRes.Text);
  FSkinFooter.Text  :=  ReplaceKatjushaSkin(FSkinFooter.Text);
  FSkinToday.Text   :=  ReplaceKatjushaSkin(FSkinToday.Text);
  FSkinSiori.Text   :=  ReplaceKatjushaSkin(FSkinSiori.Text);
  FSkinNewMark.Text :=  ReplaceKatjushaSkin(FSkinNewMark.Text); //age16
end;

procedure TZonuResWriter.ConvertHotzonuSkin;
  function ReplaceHotzonuSkin(Text: string): string;
  var
    S : string;
  begin
    S :=  Text;
    S :=  StringReplace(S, '<NUMBER>',      '<NUMBER/>',        [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '<PLAINNUMBER>', '<PLAINNUMBER/>',   [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '<CHECKBOX>',    '<CHECKBOX/>',      [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '<MAILNAME>',    '<MAILNAME/>',      [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '<NAME>',        '<NAME/>',          [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '<MAIL>',        '<MAIL/>',          [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '<MESSAGE>',     '<MESSAGE/>',       [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '<DATE>',        '<DATE/> ID:<ID/>', [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '<TODAY>',       '<TODAY/>',         [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '<PATH>',        '<SKINPATH/>',      [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '<SUBJECT>',     '<THREADNAME/>',    [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '<COUNT>',       '<ALLRESCOUNT/>',   [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '<NEWCOUNT>',    '<NEWRESCOUNT/>',   [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '<URL>',         '<THREADURL/>',     [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '<FILENAME>',    '<SKINPATH/>',      [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '<FILEPATH>',    '<SKINURL/>',       [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '<MODULEPPATH>', '<MODULEPATH/>',    [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '<MODULEURL>',   '<MODULEURL/>',     [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '<SIZE>',        '<SIZE/>',          [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '<SIZEKB>',      '<SIZEKB/>',        [rfIgnoreCase, rfReplaceAll]);
    S :=  StringReplace(S, '<SIORI>',       '<SIORI/>',         [rfIgnoreCase, rfReplaceAll]);
    Result  :=  S;
  end;
begin
  FSkinHeader.Text  :=  ReplaceHotzonuSkin(FSkinHeader.Text);
  FSkinRes.Text     :=  ReplaceHotzonuSkin(FSkinRes.Text);
  FSkinNewRes.Text  :=  ReplaceHotzonuSkin(FSkinNewRes.Text);
  FSkinFooter.Text  :=  ReplaceHotzonuSkin(FSkinFooter.Text);
  FSkinToday.Text   :=  ReplaceHotzonuSkin(FSkinToday.Text);
  FSkinSiori.Text   :=  ReplaceHotzonuSkin(FSkinSiori.Text);
  FSkinNewMark.Text :=  ReplaceHotzonuSkin(FSkinNewMark.Text);  //age16
end;

procedure TZonuResWriter.ConvertStdSkin;  //age16
  function ReplaceHotzonuSkin(Text: string): string;
  var
    S : string;
  begin
    if  (AnsiPos('<ID/>', Text)  =  0)  then  begin
      S :=  Text;
      S :=  StringReplace(S, '<DATE/>',        '<DATE/> ID:<ID/>', [rfIgnoreCase, rfReplaceAll]);
    end else begin
      S :=  Text;
    end;
    Result  :=  S;
  end;
begin
  FSkinHeader.Text  :=  ReplaceHotzonuSkin(FSkinHeader.Text);
  FSkinRes.Text     :=  ReplaceHotzonuSkin(FSkinRes.Text);
  FSkinNewRes.Text  :=  ReplaceHotzonuSkin(FSkinNewRes.Text);
  FSkinFooter.Text  :=  ReplaceHotzonuSkin(FSkinFooter.Text);
  FSkinToday.Text   :=  ReplaceHotzonuSkin(FSkinToday.Text);
  FSkinSiori.Text   :=  ReplaceHotzonuSkin(FSkinSiori.Text);
  FSkinNewMark.Text :=  ReplaceHotzonuSkin(FSkinNewMark.Text);  //age16
end;

(*
function TZonuResWriter.WriteRes(Res: TRes): string;
var
  S, LinkString : string;
  ResName : string;
  Body: string;
  td, td_b, td_e: string;
  siori, siori_b, siori_e: string;
  AUrl: string;
  ReadCgiUrl: string; //33
  BoardID, SiteID: string; //33
  ini: TMemIniFile; //33
  xSite: TSite; //33
  xBoard: TBoard; //33
begin
  ResName :=  Res.Name;

  if  (Res.IsNew) then  begin
    //age16
    if  (not FNew)  then  begin
      S   :=  S + FSkinNewMark.Text;
    end else begin
      S   :=  '';
    end;
    FNew  :=  True;
    S     :=  S + FSkinNewRes.Text;
  end else begin
    S   :=  FSkinRes.Text;
  end;

  if  (IsToday(Res.Date)) then  begin
    td   :=  FSkinToday.Text;
    td_b :=  FSkinTodayBegin.Text;
    td_e :=  FSkinTodayEnd.Text;
  end else begin
    td   :=  '';
    td_b :=  '';
    td_e :=  '';
  end;

  if  (Res.IsSiori) then  begin
    siori   :=  FSkinSiori.Text;
    siori_b :=  FSkinSioriBegin.Text;
    siori_e :=  FSkinSioriEnd.Text;
  end else begin
    siori   :=  '';
    siori_b :=  '';
    siori_e :=  '';
  end;

  Body  :=  Res.Body;

  //33
  if  (FResList.ThreadItem.Board.Site = ZonuEnviron.LocalSite)  then  begin
    ini :=  TMemIniFile.Create(FResList.ThreadItem.Board.CachePath +
                               ChangeFileExt(FResList.ThreadItem.DatFileName, '.inf'));
    BoardID   :=  ini.ReadString('ORG', 'BOARDID', '');
    SiteID    :=  ini.ReadString('ORG', 'SITEID', '');
    if  (ZonuEnviron.SiteList.FindSite(SiteID, xSite)) then  begin
      if  (xSite.BoardList.FindBoard(BoardID, xBoard)) then  begin

      end;
    end;
    ini.Free;
  end else begin
    xSite   :=  FResList.ThreadItem.Site;
    xBoard  :=  FResList.ThreadItem.Board;
  end;

  if  (ZonuConfig.AddHrefLink)  then  begin
    //if  (Res.BBS.NeedHRefLink)  then  begin
    if  (xBoard.BBS.NeedHRefLink)  then  begin
      //13 begin
      // http:// ɃNǉ
      //Body   :=  MonaUtils.AddHRefTag(Body);
      Body   :=  MonaUtils.AddHRefTag(Body, RenderImage, ImageSize);
      //13 end
      //if  (Res.BBS.BBSID = BBS_DOLIB) then
      if  (xBoard.BBS.BBSID = BBS_DOLIB) then
      begin
        //΃pX΃pXɏ
        //  >>`̂悤ȃAJ[NbNĂ_uEBhEɂȂȂB
        //  Rg[plAvP[V̒ǉƍ폜
        //  Internet Explorer813489Cpb`폜
        //̑Ή
        Body   :=  Zonutils.ReplaceRelativeUrl(Body,
                                               //FResList.ThreadItem.BoardID,
                                               //FResList.ThreadItem.DatNo,
                                               //Res.BBS.GetReadCgiUrl(FResList.ThreadItem));
                                               xBoard.BoardID,
                                               FResList.ThreadItem.DatNo,
                                               //xBoard.BBS.GetReadCgiUrl(FResList.ThreadItem));
                                               xBoard.BBS.GetReadCgiUrl(xBoard, FResList.ThreadItem.DatNo));
      end;
    end;
  end;
  //if  (Res.BBS.NeedLinkTarget) then  begin
  if  (xBoard.BBS.NeedLinkTarget) then  begin
    // A ^O TARGET=_blank ǉ
    Body   :=  MonaUtils.AddTargetBlank(Body)
  end;
  //if  (Res.BBS.RelativeLink) then  begin
  if  (xBoard.BBS.RelativeLink) then  begin
    // ΃N΃N֕ύX
    Body   :=  Zonutils.ExpandRelativeLink(FResList.ThreadItem.BBS.GetDisplayUrl(FResList.ThreadItem),
                                           Body)
  end;

  //26 begin
  if  (RenderImage) and (Res.ImgURL <> '') then begin
    //摜
    AUrl  :=  'http://' + ExtractHostname(FBoard.Url) + '/' + Res.ImgURL;
    Body  :=  Body +  Format('<BR><A HREF="%s" TARGET="_blank"><IMG SRC="%s" WIDTH=%d HEIGHT=%d></A><BR>',
                             [AUrl, AUrl, ImageSize, ImageSize]);
  end;
  //26 end

  if  (ZonuConfig.AddExtendRes) then  begin
    //33 begin
    ReadCgiUrl  :=  '';
    {
    if  (FResList.ThreadItem.Board.Site = ZonuEnviron.LocalSite)  then  begin
      ini :=  TMemIniFile.Create(FResList.ThreadItem.Board.CachePath +
                                 ChangeFileExt(FResList.ThreadItem.DatFileName, '.inf'));
      BoardID   :=  ini.ReadString('ORG', 'BOARDID', '');
      SiteID    :=  ini.ReadString('ORG', 'SITEID', '');
      if  (ZonuEnviron.SiteList.FindSite(SiteID, xSite)) then  begin
        if  (xSite.BoardList.FindBoard(BoardID, xBoard)) then  begin
          ReadCgiUrl  :=  xBoard.BBS.ConvUrl(
                              xBoard.BBS.GetReadCgiUrl(
                                xBoard, FResList.ThreadItem.DatNo));
          Body  :=  ConvRes(Body,
                            xBoard.RemoteBoardID,
                            FResList.ThreadItem.DatNo,
                            ReadCGIUrl, //33
                            xBoard.BBS.SendParam.ParamBBS,
                            xBoard.BBS.SendParam.ParamDat,
                            xBoard.BBS.SendParam.ParamStart,
                            xBoard.BBS.SendParam.ParamEnd,
                            xBoard.BBS.SendParam.ParamNoFirst,
                            xBoard.BBS.SendParam.ParamTrue);
        end;
      end;
      ini.Free;
    end else begin
    }
      ReadCgiUrl  :=  xBoard.BBS.ConvUrl(
                          xBoard.BBS.GetReadCgiUrl(
                            FResList.ThreadItem));
      Body  :=  ConvRes(Body,
                        xBoard.RemoteBoardID,
                        FResList.ThreadItem.DatNo,
                        ReadCGIUrl, //33
                        xBoard.BBS.SendParam.ParamBBS,
                        xBoard.BBS.SendParam.ParamDat,
                        xBoard.BBS.SendParam.ParamStart,
                        xBoard.BBS.SendParam.ParamEnd,
                        xBoard.BBS.SendParam.ParamNoFirst,
                        xBoard.BBS.SendParam.ParamTrue);
    //end;
    //33 end
  end;

  Body  :=  Body + #13#10;

  LinkString  :=  Format('<A HREF="zonu://res?no=%d">%d</A>', [Res.No, Res.No]);
  //age16 <> LinkString  :=  Format('<A HREF="menu:%d" name="%d">%d</A>', [Res.No, Res.No, Res.No]);  //age16

  //age16  <>  s  :=       ConvResSkin(S,
  s  :=  Format('<A NAME="ID%d"></A>', [Res.No]) +
              ConvResSkin(S,
                          Format('<INPUT TYPE="checkbox" NAME="CHK%d">',[Res.No]),
                          LinkString,
                          IntToStr(Res.No),
                          Res.Name,
                          Res.Mail,
                          Res.ID,
                          Res.BeID, //11
                          IntToStr(Res.BeLevel), //11
                          Res.RemoteHost,
                          Res.Date,
                          Body,
                          FSkinPath,
                          FSkinUrl,
                          FModulePath,
                          FModuleUrl,
                          IntToStr(FResList.ThreadItem.ReadPoint),
                          FHelpPath,
                          FHelpUrl,
                          td,
                          siori,
                          siori_b,
                          siori_e,
                          td_b,
                          td_e,
                          IDPopup);
  if  (Res.IsReadPoint) then  begin
    s :=  s + FSkinReadPoint.Text;   
  end;

  Result  :=  S;
end;
*)

function TZonuResWriter.WriteRes(Res: TRes): string;
var
  S, LinkString : string;
  ResName : string;
  Body: string;
  td, td_b, td_e: string;
  siori, siori_b, siori_e: string;
  AUrl: string;
  b: boolean;
begin
  ResName :=  Res.Name;

  if  (Res.IsNew) then  begin
    //age16
    if  (not FNew)  then  begin
      S   :=  S + FSkinNewMark.Text;
    end else begin
      S   :=  '';
    end;
    FNew  :=  True;
    S     :=  S + FSkinNewRes.Text;
  end else begin
    S   :=  FSkinRes.Text;
  end;

  if  (IsToday(Res.Date)) then  begin
    td   :=  FSkinToday.Text;
    td_b :=  FSkinTodayBegin.Text;
    td_e :=  FSkinTodayEnd.Text;
  end else begin
    td   :=  '';
    td_b :=  '';
    td_e :=  '';
  end;

  if  (Res.IsSiori) then  begin
    siori   :=  FSkinSiori.Text;
    siori_b :=  FSkinSioriBegin.Text;
    siori_e :=  FSkinSioriEnd.Text;
  end else begin
    siori   :=  '';
    siori_b :=  '';
    siori_e :=  '';
  end;

  Body  :=  Res.Body;
  if  (ZonuConfig.AddHrefLink)  then  begin
    if  (Res.BBS.NeedHRefLink)  then  begin
      //13 begin
      // http:// ɃNǉ
      //Body   :=  MonaUtils.AddHRefTag(Body);
      b :=  RenderImage;
      //V݂̂̏ꍇ
      if  (RenderImageNewOnly) and (not Res.IsNew)  then  begin
        b :=  False;
      end;

      Body   :=  MonaUtils.AddHRefTag(Body, b, ImageSize, True);
      //13 end
      if  (Res.BBS.BBSID = BBS_DOLIB) then
      begin
        //΃pX΃pXɏ
        //  >>`̂悤ȃAJ[NbNĂ_uEBhEɂȂȂB
        //  Rg[plAvP[V̒ǉƍ폜
        //  Internet Explorer813489Cpb`폜
        //̑Ή
        Body   :=  Zonutils.ReplaceRelativeUrl(Body,
                                               FResList.ThreadItem.BoardID,
                                               FResList.ThreadItem.DatNo,
                                               Res.BBS.GetReadCgiUrl(FResList.ThreadItem));
      end;
    end;
  end;
  if  (ZonuConfig.AddIDLink)  then  begin
    Body   :=  Zonutils.Add_ID_Href(Body);
  end;
  if  (Res.BBS.NeedLinkTarget) then  begin
    // A ^O TARGET=_blank ǉ
    Body   :=  MonaUtils.AddTargetBlank(Body)
  end;
  if  (Res.BBS.RelativeLink) then  begin
    // ΃N΃N֕ύX
    Body   :=  Zonutils.ExpandRelativeLink(FResList.ThreadItem.BBS.GetDisplayUrl(FResList.ThreadItem),
                                           Body)
  end;

  //26 begin
  if  (RenderImage) and (Res.ImgURL <> '') then begin
    if  (RenderImageNewOnly) and (not Res.IsNew)  then  begin
    end else begin
      //摜
      AUrl  :=  'http://' + ExtractHostname(FBoard.Url) + '/' + Res.ImgURL;
      Body  :=  Body +  Format('<BR><A HREF="%s" TARGET="_blank"><IMG SRC="%s" WIDTH=%d HEIGHT=%d></A><BR>',
                               [AUrl, AUrl, ImageSize, ImageSize]);
    end;
  end;
  //26 end

  if  (ZonuConfig.AddExtendRes) then  begin
    Body  :=  ConvRes(Body,
                      FResList.ThreadItem.Board.RemoteBoardID,
                      FResList.ThreadItem.DatNo,
                      FResList.ThreadItem.Board.BBS.ConvUrl(
                        FResList.ThreadItem.Board.BBS.GetReadCgiUrl(FResList.ThreadItem)),
                      FResList.ThreadItem.Board.BBS.SendParam.ParamBBS,
                      FResList.ThreadItem.Board.BBS.SendParam.ParamDat,
                      FResList.ThreadItem.Board.BBS.SendParam.ParamStart,
                      FResList.ThreadItem.Board.BBS.SendParam.ParamEnd,
                      FResList.ThreadItem.Board.BBS.SendParam.ParamNoFirst,
                      FResList.ThreadItem.Board.BBS.SendParam.ParamTrue);
  end;

  Body  :=  Body + #13#10;

  LinkString  :=  Format('<A HREF="zonu://res?no=%d">%d</A>', [Res.No, Res.No]);
  //age16 <> LinkString  :=  Format('<A HREF="menu:%d" name="%d">%d</A>', [Res.No, Res.No, Res.No]);  //age16

  //age16  <>  s  :=       ConvResSkin(S,
  s  :=  Format('<A NAME="ID%d"></A>', [Res.No]) +
              ConvResSkin(S,
                          Format('<INPUT TYPE="checkbox" NAME="CHK%d">',[Res.No]),
                          LinkString,
                          IntToStr(Res.No),
                          Res.Name,
                          Res.Mail,
                          Res.ID,
                          Res.BeID, //11
                          IntToStr(Res.BeLevel), //11
                          Res.RemoteHost,
                          Res.Date,
                          Res.StockURL,   //41
                          Res.StockText,  //41
                          Body,
                          FSkinPath,
                          FSkinUrl,
                          FModulePath,
                          FModuleUrl,
                          IntToStr(FResList.ThreadItem.ReadPoint),
                          FHelpPath,
                          FHelpUrl,
                          td,
                          siori,
                          siori_b,
                          siori_e,
                          td_b,
                          td_e,
                          IDPopup);
  if  (Res.IsReadPoint) then  begin
    s :=  s + FSkinReadPoint.Text;   
  end;

  Result  :=  S;
end;

procedure TZonuResWriter.ReplaceSkinTag(var S: string);
  function  GetNewCount: integer;
  var
    i, r : integer;
  begin
    r :=  0;
    for i :=  0 to  FResList.Count - 1 do  begin
      if  (FResList[i].IsNew)  then  Inc(r);
    end;
    Result  :=  r;
  end;
begin
  S :=  StringReplace(S, '<SKINPATH/>',  FSkinPath,   [rfReplaceAll]);
  S :=  StringReplace(S, '<SKINURL/>',   FSkinUrl,    [rfReplaceAll]);
  S :=  StringReplace(S, '<MODULEPATH/>',FModulePath, [rfReplaceAll]);
  S :=  StringReplace(S, '<MODULEPURL/>',FModuleUrl,  [rfReplaceAll]);
  S :=  StringReplace(S, '<HELPPATH/>',  FHelpPath,   [rfReplaceAll]);
  S :=  StringReplace(S, '<HELPURL/>',   FHelpUrl,    [rfReplaceAll]);
  if  (FResList.ThreadItem <> nil) then  begin
    S :=  StringReplace(S, '<THREADNAME/>',  FResList.ThreadItem.Title,  [rfReplaceAll]);
    S :=  StringReplace(S, '<THREADURL/>',   FResList.ThreadItem.BBS.GetReadCgiUrl(FResList.ThreadItem),  [rfReplaceAll]);
    //GetDisplayUrl(FResList.ThreadItem),  [rfReplaceAll]);
    S :=  StringReplace(S, '<BBSNAME/>',     FResList.ThreadItem.Site.SiteName,  [rfReplaceAll]);
    S :=  StringReplace(S, '<ALLRESCOUNT/>', IntToStr(FResList.Count), [rfReplaceAll]);
    S :=  StringReplace(S, '<NEWRESCOUNT/>', IntToStr(GetNewCount),  [rfReplaceAll]);
    S :=  StringReplace(S, '<BOARDNAME/>',   FResList.ThreadItem.Board.Name, [rfReplaceAll]);
    S :=  StringReplace(S, '<BOARDURL/>',    FResList.ThreadItem.Board.Url,  [rfReplaceAll]);
    S :=  StringReplace(S, '<SIZE/>',        IntToStr(FResList.ThreadItem.DatSize), [rfReplaceAll]);
    S :=  StringReplace(S, '<SIZEKB/>',      IntToStr(FResList.ThreadItem.DatSize div 1024 + 1), [rfReplaceAll]);
    S :=  StringReplace(S, '<BOOKMARKRESNO/>',IntToStr(FResList.ThreadItem.ReadPoint), [rfReplaceAll]);
    S :=  StringReplace(S, '<CATEGORYNAME/>',FResList.ThreadItem.Board.CategoryName, [rfReplaceAll]);
  end else begin
    S :=  StringReplace(S, '<THREADNAME/>', '',  [rfReplaceAll]);
    S :=  StringReplace(S, '<THREADURL/>',  '',  [rfReplaceAll]);
    S :=  StringReplace(S, '<BBSNAME/>',    '',  [rfReplaceAll]);
    S :=  StringReplace(S, '<ALLRESCOUNT/>','',  [rfReplaceAll]);
    S :=  StringReplace(S, '<NEWRESCOUNT/>','',  [rfReplaceAll]);
    S :=  StringReplace(S, '<BOARDNAME/>',  '',  [rfReplaceAll]);
    S :=  StringReplace(S, '<BOARDURL/>',   '',  [rfReplaceAll]);
    S :=  StringReplace(S, '<SIZE/>',       '',  [rfReplaceAll]);
    S :=  StringReplace(S, '<SIZEKB/>',     '',  [rfReplaceAll]);
    S :=  StringReplace(S, '<BOOKMARKRESNO/>', '', [rfReplaceAll]);
    S :=  StringReplace(S, '<CATEGORYNAME/>','', [rfReplaceAll]);
  end;
end;

procedure TZonuResWriter.SetKatjushaSkin(const Value: boolean);
begin
  FKatjushaSkin := Value;
  if  (Value) then  begin
    ConvertKatjushaSkin;
  end;
end;

procedure TZonuResWriter.SetSkinPath(const Value: string);
begin
  FSkinPath     := IncludeTrailingPathDelimiter(Value);
  FSkinUrl      := 'file:///' + DosPathToUnixPath(FSkinPath);
  FModulePath   :=  IncludeTrailingPathDelimiter(ZonuConfig.UsersPath + PATH_SKIN_MODULE);
  FModuleUrl    := 'file:///' + DosPathToUnixPath(FModulePath);
  FHelpPath     :=  IncludeTrailingPathDelimiter(ZonuConfig.AppPath + PATH_HELP);
  FHelpUrl      := 'file:///' + DosPathToUnixPath(FHelpPath);

  //
  if  (FileExists(FSkinPath + FILE_SKIN_HEADER))  then  begin //.htm
    FSkinHeader.LoadFromFile(FSkinPath + FILE_SKIN_HEADER);
  end else
  if  (FileExists(FSkinPath + FILE_SKIN_HEADER + 'l'))  then  begin //.html
    FSkinHeader.LoadFromFile(FSkinPath + FILE_SKIN_HEADER + 'l');
  end else begin
    FSkinHeader.Clear;
  end;
  //
  if  (FileExists(FSkinPath + FILE_SKIN_RES))  then  begin  //.htm
    FSkinRes.LoadFromFile(FSkinPath + FILE_SKIN_RES);
  end else
  if  (FileExists(FSkinPath + FILE_SKIN_RES + 'l'))  then  begin //.html
    FSkinRes.LoadFromFile(FSkinPath + FILE_SKIN_RES + 'l');
  end else begin
    FSkinRes.Clear;
  end;
  //
  if  (FileExists(FSkinPath + FILE_SKIN_NEWRES))  then  begin //.htm
    FSkinNewRes.LoadFromFile(FSkinPath + FILE_SKIN_NEWRES);
  end else
  if  (FileExists(FSkinPath + FILE_SKIN_NEWRES + 'l'))  then  begin //.html
    FSkinNewRes.LoadFromFile(FSkinPath + FILE_SKIN_NEWRES + 'l');
  end else begin
    FSkinNewRes.Clear;
  end;
  //
  if  (FileExists(FSkinPath + FILE_SKIN_FOOTER))  then  begin //.htm
    FSkinFooter.LoadFromFile(FSkinPath + FILE_SKIN_FOOTER);
  end else
  if  (FileExists(FSkinPath + FILE_SKIN_FOOTER + 'l'))  then  begin //.html
    FSkinFooter.LoadFromFile(FSkinPath + FILE_SKIN_FOOTER + 'l');
  end else begin
    FSkinFooter.Clear;
  end;
  //
  if  (FileExists(FSkinPath + FILE_SKIN_TODAY))  then  begin  //.htm
    FSkinToday.LoadFromFile(FSkinPath + FILE_SKIN_TODAY);
  end else
  if  (FileExists(FSkinPath + FILE_SKIN_TODAY + 'l'))  then  begin //.html
    FSkinToday.LoadFromFile(FSkinPath + FILE_SKIN_TODAY + 'l');
  end else begin
    FSkinToday.Clear;
  end;

  if  (FileExists(FSkinPath + FILE_SKIN_SIORI))  then  begin  //.htm
    FSkinSiori.LoadFromFile(FSkinPath + FILE_SKIN_SIORI);
  end else
  if  (FileExists(FSkinPath + FILE_SKIN_SIORI + 'l'))  then  begin //.html
    FSkinSiori.LoadFromFile(FSkinPath + FILE_SKIN_SIORI + 'l');
  end else begin
    FSkinSiori.Clear;
  end;

  if  (FileExists(FSkinPath + FILE_SKIN_READPOINT)) then  begin //.htm
    FSkinReadPoint.LoadFromFile(FSkinPath + FILE_SKIN_READPOINT);
  end else
  if  (FileExists(FSkinPath + FILE_SKIN_READPOINT + 'l'))  then  begin //.html
    FSkinReadPoint.LoadFromFile(FSkinPath + FILE_SKIN_READPOINT + 'l');
  end else begin
    FSkinReadPoint.Clear;
  end;
  //
  if  (FileExists(FSkinPath + FILE_SKIN_SIORI_BEGIN))  then  begin  //.htm
    FSkinSioriBegin.LoadFromFile(FSkinPath + FILE_SKIN_SIORI_BEGIN);
  end else
  if  (FileExists(FSkinPath + FILE_SKIN_SIORI_BEGIN + 'l'))  then  begin //.html
    FSkinSioriBegin.LoadFromFile(FSkinPath + FILE_SKIN_SIORI_BEGIN + 'l');
  end else begin
    FSkinSioriBegin.Clear;
  end;
  if  (FileExists(FSkinPath + FILE_SKIN_SIORI_END))  then  begin  //.htm
    FSkinSioriEnd.LoadFromFile(FSkinPath + FILE_SKIN_SIORI_END);
  end else
  if  (FileExists(FSkinPath + FILE_SKIN_SIORI_END + 'l'))  then  begin //.html
    FSkinSioriEnd.LoadFromFile(FSkinPath + FILE_SKIN_SIORI_END + 'l');
  end else begin
    FSkinSioriEnd.Clear;
  end;
  if  (FileExists(FSkinPath + FILE_SKIN_TODAY_BEGIN))  then  begin  //.htm
    FSkinTodayBegin.LoadFromFile(FSkinPath + FILE_SKIN_TODAY_BEGIN);
  end else
  if  (FileExists(FSkinPath + FILE_SKIN_TODAY_BEGIN + 'l'))  then  begin //.html
    FSkinTodayBegin.LoadFromFile(FSkinPath + FILE_SKIN_TODAY_BEGIN + 'l');
  end else begin
    FSkinTodayBegin.Clear;
  end;
  if  (FileExists(FSkinPath + FILE_SKIN_TODAY_END))  then  begin  //.htm
    FSkinTodayEnd.LoadFromFile(FSkinPath + FILE_SKIN_TODAY_END);
  end else
  if  (FileExists(FSkinPath + FILE_SKIN_TODAY_END + 'l'))  then  begin //.html
    FSkinTodayEnd.LoadFromFile(FSkinPath + FILE_SKIN_TODAY_END + 'l');
  end else begin
    FSkinTodayEnd.Clear;
  end;
  //age16
  if  (FileExists(FSkinPath + FILE_SKIN_NEWMARK))  then  begin  //.htm
    FSkinNewMark.LoadFromFile(FSkinPath + FILE_SKIN_NEWMARK);
  end else
  if  (FileExists(FSkinPath + FILE_SKIN_NEWMARK + 'l'))  then  begin //.html
    FSkinNewMark.LoadFromFile(FSkinPath + FILE_SKIN_NEWMARK + 'l');
  end else begin
    FSkinNewMark.Clear;
  end;

  if  (FKatjushaSkin) then  begin
    ConvertKatjushaSkin;
  end else
  if  (FHotzonuSkin) then  begin
    ConvertHotzonuSkin;
  end;

  //age16
  ConvertStdSkin;
end;

function TZonuResWriter.WriteHeader: string;
var
  s : string;
begin
//43 begin
  //S :=  FSkinHeader.Text;
  //ReplaceSkinTag(S);
  //{
  //*STDS1* http://dtao.cside.com/stdskin/toB_Zonu.html
  //}
  //if  (AnsiPos('FORM', S) < 1)  then  begin
  //  S :=  S + #13#10 +  '<FORM>';
  //end;
  //
  //Result  :=  S + #13#10 +
  //            '<BASE HREF="' + SkinPath +  '">' + #13#10;
  //
  ////age16

  s :=  FSkinHeader.Text;

  s :=  Copy(s, 1, AnsiPos('<head>', s) + 6) +
        '<BASE HREF="' + SkinPath +  '">' +
        Copy(s, AnsiPos('<head>', s) + 6, Length(s));

  ReplaceSkinTag(s);
  if  (AnsiPos('FORM', s) < 1)  then  begin
    s :=  s + #13#10 +  '<FORM>';
  end;
  Result  :=  s + #13#10;
//43 end
end;

function TZonuResWriter.WriteFooter: string;
var
  s : string;
begin
  S :=  FSkinFooter.Text;
  ReplaceSkinTag(S);
  Result  :=  S + #13#10;
end;

procedure TZonuResWriter.SetHotzonuSkin(const Value: boolean);
begin
  FHotzonuSkin := Value;
  if  (Value) then  begin
    ConvertHotzonuSkin;
  end;
end;

{ TZonuStrings }

function TZonuStrings._AddRef: Integer;
begin
  Result := 0; //ق
end;

function TZonuStrings._Release: Integer;
begin
  Result := 0; //ق
end;

function TZonuStrings.QueryInterface(const IID: TGUID; out Obj): HResult;
begin
  if GetInterface(IID, Obj) then
    Result := 0
  else
    Result := E_NOINTERFACE;
end;

{ TZonuDatStrings }

procedure TZonuDatStrings.WriteRes(Res: TRes);
var
  s : string;
begin
  if  (Res.IsAboned)  then  begin
    S :=  Res.BBS.AboneText + Separator +  Res.BBS.AboneText + Separator +  Res.BBS.AboneText  +  Separator + Res.BBS.AboneText;
  end else begin
    if  (Res.ID <> '')  then  begin
      S :=  Res.Name + Separator + Res.Mail + Separator + Res.Date + ' ID:' + Res.ID + Separator + Res.Body + Separator;
    end else begin
      S :=  Res.Name + Separator + Res.Mail + Separator + Res.Date + Separator + Res.Body + Separator;
    end;
  end;
  if  (Res.No = 1)  and (not Res.IsAboned)  then  S := S + Res.ThreadTitle;
  //S := S +  Separator;
  Add(S);
end;

constructor TZonuDatStrings.Create;
begin
  FSeparator := '<>';
end;

procedure TZonuDatStrings.InitOutputRes;
begin
  //
end;

procedure TZonuDatStrings.EndOutputRes;
begin

end;

function TZonuDatStrings.GetBoard: TBoard;
var
  Board : TBoard;
begin
  Result  :=  nil;
  if  (Site <> nil) then  begin
    if  (Site.BoardList.FindBoard(FBoardID, Board)) then  begin
      Result  :=  Board;
    end;
  end;
end;

procedure TZonuDatStrings.NgData(Res: TRes; Action: TZonuAction);
begin
  Res.Name  :=  'mf';
  Res.Date  :=  'mf';
  Res.Body  :=  'mf';
end;

function TZonuDatStrings.GetShowAll: boolean;
begin
  Result  :=  FShowAll;
end;

//12
function  TZonuDatStrings.ForceCurrentThradItem: boolean;
begin
  Result  :=  False;
end;

{ TZonuHtmlStrings }

constructor TZonuHtmlStrings.Create;
begin
  //
end;

destructor TZonuHtmlStrings.Destroy;
begin
  //
  inherited;
end;

procedure TZonuHtmlStrings.EndOutputRes;
begin
  //Add('</FORM></body></html>');
  Add(FResWriter.WriteFooter);
  FResWriter.Free;
end;

procedure TZonuHtmlStrings.EndOutputResNoFooter;
begin
  FResWriter.Free;
end;

function TZonuHtmlStrings.GetBoard: TBoard;
var
  Board : TBoard;
begin
  Result  :=  nil;
  if  (Site <> nil) then  begin
    if  (Site.BoardList.FindBoard(FBoardID, Board)) then  begin
      Result  :=  Board;
    end;
  end;
end;

function TZonuHtmlStrings.GetShowAll: boolean;
begin
  Result  :=  FShowAll;
end;

//12
function  TZonuHtmlStrings.ForceCurrentThradItem: boolean;
begin
  Result  :=  False;
end;

procedure TZonuHtmlStrings.InitOutputRes;
begin
  //Add('<html><body><dl><FORM>');
  //Add('<font face="lr oSVbN">');
  FResWriter  :=  TZonuResWriter.Create(FResList);
  FResWriter.SkinPath         :=  Self._SkinPath;
  FResWriter.KatjushaSkin     :=  Self._KatjushaSkin;
  FResWriter.HotzonuSkin      :=  Self._HotZonuSkin;
  FResWriter.IDPopup          :=  Self._IDPopup; //10
  FResWriter.RenderImage      :=  Self._RenderImage;  //13
  FResWriter.RenderImageNewOnly   :=  Self._RenderImageNewOnly;  //37
  FResWriter.ImageSize        :=  Self._ImageSize;    //13
  FResWriter.Board            :=  Self.Board; //26
  Add(FResWriter.WriteHeader);
end;

procedure TZonuHtmlStrings.InitSkin(ABoard: TBoard);
var
  ini: TMemIniFile;
  s: string;
  b: boolean;
begin
  ini :=  TMemIniFile.Create(ZonuConfig.UsersPath + INI_SKIN);
  XBoard := ABoard;
  b   :=  False;
  if  (ABoard <> nil) then  begin
    s :=  ABoard.Site.SiteID + '_' + ABoard.BoardID;
    if  (ini.SectionExists(s))  then  begin
      FSkinPath       :=  ini.ReadString(s, 'SKINPATH', '');
      FKatjushaSkin   :=  ini.ReadBool(s, 'KATJUSHA', False);
      FHotzonuSkin    :=  ini.ReadBool(s, 'HOTZONU', False);
      FIDPopup        :=  ini.ReadBool(s, 'IDPopup', True); //10
      FRenderImage    :=  ini.ReadBool(s, 'RenderImage', False); //13
      FRenderImageNewOnly   :=  ini.ReadBool(s, 'RenderImageNewOnly', False); //37
      FImageSize      :=  ini.ReadInteger(s, 'ImageSize', 24); //13
      b :=  (FSkinPath <> '');
    end;
  end;
  if  (not b) then  begin
    s :=  ABoard.Site.SiteID;
    if  (ini.SectionExists(s))  then  begin
      FSkinPath       :=  ini.ReadString(s, 'SKINPATH', '');
      FKatjushaSkin   :=  ini.ReadBool(s, 'KATJUSHA', False);
      FHotzonuSkin    :=  ini.ReadBool(s, 'HOTZONU', False);
      FIDPopup        :=  ini.ReadBool(s, 'IDPopup', True); //10
      FRenderImage    :=  ini.ReadBool(s, 'RenderImage', False); //13
      FRenderImageNewOnly   :=  ini.ReadBool(s, 'RenderImageNewOnly', False); //37
      FImageSize      :=  ini.ReadInteger(s, 'ImageSize', 24); //13
      b :=  (FSkinPath <> '');
    end;
  end;
  if  (not b) then  begin
    s :=  'default';
    FSkinPath       :=  ini.ReadString(s, 'SKINPATH', ZonuConfig.UsersPath + PATH_SKIN + 'default');
    FKatjushaSkin   :=  ini.ReadBool(s, 'KATJUSHA', False);
    FHotzonuSkin    :=  ini.ReadBool(s, 'HOTZONU', False);
    FIDPopup        :=  ini.ReadBool(s, 'IDPopup', True); //10
    FRenderImage    :=  ini.ReadBool(s, 'RenderImage', False); //13
    FRenderImageNewOnly   :=  ini.ReadBool(s, 'RenderImageNewOnly', False); //37
    FImageSize      :=  ini.ReadInteger(s, 'ImageSize', 24); //13
  end;
  ini.Free;
end;

procedure TZonuHtmlStrings.NgData(Res: TRes; Action: TZonuAction);
begin
  Res.Name  :=  'mf';
  Res.Date  :=  'mf';
  Res.Body  :=  'mf';
end;

procedure TZonuHtmlStrings.WriteRes(Res: TRes);
begin
  FResWriter.Board := XBoard; //26
  if  (not Res.IsAboned)  then  begin
    Add(FResWriter.WriteRes(Res));
  end else begin
    Add(Format('<A NAME="ID%d"></A>', [Res.No]));
    //age16 <> Add(Format('<A NAME="%d"></A>', [Res.No]));
  end;
end;

{ TZonuBrowser }

procedure TZonuBrowser.Active;
begin
  {$IFDEF NUXX}
  Dialogs.ShowMessage('TZonuBrowser.Active');
  {$ELSE}
  BringToFront;
  {
  if  (Assigned(FActiveEvt))  then  begin
    FActiveEvt(Self);
  end;
  }

  ToolButton.Down  :=  True;
  //ToolButton.OnClick(ToolButton);

  {

  ToolButton.Down  :=  True;
  ToolButton.OnClick(ToolButton);
  HotzonuWindow.ThreadListView.Invalidate;

  if  (FThreadNameLabel <> nil)  then  begin
    if  (not IsWebPage) then  begin
      if  (ThreadItem <> nil)  then  begin
        FThreadNameLabel.Caption  :=  ThreadItem.Title;
        FThreadNameLabel2.Caption :=  '^' +
                                      ThreadItem.Board.Name + '' +
                                      ThreadItem.Site.SiteName;
        n :=  ThreadItem.NewCount;
        if  (n < 0) then  n :=  0;
        ThreadInfoLabel.Caption   :=  Format('(%d / %d)',
                                             [n, ThreadItem.ReadCount]);
      end else begin
        FThreadNameLabel.Caption  :=  '';
        FThreadNameLabel2.Caption :=  '';
        FThreadInfoLabel.Caption  :=  '';
      end;
    end else begin
      FThreadNameLabel.Caption  :=  Title;
      FThreadNameLabel2.Caption :=  '';
      ThreadInfoLabel.Caption   :=  '';
    end;
  end;
  }
  if  (MenuItem <> nil) then  MenuItem.Checked  :=  True;
  if  (Url = '')  then  Url :=  LocationURL;
  UrlComboBox.Text  :=  Url;
  if  (ThreadItem <> nil) then  begin
    HotzonuWindow.ThreadComment.Lines.Text  :=  ThreadItem.Memo;
    HotzonuWindow.CurrentThreadItem         :=  ThreadItem;
  end else begin
    HotzonuWindow.ThreadComment.Lines.Text  :=  '';
    HotzonuWindow.CurrentThreadItem         :=  nil;
  end;
  {$ENDIF}
end;

procedure TZonuBrowser.CancelDownload;
var
  i : integer;
begin
  if  (not IsWebPage) then  begin
    if  (State = vsDownloading)  then  begin
      for i :=  0 to  ZonuHttpList.Count - 1  do  begin
        if  (AnsiPos(ThreadItem.RemoteDatFileName, ZonuHttpList[i].URL) = 1) then
        begin
          ZonuHttpList[i].Abort;
          Break;
        end;
      end;
    end;
  end else begin
    Stop;
  end;
end;

procedure TZonuBrowser.Clear;
var
  doc : variant;
begin
  if  (Assigned(Document))  then  begin
    doc   :=  Document;
    doc.Close;
    doc.Clear;
  end;
end;

constructor TZonuBrowser.Create(AOwner: TComponent);
begin
  OleInitialize(nil);
  inherited;
  UserInterfaceOptions  :=[ACTIVATE_CLIENTHIT_ONLY];
  Init;
end;

destructor TZonuBrowser.Destroy;
begin
  Release;
  inherited;
  OleUnInitialize;
end;

procedure TZonuBrowser.EndOutputRes;
var
  doc : variant;
begin
  doc :=  Document;
  if  (Assigned(Document)) then  begin
    doc.Write(FResWriter.WriteFooter);
    doc.Close;
  end;
  FResWriter.Free;
end;

//7
procedure TZonuBrowser.WriteFooter;
var
  doc : variant;
begin
  doc :=  Document;
  if  (Assigned(Document)) then  begin
    doc.Write(FResWriter.WriteFooter);
  end;
end;

procedure TZonuBrowser.FireActive;
begin
  if  (Assigned(FActiveEvt)) then  begin
    FActiveEvt(Self);
  end;
end;

function TZonuBrowser.GetBoard: TBoard;
var
  Board : TBoard;
begin
  Result  :=  nil;
  if  (FThreadItem <> nil) then  begin
    if  (FThreadItem.Site <> nil) then  begin
      if  (FThreadItem.Site.BoardList.FindBoard(FBoardID, Board)) then  begin
        Result  :=  Board;
      end;
    end;
  end;
end;

//12
function  TZonuBrowser.ForceCurrentThradItem: boolean;
begin
  Result  :=  True;
end;

function TZonuBrowser.GetCheckRes(AResList: TResList): boolean;
var
  ADocument   : IHtmlDocument2;
  FormElement : IHtmlFormElement;
  Element     : IHTMLInputElement;
  Res         : TRes;
  i,j         : integer;
begin
  if  (ThreadItem <> nil) then  begin
    ADocument  :=  Document as IHtmlDocument2;
    for i :=  0 to  ADocument.forms.length - 1 do  begin
      FormElement :=  ADocument.forms.item(EmptyParam, i)  as  IHTMLFormElement;
      for j :=  1 to  ResList.Count do  begin
        Element :=  FormElement.item('CHK' + IntToStr(j), 0) as  IHTMLInputElement;
        if  (Assigned(Element)) then  begin
          if (Element.checked)  then  begin
            Res :=  TRes.Create;
            Res.Assign(ResList[j - 1]);
            AResList.Add(Res);
          end;
        end;
      end;
    end;
  end;
  Result  :=  (AResList.Count > 0);
end;

function TZonuBrowser.GetResTopPosition(const Index: integer): integer;
var
  Element : IHTMLElement;
  s : string;
begin
  s :=  Format('ID%d', [Index + 1]);
  //age16 <> s :=  Format('%d', [Index + 1]);
  Element :=  IHTMLDocument2(Document).anchors.item(s, 0) as IHTMLElement;
  if  (Assigned(Element))  then  begin
    Result  :=  Element.offsetTop;
  end else begin
    Result  :=  -1;
  end;
end;

function TZonuBrowser.GetSelectedText: string;
var
  Selection : IHTMLSelectionObject;
  a : IHTMLTxtRange;
begin
  Result    :=  '';
  Selection :=  IHTMLDocument2(Document).selection as IHTMLSelectionObject;
  if  (Selection.Get_type_ <> 'None')  then  begin
    a :=  Selection.createRange as IHTMLTxtRange;
    Result  :=  a.Get_text;
  end;
end;

function TZonuBrowser.GetShowAll: boolean;
begin
  Result  :=  FShowAll;
end;

function TZonuBrowser.GetTopResNo: integer;
var
  Min, Max, Mid : integer;
  NowTop, n : integer;
begin
  Result  :=  0;    
  NowTop  :=  olevariant(IHTMLDocument2(Document)).body.scrollTop;
  Min     :=  0;
  Max     :=  ResList.Count - 1;
  while (True)  do  begin
    if  (Min >= Max) then  begin
      Result  :=  Min + 1;
      Break;
    end;
    Mid :=  Round((Max + Min) / 2);
    n   :=  GetResTopPosition(Mid);
    if  (n < NowTop)  then  begin
      Min :=  Mid + 1;
    end else
    if  (n  > NowTop) then  begin
      Max :=  Mid - 1;
    end else
    if  (n  = NowTop) then  begin
      Result  :=  Mid + 1;
      Break;
    end;
  end;
end;

procedure TZonuBrowser.Init;
begin
  FResList        :=  nil;  //TResList.Create(FThreadItem);
  FResNo          :=  0;
  {
  FSkinHeader     :=  TStringList.Create;
  FSkinRes        :=  TStringList.Create;
  FSkinNewRes     :=  TStringList.Create;
  FSkinFooter     :=  TStringList.Create;
  FSkinToday      :=  TStringList.Create;
  }
  Filtered        :=  False;
  FOldTop         :=  0;
  FIsWebPage      :=  False;
  FLoaded         :=  False;
  FWriteCount     :=  0;
  FNavigateLock   :=  False;
  FPageKill       :=  False;
  FKind           :=  bkThreadItem;
  FReleased       :=  False; //14
end;

procedure TZonuBrowser.InitOutputRes;
begin
  FResWriter  :=  TZonuResWriter.Create(FResList);
  FResWriter.SkinPath       :=  Self._SkinPath;
  FResWriter.KatjushaSkin   :=  Self._KatjushaSkin;
  FResWriter.HotzonuSkin    :=  Self._HotzonuSkin;
  FResWriter.IDPopup        :=  Self._IDPopup; //10
  FResWriter.RenderImage    :=  Self._RenderImage; //13
  FResWriter.RenderImageNewOnly    :=  Self._RenderImageNewOnly; //37
  FResWriter.ImageSize      :=  Self._ImageSize; //13
  FResWriter.Board          :=  Self.Board; //26
  FWriteCount :=  0;
end;

procedure TZonuBrowser.InitSkin(ABoard: TBoard);
var
  s: string;
begin
  if  (not IsWebPage) then  begin
    if  (ABoard <> nil) then  begin
      s :=  ABoard.Site.SiteID + '_' + ABoard.BoardID;
      InitSkin(ABoard.Site.SiteID, s);
    end else begin
      s :=  'default';
      InitSkin('', s);
    end;
  end;
end;

procedure TZonuBrowser.InitSkin(const ASiteID, ABoardID: string);
var
  ini: TMemIniFile;
  //ABoard: TBoard;
  s: string;
  b: boolean;
begin
  ini :=  TMemIniFile.Create(ZonuConfig.UsersPath + INI_SKIN);
  b   :=  False;
  if  (ini.SectionExists(ABoardID))  then  begin
    FSkinPath       :=  ini.ReadString(ABoardID, 'SKINPATH', '');
    FKatjushaSkin   :=  ini.ReadBool(ABoardID, 'KATJUSHA', False);
    FHotzonuSkin    :=  ini.ReadBool(ABoardID, 'HOTZONU', False);
    FIDPopup        :=  ini.ReadBool(ABoardID, 'IDPopup', True); //10
    FRenderImage    :=  ini.ReadBool(ABoardID, 'RenderImage', False); //13
    FRenderImageNewOnly :=  ini.ReadBool(ABoardID, 'RenderImageNewOnly', False); //37
    FImageSize      :=  ini.ReadInteger(ABoardID, 'ImageSize', 24); //13
    b :=  (FSkinPath <> '');
  end;
  if  (not b) and (ASiteID <> '') then  begin
    if  (ini.SectionExists(ASiteID))  then  begin
      FSkinPath       :=  ini.ReadString(ASiteID, 'SKINPATH', '');
      FKatjushaSkin   :=  ini.ReadBool(ASiteID, 'KATJUSHA', False);
      FHotzonuSkin    :=  ini.ReadBool(ASiteID, 'HOTZONU', False);
      FIDPopup        :=  ini.ReadBool(ASiteID, 'IDPopup', True); //10
      FRenderImage    :=  ini.ReadBool(ASiteID, 'RenderImage', False); //13
      FRenderImageNewOnly :=  ini.ReadBool(ABoardID, 'RenderImageNewOnly', False); //37
      FImageSize      :=  ini.ReadInteger(ASiteID, 'ImageSize', 24); //13
      b :=  (FSkinPath <> '');
    end;
  end;
  if  (not b) then  begin
    s :=  'default';
    FSkinPath       :=  ini.ReadString(s, 'SKINPATH', ZonuConfig.UsersPath + PATH_SKIN + 'default');
    FKatjushaSkin   :=  ini.ReadBool(s, 'KATJUSHA', False);
    FHotzonuSkin    :=  ini.ReadBool(s, 'HOTZONU', False);
    FIDPopup        :=  ini.ReadBool(s, 'IDPopup', True); //10
    FRenderImage    :=  ini.ReadBool(s, 'RenderImage', False); //13
    FRenderImageNewOnly :=  ini.ReadBool(s, 'RenderImageNewOnly', False); //37
    FImageSize      :=  ini.ReadInteger(s, 'ImageSize', 24); //13
  end;
  ini.Free;
end;

procedure TZonuBrowser.NgData(Res: TRes; Action: TZonuAction);
begin
  //
end;

procedure TZonuBrowser.Release;
begin
  {
  if  (FSkinHeader <> nil)  then  FreeAndNil(FSkinHeader);
  if  (FSkinRes <> nil) then  FreeAndNil(FSkinRes);
  if  (FSkinNewRes <> nil)  then  FreeAndNil(FSkinNewRes);
  if  (FSkinFooter <> nil)  then  FreeAndNil(FSkinFooter);
  if  (FSkinToday <> nil) then  FreeAndNil(FSkinToday);
  }
  //14
  if  (not FReleased) then  begin
    if  (FResList <> nil)  then  begin
      FreeAndNil(FResList);
    end;
    if  (FThreadItem <> nil)  then  begin
      FThreadItem.ReleaseRef;
    end;
    try
      if  (Assigned(Document))  then  begin
        IHTMLDocument2(Document).Clear;
        IHTMLDocument2(Document).Close;
      end;
    finally
      //
    end;
  end;
  FReleased :=  True; //14
  SendToBack;
  Hide;
end;

procedure TZonuBrowser.ResetTabImage;
begin
  ToolButton.AutoSize    :=  False;
  ToolButton.ImageIndex  :=  -1;
  if  (State = vsDownloading) then  begin
    ToolButton.ImageIndex  :=  33;
  end else
  if  (State = vsCacheLoading) then  begin
    ToolButton.ImageIndex  :=  34;
  end else begin
    if  (NavigateLock)  then  begin
      ToolButton.ImageIndex  :=  25;
    end else begin
      if  (not IsWebPage) then  begin
        case  Kind  of
          bkThreadItem  :
          begin
            if  (ThreadItem.IsKakoLog)  then  begin
              ToolButton.ImageIndex  :=  28;
            end else
            if  (ThreadItem.Site = ZonuEnviron.LocalSite)  or
                (ThreadItem.InLocalFolder)  then
            begin
              ToolButton.ImageIndex  :=  39;
            end else begin
              ToolButton.ImageIndex  :=  -1;
            end;
          end;
          bkFilter      : ToolButton.ImageIndex  :=  32;
        end;
      end;
    end;
  end;
  ToolButton.AutoSize    :=  True;
end;

procedure TZonuBrowser.ScrollTo(ResNo: integer);
var
  s : string;
  Element     : IHTMLElement;
  //n : integer;
begin
  s :=  Format('ID%d', [ResNo]);
  //age16 <> s :=  Format('%d', [ResNo]);
  Element :=  IHTMLDocument2(Document).anchors.item(s, 0) as IHTMLElement;
  (*age16 <>
  if  not (Assigned(Element))  then  begin
    //age16
    s :=  Format('ID%d', [ResNo]);
    Element :=  IHTMLDocument2(Document).anchors.item(s, 0) as IHTMLElement;
  end;
  if  not (Assigned(Element))  then  begin
    //age16
    s :=  Format('CHK%d', [ResNo]);
    //Element :=  IHTMLDocument2(Document).anchors.item(s, 0) as IHTMLElement;
    Element :=  IHTMLDocument2(Document).anchors.item('CHK' + IntToStr(ResNo), 0) as  IHTMLElement;
  end;
  *)
  if  (Assigned(Element))  then  begin
    OleVariant(IHTMLDocument2(Document)).body.scrollTop	:= Element.offsetTop;
  end;
end;

procedure TZonuBrowser.SetIsWebPage(const Value: boolean);
begin
  FIsWebPage := Value;
  {age16
  if  (Value) and (not FLoaded) then  begin
    FLoaded :=  True;
    Self.Loaded;
  end;
  }
end;

function TZonuBrowser.StrToResNo(const ZonuLink: string): integer;
var
  s: string;
begin
  //age16 Result  :=  StrToIntDef(ChooseString(ZonuLink, '=', 1), 0);
  //  menu:123
  s :=  ChooseString(ZonuLink, ':', 1);
  if  (StrToIntDef(s, 0) = 0)  then  begin
    s :=  ChooseString(ZonuLink, '=', 1);
  end;
  Result  :=  StrToIntDef(s, 0);
end;

procedure TZonuBrowser.WriteHeader;
var
  doc : variant;
begin
  if  (not Assigned(Document)) then  begin
    Navigate('about:blank');
    while (not Assigned(Document)) do  begin
      Forms.Application.ProcessMessages;
      if  (ZonuEnviron.Disconnected)  then  begin
        raise EZonuError.Create('ؒf܂B');
      end;
    end;
  end;
  doc :=  Document;
  doc.Clear;
  doc.Write(FResWriter.WriteHeader);
end;

procedure TZonuBrowser.WriteRes(Res: TRes);
var
  doc : variant;
begin
  if  (Res.Visible) or (not Filtered) then  begin
    if  (not Assigned(Document)) then  begin
      Navigate('about:blank');
      while (not Assigned(Document)) do  begin
        Forms.Application.ProcessMessages;
        if  (ZonuEnviron.Disconnected)  then  begin
          raise EZonuError.Create('ؒf܂B');
        end;
      end;
    end;
    doc :=  Document;
    if  (not Res.IsAboned) then  begin
      doc.Write(FResWriter.WriteRes(Res));
    end else begin
      doc.Write(Format('<A NAME="ID%d"><A>', [Res.No]));
      //age16 <> doc.Write(Format('<A NAME="%d"><A>', [Res.No]));
    end;
  end;
end;

//age16
procedure TZonuBrowser.SetBrowserMode();
begin
  if  (not FLoaded) then  begin
    FLoaded :=  True;
    {4
    ς
    ̃RgOƃuEUŃL[悤ɂȂ邯
    uEUƂƂG[o܂悤ɂȂBȂŁ`
    Self.HandleNeeded;
    Self.Loaded;
    }
    {5 
    Self.HandleNeeded;
    Self.Loaded;
    }
  end;
end;

////////////////////////////////////////////////////////////////////////////////
{ TResCacheLoader }
////////////////////////////////////////////////////////////////////////////////

constructor TResCacheLoader.Create(CreateSuspended: Boolean; AResList: TResList);
begin
  inherited Create(CreateSuspended);
  FResList        :=  AResList;
  NewHtmlStrings  :=  TZonuHtmlStrings.Create;
end;

destructor TResCacheLoader.Destroy;
begin
  NewHtmlStrings.Free;
  inherited;
end;

procedure TResCacheLoader.Execute;
var
  DatIni    : TMemIniFile;
  Cache     : TStringList;
  i, f      : integer;
  ReadCount : integer;
  Res       : TRes;
  ASubject  : string;
begin
  inherited;
  NewHtmlStrings.ResList              :=  ResList;
  {
  NewHtmlStrings.SkinPath             :=  ZonuConfig.SkinPath;
  NewHtmlStrings.KatjushaSkin         :=  ZonuConfig.KatjushaSkin;
  NewHtmlStrings.HotzonuSkin          :=  ZonuConfig.HotzonuSkin;
  }
  NewHtmlStrings.InitSkin(ThreadItem.Board);
  NewHtmlStrings.InitOutputRes;
  //
  Cache :=  TStringList.Create;
  if  (ThreadItem.DatExists)  then  begin
    Cache.LoadFromFile(ThreadItem.LocalDatFileName);
  end;
  ReadCount   :=  ThreadItem.ReadCount;
  DatIni      :=  TMemIniFile.Create(ChangeFileExt(ThreadItem.LocalDatFileName, '.inf'));

  if  (not ZonuConfig.ResLoadAll) and (Cache.Count > ZonuConfig.ResShowCount) then  begin
    //f :=  Cache.Count - ZonuConfig.ResShowCount;
    f :=  ReadCount - ZonuConfig.ResShowCount;
    if  (f >= ThreadItem.ReadPoint - 1) and (ThreadItem.ReadPoint > 0) then  begin
      f :=  ThreadItem.ReadPoint - 2;
      if  (f < 0) then  f :=  0;
    end;
    if  (f >= (ThreadItem.DownloadCount - ThreadItem.NewCount)) and (ThreadItem.ReadPoint > 0) then  begin
      f :=  ThreadItem.DownloadCount - ThreadItem.NewCount - 2;
      if  (f < 0) then  f :=  0;
    end;
  end else begin
    f :=  0;
    NewHtmlStrings.ShowAll  :=  True;
  end;
  for i :=  0 to  Cache.Count - 1 do  begin
    if  (Cache[i] <> '')  then  begin
      Res       :=  TRes.Create;
      Res.No    :=  i + 1;
      Res.IsReadPoint :=  (Res.No = ThreadItem.ReadPoint);
      ParseLocalDat(Cache[i], i, Res, ASubject);
      Res.BBS   :=  ThreadItem.BBS;
      Res.Site  :=  ThreadItem.Site;
      Res.IsAboned  :=  DatIni.ReadBool('ERASE', 'RES' + IntToStr(i + 1), False);
      Res.IsSiori   :=  (ThreadItem.BookmarkList.FindRes(i + 1) <> nil);
      //
      Res.IsNew     :=  (ReadCount < ResList.Count + 1);
      Res.IsChecked :=  (not Res.IsNew);
      //
      ResList.Add(Res);
      if  (f < i) or (i = 0) then  begin
        Res.Showing :=  True;
        NewHtmlStrings.WriteRes(Res);
      end else begin
        Res.Showing :=  False;
      end;
    end;
    if  (i = 0) then  begin
      Synchronize(FireProgressEvt);
      NewHtmlStrings.Clear;
    end;
  end;
  //*!*
  if  (NewHtmlStrings.Text <> '') then  begin
    Synchronize(FireProgressEvt);
  end;
  Synchronize(FireEndEvt);
  DatIni.Free;
  Cache.Free;
  NewHtmlStrings.EndOutputResNoFooter;
end;

procedure TResCacheLoader.FireEndEvt;
begin
  if  (Assigned(FEndEvt)) then  begin
    FEndEvt(Self);
  end;
end;

procedure TResCacheLoader.FireProgressEvt;
begin
  if  (Assigned(FProgressEvt)) then  begin
    FProgressEvt(Self);
  end;
end;

procedure TZonuBrowser.SetFiltered(const Value: boolean);
begin
  FFiltered   := Value;
  if  (not Value) then  begin
    FFilterText   :=  '';
    FFilterCount  :=  0;
  end;
end;

{ TZonuHintWindow }

constructor TZonuHintWindow.Create(AOwner: TComponent);
begin
  inherited;
  Color   :=  clInfoBk;
end;

{
function TZonuHintWindow.QueryInterface(const IID: TGUID;
  out Obj): HResult;
begin
  if GetInterface(IID, Obj) then
    Result := 0
  else
    Result := E_NOINTERFACE;
end;
}

function TZonuHintWindow._AddRef: Integer;
begin
  Result := 0; //ق
end;

function TZonuHintWindow._Release: Integer;
begin
  Result := 0; //ق
end;

//12
function  TZonuHintWindow.ForceCurrentThradItem: boolean;
begin
  Result  :=  False;
end;

procedure TZonuHintWindow.Show(const Text: string; const p: TPoint);
var
  ARect : TRect;
begin
  // from GikoNavi
  ARect :=  CalcHintRect(Screen.Width, Text, nil);
  ARect.Top   :=  ARect.Top   + p.y;      //Ȃ WinApi݂
  ARect.Left  :=  ARect.Left  + p.x;      //A킩ȂB

  if  (AnsiPos(#9, Text) > 0) then  begin //  킩ȂB
    //̍ŝł傢ƐL΂
    ARect.Bottom:=  ARect.Bottom+ p.y + 8;
    //ARect.Right :=  ARect.Right + p.x + 48;
    ARect.Right :=  ARect.Right + p.x + 64;
  end else begin
    ARect.Bottom:=  ARect.Bottom+ p.y;
    ARect.Right :=  ARect.Right + p.x;
  end;
    {
  if  (FHintWindow.IsMailMsg) then  begin
    ARect.Right :=  ARect.Right + 64; //ɂȂ̂ł傢傫߂
  end;
  }
  ActivateHint(ARect, Text);
end;

procedure TZonuHintWindow.ShowAtCursorPos(const Text: string);
var
  p : TPoint;
  DispText : string;
  ARect : TRect;
begin
  DispText  :=  DecodeHtmlEsc(Text);
  GetCursorPos(p);
  if  (ZonuConfig.PopupPosition = ppTop)  then  begin
    ARect :=  CalcHintRect(Screen.Width, DispText, nil);
    p.x   :=  p.x + 8;
    p.y   :=  p.y -(ARect.Bottom - ARect.Top)  - 8;
    if  (p.y  <  0) then  P.y :=  0;
  end else begin
    p.x :=  p.x + 15;
    p.y :=  p.y + 15;
  end;
  Show(DispText, p);
end;

procedure TZonuHintWindow.ShowThreadInfo(const SiteName, BoardName,
  ThreadName: string);
begin
  ShowThreadInfo(SiteName, BoardName, ThreadName, nil);
end;

procedure TZonuHintWindow.ShowThreadInfo(const SiteName, BoardName,
  ThreadName: string; ResList: TResList);
var
  DispText : string;
  i : integer;
  AThreadName, ABoardName : string;
begin
  {$IFDEF NUXX}
  Dialogs.ShowMessage('TZonuHintWindow.ShowThreadInfo');
  {$ELSE}
  if (ThreadName = '')  then  begin
    AThreadName  :=  '<LbV>';
  end else begin
    AThreadName := ThreadName;
  end;
  if (BoardName = '')   then  begin
    ABoardName   :=  '<Y>';
  end else begin
    ABoardName := BoardName;
  end;
  DispText  :=  '' + AThreadName + '^' + ABoardName + '' + SiteName;

  if  (ResList = nil) then  begin
    DispText  :=  #13#10 + '<LbV>';
  end else begin
    ResList.ThreadItem.LoadAbonedList;
    FRes  :=  '';
    for i :=  0 to  ResList.Count - 1 do  begin
      if  (ResList[i].Showing)  then  begin
        HotzonuWindow.OutputRes(Self, Self, ResList[i], ResList);
        DispText := DispText + #13#10 + #13#10 + FRes;
      end;
    end;
  end;
  ShowAtCursorPos(DispText);
  {$ENDIF}
end;

procedure TZonuHintWindow.ShowRangeRes(ResList: TResList; Prefix: string = '');
var
  DispText : string;
  i, n : integer;
  List: TList;
  s: string;
begin
  {$IFDEF NUXX}
  Dialogs.ShowMessage('TZonuHintWindow.ShowRangeRes');
  {$ELSE}
  {13
  FRes      :=  '';
  DispText  :=  '';
  if  (Prefix <> '')  then  begin
    DispText  :=  Prefix;
  end;
  HotzonuWindow.InitOutputRes(Self, ResList);
  x :=  0;
  for i :=  0 to  ResList.Count - 1 do  begin
    if  (ResList[i].Showing)  then  begin
      Inc(x);
      HotzonuWindow.OutputRes(Self, Self, ResList[i], ResList);
      if  (DispText <> '')  then  DispText := DispText + #13#10 + #13#10;
      DispText := DispText + FRes;
      if  (x > ZonuConfig.MaxPopupCount - 1)  then  Break;  //13
    end;
  end;
  }
  List      :=  TList.Create;
  FRes      :=  '';
  DispText  :=  '';
  if  (Prefix <> '')  then  begin
    DispText  :=  Prefix;
  end;
  HotzonuWindow.InitOutputRes(Self, ResList);
  for i :=  0 to  ResList.Count - 1 do  begin
    if  (ResList[i].Showing)  then  begin
      if  (ResList[i].Showing)  then  begin
        List.Add(ResList[i]);
      end;
    end;
  end;
  
  for i :=  0 to  List.Count - 1  do  begin
    n :=  i;
    if  (ZonuConfig.ResPopupOrder = poDesc) then  begin
      if  (List.Count > ZonuConfig.MaxPopupCount) then  begin
        n :=  (List.Count  - ZonuConfig.MaxPopupCount ) + i;
      end;
    end else begin
      if  (n > ZonuConfig.MaxPopupCount - 1)  then  Break;
    end;
    if  (n <= List.Count - 1)  then  begin
      HotzonuWindow.OutputRes(Self, Self, TRes(List[n]), ResList);
      if  (DispText <> '')  then  DispText := DispText + #13#10 + #13#10;
      DispText := DispText + FRes;
    end;
  end;

  if  (List.Count > ZonuConfig.MaxPopupCount) then  begin
    s :=  Format('<%dXȗ>', [List.Count - ZonuConfig.MaxPopupCount]);
    if  (ZonuConfig.ResPopupOrder = poDesc) then  begin
      DispText := s + #9#13#10 + DispText + #13#10;
    end else begin
      DispText := DispText + #13#10 + s + #9;
    end;
  end;

  List.Free;
  //
  HotzonuWindow.EndOutputRes(Self);
  ShowAtCursorPos(DispText);
  {$ENDIF}
end;

procedure TZonuHintWindow.WriteRes(Res: TRes);
begin
  FRes := IntToStr(Res.No) +
          ' eҁF' + TrimTag(Res.Name) + ' ' +
          '[' + TrimTag(Res.Mail) + ']' +
          ' eF' + TrimTag(Res.Date) +
          ' ' + Res.ID + #9 + #13#10  +
          ' ' + DecodeHtmlEsc(TrimTag(StringReplace(Res.Body, '<BR>', #13#10, [rfReplaceAll, rfIgnoreCase])));
end;

procedure TZonuHintWindow.Paint;
var
  Y : integer;
  S : TStringList;
begin
  Color       :=  ZonuConfig.PopupBkColor;
  Self.Canvas.Font.Name   :=  ZonuConfig.PopupFontName;
  Self.Canvas.Font.Size   :=  ZonuConfig.PopupFontSize;
  if  (GetForegroundWindow <> HotzonuWindow.Handle) then  begin
    ReleaseHandle;
    Exit;
  end;
  S := TStringList.Create;
  S.Text := Text;
  for y :=  0 to  S.Count - 1 do  begin
    //ǋāII
    if  (Length(S[y]) > 0)  then  begin
      //if  (Copy(S[y],6,5) = 'O:') and (Pos('e:',S[y]) > 0)  then  begin
      if  (Copy(S[y], Length(S[y]), 2) = #9)  then  begin
        //AnsiPos(#9, S[y]) > 0) then  begin
        //O̍sȂ璅F
        S[y] := Copy(S[y], 1, Length(S[y]) - 1);
        Self.Canvas.Font.Color  :=  ZonuConfig.PopupTitleColor;
        Self.Canvas.Font.Style  :=  [fsBold];
      end else begin
        Self.Canvas.Font.Color  :=  ZonuConfig.PopupTextColor;
        Self.Canvas.Font.Style  :=  [];
      end;
    end else begin
      Self.Canvas.Font.Color  :=  ZonuConfig.PopupTextColor;
      Self.Canvas.Font.Style  :=  [];
    end;
    Self.Canvas.TextOut(4, 4 + y * Abs(Self.Canvas.TextHeight(S[y])), S[y]);
  end;
  S.Free;
end;

procedure TZonuHintWindow.InitOutputRes;
begin
  //
end;

procedure TZonuHintWindow.EndOutputRes;
begin
  //
end;

function TZonuHintWindow.GetBoard: TBoard;
begin
  Result  :=  FBoard;
end;

procedure TZonuHintWindow.NgData(Res: TRes; Action: TZonuAction);
begin
  if  (Action.AboneHideInPopup)  then  begin
    Res.Name  :=  'mf';
    Res.Date  :=  'mf';
    Res.Body  :=  'mf';
  end;
end;

function TZonuHintWindow.GetShowAll: boolean;
begin
  Result := FShowAll;
end;

{ TBrowserMenuItem }

procedure TBrowserMenuItem.Clicked(Sender: TObject);
begin
  Browser.Active;
  Browser.FireActive;
end;

{ TThreadListMenuItem }

procedure TThreadListMenuItem.Clicked(Sender: TObject);
begin
  ListDoc.Active;
  ListDoc.FireActive;
end;

{ TZonuToolButton }

procedure TZonuToolButton.FireExecClose;
begin
  if  (Assigned(FExecCloseEvt)) then  begin
    FExecCloseEvt(Self);
  end;
end;

procedure TZonuToolButton.FireExecReload;
begin
  if  (Assigned(FExecReloadEvt)) then  begin
    FExecReloadEvt(Self);
  end;
end;

{ TTabData }

function TTabData.Add: TShortcutData;
var
  v : TShortcutData;
begin
  v :=  TShortcutData.Create;
  FList.Add(v);
  Result  :=  v;
end;

procedure TTabData.Assign(Source: TPersistent);
begin
  if  (Source is TShortcutData)  then  begin
    FTitle  :=  TTabData(Source).Title;
    FBitmapFileName :=  TTabData(Source).BitmapFileName;
    FColor  :=  TTabData(Source).Color;
    FBitmap :=  TTabData(Source).Bitmap;
  end else begin
    inherited Assign(Source);
  end;
end;

constructor TTabData.Create;
begin
  FList :=  TList.Create;
  FBitmap :=  Graphics.TBitmap.Create;
end;

procedure TTabData.Delete(Index: integer);
begin
  TObject(FList[Index]).Free;
  FList.Delete(Index);
end;

destructor TTabData.Destroy;
var
  i : integer;
begin
  for i :=  FList.Count - 1 downto  0 do  begin
    TObject(FList[i]).Free;
    FList.Delete(i);
  end;
  FList.Free;
  FBitmap.Free;
  inherited;
end;


function TTabData.GetShortcutCount: integer;
begin
  Result  :=  FList.Count;
end;

function TTabData.GetShortcuts(Index: integer): TShortcutData;
begin
  Result  :=  TShortcutData(FList[index]);
end;

function TTabData.Insert(const Index: integer): TShortcutData;
var
  v : TShortcutData;
begin
  v :=  TShortcutData.Create;
  FList.Insert(Index, v);
  Result  :=  v;
end;

procedure TTabData.SetBitmapFileName(const Value: string);
var
 s: string;
begin
  FBitmapFileName := Value;
  SetCurrentDir(ZonuConfig.AppPath);
  s :=  ExtractRelativePath(ZonuConfig.AppPath, Value);
  if  (FileExists(s)) then  begin
    try
      FBitmap.LoadFromFile(s);
    except
      MessageDlg('w肳ꂽ摜͗pł܂B', mtError, [mbOk], 0);
      //
    end;
  end;
end;

procedure TTabData.SetShotcuts(Index: integer; const Value: TShortcutData);
begin
  FList[index]  :=  Value;
end;

{ TShortcutData }

procedure TShortcutData.Assign(Source: TPersistent);
begin
  if  (Source is TShortcutData)  then  begin
    FParam1     :=  TShortcutData(Source).Param1;
    FTitle      :=  TShortcutData(Source).Title;
    FParam2     :=  TShortcutData(Source).Param2;
    FParam3     :=  TShortcutData(Source).Param3;
    FObjectType :=  TShortcutData(Source).ObjectType;
  end else begin
    inherited Assign(Source);
  end;
end;

end.
