{ *************************************************************************** }
{                                                                             }
{ Hotzonu Function Library                                                    }
{                                                                             }
{ 2001-04 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Hzbfunc;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, ToolWin, ActnList, ZonuSplitter, MSHTML,
  EnhListView, ExtListView, OleCtrls, SHDocVw, EmbeddedWB, StdCtrls, IniFiles,
  Buttons, Menus, MenuBar, ImgList, ZonuClass, ZonuConf, Main, Hzbclass,
  ShellApi, ActiveX, Mmsystem, Hzbconst, ZonuShortcutBar;

type
  //10
  TLinkItem = class(TObject)
  private
    FFileExt: string;
    FUrl: string;
    FFileName: string;
    FRes: TRes;
    FResList: TResList;
    //FIsBookmarked: boolean;
  public
    property  ResList: TResList   read  FResList  write FResList;
    property  Res: TRes   read  FRes  write FRes;
    property  Url: string read  FUrl  write FUrl;
    property  FileName: string  read  FFileName write FFileName;
    property  FileExt: string read  FFileExt  write FFileExt;
    //property  IsBookmarked: boolean read  FIsBookmarked write FIsBookmarked;
  end;


  procedure InitUserData(const Path: string);
  procedure BuildSiteList(TreeView: TTreeView; RootNode: TTreeNode;
    ImageList: TImageList); overload;
  procedure BuildSiteList(ComboBox: TComboBox; ImageList: TImageList); overload;

  procedure CommandBoardList(TreeView: TTreeView);

  procedure BuildBoardList(TreeView: TTreeView; ParentNode: TTreeNode); overload;
  //21 begin
  //procedure BuildBoardList(TreeView: TTreeView; Site: TSite); overload;
  procedure BuildBoardList(TreeView: TTreeView; Site: TSite;
    const FindText: string = ''); overload;
  //21 end

  procedure CreateNewListDoc(var NewListDoc: TZonuListDoc;
      ThreadItemList, AllThreadItemList: TThreadItemList;
      Board: TBoard; const Title: string;
      Activate: boolean);
  procedure CreateNewBrowser(var NewBrowser: TZonuBrowser;
      ResList: TResList; ThreadItem: TThreadItem; const Title: string;
      Activate: boolean);
  procedure RecalcToolBarSize(ToolBar: TToolBar);
  function  CalcToolBarSize(ToolBar: TToolBar): integer;

  function GetActiveToolButton(ToolBar: TToolBar; var Button: TToolButton): boolean;

  function FindListDoc(Board: TBoard; var ListDoc: TZonuListDoc): boolean;
  function FindThreadPageIndex(ListDoc: TZonuListDoc): integer; overload;
  function FindThreadPageIndex(Board: TBoard): integer; overload;
  function FindBrowserPageIndex(Browser: TZonuBrowser): integer; overload;
  function FindBrowserPageIndex: integer; overload;

  procedure CloseThreadList(ScreenUpdate: boolean); overload;
  procedure CloseThreadList(ListDoc: TZonuListDoc; ScreenUpdate: boolean); overload;
  procedure CloseBrowser(ScreenUpdate: boolean); overload;
  procedure CloseBrowser(Browser: TZonuBrowser; ScreenUpdate: boolean); overload;
  procedure SetActionEnabled(AEnabled: boolean);  overload;
  procedure SetActionEnabled(const Category: string; const AEnabled: boolean); overload;

  procedure CommandThreadList(Sender: TObject);
  procedure DeleteThreadLog(ThreadItem: TThreadItem);
  procedure ShowDoubleWindow;
  procedure LoadShortCutSetting;

  procedure SaveBoardListSetting(TreeView: TTreeView; Site: TSite);

  function GetRangeRes(const Url: string;
    var ResList: TResList;
    var ThreadItem: TThreadItem;
    var pBoard: TBoard;
    var pSite: TSite;
    out ResStart: integer): boolean;
  procedure CopyRangeRes(OrgResList: TResList; var ToResList: TResList;
    ResStart, ResEnd: integer; NoFirst: boolean); overload;

  procedure CopyRangeRes(OrgResList: TResList; var ToResList: TResList;
    AId: string); overload; //9

  function  ExtractParamInfo(const Url: string; ThreadItem: TThreadItem;
    out BoardID, DatNo: string; out ResStart, ResEnd: integer;
    out NoFirst: boolean): boolean;

  procedure ExecBrowser(const Url: string);

  //22 procedure Navigate(const Url, Title: string; Active: boolean);
  procedure Navigate(const Url, Title: string; Active: boolean;
    IgnoreNavigateDialog: boolean = False);
  //22 procedure Open(const Url: string);
  procedure Open(const Url: string; IgnoreNavigateDialog: boolean = False);
  procedure SaveUrlLog(Strings: TStrings; const Url: string);

  procedure DeleteFromFav(ThreadItem: TThreadItem);
  procedure BuildTools;
  function FindAction(const AName: string): TAction;
  procedure LoadToolButtons(const FileName: string; ToolBar: TToolBar);
  procedure BuildSearchEngineList(Menu: TPopupMenu);
  procedure LoadPopupMenuItems(const FileName: string; PopupMenu: TPopupMenu);

  function AddBoard(Site: TSite; const CategoryName, BoardName, Path: string): boolean;
  function EditBoard(Site: TSite; Board: TBoard): boolean;
  function DeleteBoard(Site: TSite; Board: TBoard): boolean;

  procedure ScrollBoardList(Board: TBoard);

  procedure BuildShortcutList(ListBox: TListBox; FileName: string = '');
  procedure SaveShortcutList(ListBox: TListBox; FileName: string = '');
  procedure DrawTabDataListBox(ListBox: TListBox;
    Index: Integer; ARect: TRect; State: TOwnerDrawState);
  procedure ReleaseShortcutList(ListBox: TListBox);
  procedure DeleteFromShortcut(ThreadItem: TThreadItem);

  procedure RebuildColumn(FViewColumn: TStringList);
  //age16
  //procedure SaveHist(ThreadItem: TThreadItem; const FileName: string;
  //  const Sort: boolean);
  procedure SaveHist(ThreadItem: TThreadItem; const FileName: string;
    const Sort: boolean; ASaveHist: boolean);

  procedure BuildLocalThreadList(ListDoc: TZonuListDoc; Path: string = '');
  function  IsToday(const DateText: string): boolean;
  procedure AddWindowList(Form: TForm);
  //procedure DeleteWindowList(Form: TForm);
  procedure BuildWindowList;
  function  ExtractSkinName(const FileName: string): string;
  procedure RefreshThreadListEx(ThreadItem: TThreadItem);
  procedure CreateDefaultFavFolder;
  function  GetDefaultFavFolder(var Board: TBoard): boolean;
  procedure ShowResToDoubleWindow(ThreadItem: TThreadItem; Res: TRes);
  procedure HideBrowser(Browser: TZonuBrowser; MoveToPanel: boolean);
  procedure BuildGaishutuMenu(GaishutuMenu: TPopupMenu);
  procedure UpdateFav(const OldBoardPath, OldBoardID,
    NewBoardPath, NewBoardName : string; NewBoard: TBoard);
  function ExtractRes(ResList: TResList; ResNo: integer; var OutList: TResList): integer;
  procedure BuildBBSToolBar(var ToolBar: TToolBar);
  procedure KillAge2ch;
  procedure BuildBBSFunc;
  procedure BuildRecentMenu(MenuItem: TMenuItem; const rw: integer);
  procedure PlaySound(SoundType: TSoundType);
  procedure SaveToolBarPos(CoolBar: TCoolBar; const SectionName: string);
  procedure LoadToolBarPos(Coolbar: TCoolBar; const SectionName: string);
  procedure ChangeBrowserFontSize(Size: OleVariant);
  //age16 function HzbFind(const FindText, Text: string): integer;
  function HzbFind(const FindText, Text: string; IgnoreCase: boolean = False): integer;  //age16
  procedure AddLog(AText: string);  //age16
  function AddTag(const AText, AFindText, ATagBefore, ATagAfter: string): string; //7
  procedure ExtractLink(ResList: TResList; LinkList: TList; const NewOnly: boolean);  //10

  function InTextRes(
    const AllTarget, HandleTarget, HandleLike, MailTarget, IDTarget, BodyTarget: boolean;
    IgnoreCase, InsertTag: boolean;
    const AFindText: string; Res: TRes): boolean;
  procedure FilterResHoliday(
    Board: TBoard;
    const AllTarget, HandleTarget, HandleLike, MailTarget, IDTarget, BodyTarget: boolean;
    const FindText: string; IgnoreCase, InsertTag: boolean);
  procedure SetShortTitle(Browser: TZonuBrowser);
  procedure CleanupBookmarkFile(AThreadItem: TThreadItem);  //13
  procedure BrowserExec(Browser: TZonuBrowser; op: TBrowserExec); //13
  procedure Wrapable(ToolBar: TToolBar); //24
  function GetBoardListURL(const URL: string; var Board: TBoard): boolean;
  procedure LoadDatOchi(AListDoc: TZonuListDoc);  //33

implementation

uses
  MonaUtils, Zonutils, ZonuCommon, Boardedt, ZonuHttp,
  Histdlg, Msgdlg;

type
  TToolBarA = class(TToolBar)
  private
  public
  end;

  TListViewA = class(TCustomListView)
  private
  public
  end;

procedure InitUserData(const Path: string);
var
  sl: TStringList;
begin
  //tH_
  if  (not DirectoryExists(ZonuConfig.UsersPath))  then  begin
    ForceDirectories(ZonuConfig.UsersPath);
  end;

  //V[gJbgo[
  if  (not FileExists(ZonuConfig.UsersPath + FILE_SHORTCUT))  then  begin
    CopyFile(PChar(ZonuConfig.AppPath + PATH_DEF + FILE_SHORTCUT),
             PChar(ZonuConfig.UsersPath + FILE_SHORTCUT),
             True);
  end;
  //c[o[
  if  (not FileExists(ZonuConfig.UsersPath + FILE_TOOLBAR_INI))  then  begin
    CopyFile(PChar(ZonuConfig.AppPath + PATH_DEF + FILE_TOOLBAR_INI),
             PChar(ZonuConfig.UsersPath + FILE_TOOLBAR_INI),
             True);
  end;
  //|bvAbvj[
  if  (not FileExists(ZonuConfig.UsersPath + FILE_POPUPMENU_INI))  then  begin
    if  (FileExists(ZonuConfig.AppPath + PATH_DEF + FILE_POPUPMENU_INI))  then  begin
      CopyFile(PChar(ZonuConfig.AppPath + PATH_DEF + FILE_POPUPMENU_INI),
               PChar(ZonuConfig.UsersPath + FILE_POPUPMENU_INI),
               True);
    end;
  end;
  //Cɓ
  {
  if  (not DirectoryExists(ZonuConfig.UsersPath + PATH_FAVORITES))  then  begin
    ForceDirectories(ZonuConfig.UsersPath + PATH_FAVORITES);
  end;
  //CɓXML
  if  (not FileExists(ZonuConfig.UsersPath + PATH_FAVORITES + FILE_FAVORITES_XML))  then
  begin
    CopyFile(PChar(ZonuConfig.AppPath + PATH_DEF + PATH_FAVORITES + FILE_FAVORITES_XML),
             PChar(ZonuConfig.UsersPath + PATH_FAVORITES + FILE_FAVORITES_XML),
             True);
  end;
  if  (not FileExists(ZonuConfig.UsersPath + PATH_FAVORITES + FILE_FAVORITES_DTD))  then
  begin
    CopyFile(PChar(ZonuConfig.AppPath + PATH_DEF + PATH_FAVORITES + FILE_FAVORITES_DTD),
             PChar(ZonuConfig.UsersPath + PATH_FAVORITES + FILE_FAVORITES_DTD),
             True);
  end;
  //tH_
  if  (not DirectoryExists(ZonuConfig.UsersPath + PATH_ROUND)) then  begin
    ForceDirectories(ZonuConfig.UsersPath + PATH_ROUND);
  end;
  }
  //AAXg
  if  (not FileExists(ZonuConfig.UsersPath + FILE_AA_LIST))  then  begin
    CopyFile(PChar(ZonuConfig.AppPath + PATH_DEF + FILE_AA_LIST),
             PChar(ZonuConfig.UsersPath + FILE_AA_LIST),
             True);
  end;
  //GWXg
  if  (not FileExists(ZonuConfig.UsersPath + FILE_SEARCH_ENGINE))  then  begin
    CopyFile(PChar(ZonuConfig.AppPath + PATH_DEF + FILE_SEARCH_ENGINE),
             PChar(ZonuConfig.UsersPath + FILE_SEARCH_ENGINE),
             True);
  end;
  //Skin
  if  (not DirectoryExists(ZonuConfig.UsersPath + PATH_SKIN))  then  begin
    ForceDirectories(ZonuConfig.UsersPath + PATH_SKIN);
    CopyFileEx(ZonuConfig.AppPath + PATH_DEF + PATH_SKIN + '*.*',
               ZonuConfig.UsersPath + PATH_SKIN,
               True);
  end;
  //SkinModule
  if  (not DirectoryExists(ZonuConfig.UsersPath + PATH_SKIN_MODULE))  then  begin
    ForceDirectories(ZonuConfig.UsersPath + PATH_SKIN_MODULE);
  end;
  //
  if  (FileExists(ZonuConfig.UsersPath + FILE_COLUMN))  then  begin
    CopyFile(PChar(ZonuConfig.AppPath + PATH_DEF + FILE_COLUMN),
             PChar(ZonuConfig.UsersPath + FILE_COLUMN),
             True);
  end;
  //Sound
  if  (not FileExists(ZonuConfig.UsersPath + 'newres.wav'))  then  begin
    CopyFileEx(ZonuConfig.AppPath + PATH_DEF + '*.wav',
               ZonuConfig.UsersPath,
               True);
  end;

  //age 13 (age 12܂ł̌GWXgC)
  //GWXg̏C
  if  (FileExists(ZonuConfig.UsersPath + FILE_SEARCH_ENGINE)) then  begin
    sl  :=  TStringList.Create;
    sl.LoadFromFile(ZonuConfig.UsersPath + FILE_SEARCH_ENGINE);
    if  (sl.Values['Google'] = 'http://www.google.co.jp/search?q=%s&hl=ja&btnG=Google+%8C%9F%8D%F5&lr=lang_ja')  then  begin
      sl.Values['Google'] :=  'http://www.google.com/search?num=100&hl=ja&ie=EUC-JP&q=%s ';
      sl.SaveToFile(ZonuConfig.UsersPath + FILE_SEARCH_ENGINE);
    end;
    sl.Free;
  end;
end;

procedure BuildSiteList(ComboBox: TComboBox; ImageList: TImageList);
var
  Site    : TSite;
  BBSList : TStringList;
  //BBSNode : TTreeNode;
  Bmp     : TBitmap;
  p       : TColor;
  i, x, y : integer;
begin
  ComboBox.Items.Clear;
  if  (FileExists(ZonuConfig.UsersPath + FILE_USER_BBS))  then  begin
    BBSList :=  TStringList.Create;
    BBSList.LoadFromFile(ZonuConfig.UsersPath + FILE_USER_BBS);
    for i :=  0 to  BBSList.Count - 1 do  begin
      if  (ZonuEnviron.SiteList.FindSite(BBSList[i], Site))  then  begin
        Site.IsSubscription :=  True;
        y :=  ComboBox.Items.Add(Site.SiteName);
        if  (Site.ImageIndex = 0) then  begin
          if  (FileExists(Site.ConfigPath +  FILE_BBS_ICON))  then  begin
            Bmp   :=  TBitmap.Create;
            Bmp.LoadFromFile(Site.ConfigPath +  FILE_BBS_ICON);
            p     :=  Bmp.Canvas.Pixels[0,15];
            x     :=  ImageList.AddMasked(Bmp, p);
            Bmp.Free;
          end else begin
            x :=  1;
          end;
          Site.ImageIndex :=  x;
          Bmp :=  TBitmap.Create;
          ImageList.GetBitmap(x, Bmp);
          Site.Image.Assign(Bmp);
          Bmp.Free;
        end;
        ComboBox.Items.Objects[y] :=  Site;
        {
        BBSNode :=  TreeView.Items.AddChild(RootNode, Site.SiteName);
        Site.ImageIndex         :=  x;
        BBSNode.ImageIndex      :=  x;
        BBSNode.SelectedIndex   :=  x;
        BBSNode.Data            :=  Site;
        }
      end;
    end;
    BBSList.Free;
  end;
  ComboBox.DropDownCount  :=  ComboBox.Items.Count;
end;

procedure BuildSiteList(TreeView: TTreeView; RootNode: TTreeNode;
  ImageList: TImageList);
var
  Site    : TSite;
  BBSList : TStringList;
  BBSNode : TTreeNode;
  Bmp     : TBitmap;
  p       : TColor;
  i, x    : integer;
begin
  //RootNode.DeleteChildren;
  if  (FileExists(ZonuConfig.UsersPath + FILE_USER_BBS))  then  begin
    BBSList :=  TStringList.Create;
    BBSList.LoadFromFile(ZonuConfig.UsersPath + FILE_USER_BBS);
    for i :=  0 to  BBSList.Count - 1 do  begin
      if  (ZonuEnviron.SiteList.FindSite(BBSList[i], Site))  then  begin
        Site.IsSubscription :=  True;
        BBSNode :=  TreeView.Items.AddChild(RootNode, Site.SiteName);
        if  (FileExists(Site.ConfigPath +  FILE_BBS_ICON))  then  begin
          Bmp   :=  TBitmap.Create;
          Bmp.LoadFromFile(Site.ConfigPath +  FILE_BBS_ICON);
          p     :=  Bmp.Canvas.Pixels[0,15];
          x     :=  ImageList.AddMasked(Bmp, p);
          Bmp.Free;
        end else begin
          x :=  1;
        end;
        Site.ImageIndex         :=  x;
        BBSNode.ImageIndex      :=  x;
        BBSNode.SelectedIndex   :=  x;
        BBSNode.Data            :=  Site;
      end;
    end;
    BBSList.Free;
  end;
end;

procedure CommandBoardList(TreeView: TTreeView);
var
  o : TObject;
  //i : integer;
begin
  HotzonuWindow.StatusBar1.Panels[0].Text :=  '';
  HotzonuWindow.StatusBar1.Panels[1].Text :=  '';
  if  (TreeView.Selected <> nil) then  begin
    if  (TreeView.Selected.Data <> nil) then  begin
      o :=  TObject(TreeView.Selected.Data);
      //
      //  {[h
      //
      if  (o is TBoard) then  begin
        //{[hꗗ
        //CurrentBoard  :=  TBoard(o);
        //i :=  FindThreadPageIndex(TBoard(o));
        //if  (i > -1) then  begin
        //  TabControl1.TabIndex  :=  i;
        //  if  (TabControl1.Tabs.Objects[i] <> nil)  then  begin
        //    TZonuListDoc(TabControl1.Tabs.Objects[i]).Active;
        //  end;
        //end else begin
        if  (TBoard(o).BoardType = btWebPage) then  begin
          Navigate(TBoard(o).Url, TBoard(o).Name, True);
          if  (HotzonuWindow.actShowThreadList2.Checked) and
              (ZonuConfig.ChangePaneBoardList)  then
          begin
            HotzonuWindow.actShowPaneChange.Execute;
          end;
        end else  begin
          HotzonuWindow.LoadThreadList(TBoard(o));
          if  (TBoard(o).BoardType = btBBSBoard) or
              (TBoard(o).BoardType = btRSS) then  //14
          begin
            if  (ZonuConfig.Cached) then  begin
              TBoard(o).Gaishutu  :=  True;
              TreeView.Selected.ImageIndex     :=  15;
              TreeView.Selected.SelectedIndex  :=  15;
            end;
          end;
          if  (not HotzonuWindow.actShowThreadList2.Checked) and
              (ZonuConfig.ChangePaneBoardList)  then
          begin
            HotzonuWindow.actShowPaneChange.Execute;
          end;
        end;
        //end;
      end else
      //
      //  SITE
      //
      if  (o is TSite) then  begin
        if  (not TreeView.Selected.HasChildren)  then  begin
          BuildBoardList(TreeView, TreeView.Selected);
          if  (ZonuConfig.BoardListSetting = 1) then  begin
            TreeView.Selected.Expand(False);
          end;
        end;
      end else
      //
      //  JĂ{[h
      //
      //if  (o is TZonuListDoc) then  begin
        //JĂ{[h
        //CurrentBoard  :=  TZonuListDoc(o).Board;
        //i :=  FindThreadPageIndex(TZonuListDoc(o));
        //if  (i > -1)  then  TabControl1.TabIndex  :=  i;
        //TZonuListDoc(o).Active;
      //end else
      //
      //  JĂXbh
      //
      //if  (o is TZonuBrowser) then  begin
        //i :=  FindResPageIndex(TZonuBrowser(o));
        //if  (i > -1)  then  TabControl2.TabIndex  :=  i;
        //TZonuBrowser(o).Active;
      //end;
    end else begin
      //
      //  S擾Xbh
      //
      //if  (TreeView.Selected = FAllThreadsNode) then  begin
      //  OpenHistory(ZonuConfig.UsersPath + FILE_READ_HISTORY);
      //end else
      //
      //  S擾Xbh
      //
      //if  (TreeView.Selected = FSendLogNode) then  begin
      //  OpenHistory(ZonuConfig.UsersPath + FILE_SEND_HISTORY);
      //end;
    end;
  end;
end;

//procedure BuildBoardList(TreeView: TTreeView; Site: TSite); //21
procedure BuildBoardList(TreeView: TTreeView; Site: TSite; const FindText: string = '');
var
  x : integer;
  s : string;
  CategoryNode, Node  : TTreeNode;
  CategoryName : string;
  ini : TMemIniFile;
  procedure ResetCategoryNode(CategoryName: string; CategoryNode: TTreeNode);
  begin
    if  (CategoryName <> '')  then  begin
      if  (ini.ReadBool(Site.SiteID, CategoryName, False))  then  begin
        CategoryNode.Collapse(True);
        CategoryNode.ImageIndex     :=  6;
        CategoryNode.SelectedIndex  :=  6;
      end else begin
        CategoryNode.Expand(True);
        CategoryNode.ImageIndex     :=  8;
        CategoryNode.SelectedIndex  :=  8;
        //4 begin
        if  (ZonuConfig.BoardListAutoExpand)  then  begin
          CategoryNode.Selected :=  True;
        end;
        //4 end
      end;
    end;
  end;
begin
  TreeView.Items.BeginUpdate;
  TreeView.Items.Clear;
  CategoryName  :=  '';
  CategoryNode  :=  nil;
  ini   :=  TMemIniFile.Create(ZonuConfig.UsersPath + INI_BOARDCONF);
  for x :=  0 to  Site.BoardList.Count - 1  do  begin

    if  (FindText = '') or (HzbFind(FindText, Site.BoardList[x].Name, True) > 0) then
    begin




      if  (CategoryName <> Site.BoardList[x].CategoryName)  then  begin
        ResetCategoryNode(CategoryName, CategoryNode);
        CategoryName  :=  Site.BoardList[x].CategoryName;
        CategoryNode  :=  TreeView.Items.AddChild(nil, CategoryName);
        CategoryNode.ImageIndex     :=  6;
        CategoryNode.SelectedIndex  :=  6;
      end;
      s     :=  Site.BoardList[x].Name; // + #9 + ExtractHostName(Site.BoardList[x].Url);
      //if  (ZonuConfig.ShowHostName) then  begin
      //  s     :=  s + ' (' + ExtractHostName(Site.BoardList[x].Url) + ')';
      //end;
      Node  :=  TreeView.Items.AddChild(CategoryNode, s);
      Node.Data           :=  Site.BoardList[x];
      if  (Site.BoardList[x].BoardType = btFavorites) then  begin
        Node.ImageIndex     :=  35;
        Node.SelectedIndex  :=  35;
      end else
      if  (Site.BoardList[x].BoardType = btLocalFolder) then  begin
        Node.ImageIndex     :=  36;
        Node.SelectedIndex  :=  36;
      end else
      if  (Site.BoardList[x].BoardType = btWebPage) then  begin
        Node.ImageIndex     :=  30;
        Node.SelectedIndex  :=  30;
      end else
      if  (Site.BoardList[x].Gaishutu)  then  begin
        Node.ImageIndex     :=  15; //7;
        Node.SelectedIndex  :=  15; //8;
      end else begin
        Node.ImageIndex     :=  14; //7;
        Node.SelectedIndex  :=  14; //8;
      end;

    end;

  end;
  ResetCategoryNode(CategoryName, CategoryNode);
  TreeView.Items.EndUpdate;


  if  (TreeView.Items.Count > 0)  then  begin
    s :=  ini.ReadString(Site.SiteID, 'TOP', '');
    for x :=  0 to  TreeView.Items.Count - 1  do  begin
      if  (TreeView.Items[x].Text = s)  then  begin
        TreeView.TopItem  :=  TreeView.Items[x];
        Break;
      end;
    end;
  end;

  ini.Free;
end;

//
//  {[hꗗ̍\z
//
procedure BuildBoardList(TreeView: TTreeView; ParentNode: TTreeNode);
var
  Site : TSite;
  x : integer;
  CategoryNode, Node  : TTreeNode;
  CategoryName : string;
begin
  Site  :=  TSite(ParentNode.Data);
  CategoryName  :=  '';
  CategoryNode  :=  ParentNode;
  for x :=  0 to  Site.BoardList.Count - 1  do  begin
    if  (CategoryName <> Site.BoardList[x].CategoryName)  then  begin
      CategoryName  :=  Site.BoardList[x].CategoryName;
      CategoryNode  :=  TreeView.Items.AddChild(ParentNode, CategoryName);
      CategoryNode.ImageIndex     :=  6;
      CategoryNode.SelectedIndex  :=  8;
    end;
    Node  :=  TreeView.Items.AddChild(CategoryNode, Site.BoardList[x].Name);
    Node.Data           :=  Site.BoardList[x];
    if  (Site.BoardList[x].Gaishutu)  then  begin
      Node.ImageIndex     :=  15; //7;
      Node.SelectedIndex  :=  15; //8;
    end else begin
      Node.ImageIndex     :=  14; //7;
      Node.SelectedIndex  :=  14; //8;
    end;
  end;
  if  (TreeView.AutoExpand)  then  ParentNode.Expand(False);
end;

//
//  ListDoc̐VK쐬
//
(*
procedure CreateNewListDoc(var NewListDoc: TZonuListDoc;
  ThreadItemList, AllThreadItemList: TThreadItemList;
  Board: TBoard; const Title: string; Activate: boolean);
const
  MULTITAB = False;
var
  b  : TThreadListToolButton;
  sp : TToolButton;
  mn : TThreadListMenuItem;
  //
  procedure CreateButton();
  begin
    b           :=  TThreadListToolButton.Create(HotzonuWindow.ThreadListBar);
    b.Parent    :=  HotzonuWindow.ThreadListBar;
    b.Caption   :=  Title;
    b.AutoSize  :=  True;
    if  (ZonuConfig.ThreadListTabOrder = taLeftToRight) then  begin //24
      b.Left      :=  CalcToolBarSize(HotzonuWindow.ThreadListBar) + 2;
    end else begin
      b.Left      :=  0;
    end;
    b.Grouped   :=  True;
    b.Style     :=  tbsCheck;
    b.ListDoc   :=  NewListDoc;
    b.OnClick       :=  HotzonuWindow.ThreadListTabClick;
    b.OnMouseDown   :=  HotzonuWindow.ToolButtonMouseDown;
    //b.OnDblClick    :=  HotzonuWindow.ToolButtonDblClick;
    b.OnExecReload  :=  HotzonuWindow.ThreadListReload;
    b.OnExecClose   :=  HotzonuWindow.ThreadListClose;
  end;
  //
  procedure CreateSeparator(const ALeft: integer);
  begin
    sp          :=  TToolButton.Create(HotzonuWindow.ThreadListBar);
    sp.Parent   :=  HotzonuWindow.ThreadListBar;
    sp.Caption  :=  '';
    sp.Style    :=  tbsSeparator;
    sp.AutoSize :=  False;
    sp.Width    :=  3;
    sp.Left     :=  ALeft;
    sp.Grouped  :=  True;
  end;
begin
  NewListDoc                      :=  TZonuListDoc.Create;
  if  (Board <> nil)  then  begin
    NewListDoc.BoardID            :=  Board.BoardID;
  end else begin
    NewListDoc.BoardID            :=  '';
  end;
  NewListDoc.ListView             :=  HotzonuWindow.ThreadListView;
  NewListDoc.Title                :=  Title;
  NewListDoc.ThreadItemList       :=  ThreadItemList;
  NewListDoc.AllThreadItemList    :=  AllThreadItemList;
  NewListDoc.State                :=  vsReady;
  NewListDoc.OnActive             :=  HotzonuWindow.ListDocActive;
  if  (Board <> nil)  then  begin
    if  (Board.BBS.BBSID = BBS_FAVORITES) then  begin
      NewListDoc.Kind :=  lkFavorites;
    end else begin
      NewListDoc.Kind :=  lkThreadList;
    end;
  end else begin
    NewListDoc.Kind :=  lkThreadList;
  end;
  //
  if  (MULTITAB)  then  begin
    if  (ZonuConfig.ThreadListTabOrder = taLeftToRight) then  begin //24
      CreateButton;
      CreateSeparator(b.Left + b.Width + 2);
    end else begin
      CreateSeparator(0);
      CreateButton;
    end;
    b.Separator :=  sp;
    NewListDoc.ToolButton  :=  b;

    Wrapable(HotzonuWindow.ThreadListBar);
  end else begin

    if  (ZonuConfig.ThreadListTabOrder = taLeftToRight) then  begin //24
      CreateButton;
      CreateSeparator(b.Left + b.Width + 2);
    end else begin
      CreateSeparator(0);
      CreateButton;
    end;
    b.Separator :=  sp;
    NewListDoc.ToolButton  :=  b;
    RecalcToolBarSize(HotzonuWindow.ThreadListBar);
  end;
  {
  n :=  0;
  for i :=  0 to  HotzonuWindow.ThreadListBar.ButtonCount - 1 do  begin
    n :=  n + HotzonuWindow.ThreadListBar.Buttons[i].Width;
  end;
  HotzonuWindow.ThreadListBar.Width :=  n;
  }

  mn  :=  TThreadListMenuItem.Create(HotzonuWindow.ThreadListTabMenu);
  mn.ListDoc  :=  NewListDoc;
  mn.Caption  :=  Title;
  mn.OnClick  :=  mn.Clicked;
  mn.GroupIndex   :=  1;
  mn.RadioItem    :=  True;
  HotzonuWindow.ThreadListTabMenu.Items.Add(mn);
  NewListDoc.MenuItem :=  mn;

  if  (Activate)  then  begin
    b.Down    :=  True;
    HotzonuWindow.ActiveListDoc       :=  NewListDoc;
    NewListDoc.Active;
    HotzonuWindow.ThreadListTab.Insert(0, NewListDoc);
  end else begin
    HotzonuWindow.ThreadListTab.Add(NewListDoc);
  end;

  HotzonuWindow.StatusBar2.Panels[0].Text :=  Format(': %d', [HotzonuWindow.ThreadListTab.Count]);

end;

procedure CreateNewListDoc(var NewListDoc: TZonuListDoc;
  ThreadItemList, AllThreadItemList: TThreadItemList;
  Board: TBoard; const Title: string; Activate: boolean);
var
  b  : TThreadListToolButton;
  sp : TToolButton;
  mn : TThreadListMenuItem;
  procedure CreateButton();
  begin
    b           :=  TThreadListToolButton.Create(HotzonuWindow.ThreadListBar);
    b.Parent    :=  HotzonuWindow.ThreadListBar;
    b.Caption   :=  Title;
    b.AutoSize  :=  True;
    if  (ZonuConfig.ThreadListTabOrder = taLeftToRight) then  begin //24
      b.Left      :=  CalcToolBarSize(HotzonuWindow.ThreadListBar) + 2;
    end else begin
      b.Left      :=  0;
    end;
    b.Grouped   :=  True;
    b.Style     :=  tbsCheck;
    b.ListDoc   :=  NewListDoc;
    b.OnClick       :=  HotzonuWindow.ThreadListTabClick;
    b.OnMouseDown   :=  HotzonuWindow.ToolButtonMouseDown;
    //b.OnDblClick    :=  HotzonuWindow.ToolButtonDblClick;
    b.OnExecReload  :=  HotzonuWindow.ThreadListReload;
    b.OnExecClose   :=  HotzonuWindow.ThreadListClose;
  end;
  //
  procedure CreateSeparator(const ALeft: integer);
  begin
    sp          :=  TToolButton.Create(HotzonuWindow.ThreadListBar);
    sp.Parent   :=  HotzonuWindow.ThreadListBar;
    sp.Caption  :=  '';
    sp.Style    :=  tbsSeparator;
    sp.AutoSize :=  False;
    sp.Width    :=  3;
    sp.Left     :=  ALeft;
    sp.Grouped  :=  True;
  end;
begin
  NewListDoc                      :=  TZonuListDoc.Create;
  if  (Board <> nil)  then  begin
    NewListDoc.BoardID            :=  Board.BoardID;
  end else begin
    NewListDoc.BoardID            :=  '';
  end;
  NewListDoc.ListView             :=  HotzonuWindow.ThreadListView;
  NewListDoc.Title                :=  Title;
  NewListDoc.ThreadItemList       :=  ThreadItemList;
  NewListDoc.AllThreadItemList    :=  AllThreadItemList;
  NewListDoc.State                :=  vsReady;
  NewListDoc.OnActive             :=  HotzonuWindow.ListDocActive;
  if  (Board <> nil)  then  begin
    if  (Board.BBS.BBSID = BBS_FAVORITES) then  begin
      NewListDoc.Kind :=  lkFavorites;
    end else begin
      NewListDoc.Kind :=  lkThreadList;
    end;
  end else begin
    NewListDoc.Kind :=  lkThreadList;
  end;
  //
  {
  b           :=  TThreadListToolButton.Create(HotzonuWindow.ThreadListBar);
  b.Parent    :=  HotzonuWindow.ThreadListBar;
  b.Caption   :=  Title;
  b.AutoSize  :=  True;
  b.Left      :=  CalcToolBarSize(HotzonuWindow.ThreadListBar) + 2;
  b.Grouped   :=  True;
  b.Style     :=  tbsCheck;
  b.ListDoc   :=  NewListDoc;
  b.OnClick       :=  HotzonuWindow.ThreadListTabClick;
  b.OnMouseDown   :=  HotzonuWindow.ToolButtonMouseDown;
  //b.OnDblClick    :=  HotzonuWindow.ToolButtonDblClick;
  b.OnExecReload  :=  HotzonuWindow.ThreadListReload;
  b.OnExecClose   :=  HotzonuWindow.ThreadListClose;
  NewListDoc.ToolButton  :=  b;

  sp          :=  TToolButton.Create(HotzonuWindow.ThreadListBar);
  sp.Parent   :=  HotzonuWindow.ThreadListBar;
  sp.Caption  :=  '';
  sp.AutoSize :=  False;
  sp.Left     :=  b.Left + b.Width + 2;
  sp.Grouped  :=  True;
  sp.Style    :=  tbsSeparator;
  sp.Width    :=  3;
  b.Separator :=  sp;

  RecalcToolBarSize(HotzonuWindow.ThreadListBar);
  }

  if  (ZonuConfig.ThreadListTabOrder = taLeftToRight) then  begin //24
    CreateButton;
    CreateSeparator(b.Left + b.Width + 2);
  end else begin
    CreateSeparator(0);
    CreateButton;
  end;
  b.Separator :=  sp;
  NewListDoc.ToolButton  :=  b;
  RecalcToolBarSize(HotzonuWindow.ThreadListBar);

  {
  n :=  0;
  for i :=  0 to  HotzonuWindow.ThreadListBar.ButtonCount - 1 do  begin
    n :=  n + HotzonuWindow.ThreadListBar.Buttons[i].Width;
  end;
  HotzonuWindow.ThreadListBar.Width :=  n;
  }

  mn  :=  TThreadListMenuItem.Create(HotzonuWindow.ThreadListTabMenu);
  mn.ListDoc  :=  NewListDoc;
  mn.Caption  :=  Title;
  mn.OnClick  :=  mn.Clicked;
  mn.GroupIndex   :=  1;
  mn.RadioItem    :=  True;
  HotzonuWindow.ThreadListTabMenu.Items.Add(mn);
  NewListDoc.MenuItem :=  mn;

  if  (Activate)  then  begin
    b.Down    :=  True;
    HotzonuWindow.ActiveListDoc       :=  NewListDoc;
    NewListDoc.Active;
    HotzonuWindow.ThreadListTab.Insert(0, NewListDoc);
  end else begin
    HotzonuWindow.ThreadListTab.Add(NewListDoc);
  end;

  HotzonuWindow.StatusBar2.Panels[0].Text :=  Format(': %d', [HotzonuWindow.ThreadListTab.Count]);

end;
*)
procedure CreateNewListDoc(var NewListDoc: TZonuListDoc;
  ThreadItemList, AllThreadItemList: TThreadItemList;
  Board: TBoard; const Title: string; Activate: boolean);
var
  b  : TThreadListToolButton;
  sp : TToolButton;
  mn : TThreadListMenuItem;
begin
  NewListDoc                      :=  TZonuListDoc.Create;

  //29
  if  (HotzonuWindow.ThreadListView.Font.Name <> ZonuConfig.ThreadListFontName) then  begin
    HotzonuWindow.ThreadListView.Font.Name  :=  ZonuConfig.ThreadListFontName;
  end;
  if  (HotzonuWindow.ThreadListView.Font.Size <> ZonuConfig.ThreadListFontSize) then  begin
    HotzonuWindow.ThreadListView.Font.Size  :=  ZonuConfig.ThreadListFontSize;
  end;

  if  (Board <> nil)  then  begin
    NewListDoc.BoardID            :=  Board.BoardID;
  end else begin
    NewListDoc.BoardID            :=  '';
  end;
  NewListDoc.ListView             :=  HotzonuWindow.ThreadListView;
  NewListDoc.Title                :=  Title;
  NewListDoc.ThreadItemList       :=  ThreadItemList;
  NewListDoc.AllThreadItemList    :=  AllThreadItemList;
  NewListDoc.State                :=  vsReady;
  NewListDoc.OnActive             :=  HotzonuWindow.ListDocActive;
  if  (Board <> nil)  then  begin
    if  (Board.BBS.BBSID = BBS_FAVORITES) then  begin
      NewListDoc.Kind :=  lkFavorites;
    end else begin
      NewListDoc.Kind :=  lkThreadList;
    end;
  end else begin
    NewListDoc.Kind :=  lkThreadList;
  end;
  //
  b           :=  TThreadListToolButton.Create(HotzonuWindow.ThreadListBar);
  b.Parent    :=  HotzonuWindow.ThreadListBar;
  b.Caption   :=  Title;
  b.AutoSize  :=  True;
  b.Left      :=  CalcToolBarSize(HotzonuWindow.ThreadListBar) + 2;
  b.Grouped   :=  True;
  b.Style     :=  tbsCheck;
  b.ListDoc   :=  NewListDoc;
  b.OnClick       :=  HotzonuWindow.ThreadListTabClick;
  b.OnMouseDown   :=  HotzonuWindow.ToolButtonMouseDown;
  //b.OnDblClick    :=  HotzonuWindow.ToolButtonDblClick;
  b.OnExecReload  :=  HotzonuWindow.ThreadListReload;
  b.OnExecClose   :=  HotzonuWindow.ThreadListClose;
  NewListDoc.ToolButton  :=  b;

  sp          :=  TToolButton.Create(HotzonuWindow.ThreadListBar);
  sp.Parent   :=  HotzonuWindow.ThreadListBar;
  sp.Caption  :=  '';
  sp.AutoSize :=  False;
  sp.Left     :=  b.Left + b.Width + 2;
  sp.Grouped  :=  True;
  sp.Style    :=  tbsSeparator;
  sp.Width    :=  3;
  b.Separator :=  sp;

  RecalcToolBarSize(HotzonuWindow.ThreadListBar);
  {
  n :=  0;
  for i :=  0 to  HotzonuWindow.ThreadListBar.ButtonCount - 1 do  begin
    n :=  n + HotzonuWindow.ThreadListBar.Buttons[i].Width;
  end;
  HotzonuWindow.ThreadListBar.Width :=  n;
  }

  mn  :=  TThreadListMenuItem.Create(HotzonuWindow.ThreadListTabMenu);
  mn.ListDoc  :=  NewListDoc;
  mn.Caption  :=  Title;
  mn.OnClick  :=  mn.Clicked;
  mn.GroupIndex   :=  1;
  mn.RadioItem    :=  True;
  HotzonuWindow.ThreadListTabMenu.Items.Add(mn);
  NewListDoc.MenuItem :=  mn;

  if  (Activate)  then  begin
    b.Down    :=  True;
    HotzonuWindow.ActiveListDoc       :=  NewListDoc;
    NewListDoc.Active;
    HotzonuWindow.ThreadListTab.Insert(0, NewListDoc);
  end else begin
    HotzonuWindow.ThreadListTab.Add(NewListDoc);
  end;

  HotzonuWindow.StatusBar2.Panels[0].Text :=  Format(': %d', [HotzonuWindow.ThreadListTab.Count]);

end;

function  GetActiveToolButton(ToolBar: TToolBar; var Button: TToolButton): boolean;
var
  i : integer;
begin
  Result  :=  False;
  for   i :=  0 to  ToolBar.ButtonCount - 1 do  begin
    if  (ToolBar.Buttons[i].Down) then  begin
      Button  :=  ToolBar.Buttons[i];
      Result  :=  True;
      Break;
    end;
  end;
end;

//
//  ListDoč
//
function FindListDoc(Board: TBoard; var ListDoc: TZonuListDoc): boolean;
var
  i : integer;
  b : TThreadListToolButton;
begin
  Result  :=  False;
  for i :=  0 to  HotzonuWindow.ThreadListBar.ButtonCount - 1 do  begin
    if  (HotzonuWindow.ThreadListBar.Buttons[i].Style = tbsButton)    or
        (HotzonuWindow.ThreadListBar.Buttons[i].Style = tbsCheck)     or
        (HotzonuWindow.ThreadListBar.Buttons[i].Style = tbsDropDown)  then
    begin
      b   :=  TThreadListToolButton(HotzonuWindow.ThreadListBar.Buttons[i]);
      if  (b.ListDoc <> nil)  then  begin
        if  (b.ListDoc.Board <> nil)  then  begin
          if  (b.ListDoc.Board.Site.SiteID = Board.Site.SiteID)  and
              (b.ListDoc.Board.BoardID = Board.BoardID)  then
          begin
            ListDoc :=  b.ListDoc;
            Result  :=  True;
            Break;
          end;
        end;
      end;
    end;
  end;
end;

//
//  Xbhꗗ̃y[W
//
function FindThreadPageIndex(ListDoc: TZonuListDoc): integer;
var
  i : integer;
  b : TThreadListToolButton;
begin
  Result  :=  -1;
  for i :=  0 to  HotzonuWindow.ThreadListBar.ButtonCount - 1 do  begin
    if  (HotzonuWindow.ThreadListBar.Buttons[i].Style = tbsButton)    or
        (HotzonuWindow.ThreadListBar.Buttons[i].Style = tbsCheck)     or
        (HotzonuWindow.ThreadListBar.Buttons[i].Style = tbsDropDown)  then
    begin
      b   :=  TThreadListToolButton(HotzonuWindow.ThreadListBar.Buttons[i]);
      if  (b.ListDoc <> nil)  then  begin
        if  (b.ListDoc = ListDoc)  then  begin
          Result  :=  i;
          Break;
        end;
      end;
    end;
  end;
end;

//
//  Xbhꗗ̃y[W
//
function FindThreadPageIndex(Board: TBoard): integer;
var
  i : integer;
  b : TThreadListToolButton;
begin
  Result  :=  -1;
  for i :=  0 to  HotzonuWindow.ThreadListBar.ButtonCount - 1 do  begin
    if  (HotzonuWindow.ThreadListBar.Buttons[i].Style = tbsButton)    or
        (HotzonuWindow.ThreadListBar.Buttons[i].Style = tbsCheck)     or
        (HotzonuWindow.ThreadListBar.Buttons[i].Style = tbsDropDown)  then
    begin
      b   :=  TThreadListToolButton(HotzonuWindow.ThreadListBar.Buttons[i]);
      if  (b.ListDoc <> nil)  then  begin
        if  (b.ListDoc.Board <> nil)  then  begin
          if  (b.ListDoc.Board = Board)  then  begin
            Result  :=  i;
            Break;
          end;
        end;
      end;
    end;
  end;
end;

//
//  Xbhꗗ
//
procedure CloseThreadList(ScreenUpdate: boolean);
var
  tb  : TThreadListToolButton;
begin
  if  (GetActiveToolButton(HotzonuWindow.ThreadListBar, TToolButton(tb))) then  begin
    CloseThreadList(tb.ListDoc, ScreenUpdate);
  end;
end;

procedure CloseThreadList(ListDoc: TZonuListDoc; ScreenUpdate: boolean);
var
  i : integer;
begin
  if  (ListDoc.State = vsDownloading)  then  begin
    ListDoc.CancelDownload;
    while (ListDoc.State <> vsReady) do  begin
      Sleep(1000);
      Application.ProcessMessages;
      if  (ZonuEnviron.Disconnected)  then  begin
        raise EZonuError.Create('ؒf܂B');
      end;
    end;
  end;
  {
  for i :=  0 to  HotzonuWindow.BoardNode.Count - 1  do  begin
    if  (HotzonuWindow.BoardNode.Item[i].Data = ListDoc) then  begin
      HotzonuWindow.BoardNode.Item[i].Delete;
      HotzonuWindow.BoardNode.Text :=  Format(TEXT_OPEN_BOARD, [HotzonuWindow.BoardNode.Count]);
      Break;
    end;
  end;
  }
  {$IFDEF NUXX}
  ShowMessage('CloseThreadList');
  {$ELSE}
  for i :=  0 to  HotzonuWindow.ThreadListTab.Count - 1  do  begin
    if  (HotzonuWindow.ThreadListTab[i] = ListDoc) then  begin
      HotzonuWindow.ThreadListTab.Delete(i);
      Break;
    end;
  end;

  ListDoc.ToolButton.Separator.Free;
  ListDoc.ToolButton.Free;
  ListDoc.MenuItem.Free;
  ListDoc.Free;

  if  (HotzonuWindow.ThreadListTab.Count > 0)  then  begin
    TZonuListDoc(HotzonuWindow.ThreadListTab[0]).Active;
  end else begin
    HotzonuWindow.ThreadListView.SetItemCountEx(0, []);
  end;


  if  (ScreenUpdate)  then  begin
    Application.ProcessMessages;
    RecalcToolBarSize(HotzonuWindow.ThreadListBar);
    if  (HotzonuWindow.ThreadListBar.ButtonCount = 0)  then  begin
      HotzonuWindow.ThreadListView.SetItemCountEx(0, []);
    end;
  end;
  HotzonuWindow.RefreshThreadList;
  HotzonuWindow.StatusBar2.Panels[0].Text :=  Format(': %d', [HotzonuWindow.ThreadListTab.Count]);
  {$ENDIF}
end;

procedure CloseBrowser(ScreenUpdate: boolean); 
var
  tb  : TBrowserToolButton;
begin
  if  (GetActiveToolButton(HotzonuWindow.BrowserToolBar, TToolButton(tb))) then  begin
    CloseBrowser(tb.Browser, ScreenUpdate);
  end;
end;

procedure CloseBrowser(Browser: TZonuBrowser; ScreenUpdate: boolean);
var
  i : integer;
begin
  //if  (Browser.State = vsDownloading)  then  begin
  if  (Browser.State = vsDownloading) and (not Browser.IsWebPage) then  begin
    Browser.CancelDownload;
    while (Browser.State <> vsReady) do  begin
      Sleep(1000);
      Application.ProcessMessages;
      if  (ZonuEnviron.Disconnected)  then  begin
        raise EZonuError.Create('ؒf܂B');
      end;
    end;
  end;
  {
  for i :=  0 to  HotzonuWindow.ThreadNode.Count - 1  do  begin
    if  (HotzonuWindow.ThreadNode.Item[i].Data = Browser) then  begin
      HotzonuWindow.ThreadNode.Item[i].Delete;
      HotzonuWindow.ThreadNode.Text :=  Format(TEXT_OPEN_THREAD, [HotzonuWindow.ThreadNode.Count]);
      Break;
    end;
  end;
  }
  {$IFDEF NUXX}
  ShowMessage('CloseThreadList');
  {$ELSE}
  for i :=  0 to  HotzonuWindow.BrowserTab.Count - 1  do  begin
    if  (HotzonuWindow.BrowserTab[i] = Browser) then  begin
      HotzonuWindow.BrowserTab.Delete(i);
      Break;
    end;
  end;
  if  (not Browser.IsWebPage) then  begin
    if  (Browser.ThreadItem <> nil) then  begin
      if  (Browser.ThreadItem.DatExists)  then  begin
        Browser.ThreadItem.ScrollTop  :=  Browser.GetTopResNo;
        Browser.ThreadItem.SaveConfig;
      end;
      Browser.ThreadItem.ReleaseRef;
      Browser.ThreadItem  :=  nil;
    end;
  end;
  //
  Browser.ToolButton.Separator.Free;
  Browser.ToolButton.Free;
  Browser.MenuItem.Free;
  Browser.Destroy;
  //FreeAndNil(Browser);
  //Browser.Release;
  //HotzonuWindow.BrowserList.Add(Browser);

  if  (HotzonuWindow.BrowserTab.Count > 0)  then  begin
    TZonuBrowser(HotzonuWindow.BrowserTab[0]).Active;
  end else begin
    HotzonuWindow.ThreadComment.Lines.Clear;
    HotzonuWindow.URLComboBox.Text  :=  '';
    HotzonuWindow.CurrentThreadItem :=  nil;
  end;


  if  (ScreenUpdate)  then  begin
    Application.ProcessMessages;
    RecalcToolBarSize(HotzonuWindow.BrowserToolBar);
    //if  (HotzonuWindow.BrowserToolBar.ButtonCount = 0)  then  begin
      //HotzonuWindow.ThreadListView.SetItemCountEx(0, []);
    //end;
  end;
  //HotzonuWindow.RefreshThreadList;
  HotzonuWindow.RefreshBrowser;
  HotzonuWindow.StatusBar2.Panels[1].Text :=  Format(': %d', [HotzonuWindow.BrowserTab.Count]);
  HotzonuWindow.ProgressBar.Position     :=  HotzonuWindow.ProgressBar.Min;
  {$ENDIF}
end;

//
//  eANV EnabledZbg
//
procedure SetActionEnabled(AEnabled: boolean);
const
  OLD_VALUE : boolean = True;
var
  i : integer;
  Action : TAction;
begin
  if  (HotzonuWindow.Showing) then  begin
    if  (OLD_VALUE = AEnabled)  then  Exit;
    OLD_VALUE :=  AEnabled;
    HotzonuWindow.MenuBar1.Enabled  :=  AEnabled;
    for i :=  0 to  HotzonuWindow.ActionList1.ActionCount - 1  do  begin
      Action  :=  TAction(HotzonuWindow.ActionList1.Actions[i]);
      if  (AEnabled = False)  then  begin
        if  (Action.Enabled)  then  begin
          Action.Tag  :=  0;
        end else begin
          Action.Tag  :=  -1;
        end;
        Action.Enabled  :=  False;
      end else begin
        Action.Enabled  :=  (Action.Tag = 0);
      end;
    end;
  end;
end;

//
//  JeSw肵ĊeANV EnabledZbg
//
procedure SetActionEnabled(const Category: string; const AEnabled: boolean);
var
  i : integer;
  Action : TAction;
begin
  for i :=  0 to  HotzonuWindow.ActionList1.ActionCount - 1  do  begin
    Action  :=  TAction(HotzonuWindow.ActionList1.Actions[i]);
    if  (Action.Category = Category)  then  begin
      Action.Enabled  :=  AEnabled;
    end;
  end;
end;

procedure CommandThreadList(Sender: TObject);
begin
  {$IFDEF NUXX}
  ShowMessage('CommandThreadList');
  {$ELSE}
  if  (HotzonuWindow.ThreadListView.Selected <> nil)  then  begin
    if  (HotzonuWindow.ThreadListView.Selected.Index > -1)  then  begin
      if  (HotzonuWindow.ActiveListDoc <> nil)  then  begin
        if  (HotzonuWindow.ThreadListView.Selected.Index < HotzonuWindow.ActiveListDoc.ThreadItemList.Count)  then  begin
          if  (HotzonuWindow.ActiveListDoc.ThreadItemList[HotzonuWindow.ThreadListView.Selected.Index].BBS <> nil)  then
          begin
            if  (not HotzonuWindow.actShowBrowser.Checked) and
                (ZonuConfig.ChangePaneBrowser)  then
            begin
              HotzonuWindow.actShowPaneChange.Execute;
            end;
            HotzonuWindow.LoadRes(
                    HotzonuWindow.ActiveListDoc.ThreadItemList[HotzonuWindow.ThreadListView.Selected.Index],
                    False,
                    Sender = HotzonuWindow.actThreadListDownloadThreadNewPage);
          end;
        end;
      end;
    end;
  end;
  {$ENDIF}
end;

(*
procedure CreateNewBrowser(var NewBrowser: TZonuBrowser;
  ResList: TResList; ThreadItem: TThreadItem; const Title: string;
  Activate: boolean);
var
  b  : TBrowserToolButton;
  sp : TToolButton;
  mn : TBrowserMenuItem;
  procedure CreateButton();
  begin
    b           :=  TBrowserToolButton.Create(HotzonuWindow.BrowserToolBar);
    b.Parent    :=  HotzonuWindow.BrowserToolBar;
    b.Caption   :=  Title;
    b.AutoSize  :=  True;
    if  (ZonuConfig.ThreadListTabOrder = taLeftToRight) then  begin //24
      b.Left      :=  CalcToolBarSize(HotzonuWindow.ThreadListBar) + 2;
    end else begin
      b.Left      :=  0;
    end;
    b.Grouped   :=  True;
    b.Style     :=  tbsCheck;
    b.Browser   :=  NewBrowser;
    b.OnClick       :=  HotzonuWindow.BrowserTabClick;
    b.OnMouseDown   :=  HotzonuWindow.ToolButtonMouseDown;
    //b.OnDblClick    :=  HotzonuWindow.ToolButtonDblClick;
    b.OnExecReload  :=  HotzonuWindow.BrowserReload;
    b.OnExecClose   :=  HotzonuWindow.BrowserClose;
  end;
  //
  procedure CreateSeparator(const ALeft: integer);
  begin
    sp          :=  TToolButton.Create(HotzonuWindow.BrowserToolBar);
    sp.Parent   :=  HotzonuWindow.BrowserToolBar;
    sp.Caption  :=  '';
    sp.Style    :=  tbsSeparator;
    sp.AutoSize :=  False;
    sp.Width    :=  3;
    sp.Left     :=  ALeft;
    sp.Grouped  :=  True;
  end;
begin
  {$IFDEF NUXX}
  ShowMessage('CreateNewBrowser');
  {$ELSE}
  NewBrowser  :=  TZonuBrowser.Create(HotzonuWindow);
  TOleControl(NewBrowser).Parent  :=  HotzonuWindow.Panel10;
  NewBrowser.Align                :=  alClient;
  // *test* NewBrowser.Loaded; *test* //
  NewBrowser.Node :=  nil;
  NewBrowser.UrlComboBox          :=  HotzonuWindow.UrlComboBox;
  NewBrowser.ResList              :=  ResList;
  if  (ThreadItem <> nil) then  begin
    ThreadItem.AddRef;
    NewBrowser.ThreadItem :=  ThreadItem;
    NewBrowser.IsWebPage  :=  False;
  end else begin
    NewBrowser.IsWebPage  :=  True;
  end;
  NewBrowser.Navigate('about:blank');
  while (not Assigned(NewBrowser.Document)) do  begin
    Application.ProcessMessages;
    if  (ZonuEnviron.Disconnected)  then  begin
      raise EZonuError.Create('ؒf܂B');
    end;
  end;

  NewBrowser.OnBeforeNavigate2    :=  HotzonuWindow.WebBrowser1BeforeNavigate2;
  NewBrowser.OnNewWindow2         :=  HotzonuWindow.WebBrowser1NewWindow2;

  {
  if  (NewBrowser.IsWebPage)  then  begin
    //Thanx Part19/743 񁗂ςB
    NewBrowser.HandleNeeded;
    NewBrowser.Loaded;
  end;
  }

  //NewBrowser.OnCommandStateChange :=  HotzonuWindow.WebBrowser1CommandStateChange;

  {
  NewBrowser.SkinPath       :=  ZonuConfig.SkinPath;
  NewBrowser.KatjushaSkin   :=  ZonuConfig.KatjushaSkin;
  NewBrowser.HotzonuSkin    :=  ZonuConfig.HotzonuSkin;
  }
  if  (ThreadItem <> nil) then  begin
    NewBrowser.InitSkin(ThreadItem.Board);
  end else begin
    NewBrowser.InitSkin(nil);
  end;

  {
  b           :=  TBrowserToolButton.Create(HotzonuWindow.BrowserToolBar);
  b.Parent    :=  HotzonuWindow.BrowserToolBar;
  b.Caption   :=  Title;
  b.AutoSize  :=  True;
  if  (ZonuConfig.BrowserTabOrder = taLeftToRight) then  begin //24
    b.Left      :=  CalcToolBarSize(HotzonuWindow.BrowserToolBar) + 2;
  end else begin
    b.Left      :=  0;
  end;
  b.Grouped   :=  True;
  b.Style     :=  tbsCheck;
  b.Browser   :=  NewBrowser;
  b.OnClick       :=  HotzonuWindow.BrowserTabClick;
  b.OnMouseDown   :=  HotzonuWindow.ToolButtonMouseDown;
  //b.OnDblClick    :=  HotzonuWindow.ToolButtonDblClick;
  b.OnExecReload  :=  HotzonuWindow.BrowserReload;
  b.OnExecClose   :=  HotzonuWindow.BrowserClose;
  NewBrowser.ToolButton  :=  b;

  sp          :=  TToolButton.Create(HotzonuWindow.BrowserToolBar);
  sp.Parent   :=  HotzonuWindow.BrowserToolBar;
  sp.Caption  :=  '';
  sp.AutoSize :=  False;
  if  (ZonuConfig.BrowserTabOrder = taLeftToRight) then  begin //24
    sp.Left     :=  b.Left + b.Width + 2;
  end else begin
    sp.Left     :=  0;
  end;
  sp.Grouped  :=  True;
  sp.Style    :=  tbsSeparator;
  sp.Width    :=  3;
  b.Separator :=  sp;

  RecalcToolBarSize(HotzonuWindow.BrowserToolBar);
  }
  if  (ZonuConfig.BrowserTabOrder = taLeftToRight) then  begin //24
    CreateButton;
    CreateSeparator(b.Left + b.Width + 2);
  end else begin
    CreateSeparator(0);
    CreateButton;
  end;
  b.Separator :=  sp;
  NewBrowser.ToolButton  :=  b;
  RecalcToolBarSize(HotzonuWindow.BrowserToolBar);
  {
  n :=  0;
  for i :=  0 to  HotzonuWindow.BrowserToolBar.ButtonCount - 1 do  begin
    n :=  n + HotzonuWindow.BrowserToolBar.Buttons[i].Width;
  end;
  HotzonuWindow.BrowserToolBar.Width :=  n;
  }
  mn  :=  TBrowserMenuItem.Create(HotzonuWindow.BrowserTabMenu);
  mn.Browser  :=  NewBrowser;
  mn.Caption  :=  Title;
  mn.OnClick  :=  mn.Clicked;
  mn.GroupIndex   :=  1;
  mn.RadioItem    :=  True;
  HotzonuWindow.BrowserTabMenu.Items.Add(mn);
  NewBrowser.MenuItem :=  mn;

  if  (Activate)  then  begin
    b.Down    :=  True;
    //HotzonuWindow.ActiveListDoc       :=  NewBrowser;
    //NewListDoc.Active;
    HotzonuWindow.BrowserTab.Insert(0, NewBrowser);
    NewBrowser.BringToFront;
  end else begin
    HotzonuWindow.BrowserTab.Add(NewBrowser);
    NewBrowser.SendToBack;
  end;

  {
  NewBrowser.OnStatusTextChange       :=  WebBrowser1StatusTextChange;
  NewBrowser.OnBeforeNavigate2        :=  WebBrowser1BeforeNavigate2;
  NewBrowser.OnNewWindow2             :=  WebBrowser1NewWindow2;
  NewBrowser.OnTitleChange            :=  WebBrowser1TitleChange;
  NewBrowser.OnShowContextMenu        :=  WebBrowser1ShowContextMenu;
  NewBrowser.OnProgressChange         :=  WebBrowser1ProgressChange;
  }
  NewBrowser.OnActive           :=  HotzonuWindow.BrowserActive;
  NewBrowser.OnStatusTextChange :=  HotzonuWindow.WebBrowser1StatusTextChange;
  NewBrowser.OnTitleChange      :=  HotzonuWindow.WebBrowser1TitleChange;
  NewBrowser.OnProgressChange   :=  HotzonuWindow.WebBrowser1ProgressChange;
  NewBrowser.OnShowContextMenu  :=  HotzonuWindow.WebBrowser1ShowContextMenu;

  {
  FTabList[1].Add(NewBrowser);

  {////////////////////////////////////////////////
  }
  HotzonuWindow.StatusBar2.Panels[1].Text :=  Format(': %d', [HotzonuWindow.BrowserTab.Count]);

  HotzonuWindow.RefreshBrowser;
  {$ENDIF}
end;
*)

procedure CreateNewBrowser(var NewBrowser: TZonuBrowser;
  ResList: TResList; ThreadItem: TThreadItem; const Title: string;
  Activate: boolean);
var
  b  : TBrowserToolButton;
  sp : TToolButton;
  mn : TBrowserMenuItem;
begin
  {$IFDEF NUXX}
  ShowMessage('CreateNewBrowser');
  {$ELSE}
  NewBrowser  :=  TZonuBrowser.Create(HotzonuWindow);
  TOleControl(NewBrowser).Parent  :=  HotzonuWindow.Panel10;
  NewBrowser.Align                :=  alClient;
  // *test* NewBrowser.Loaded; *test* //
  NewBrowser.Node :=  nil;
  NewBrowser.UrlComboBox          :=  HotzonuWindow.UrlComboBox;
  NewBrowser.ResList              :=  ResList;
  if  (ThreadItem <> nil) then  begin
    ThreadItem.AddRef;
    NewBrowser.ThreadItem :=  ThreadItem;
    NewBrowser.IsWebPage  :=  False;
  end else begin
    NewBrowser.IsWebPage  :=  True;
  end;
  NewBrowser.Navigate('about:blank');
  while (not Assigned(NewBrowser.Document)) do  begin
    Application.ProcessMessages;
    if  (ZonuEnviron.Disconnected)  then  begin
      raise EZonuError.Create('ؒf܂B');
    end;
  end;

  NewBrowser.OnBeforeNavigate2    :=  HotzonuWindow.WebBrowser1BeforeNavigate2;
  NewBrowser.OnNewWindow2         :=  HotzonuWindow.WebBrowser1NewWindow2;
  //NewBrowser.OnNavigateComplete2  :=  HotzonuWindow.WebBrowser1NavigateComplete2;

  {
  if  (NewBrowser.IsWebPage)  then  begin
    //Thanx Part19/743 񁗂ςB
    NewBrowser.HandleNeeded;
    NewBrowser.Loaded;
  end;
  }

  //NewBrowser.OnCommandStateChange :=  HotzonuWindow.WebBrowser1CommandStateChange;

  {
  NewBrowser.SkinPath       :=  ZonuConfig.SkinPath;
  NewBrowser.KatjushaSkin   :=  ZonuConfig.KatjushaSkin;
  NewBrowser.HotzonuSkin    :=  ZonuConfig.HotzonuSkin;
  }
  if  (ThreadItem <> nil) then  begin
    NewBrowser.InitSkin(ThreadItem.Board);
  end else begin
    NewBrowser.InitSkin(nil);
  end;

  b           :=  TBrowserToolButton.Create(HotzonuWindow.BrowserToolBar);
  b.Parent    :=  HotzonuWindow.BrowserToolBar;
  b.Caption   :=  Title;
  b.AutoSize  :=  True;
  b.Left      :=  CalcToolBarSize(HotzonuWindow.BrowserToolBar) + 2;
  b.Grouped   :=  True;
  b.Style     :=  tbsCheck;
  b.Browser   :=  NewBrowser;
  b.OnClick       :=  HotzonuWindow.BrowserTabClick;
  b.OnMouseDown   :=  HotzonuWindow.ToolButtonMouseDown;
  //b.OnDblClick    :=  HotzonuWindow.ToolButtonDblClick;
  b.OnExecReload  :=  HotzonuWindow.BrowserReload;
  b.OnExecClose   :=  HotzonuWindow.BrowserClose;
  NewBrowser.ToolButton  :=  b;

  sp          :=  TToolButton.Create(HotzonuWindow.BrowserToolBar);
  sp.Parent   :=  HotzonuWindow.BrowserToolBar;
  sp.Caption  :=  '';
  sp.AutoSize :=  False;
  sp.Left     :=  b.Left + b.Width + 2;
  sp.Grouped  :=  True;
  sp.Style    :=  tbsSeparator;
  sp.Width    :=  3;
  b.Separator :=  sp;

  RecalcToolBarSize(HotzonuWindow.BrowserToolBar);
  {
  n :=  0;
  for i :=  0 to  HotzonuWindow.BrowserToolBar.ButtonCount - 1 do  begin
    n :=  n + HotzonuWindow.BrowserToolBar.Buttons[i].Width;
  end;
  HotzonuWindow.BrowserToolBar.Width :=  n;
  }
  mn  :=  TBrowserMenuItem.Create(HotzonuWindow.BrowserTabMenu);
  mn.Browser  :=  NewBrowser;
  mn.Caption  :=  Title;
  mn.OnClick  :=  mn.Clicked;
  mn.GroupIndex   :=  1;
  mn.RadioItem    :=  True;
  HotzonuWindow.BrowserTabMenu.Items.Add(mn);
  NewBrowser.MenuItem :=  mn;

  if  (Activate)  then  begin
    b.Down    :=  True;
    //HotzonuWindow.ActiveListDoc       :=  NewBrowser;
    //NewListDoc.Active;
    HotzonuWindow.BrowserTab.Insert(0, NewBrowser);
    NewBrowser.BringToFront;
  end else begin
    HotzonuWindow.BrowserTab.Add(NewBrowser);
    NewBrowser.SendToBack;
  end;

  {
  NewBrowser.OnStatusTextChange       :=  WebBrowser1StatusTextChange;
  NewBrowser.OnBeforeNavigate2        :=  WebBrowser1BeforeNavigate2;
  NewBrowser.OnNewWindow2             :=  WebBrowser1NewWindow2;
  NewBrowser.OnTitleChange            :=  WebBrowser1TitleChange;
  NewBrowser.OnShowContextMenu        :=  WebBrowser1ShowContextMenu;
  NewBrowser.OnProgressChange         :=  WebBrowser1ProgressChange;
  }
  NewBrowser.OnActive           :=  HotzonuWindow.BrowserActive;
  NewBrowser.OnStatusTextChange :=  HotzonuWindow.WebBrowser1StatusTextChange;
  NewBrowser.OnTitleChange      :=  HotzonuWindow.WebBrowser1TitleChange;
  NewBrowser.OnProgressChange   :=  HotzonuWindow.WebBrowser1ProgressChange;
  NewBrowser.OnShowContextMenu  :=  HotzonuWindow.WebBrowser1ShowContextMenu;

  {
  FTabList[1].Add(NewBrowser);

  {////////////////////////////////////////////////
  }
  HotzonuWindow.StatusBar2.Panels[1].Text :=  Format(': %d', [HotzonuWindow.BrowserTab.Count]);

  HotzonuWindow.RefreshBrowser;
  {$ENDIF}
end;

procedure RecalcToolBarSize(ToolBar: TToolBar);
begin
  ToolBar.Width :=  CalcToolBarSize(ToolBar);
end;

function  CalcToolBarSize(ToolBar: TToolBar): integer;
var
  n, i : integer;
begin
  n :=  0;
  for i :=  0 to  ToolBar.ButtonCount - 1 do  begin
    n :=  n + ToolBar.Buttons[i].Width;
  end;
  Result  :=  n;
end;

procedure DeleteThreadLog(ThreadItem: TThreadItem);
var
  b: boolean;
begin
  {$IFDEF NUXX}
  ShowMessage('DeleteThreadLog');
  {$ELSE}
  if  (ThreadItem <> nil) then  begin
    if  (ThreadItem.InFavorites) then  begin
      if  (ZonuConfig.PromptDeleteWithFav)  then  begin
        b :=  (MessageDlg('Cɓ肩폜܂H' + #13#10 +
                          ThreadItem.Title,
                          mtWarning, [mbYes, mbNo], 0) = mrYes);
      end else begin
        b :=  True;
      end;
      if  (b) then  begin
        DeleteFromFav(ThreadItem);
        ThreadItem.InFavorites :=  False;
        ThreadItem.DeleteLog(True, True, True, True);
      end else begin
        ThreadItem.DeleteLog(True, True, True, True);
        ThreadItem.InFavorites :=  True;
        ThreadItem.SaveConfig;
      end;
    end else begin
      ThreadItem.DeleteLog(True, True, True, True);
    end;
  end;
  {$ENDIF}
end;

//
//  _uEBhE\
//
procedure ShowDoubleWindow;
begin
  {$IFDEF NUXX}
  ShowMessage('ShowDoubleWindow');
  {$ELSE}
  if  (HotzonuWindow.ZonuBrowser2.Showing)  then  begin
    if  (not HotzonuWindow.ZonuBrowser2.IsWebPage)  then  begin
      if  (HotzonuWindow.ZonuBrowser2.ThreadItem <> nil) then  begin
        HotzonuWindow.ZonuBrowser2.ThreadItem.ReleaseRef;
        HotzonuWindow.ZonuBrowser2.ResList.Clear;
        HotzonuWindow.ZonuBrowser2.ResList.Free;
        HotzonuWindow.ZonuBrowser2.ResList :=  nil;
      end;
    end;
  end else begin
    HotzonuWindow.ZonuBrowser2.Show;
    HotzonuWindow.Splitter1.Show;
    if  (ZonuConfig.DoubleWindowHeight = 0) or (ZonuConfig.DoubleWindowHeight > HotzonuWindow.Panel10.Height) then  begin
      HotzonuWindow.ZonuBrowser2.Height   :=  (HotzonuWindow.Panel10.Height div 2);
    end else begin
      HotzonuWindow.ZonuBrowser2.Height   :=  ZonuConfig.DoubleWindowHeight;
    end;

    HotzonuWindow.Splitter1.Top         :=  HotzonuWindow.ZonuBrowser2.Top + HotzonuWindow.ZonuBrowser2.Height + 1;
    HotzonuWindow.actShowDoubleWindow.Checked  :=  True;
  end;
  {$ENDIF}
end;

procedure LoadShortCutSetting;
var
  i : integer;
  S : string;
begin
  {$IFDEF NUXX}
  ShowMessage('LoadShortCutSetting');
  {$ELSE}
  for i :=  0 to  HotzonuWindow.ActionList1.ActionCount - 1  do  begin
    S :=  ZonuConfig.Fini.ReadString('SHORTCUT',
                                     HotzonuWindow.ActionList1.Actions[i].Name,
                                     '');
    if  (S <> '') then  begin
      TAction(HotzonuWindow.ActionList1.Actions[i]).ShortCut :=  TextToShortCut(S);
    end else begin
      TAction(HotzonuWindow.ActionList1.Actions[i]).ShortCut :=  0;
    end;
  end;
  {$ENDIF}
end;

procedure SaveBoardListSetting(TreeView: TTreeView; Site: TSite);
var
  ini   : TMemIniFile;
  Node  : TTreeNode;
  //i : integer;
begin
  {$IFDEF NUXX}
  ShowMessage('SaveBoardListSetting');
  {$ELSE}
  if  (TreeView.Items.Count > 0)  then  begin
    if  (Site <> nil) then  begin
      ini   :=  TMemIniFile.Create(ZonuConfig.UsersPath + INI_BOARDCONF);
      ini.EraseSection(Site.SiteID);
      Node  :=  TreeView.Items[0];
      while (Node <>  nil)  do  begin
        if  (Node.HasChildren)  then  begin
          if  (not  Node.Expanded) then  begin
            ini.WriteBool(Site.SiteID, Node.Text, True);
          end;
        end;
        Node :=  Node.getNextSibling
      end;
      ini.WriteString(Site.SiteID, 'TOP', TreeView.TopItem.Text);
      ini.UpdateFile;
      ini.Free;
    end;
  end;
  {$ENDIF}
end;

function  ExtractParamInfo(const Url: string; ThreadItem: TThreadItem;
  out BoardID, DatNo: string; out ResStart, ResEnd: integer;
  out NoFirst: boolean): boolean;
var
  s     : string;
  ParamBBS, ParamDat, ParamStart, ParamEnd  : string;
  ParamRes, ParamNoFirst : string;
begin
  //URLϊi2chpj
  s :=  ThreadItem.BBS.ConvUrl(Url);
  //p[^̎
  try
    ParamBBS      :=  ChooseValue(s, ThreadItem.BBS.SendParam.ParamBBS);
    ParamDat      :=  ChooseValue(s, ThreadItem.BBS.SendParam.ParamDat);
    ParamStart    :=  ChooseValue(s, ThreadItem.BBS.SendParam.ParamStart);
    ParamEnd      :=  ChooseValue(s, ThreadItem.BBS.SendParam.ParamEnd);
    ParamRes      :=  ChooseValue(s, ThreadItem.BBS.SendParam.ParamRes);
    ParamNoFirst  :=  ChooseValue(s, ThreadItem.BBS.SendParam.ParamNoFirst);
  except
    // %s ̏ʉ߂
    Result  :=  False;
    Exit;
  end;
  if  (ParamBBS <> '') and (ParamDat <> '') then  begin
    BoardID     :=  ParamBBS;
    DatNo       :=  ParamDat;
    ResStart    :=  StrToIntDef(ParamStart, 0);
    ResEnd      :=  StrToIntDef(ParamEnd, 0);
    if  (ParamRes <> '')  then  begin
      ResStart    :=  StrToIntDef(ParamRes, 0);
      ResEnd      :=  StrToIntDef(ParamRes, 0);
    end;
    NoFirst     :=  (ParamNoFirst = ThreadItem.BBS.SendParam.ParamTrue);
  end;
  Result  :=  True;
end;

function GetRangeRes(const Url: string; var ResList: TResList;
  var ThreadItem: TThreadItem; var pBoard: TBoard;
  var pSite: TSite; out ResStart: integer): boolean;
var
  i, x  : integer;
  s, a, b: string;
  xBBS  : TBBS;
  ParamBBS, ParamDat, ParamStart, ParamEnd  : string;
  ParamRes, ParamNoFirst : string;
  nStart, nEnd : integer;
  AResList : TResList;
  NoFirst  : boolean;
  Board : TBoard;
begin
  try
    xBBS    :=  nil;
    pBoard  :=  nil;
    pSite   :=  nil;
    ResStart:=  0;
    //̑BBS
    for i :=  0 to  ZonuEnviron.SiteList.Count - 1 do  begin
      if  (ZonuEnviron.SiteList[i].SiteType = stUser)  then  begin
        for x :=  0 to  ZonuEnviron.SiteList[i].BoardList.Count - 1  do  begin
          if ((AnsiPos(ZonuEnviron.SiteList[i].BoardList[x].BoardPath, Url) > 0) and
              (AnsiPos(ZonuEnviron.SiteList[i].BoardList[x].BoardID, Url) > 0)) then
          begin
            pSite :=  ZonuEnviron.SiteList[i];
            xBBS  :=  ZonuEnviron.SiteList[i].BoardList[x].BBS;
            Break;
          end else begin
            Board :=  ZonuEnviron.SiteList[i].BoardList[x];
            s :=  Board.BBS.GetReadCgiUrl();
            s :=  StringReplace(s, '<host>',
                                ExtractHostName(Board.Url),
                                [rfReplaceAll, rfIgnoreCase]);
            s :=  StringReplace(s, '<bbs>',
                                Board.RemoteBoardID,
                                [rfReplaceAll, rfIgnoreCase]);
            s :=  StringReplace(s, '<boardpath>',
                                Board.BoardPath,
                                [rfReplaceAll, rfIgnoreCase]);
            //7 begin
            s :=  StringReplace(s, '<dir>',
                                Board.Dir,
                                [rfReplaceAll, rfIgnoreCase]);
            //JBBSp̏
            s :=  StringReplace(s, '<dat>/', '' , [rfReplaceAll, rfIgnoreCase]);
            //7 end
            if (AnsiPos(s, Url) > 0) then  begin
              pSite :=  ZonuEnviron.SiteList[i];
              xBBS  :=  ZonuEnviron.SiteList[i].BoardList[x].BBS;
              Break;
            end;
          end;
        end;
      end;
    end;

    if  (xBBS = nil)  then  begin
      //ǂ̃TCg
      for i :=  0 to  ZonuEnviron.SiteList.Count - 1 do  begin
        if  (ZonuEnviron.SiteList[i].BBS <> nil)  then  begin
          if ((ZonuEnviron.SiteList[i].IsInclude(Url)) or
              (ZonuEnviron.SiteList[i].IsInclude(ZonuEnviron.SiteList[i].BBS.ConvUrl(Url)))) then
          begin
          //if  (IsInclude(FSiteList[i].IncludeUrl, Url)) then  begin
            pSite :=  ZonuEnviron.SiteList[i];
            xBBS  :=  pSite.BBS;
            Break;
          end;
        end;
      end;
    end;

    if  (xBBS <> nil) then  begin
      //URLϊi2chpj
      s :=  xBBS.ConvUrl(Url);
      a :=  ExtractUrlName(s);
      //b :=  ExtractUrlName(xBBS.GetReadCgiUrl(nil, ''));
      b :=  ExtractUrlName(xBBS.ConvUrl(  xBBS.GetReadCgiUrl(nil, '') ));
      if  (AnsiPos('?', a) > 0) then  a :=  Copy(a, 1, AnsiPos('?', a) - 1);
      if  (AnsiPos(a, b) > 0) then  begin
        //p[^̎
        ParamBBS      :=  ChooseValue(s, xBBS.SendParam.ParamBBS);
        ParamDat      :=  ChooseValue(s, xBBS.SendParam.ParamDat);
        ParamStart    :=  ChooseValue(s, xBBS.SendParam.ParamStart);
        ParamEnd      :=  ChooseValue(s, xBBS.SendParam.ParamEnd);
        ParamRes      :=  ChooseValue(s, xBBS.SendParam.ParamRes);
        ParamNoFirst  :=  ChooseValue(s, xBBS.SendParam.ParamNoFirst);
        //
        if  (ParamStart <> '')  then  begin
          ResStart  :=  StrToIntDef(ParamStart, 0);
        end else
        if  (ParamRes <> '')  then  begin
          ResStart  :=  StrToIntDef(ParamRes, 0);
        end;
        //
        if  (ParamBBS <> '') and (ParamDat <> '') then  begin
          //(TBoard)̌
          if  (pSite.BoardList.FindBoard(ParamBBS, pBoard)) then  begin
            //Xbh̍쐬
            ThreadItem.DatFileName  :=  DatFileNameToDatNo(ParamDat) + '.dat';
            ThreadItem.LocalDatFileName := pBoard.CachePath + ThreadItem.DatFileName;

            if  (ThreadItem.DatExists) then  begin
              //Xbh͂łɃ[Jɂ
              AResList := TResList.Create(ThreadItem);
              ThreadItem.LoadConfig;
              ThreadItem.BBS := xBBS;
              ThreadItem.LoadFromFile(AResList);

              nStart  :=  0;
              nEnd    :=  0;
              if  (AResList.Count > 0)  then  begin
                //X擾
                if  (ParamRes <> '')  then  begin
                  nStart  :=  StrToIntDef(ParamRes, 0);
                  nEnd    :=  nStart;
                end else begin
                  nStart  :=  StrToIntDef(ParamStart, 0);
                  nEnd    :=  StrToIntDef(ParamEnd,   0);
                end;
                if  (nStart = 0) then  begin
                  nStart  :=  AResList.Count - ZonuConfig.MaxPopupCount;
                  nEnd    :=  AResList.Count;
                end;
                if  (nStart > nEnd) then  begin
                  nEnd  :=  nStart;
                end;
              end;

              NoFirst :=  (ParamNoFirst = xBBS.SendParam.ParamTrue);
              if  (not NoFirst) then  begin
                if  (ParamNoFirst = '') then  begin
                  if  (not ZonuConfig.Res1NonPopup)  then  begin
                    NoFirst :=  True;
                  end;
                end;
              end;
              CopyRangeRes(AResList, ResList, nStart, nEnd, NoFirst);

              AResList.Free;
            end else begin
              //Xbh̓[JɂȂ
              ThreadItem.BBS  :=  xBBS;
              ThreadItem.Site :=  pSite;
              //ThreadItem.Board:=  pBoard;
              ThreadItem.BoardID  :=  pBoard.BoardID;
              ThreadItem.Title    :=  pBoard.GetThreadTitle(ParamDat); //Xbhsubject.txt擾
              ThreadItem.DatFileName  :=  ParamDat + '.dat';
            end;
          end;
          Result  :=  (pBoard <> nil);
        end else begin
          Result  :=  False;
        end;
      end else begin
        Result  :=  False;
      end;
    end else begin
      Result  :=  False;
    end;
  except
    Result  :=  False;
  end;
end;

procedure CopyRangeRes(OrgResList: TResList; var ToResList: TResList;
  ResStart, ResEnd: integer; NoFirst: boolean);
var
  ARes : TRes;
  i : integer;
begin
  if  (OrgResList.Count > 0)  then  begin
    if  (ResStart = 0) and (ResEnd = 0) then  begin
      ResStart  :=  OrgResList.Count - ZonuConfig.MaxPopupCount;
      ResEnd    :=  OrgResList.Count;
    end else
    if  (ResStart = 0) and (ResEnd > 0) then  begin
      ResStart  :=  ResEnd - ZonuConfig.MaxPopupCount;
      if  (ResStart < 1)  then  ResStart  :=  1;
    end;
    if  (ResStart > ResEnd) then  begin
      ResEnd  :=  ResStart;
    end;

    //if  (not NoFirst)  then  begin
    //  ARes  :=  TRes.Create;
    //  ARes.Assign(OrgResList[0]);
    //  ARes.No := 1;
    //  ToResList.Add(ARes);
    //end;
    
    for i :=  1 to  OrgResList.Count  do  begin
    //for i :=  ResStart  to  ResEnd  do  begin
      //if  (i > 0)  and
      //    (i < OrgResList.Count)  then
      //begin
      ARes  :=  TRes.Create;
      ARes.Assign(OrgResList[i - 1]);
      ARes.No := i;
      ARes.Showing  :=  ((i = 1) and (not NoFirst)) or
                        ((i >= ResStart) and (i <= ResEnd));
      ToResList.Add(ARes);
    end;
  end;
end;

//9
procedure CopyRangeRes(OrgResList: TResList; var ToResList: TResList;
  AId: string);
var
  ARes : TRes;
  i : integer;
begin
  if  (OrgResList.Count > 0)  then  begin
    for i :=  1 to  OrgResList.Count  do  begin
      ARes  :=  TRes.Create;
      ARes.Assign(OrgResList[i - 1]);
      ARes.No := i;
      ARes.Showing  :=  (OrgResList[i - 1].ID = AId);
      ToResList.Add(ARes);
    end;
  end;
end;

procedure ExecBrowser(const Url: string);
begin
  if  (ZonuConfig.ExecDefBrowser) then  begin
    //ʏguEUŊJ
    ShellExecute(HotzonuWindow.Handle,
                 'open',
                 PChar(Url),
                 '', '', SW_SHOW);
  end else begin
    //uEUw肵ĊJ
    ShellExecute(HotzonuWindow.Handle,
                 'open',
                 PChar(ZonuConfig.ExecBrowser),
                 PChar(Url),
                 '', SW_SHOW);
  end;
end;

//
//  EFuy[W̕\
//
//procedure Navigate(const Url, Title: string; Active: boolean);  //22
procedure Navigate(const Url, Title: string; Active: boolean;
  IgnoreNavigateDialog: boolean = False);
var
  br : TZonuBrowser;
begin
  //if  (ZonuConfig.OpenInHotzonu)  then  begin
  if  (ZonuConfig.OpenInHotzonu = oaHotzonu)  or
      (ZonuConfig.OpenInHotzonu = oaChotto)   then  //24
  begin
    CreateNewBrowser(br, nil, nil, Title, Active);
    br.IsWebPage  :=  True; //5
    br.ResetTabImage;
    br.IgnoreNavigateDialog :=  IgnoreNavigateDialog; //22
    br.Navigate(Url);
    //5 br.IsWebPage  :=  True; //Ɉړ
    br.SetBrowserMode; //age16
  end else
  if  (ZonuConfig.OpenInHotzonu = oaBrowser)  then  begin
    ExecBrowser(Url);
  end;
end;

//
//  URLJ
//
//procedure Open(const Url: string); //22
procedure Open(const Url: string; IgnoreNavigateDialog: boolean = False);
var
  //n : integer;
  //NewBrowser  : TZonuBrowser;
  AResList    : TResList;
  AThreadItem : TThreadItem;
  ABoard      : TBoard;
  ASite       : TSite;
  nResStart   : integer;
begin
  {$IFDEF NUXX}
  ShowMessage('Open');
  {$ELSE}
  AThreadItem :=  TThreadItem.Create;
  AResList    :=  TResList.Create(AThreadItem);
  if (GetRangeRes(Url, AResList, AThreadItem, ABoard, ASite, nResStart)) then
  begin
    AThreadItem.BoardID :=  ABoard.BoardID;
    AThreadItem.BBS     :=  ABoard.BBS;
    AThreadItem.Site    :=  ASite;
    AThreadItem.RemoteDatFileName  :=  AThreadItem.BBS.GetRemoteDatFileName(AThreadItem);
    //zbg]k
    HotzonuWindow.LoadRes(AThreadItem,
                          False,
                          True,
                          False,
                          True,
                          nResStart,
                          False,
                          Url);
  end else begin
    //ʏy[Wւ̃N
    //22 Navigate(Url, Url, True);
    Navigate(Url, Url, True, IgnoreNavigateDialog);
    AThreadItem.Free;
  end;
  AResList.Free;
  {$ENDIF}
end;

procedure SaveUrlLog(Strings: TStrings; const Url: string);
var
  n : integer;
begin
  if  (ZonuConfig.SaveHist)  then  begin
    n :=  Strings.IndexOf(Url);
    if  (n < 0) then  begin
      Strings.Insert(0, Url);
    end else begin
      Strings.Move(n, 0);
    end;
    while (Strings.Count > 20)  do  begin
      Strings.Delete(Strings.Count - 1);
    end;
    Strings.SaveToFile(ZonuConfig.UsersPath + FILE_URL_LOG);
  end;
end;

procedure DeleteFromFav(ThreadItem: TThreadItem);
var
  Rec : TSearchRec;
  sl  : TStringList;
  Path: string;
  i   : integer;
  d   : integer;
  SiteID, BoardID, DatNo : string;
begin
  sl    :=  TStringList.Create;
  Path  :=  ZonuConfig.UsersPath + PATH_CONFIG + PATH_FAVORITES;
  if (FindFirst(Path + 'fav*.txt' , faAnyFile, Rec) = 0)  then
  begin
    repeat
      sl.LoadFromFile(Path + Rec.Name);
      d :=  0;
      for i :=  sl.Count - 1  downto  1  do  begin
        SiteID  :=  ChooseString(sl[i], #9, 0);
        BoardID :=  ChooseString(sl[i], #9, 1);
        DatNo   :=  ChooseString(sl[i], #9, 2);
        if  (ThreadItem.Site.SiteID = SiteID) and
            (ThreadItem.BoardID = BoardID) and
            (ThreadItem.DatNo   = DatNo) then
        begin
          sl.Delete(i);
          inc(d);
        end;
      end;
      if  (d > 0) then  sl.SaveToFile(Path + Rec.Name);
    until (FindNext(Rec) <> 0);
  end;
  FindClose(Rec);
  sl.Free;
  ThreadItem.InFavorites  :=  False;
end;

procedure DeleteFromShortcut(ThreadItem: TThreadItem);
var
  sl  : TStringList;
  Path: string;
  i   : integer;
  d   : integer;
  SiteID, BoardID, DatNo : string;
begin
  sl    :=  TStringList.Create;
  Path  :=  ZonuConfig.UsersPath + FILE_SHORTCUT;
  if  (FileExists(Path))  then  begin
    sl.LoadFromFile(Path);
    d :=  0;
    for i :=  sl.Count - 1  downto  1  do  begin
      if  (ChooseString(sl[i], #9, 1) = '2')  then  begin
        SiteID  :=  ChooseString(sl[i], #9, 5);
        BoardID :=  ChooseString(sl[i], #9, 4);
        DatNo   :=  ChooseString(sl[i], #9, 3);
        if  (ThreadItem.Site.SiteID = SiteID) and
            (ThreadItem.BoardID = BoardID) and
            (ThreadItem.DatNo   = DatNo) then
        begin
          sl.Delete(i);
          Inc(d);
        end;
      end;
    end;
    if  (d > 0) then  sl.SaveToFile(Path);
  end;
  sl.Free;
  ThreadItem.InShortcut  :=  False;
end;


procedure ClearMenuItemSub(vParent, vMenuItem: TMenuItem; index: integer);
var
  Item: TMenuItem;
begin
  if (vParent <> nil) then begin
    Item := vParent[index];
    vParent.Delete(index);

    Item.Free;
  end;
end;

//
//  c[j[\z
//
procedure BuildTools;
var
  FToolConfig : TStringList;
  i : integer;
  p : TToolMenuItem;
begin
  {$IFDEF NUXX}
  ShowMessage('BuildTools');
  {$ELSE}
  FToolConfig :=  TStringList.Create;
  if  (FileExists(ZonuConfig.UsersPath + FILE_TOOL))  then  begin
    FToolConfig.LoadFromFile(ZonuConfig.UsersPath + FILE_TOOL);
  end;
  for i :=  HotzonuWindow.Tool1.Count -1  downto  0 do  begin
    if  (HotzonuWindow.Tool1[i] is TToolMenuItem) then  begin
      ClearMenuItemSub(HotzonuWindow.Tool1, HotzonuWindow.Tool1[i], i);
    end;
  end;
  if  (FileExists(ZonuConfig.UsersPath + FILE_TOOL))  then  begin
    p :=  TToolMenuItem.Create(HotzonuWindow);
    p.Caption   :=  '-';
    HotzonuWindow.Tool1.Add(p);
    for i :=  0 to  FToolConfig.Count - 1 do  begin
      if  (Trim(FToolConfig[i]) <> '')  then  begin
        p :=  TToolMenuItem.Create(HotzonuWindow);
        p.Title     :=  ChooseString(FToolConfig[i], #9, 0);
        p.FilePath  :=  ChooseString(FToolConfig[i], #9, 1);
        p.WorkDir   :=  ChooseString(FToolConfig[i], #9, 2);
        p.Params    :=  ChooseString(FToolConfig[i], #9, 3);
        p.ParamUrl  :=  (ChooseString(FToolConfig[i], #9, 4) = '1');
        p.Caption   :=  StringReplace(p.Title, '&', '&&', [rfReplaceAll]);
        p.OnClick   :=  HotzonuWindow.ToolMenuClick;
        HotzonuWindow.Tool1.Add(p);
      end;
    end;
  end;
  FToolConfig.Free;
  {$ENDIF}
end;

function FindAction(const AName: string): TAction;
var
  i : integer;
begin
  Result  :=  nil;
  for i :=  0 to  HotzonuWindow.ActionList1.ActionCount - 1 do  begin
    if  (TAction(HotzonuWindow.ActionList1.Actions[i]).Name = AName)  then  begin
      Result  :=  TAction(HotzonuWindow.ActionList1.Actions[i]);
      Break;
    end;
  end;
end;

procedure LoadToolButtons(const FileName: string; ToolBar: TToolBar);
var
  ini : TMemIniFile;
  i, x, w, h  : integer;
  s : string;
  b : TToolButton;
begin
  ini :=  TMemIniFile.Create(FileName);
  if  (ini.SectionExists(ToolBar.Name)) then  begin
    for x :=  ToolBar.ButtonCount - 1 downto  0 do  begin
      ToolBar.Buttons[x].Free;
    end;
    for i :=  ini.ReadInteger(ToolBar.Name, 'COUNT', 0) downto  1 do  begin
      s :=  ini.ReadString(ToolBar.Name, 'BUTTON' + IntToStr(i), '');
      if  (s <> '') then  begin
        b :=  TToolButton.Create(ToolBar);
        b.Parent  :=  ToolBar;
        if  (s = '-') then  begin
          b.Style   := tbsSeparator;
          b.Caption :=  '';
          b.AutoSize  :=  False;
          b.Width     :=  8;
        end else begin
          b.Action    :=  FindAction(s);
          b.AutoSize  :=  True;
          {
          b.OnStartDrag   :=  HotzonuWindow.ToolButtonStartDrag;
          b.OnDragDrop    :=  HotzonuWindow.ToolButtonDragDrop;
          b.OnDragOver    :=  HotzonuWindow.ToolButtonDragOver;
          b.DragKind      :=  dkDrag;
          b.DragMode      :=  dmManual;
          b.OnMouseDown   :=  HotzonuWindow.ToolButtonXMouseDown;
          b.OnMouseMove   :=  HotzonuWindow.ToolButtonXMouseMove;
          b.OnMouseUp     :=  HotzonuWindow.ToolButtonXMouseUp;
          }
          {
          if  (ToolBar.Align = alLeft) or (ToolBar.Align = alRight) or (ToolBar.Align = alClient) then  begin
            b.Wrap  :=  True;
          end;
          }
        end;
      end;
    end;
  end;
  w :=  ToolBar.Width;
  h :=  ToolBar.Height;
  TToolBarA(ToolBar).WrapButtons(w, h);
  {
  Application.ProcessMessages;
  for i :=  0 to  ToolBar.ButtonCount - 1 do  begin
    TToolBarA(ToolBar).RepositionButton(i);
  end;
  }
  ini.Free;
end;

procedure LoadPopupMenuItems(const FileName: string; PopupMenu: TPopupMenu);
var
  ini : TMemIniFile;
  i, x: integer;
  s : string;
  b : TMenuItem;
begin
  ini :=  TMemIniFile.Create(FileName);
  if  (ini.SectionExists(PopupMenu.Name)) then  begin
    for x :=  PopupMenu.Items.Count - 1 downto  0 do  begin
      PopupMenu.Items[x].Free;
    end;
    for i :=  1 to  ini.ReadInteger(PopupMenu.Name, 'COUNT', 0) do  begin
      s :=  ini.ReadString(PopupMenu.Name, 'ITEM' + IntToStr(i), '');
      if  (s <> '') then  begin
        b :=  TMenuItem.Create(PopupMenu);
        if  (s = '-') then  begin
          b.Caption :=  '-';
        end else begin
          b.Action    :=  FindAction(s);
        end;
        PopupMenu.Items.Add(b);
      end;
    end;
  end;
  ini.Free;
end;

procedure BuildSearchEngineList(Menu: TPopupMenu);
var
  sl : TStringList;
  i : integer;
  p : TMenuItem;
  m : TSearchEngineMenuItem;
begin
  {$IFDEF NUXX}
  ShowMessage('BuildSearchEngineList');
  {$ELSE}
  sl  :=  TStringList.Create;
  if  (FileExists(ZonuConfig.UsersPath + FILE_SEARCH_ENGINE)) then  begin
    sl.LoadFromFile(ZonuConfig.UsersPath + FILE_SEARCH_ENGINE);
  end;
  Menu.Items.Clear;
  //
  p :=  TMenuItem.Create(HotzonuWindow);
  p.Action  :=  HotzonuWindow.actSelectionCopy;
  Menu.Items.Add(p);
  //
  //35 begin
  p :=  TMenuItem.Create(HotzonuWindow);
  p.Action  :=  HotzonuWindow.actSelectionFilter;
  Menu.Items.Add(p);
  //35 end
  //
  p :=  TMenuItem.Create(HotzonuWindow);
  p.Caption :=  '-';
  Menu.Items.Add(p);
  for i :=  0 to  sl.Count  - 1 do  begin
    if  (sl[i]  = '-')  then  begin
      p :=  TMenuItem.Create(HotzonuWindow);
      p.Caption :=  '-';
      Menu.Items.Add(p);
    end else begin
      m :=  TSearchEngineMenuItem.Create(HotzonuWindow);
      m.Caption :=  sl.Names[i];
      m.Url     :=  sl.Values[sl.Names[i]];
      m.OnClick :=  HotzonuWindow.SearchEngineClicked;
      Menu.Items.Add(m);
    end;
  end;
  sl.Free;
  {$ENDIF}
end;

function AddBoard(Site: TSite; const CategoryName, BoardName, Path: string): boolean;
var
  Board : TBoard;
  b : boolean;
  i : integer;
begin
  Result  :=  False;
  if  (ZonuHttpList.Count > 0)  then  begin
    MessageDlg('ǂݍ݁C܂͏݂Ă܂B', mtError, [mbOk], 0);
    Exit;
  end;
  BoardEditor               :=  TBoardEditor.Create(HotzonuWindow);
  BoardEditor.Site          :=  Site;
  BoardEditor.CategoryName  :=  CategoryName;
  BoardEditor.EditMode      :=  emNew;
  BoardEditor.BoardName     :=  BoardName;
  BoardEditor.Path          :=  Path;
  BoardEditor.CharSet       :=  Site.CharSet; //age16
  if  (BoardEditor.ShowModal = mrOk)  then  begin
    Board               :=  TBoard.Create;
    Board.Site          :=  Site;
    Board.Name          :=  BoardEditor.BoardName;
    Board.BoardPath     :=  BoardEditor.BoardPath;
    Board.BoardID       :=  BoardEditor.BoardID;
    Board.Url           :=  BoardEditor.Path;
    if  (Site.SiteType = stLocal) then  begin
      Board.CachePath   :=  BoardEditor.Path;
    end;
    Board.Key           :=  BoardEditor.BoardID;
    Board.Expanded      :=  True;
    Board.BBS           :=  Site.BBS;
    Board.CharSet       :=  Site.CharSet;
    Board.Gaishutu      :=  False;
    Board.CategoryName  :=  BoardEditor.CategoryName;
    Board.CharSet       :=  BoardEditor.CharSet;  //age16
    if  (BoardEditor.CategoryName = '') then  begin
      Site.BoardList.Insert(0, Board);
    end else begin
      b :=  False;
      for i :=  Site.BoardList.Count - 1  downto  0 do  begin
        if  (Site.BoardList[i].CategoryName = Board.CategoryName) then  begin
          Site.BoardList.Insert(i + 1, Board);
          b :=  True;
          Break;
        end;
      end;
      if  (not b) then  Site.BoardList.Add(Board);
    end;
    Site.BoardList.SaveToFile(ZonuConfig.UsersPath + 'config\site\' + Site.SiteID + '\' + FILE_BOARD);
    Site.BoardList.Clear;
    Site.LoadBoardList;
    Result  :=  True;
  end;
  BoardEditor.Release;
end;

function EditBoard(Site: TSite; Board: TBoard): boolean;
var
  b : boolean;
  i, x : integer;
  OldBaordPath, OldBoardID: string;
begin
  Result  :=  False;
  if  (ZonuHttpList.Count > 0)  then  begin
    MessageDlg('ǂݍ݁C܂͏݂Ă܂B', mtError, [mbOk], 0);
    Exit;
  end;
  if  (Site.SiteType = stFavorites) then  begin
    if  (Board.BoardType <> btFavorites)  then  begin
      MessageDlg('͏Cł܂B', mtError, [mbOk], 0);
      Exit;
    end;
  end;

  BoardEditor               :=  TBoardEditor.Create(HotzonuWindow);
  BoardEditor.Site          :=  Site;
  BoardEditor.CategoryName  :=  Board.CategoryName;
  BoardEditor.BoardName     :=  Board.Name;
  BoardEditor.CategoryName  :=  Board.CategoryName;
  BoardEditor.Path          :=  Board.Url;
  BoardEditor.Board         :=  Board;
  BoardEditor.EditMode      :=  emEdit;
  BoardEditor.CharSet       :=  Board.CharSet;  //age16
  OldBaordPath              :=  Board.BoardPath;
  OldBoardID                :=  Board.BoardID;
  if  (BoardEditor.ShowModal = mrOk)  then  begin
    Board.Name          :=  BoardEditor.BoardName;
    Board.BoardPath     :=  BoardEditor.BoardPath;
    Board.BoardID       :=  BoardEditor.BoardID;
    Board.Url           :=  BoardEditor.Path;
    if  (Site.SiteType = stLocal) then  begin
      Board.CachePath   :=  BoardEditor.Path;
    end;
    Board.Key           :=  BoardEditor.BoardID;
    Board.Expanded      :=  True;
    //Board.BBS           :=  Site.BBS;
    //Board.CharSet       :=  Site.CharSet;
    Board.CharSet       :=  BoardEditor.CharSet;  //age16
    UpdateFav(OldBaordPath,
              OldBoardID,
              Board.BoardID,
              Board.Name,
              Board);
    if  (Board.CategoryName <> BoardEditor.CategoryName)  then  begin
      for x :=  0 to  Site.BoardList.Count - 1  do  begin
        if  (Site.BoardList[x] = Board) then  Break;
      end;
      Board.CategoryName  :=  BoardEditor.CategoryName;
      b :=  False;
      for i :=  Site.BoardList.Count - 1  downto  0 do  begin
        if  (Site.BoardList[i].CategoryName = Board.CategoryName) and
            (Site.BoardList[i] <> Board)  then
        begin
          Site.BoardList.Move(x, i);
          b :=  True;
          Break;
        end;
      end;
      if  (not b) then  Site.BoardList.Move(x, Site.BoardList.Count - 1);
    end else begin

    end;
    //Site.BoardList.SaveToFile(Site.ConfigPath + FILE_BOARD);
    Site.BoardList.SaveToFile(ZonuConfig.UsersPath + 'config\site\' + Site.SiteID + '\' + FILE_BOARD);
    Site.BoardList.Clear;
    Site.LoadBoardList;
    Result  :=  True;
  end;
  BoardEditor.Release;
end;

function DeleteBoard(Site: TSite; Board: TBoard): boolean;
var
  sl: TStringList;
  i : integer;
  s : string;
begin
  Result  :=  False;
  if  (ZonuHttpList.Count > 0)  then  begin
    MessageDlg('ǂݍ݁C܂͏݂Ă܂B', mtError, [mbOk], 0);
    Exit;
  end;
  if  (MessageDlg(Board.Name + '폜܂H',
                  mtWarning, [mbYes, mbNo], 0) = mrYes) then
  begin
    for i :=  Site.BoardList.Count - 1  downto  0 do  begin
      if  (Site.BoardList[i] = Board) then  begin
        //̈ꗗۑĂA{[hꗗXVĂoȂ悤ɂ
        s :=  ZonuConfig.UsersPath + PATH_SITE_CONFIG +
              Site.SiteID + '\' + FILE_ABONE_BOARD;
        sl  :=  TStringList.Create;
        if  (FileExists(s)) then  begin
          sl.LoadFromFile(s);
        end;
        if  (sl.IndexOf(Site.BoardList[i].BoardID) < 0) then  begin
          sl.Add(Site.BoardList[i].BoardID);
        end;
        sl.SaveToFile(s);
        sl.Free;
        Site.BoardList.Delete(i);
        Break;
      end;
    end;
    Site.BoardList.SaveToFile(ZonuConfig.UsersPath + 'config\site\' + Site.SiteID + '\' + FILE_BOARD);
    //Site.BoardList.SaveToFile(Site.ConfigPath + FILE_BOARD);
    Site.BoardList.Clear;
    Site.LoadBoardList;
    Result  :=  True;
  end;
end;

procedure BuildShortcutList(ListBox: TListBox; FileName: string = '');
var
  sl : TStringList;
  TabData : TTabData;
  ShortcutData  : TShortcutData;
  i : integer;
  img : string;
begin
  sl  :=  TStringList.Create;
  if  (FileName = '') then  begin
    if  (FileExists(ZonuConfig.UsersPath + FILE_SHORTCUT))  then  begin
      sl.LoadFromFile(ZonuConfig.UsersPath + FILE_SHORTCUT);
    end;
  end else begin
    sl.LoadFromFile(FileName);
  end;
  TabData :=  nil;
  for i :=  0 to  sl.Count - 1  do  begin
    if  (sl[i][1] <> #9)  then  begin
      TabData :=  TTabData.Create;
      TabData.Title   :=  ChooseString(sl[i], #9, 0);
      TabData.Color   :=  StringToColor(ChooseString(sl[i], #9, 1));

      SetCurrentDir(ExtractFilePath(ZonuConfig.AppPath));
      img :=  ExpandFileName(ChooseString(sl[i], #9, 2));
      TabData.BitmapFileName  :=  img;
      //TabData.BitmapFileName  :=  ChooseString(sl[i], #9, 2);

      ListBox.Items.Objects[ListBox.Items.Add(TabData.Title)] := TabData;
    end else begin
      if  (TabData <> nil)  then  begin
        ShortcutData  :=  TabData.Add;
        {
        ShortcutData.Title    :=  ChooseString(sl[i], #9, 1);
        ShortcutData.SiteID   :=  ChooseString(sl[i], #9, 2);
        ShortcutData.BoardID  :=  ChooseString(sl[i], #9, 3);
        }
        ShortcutData.ObjectType   :=  TObjectType(StrToInt(ChooseString(sl[i], #9, 1)));
        ShortcutData.Title        :=  ChooseString(sl[i], #9, 2);
        ShortcutData.Param1       :=  ChooseString(sl[i], #9, 3);
        ShortcutData.Param2       :=  ChooseString(sl[i], #9, 4);
        ShortcutData.Param3       :=  ChooseString(sl[i], #9, 5);
        {
        Zonu.FindSite(ShortcutData.SiteID, Site);
        if  (Site <> nil) then  begin
          Site.BoardList.FindBoard(ShortcutData.BoardID, Board);
        end;
        ShortcutData.Site   :=  Site;
        ShortcutData.Board  :=  Board;
        }
      end;
    end;
  end;
  sl.Free;
end;

procedure DrawTabDataListBox(ListBox: TListBox;
  Index: Integer; ARect: TRect; State: TOwnerDrawState);
var
  TabData : TTabData;
  a: integer;
begin
  if  (Index > -1) and (Index < ListBox.Items.Count) then  begin
    if  (ListBox.Items.Objects[Index] <> nil) then  begin
      TabData :=  TTabData(ListBox.Items.Objects[Index]);
      with  ListBox.Canvas do  begin
        if  (odSelected in State) then  begin
          Brush.Color :=  clHighlight;
          Font.Style  :=  [fsBold];
          Font.Color  :=  clHighlightText;
        end else begin
          Brush.Color :=  clWindow;
          Font.Style  :=  [];
          Font.Color  :=  clWindowText;
        end;
        FillRect(ARect);
        a :=  (ARect.Bottom - ARect.Top - Abs(TextHeight(ListBox.Items[Index]))) div 2;
        TextRect(ARect, ARect.Left + 27, ARect.Top + a, TabData.Title);
        if  (TabData.Bitmap <> nil) then  begin
          BrushCopy(
                    Rect(ARect.Left, ARect.Top, ARect.Left + TabData.Bitmap.Width, ARect.Top + TabData.Bitmap.Height),
                    TabData.Bitmap,
                    Rect(0, 0, TabData.Bitmap.Width, TabData.Bitmap.Height), clRed);
        end;
        Brush.Color :=  TabData.Color;
        FillRect(Rect(ARect.Left + 17, ARect.Top, ARect.Left + 25, ARect.Bottom));
      end;
    end;
  end;
end;

procedure SaveShortcutList(ListBox: TListBox; FileName: string = '');
var
  sl : TStringList;
  i, x : integer;
  TabData : TTabData;
  ShortcutData :  TShortcutData;
begin
  sl  :=  TStringList.Create;
  for i :=  0 to  ListBox.Items.Count - 1  do  begin
    TabData :=  TTabData(ListBox.Items.Objects[i]);
    //n := sl.Add(TabData.Title + #9 + ColorToString(TabData.Color) + #9 + TabData.BitmapFileName);
    sl.Add(TabData.Title + #9 + ColorToString(TabData.Color) + #9 + ExtractRelativePath(ZonuConfig.AppPath, TabData.BitmapFileName));
    for x :=  0 to  TabData.ShortcutCount - 1 do  begin
      ShortcutData  :=  TabData.Shortcuts[x];
      {
      if  (ShortcutData.Title = '-')  then  begin
        sl.Insert(n + 1, #9 + '0');
      end else begin
        sl.Insert(n + 1, #9 + '1' + #9 + ShortcutData.Title + #9 + ShortcutData.SiteID + #9 + ShortcutData.BoardID);
      end;
      }
      sl.Add(Format(#9 + '%d' + #9 + '%s' + #9 + '%s' + #9 + '%s' + #9 + '%s',
                   [Integer(ShortcutData.ObjectType),
                            ShortcutData.Title,
                            ShortcutData.Param1,
                            ShortcutData.Param2,
                            ShortcutData.Param3]));
    end;
  end;
  if  (FileName = '') then  begin
    sl.SaveToFile(ZonuConfig.UsersPath + FILE_SHORTCUT);
  end else begin
    sl.SaveToFile(FileName);
  end;
  sl.Free;
end;

procedure ReleaseShortcutList(ListBox: TListBox);
var
  i : integer;
begin
  for i :=  ListBox.Items.Count - 1  downto  0 do  begin
    TTabData(ListBox.Items.Objects[i]).Free;
  end;
end;

procedure ScrollBoardList(Board: TBoard);
var
  i : integer;
  Node  : TTreeNode;
begin
  {$IFDEF NUXX}
  ShowMessage('ScrollBoardList');
  {$ELSE}
  if  (HotzonuWindow.ActiveSite <> Board.Site)  then  begin
    HotzonuWindow.SetActiveSite(Board.Site);
  end;
  if  (ZonuConfig.BoardListAutoExpand)  then  begin
    HotzonuWindow.BoardListView.FullCollapse;
  end;
  for i :=  0 to  HotzonuWindow.BoardListView.Items.Count - 1  do  begin
    Node  :=  HotzonuWindow.BoardListView.Items[i];
    if  (Node.Data  <>  nil)  then  begin
      if  (TObject(Node.Data) is TBoard)  then  begin
        if  (TBoard(Node.Data) = Board) then  begin
          HotzonuWindow.BoardListView.Selected  :=  Node;
          if  (HotzonuWindow.BoardListView.Selected.Level > 0)  then  begin
            HotzonuWindow.BoardListView.Selected.Parent.Expand(True);
          end;
          Exit;
        end;
      end;
    end;
  end;
  {$ENDIF}
end;

procedure RebuildColumn(FViewColumn: TStringList);
var
  i: integer;
  Col: TListColumn;
begin
  FViewColumn.LoadFromFile(ZonuConfig.UsersPath + FILE_COLUMN);
  //[XɒǉJǉ
  if  (FViewColumn.IndexOf('SINCE') < 0)  then  begin
    FViewColumn.Add('SINCE');
    FViewColumn.SaveToFile(ZonuConfig.UsersPath + FILE_COLUMN);
  end;
  if  (FViewColumn.IndexOf('READPOINT') < 0)  then  begin
    FViewColumn.Add('READPOINT');
    FViewColumn.SaveToFile(ZonuConfig.UsersPath + FILE_COLUMN);
  end;
  if  (FViewColumn.IndexOf('THREADNO') < 0)  then  begin
    FViewColumn.Add('THREADNO');
    FViewColumn.SaveToFile(ZonuConfig.UsersPath + FILE_COLUMN);
  end;

  HotzonuWindow.ThreadListView.Columns.Clear;
  for i :=  0 to  FViewColumn.Count - 1 do  begin
    if  (i = 0) then  begin
      Col :=  HotzonuWindow.ThreadListView.Columns.Add;
      Col.Caption :=  'NO';
    end;
    Col :=  HotzonuWindow.ThreadListView.Columns.Add;
    if  (FViewColumn[i] = 'UPDATE') then  begin
      Col.Caption     :=  '';
      Col.ImageIndex  :=  11;
    end else
    if  (FViewColumn[i] = 'INFO') then  begin
      Col.Caption     :=  '';
      Col.ImageIndex  :=  10;
    end else
    if  (FViewColumn[i] = 'TITLE') then  begin
      Col.Caption     :=  '^Cg';
    end else
    if  (FViewColumn[i] = 'AGECOUNT') then  begin
      Col.Caption     :=  'JEg';
      Col.Alignment   :=  taRightJustify;  
    end else
    if  (FViewColumn[i] = 'NEWCOUNT') then  begin
      Col.Caption     :=  'V';
      Col.Alignment   :=  taRightJustify;
    end else
    if  (FViewColumn[i] = 'RESCOUNT') then  begin
      Col.Caption     :=  '';
      Col.Alignment   :=  taRightJustify;
    end else
    if  (FViewColumn[i] = 'PRIORITY') then  begin
      Col.Caption     :=  '';
      Col.ImageIndex  :=  38; //16;
    end else
    if  (FViewColumn[i] = 'LASTLOAD') then  begin
      Col.Caption     :=  'ŏI擾';
    end else
    if  (FViewColumn[i] = 'LASTSENT') then  begin
      Col.Caption     :=  'ŏI';
    end else
    if  (FViewColumn[i] = 'COMMENT') then  begin
      Col.Caption     :=  'Rg';
    end else
    if  (FViewColumn[i] = 'BOARD') then  begin
      Col.Caption     :=  '';
    end else
    if  (FViewColumn[i] = 'BBS') then  begin
      Col.Caption     :=  'BBS';
    end else
    if  (FViewColumn[i] = 'READPOINT') then  begin
      Col.Caption     :=  '';
      Col.ImageIndex  :=  37;
    end else
    if  (FViewColumn[i] = 'READPOINTNO') then  begin
      Col.Caption     :=  '';
      Col.Alignment   :=  taRightJustify;
    end else
    if  (FViewColumn[i] = 'THREADNO') then  begin
      Col.Caption     :=  '';
      Col.Alignment   :=  taRightJustify;
    end else
    if  (FViewColumn[i] = 'DAT') then  begin
      Col.Caption     :=  'DAT';
      Col.Alignment   :=  taRightJustify;
    end else
    if  (FViewColumn[i] = 'SINCE') then  begin
      Col.Caption     :=  'Xē';
      Col.Alignment   :=  taLeftJustify;
    end;
  end;
end;

//age16
//procedure SaveHist(ThreadItem: TThreadItem; const FileName: string;
//  const Sort: boolean);
procedure SaveHist(ThreadItem: TThreadItem; const FileName: string;
  const Sort: boolean; ASaveHist: boolean);
var
  sl: TStringList;
  s: string;
  n: integer;
begin
  //age16 if  (ZonuConfig.SaveHist)  then  begin
  if  (ASaveHist)  then  begin
    sl  :=  TStringList.Create;
    if  (FileExists(FileName))  then  begin
      sl.LoadFromFile(FileName);
    end;
    s :=  ThreadItem.Site.SiteID    + #9 +
          ThreadItem.BoardID  + #9 +
          ThreadItem.DatNo  + #9  +
          ThreadItem.Title  + #9  +
          FormatDateTime('yyyy/mm/dd hh:nn:ss', Now);
    if  (Sort)  then  begin
      for n :=  sl.Count - 1 downto  0 do  begin
        if  (ThreadItem.Site.SiteID     = ChooseString(sl[n], #9, 0)) and
            (ThreadItem.BoardID         = ChooseString(sl[n], #9, 1)) and
            (ThreadItem.DatNo           = ChooseString(sl[n], #9, 2)) then
        begin
          sl.Delete(n);
        end;
      end;
    end;
    sl.Insert(0, S);
    try
      sl.SaveToFile(FileName);
    finally
      sl.Free;
    end;
    if  (ZonuConfig.HistReloadAfterLoad) and  (HistDialog.Showing)  then  begin
      HistDialog.LoadHist;
    end;
  end;
end;

procedure BuildLocalThreadList(ListDoc: TZonuListDoc; Path: string = '');
var
  ThreadItem  : TThreadItem;
  sl  : TStringList;
  tl  : TStringList;
  Rec : TSearchRec;
  DatNo : string;
  s : string;
  n : integer;
  p  : string;
begin
  sl  :=  TStringList.Create;
  tl  :=  TStringList.Create;
  if  (Path = '') then  begin
    p :=  ListDoc.Board.CachePath;
  end else begin
    p :=  Path;
  end;
  if  (FileExists(p + 'subject.dat')) then  begin
    tl.LoadFromFile(p + 'subject.dat');
  end;
  n   :=  1;
  if  (FindFirst(p + '*.dat', faAnyFile, Rec) = 0) then  begin
    repeat
      if  (AnsiLowerCase(Rec.Name) <> 'subject.dat')  then  begin
        sl.LoadFromFile(p + Rec.Name);
        if  (sl.Count > 0)  then  begin
          s :=  ChooseString(sl[0], '<>', 4);
          DatNo :=  Copy(Rec.Name, 1, AnsiPos('.dat', Rec.Name) - 1);
          ThreadItem        :=  TThreadItem.Create;
          ThreadItem.CreateThreadItem(ListDoc.Board.Site.SiteID,
                                      ListDoc.Board.BoardID,
                                      DatNo,
                                      ThreadItem.Title);
          if  (not ThreadItem.IsKakoLog)  then  begin
            if  (tl.Values[DatNo] = '') then  begin
              ThreadItem.IsKakoLog  :=  True;
            end;
          end;
          ThreadItem.No :=  n;
          Inc(n);
          ListDoc.ThreadItemList.Add(ThreadItem);
          if  ((ListDoc.ThreadItemList.Count mod 30) = 0)  then  begin
            Application.ProcessMessages;
          end;
        end;
      end;
    until (FindNext(Rec) <> 0);
  end;
  sl.Free;
  tl.Free;
end;

function  IsToday(const DateText: string): boolean;
var
  y,m,d: word;
  yy,mm,dd: integer;
  i, n: integer;
  s: string;
begin
  n :=  0;
  s :=  '';
  yy  :=  0;
  mm  :=  0;
  dd  :=  0;
  for i :=  1 to  Length(DateText)  do  begin
    if  (DateText[i] in ['0','1','2','3','4','5','6','7','8','9'])  then  begin
      s :=  s + DateText[i];
    end else begin
      if  (s <> '') then  begin
        Inc(n);
        if  (n  = 1)  then  begin
          yy  :=  StrToInt(s);
          if  (yy < 100)  then  begin
            if  (yy < 90) then  begin
              yy  :=  yy  + 2000;
            end else begin
              yy  :=  yy  + 1900;
            end;
          end;
        end else
        if  (n  = 2)  then  begin
          mm  :=  StrToInt(s);
        end else begin
          dd  :=  StrToInt(s);
          Break;
        end;
        s :=  '';
      end;
    end;
  end;
  //
  DecodeDate(Now, y, m, d);
  //
  Result  :=  ((y = yy) and (m = mm) and (d = dd));
end;

procedure AddWindowList(Form: TForm);
begin
  {
  HotzonuWindow.WindowList.Add(Form);
  BuildWindowList;
  }
end;

procedure DeleteWindowList(Form: TForm);
//var
//  i: integer;
begin
  {
  for i :=  HotzonuWindow.WindowList.Count - 1  downto  0 do  begin
    if  (HotzonuWindow.WindowList[i] = Form)  then  begin
      HotzonuWindow.WindowList.Delete(i);
    end;
  end;
  BuildWindowList;
  }
end;

procedure BuildWindowList;
//var
//  i : integer;
//  Item: TMenuItem;
begin
  {
  HotzonuWindow.Window1.Clear;
  for i :=  0 to  HotzonuWindow.WindowList.Count - 1  do  begin
    Item  :=  TMenuItem.Create(HotzonuWindow.Window1);
    Item.Caption  :=  TForm(HotzonuWindow.WindowList[i]).Caption;
    HotzonuWindow.Window1.Add(Item);
  end;
  }
end;

function  ExtractSkinName(const FileName: string): string;
var
  s: string;
begin
  if  (FileName <> '')  then  begin
    s :=  ExcludeTrailingPathDelimiter(FileName);
    //s :=  Copy(FileName, 1, Length(FileName) - 1);
  end else begin
    s :=  '';
  end;
  Result  :=  ExtractFileName(s);
end;

procedure RefreshThreadListEx(ThreadItem: TThreadItem);
var
  ActiveListDoc: TZonuListDoc;
  ListDoc: TZonuListDoc;
  i, x: integer;
begin
  {$IFDEF NUXX}
  ShowMessage('RefreshThreadListEx');
  {$ELSE}
  HotzonuWindow.GetActiveListDoc(ActiveListDoc);
  for i :=  0 to  HotzonuWindow.ThreadListTab.Count - 1 do  begin
    ListDoc :=  TZonuListDoc(HotzonuWindow.ThreadListTab[i]);
    for x :=  0 to  ListDoc.ThreadItemList.Count - 1  do  begin
      if  (ThreadItem = ListDoc.ThreadItemList[x])  and
          (ActiveListDoc = ListDoc) and
          (HotzonuWindow.ThreadListView.Items.Count > x)  then
      begin
        HotzonuWindow.ThreadListView.Items[x].Update;
        Break;
      end;
      if  (ThreadItem <> ListDoc.ThreadItemList[x])  and
          (ThreadItem.DatNo = ListDoc.ThreadItemList[x].DatNo)  then
      begin
        ListDoc.ThreadItemList[x].LoadConfig;
      end;
    end;
  end;
  {$ENDIF}
end;

procedure CreateDefaultFavFolder;
var
  Board: TBoard;
  ini: TMemIniFile;
  FBoardID: string;
  FBoardPath: string;
  sl: TStringList;
  i, n: integer;
  b: boolean;
  DefaultFolderName: string;
begin
  b :=  False;
  DefaultFolderName :=  ZonuConfig.DefaultFavoriteFolderName;
  for i :=  0 to  ZonuEnviron.FavoritesSite.BoardList.Count - 1 do  begin
    if  (SameText(ZonuEnviron.FavoritesSite.BoardList[i].Name, DefaultFolderName))  then
    begin
      b :=  True;
      Break;
    end;
  end;
  if  (not b) then  begin
    ini         :=  TMemIniFile.Create(ZonuConfig.UsersPath + PATH_CONFIG + PATH_FAVORITES + INI_SITE);
    n           :=  ini.ReadInteger('LIST', 'USED', 0) + 1;
    FBoardID    :=  Format('fav%.5d', [n]);
    FBoardPath  :=  BOARDPATH_FAV;
    ini.WriteInteger('LIST', 'USED', n);
    ini.UpdateFile;
    sl          :=  TStringList.Create;
    sl.Add(DefaultFolderName);
    sl.SaveToFile(ZonuConfig.UsersPath + PATH_CONFIG + PATH_FAVORITES + FBoardID + '.txt');
    sl.Free;
    ini.Free;
    Board :=  TBoard.Create;
    if  (ZonuEnviron.FavoritesSite.BoardList.Count > 0) then  begin
      Board.CategoryName  :=  ZonuEnviron.FavoritesSite.BoardList[0].CategoryName;
    end else begin
      Board.CategoryName  :=  'system';
    end;
    Board.BoardType       :=  btFavorites;
    Board.Name            :=  DefaultFolderName;
    Board.BBS             :=  ZonuEnviron.FavoritesSite.BBS;
    Board.Site            :=  ZonuEnviron.FavoritesSite;
    Board.BoardPath       :=  FBoardPath;
    Board.BoardID         :=  FBoardID;
    Board.Url             :=  '';
    Board.Key             :=  FBoardID;
    Board.Expanded        :=  True;
    Board.CharSet         :=  ZonuEnviron.FavoritesSite.CharSet;
    Board.Gaishutu        :=  False;
    b :=  False;
    for i :=  ZonuEnviron.FavoritesSite.BoardList.Count - 1  downto  0 do  begin
      if  (ZonuEnviron.FavoritesSite.BoardList[i].CategoryName = Board.CategoryName) then  begin
        ZonuEnviron.FavoritesSite.BoardList.Insert(i + 1, Board);
        b :=  True;
        Break;
      end;
    end;
    if  (not b) then  ZonuEnviron.FavoritesSite.BoardList.Add(Board);
    ZonuEnviron.FavoritesSite.BoardList.SaveToFile(ZonuConfig.UsersPath + 'config\site\' + ZonuEnviron.FavoritesSite.SiteID + '\' + FILE_BOARD);
    ZonuEnviron.FavoritesSite.BoardList.Clear;
    ZonuEnviron.FavoritesSite.LoadBoardList;
  end;
end;

function  GetDefaultFavFolder(var Board: TBoard): boolean;
var
  b: boolean;
  i: integer;
begin
  b :=  False;
  Board :=  nil;
  for i :=  0 to  ZonuEnviron.FavoritesSite.BoardList.Count - 1 do  begin
    if  (SameText(ZonuEnviron.FavoritesSite.BoardList[i].Name,
                  ZonuConfig.DefaultFavoriteFolderName))  then
    begin
      b :=  True;
      Board :=  ZonuEnviron.FavoritesSite.BoardList[i];
      Break;
    end;
  end;
  Result  :=  b;
end;

procedure ShowResToDoubleWindow(ThreadItem: TThreadItem; Res: TRes);
var
  AResList: TResList;
  ARes: TRes;
  i: integer;
begin
  {$IFDEF NUXX}
  ShowMessage('ShowResToDoubleWindow');
  {$ELSE}
  ShowDoubleWindow;
  AResList  :=  TResList.Create(ThreadItem);
  ARes      :=  TRes.Create;
  ARes.Assign(Res);
  AResList.Add(ARes);

  ThreadItem.AddRef;
  HotzonuWindow.ZonuBrowser2.BoardID       :=  ThreadItem.BoardID;
  HotzonuWindow.ZonuBrowser2.ResList       :=  AResList;
  HotzonuWindow.ZonuBrowser2.ThreadItem    :=  ThreadItem;
  HotzonuWindow.ZonuBrowser2.State         :=  vsReady;
  HotzonuWindow.ZonuBrowser2.InitSkin(ThreadItem.Board);
  HotzonuWindow.InitOutputRes(HotzonuWindow.ZonuBrowser2,
                              HotzonuWindow.ZonuBrowser2.ResList);
  HotzonuWindow.ZonuBrowser2.WriteHeader;
  for i :=  0 to  AResList.Count - 1 do  begin
    AResList[i].BBS     :=  ThreadItem.BBS;
    AResList[i].Showing :=  True;
    HotzonuWindow.OutputRes(HotzonuWindow.ZonuBrowser2,
                            HotzonuWindow.ZonuBrowser2,
                            AResList[i],
                            AResList);
  end;
  HotzonuWindow.ZonuBrowser2.State :=  vsReady;
  HotzonuWindow.EndOutputRes(HotzonuWindow.ZonuBrowser2);
  {$ENDIF}
end;

procedure HideBrowser(Browser: TZonuBrowser; MoveToPanel: boolean);
var
  i:  integer;
begin
  {$IFDEF NUXX}
  ShowMessage('HideBrowser');
  {$ELSE}
  Browser.PageKill  :=  True;
  //x :=  FindResPageIndex(Browser);
  //^u̍폜
  //CloseBrowser(x, True, True);
  //CloseBrowser(Browser, True);
  Browser.OnStatusTextChange    :=  nil;
  Browser.OnBeforeNavigate2     :=  nil;
  Browser.OnNewWindow2          :=  nil;
  Browser.OnTitleChange         :=  nil;
  Browser.OnShowContextMenu     :=  nil;
  Browser.OnActive              :=  nil;
  Browser.OnProgressChange      :=  nil;
  Browser.OnShowContextMenu     :=  nil;

  //
  Browser.ToolButton.Separator.Free;
  Browser.ToolButton.Free;
  Browser.MenuItem.Free;
  RecalcToolBarSize(HotzonuWindow.BrowserToolBar);
  //
  if  (MoveToPanel) then  begin
    TOleControl(Browser).Parent  :=  HotzonuWindow.BrowserHidePanel;
  end;
  //
  for i :=  HotzonuWindow.BrowserTab.Count - 1  downto  0  do  begin
    if  (HotzonuWindow.BrowserTab[i] = Browser) then  begin
      HotzonuWindow.BrowserTab.Delete(i);
    end;
  end;
  //
  HotzonuWindow.BrowserCollectTimer.Enabled   :=  True;
  {$ENDIF}
end;

function UIStr(const S: string): string;
var
  x : string;
begin
  //x :=  StringReplace(S, '', '', [rfReplaceAll]);
  x :=  StringReplace(S, '&', '&&', [rfReplaceAll]);
  Result  :=  x;
end;

procedure BuildGaishutuMenu(GaishutuMenu: TPopupMenu);
  function AddGaishutuMenu(BoardList : TBoardList): boolean;
  var
    p1 : TMenuItem;
    p2 : TGaishutuMenuItem;
    p3 : TMenuItem;
    i  : integer;
    List: TList;
    CategoryName: string;
  begin
    {$IFDEF NUXX}
    ShowMessage('BuildGaishutuMenu');
    {$ELSE}
    Result  :=  False;
    p1      :=  nil;
    p3      :=  nil;
    List    :=  TList.Create;
    for i :=  0 to  BoardList.Count - 1  do  begin
      if  (BoardList[i].Gaishutu)  then  begin
        List.Add(BoardList[i]);
      end;
    end;
    {
    for i :=  0 to  List.Count - 2  do  begin
      for x :=  i + 1 to  List.Count - 1  do  begin
        if  (TBoard(List[i]).a
      end
    end;
    }
    CategoryName  :=  '';
    for i :=  0 to  List.Count - 1  do  begin
      if  (p1 = nil)  then  begin
        p1 :=  TMenuItem.Create(HotzonuWindow);
        p1.Caption    :=  UIStr(BoardList.Site.SiteName);
        p1.ImageIndex :=  BoardList.Site.ImageIndex;
        GaishutuMenu.Items.Add(p1);
      end;
      if  (CategoryName <>  TBoard(List[i]).CategoryName) then  begin
        CategoryName  :=  TBoard(List[i]).CategoryName;
        if  (ZonuConfig.GaishutuCategorize) then  begin
          p3  :=  TMenuItem.Create(HotzonuWindow);
          p3.Caption    :=  CategoryName;
          p3.ImageIndex :=  7;
          p1.Add(p3);
        end;
      end;
      p2 :=  TGaishutuMenuItem.Create(HotzonuWindow);
      p2.Caption    :=  UIStr(TBoard(List[i]).Name);
      p2.BoardID    :=  TBoard(List[i]).BoardID;
      p2.BBS        :=  BoardList.BBS;
      p2.Site       :=  BoardList.Site;
      if  (TBoard(List[i]).BoardType  = btFavorites)  then  begin
        p2.ImageIndex :=  35;
      end else
      if  (TBoard(List[i]).BoardType  = btLocalFolder)  then  begin
        p2.ImageIndex :=  36;
      end else begin
        p2.ImageIndex :=  14;
      end;
      //p2.ImageIndex :=  1;
      p2.OnClick    :=  HotzonuWindow.GaishutuClick;
      if  (ZonuConfig.GaishutuCategorize) and (p3 <> nil) then  begin
        p3.Add(p2);
      end else begin
        p1.Add(p2);
      end;
      Result  :=  True;
    end;
    List.Free;
    {$ENDIF}
  end;
  procedure AddSeparator;
  var
    p : TMenuItem;
  begin
    p :=  TMenuItem.Create(HotzonuWindow);
    p.Caption   :=  '-';
    GaishutuMenu.Items.Add(p);
  end;
var
  i : integer;
begin
  if  GaishutuMenu.Items.Count >  0 then  begin
    for i :=  GaishutuMenu.Items.Count - 1  downto  0 do  begin
      Zonutils.ClearMenuItem(GaishutuMenu.Items[i]);
      GaishutuMenu.Items.Delete(i);
    end;
  end;
  for i :=  0 to  ZonuEnviron.SiteList.Count - 1  do  begin
    if  (ZonuEnviron.SiteList[i].IsSubscription)  then  begin
      AddGaishutuMenu(ZonuEnviron.SiteList[i].BoardList);
    end;
  end;
end;

procedure UpdateFav(const OldBoardPath, OldBoardID,
  NewBoardPath, NewBoardName : string; NewBoard: TBoard);
var
  i:  integer;
  fav:  TSite;
  cn: string;
begin
  fav   :=  ZonuEnviron.FavoritesSite;
  for i :=  0 to  fav.BoardList.Count - 1 do  begin
    if  (fav.BoardList[i].BoardPath = OldBoardPath) and
        (fav.BoardList[i].BoardID   = OldBoardID) then
    begin
      cn  :=  fav.BoardList[i].CategoryName;
      //fav.BoardList[i].BoardPath  :=  NewBoardPath;
      //fav.BoardList[i].Name       :=  NewBoardName;
      fav.BoardList[i].Assign(NewBoard);
      fav.BoardList[i].CategoryName :=  cn;
      fav.BoardList[i].BBS  :=  NewBoard.BBS;
      fav.BoardList[i].Site :=  NewBoard.Site;
      fav.BoardList[i].CachePath  :=  NewBoard.CachePath;
    end;
  end;
end;

function ExtractRes(ResList: TResList; ResNo: integer; var OutList: TResList): integer;
  function a(const str, res: string): boolean;
  var
    n:  integer;
    s:  string;
    ss: string;
  begin
    Result  :=  False;
    ss  :=  res;
    while true  do  begin
      n :=  AnsiPos(str, ss);
      if  (n > 0) then  begin
        s :=  Copy(ss, n + Length(str), 1);
        if  (not IsNumeric(s))  then  begin
          Result  :=  True;
          Break;
        end else begin
          ss  :=  Copy(ss, n + Length(str) + 1, Length(ss));
        end;
      end else begin
        Result  :=  False;
        Break;
      end;
    end;
  end;
var
  i:  integer;
  Res:  TRes;
  Hits: integer;
begin
  Hits  :=  0;
  for i :=  0 to  ResList.Count - 1 do  begin
    Res :=  TRes.Create;
    Res.Assign(ResList[i]);
    Res.BBS         :=  ResList[i].BBS;
    Res.ThreadTitle :=  ResList[i].ThreadTitle;
    Res.Site        :=  ResList[i].Site;
    if  (a('&gt;' + IntToStr(ResNo), ResList[i].Body))  or
        (a('&gt;' + HanToZen(IntToStr(ResNo)), ResList[i].Body))  or
        (a('>' + HanToZen(IntToStr(ResNo)), ResList[i].Body))  or
        (a('' + IntToStr(ResNo), ResList[i].Body))  or
        (a('' + HanToZen(IntToStr(ResNo)), ResList[i].Body))  or
        (a('>' + IntToStr(ResNo), ResList[i].Body))  then
    begin
      Res.Visible :=  True;
      Res.Showing :=  True;
      Inc(Hits);
    end else begin
      Res.Showing :=  False;  //12
      Res.Visible :=  False;
    end;
    OutList.Add(Res);
  end;
  Result  :=  Hits;
end;

procedure BuildBBSToolBar(var ToolBar: TToolBar);
var
  sl: TStringList;
  i: integer;
  Site: TSite;
  b: TBBSToolButton;
  sp: TToolButton;
  s: string;
begin
  {$IFDEF NUXX}
  ShowMessage('BuildBBSToolBar');
  {$ELSE}
  for i :=  ToolBar.ButtonCount - 1 downto  0 do  begin
    ToolBar.Buttons[i].Free;
  end;
  if  (ZonuConfig.ShowBBSToolBar) then  begin
    HotzonuWindow.CoolBar2.Show;
    if  (ZonuConfig.BBSToolBarShowImage)  then  begin
      ToolBar.Images  :=  HotzonuWindow.ViewImage;
    end else begin
      ToolBar.Images  :=  nil;
    end;
    if  (FileExists(ZonuConfig.UsersPath + FILE_BBS_TOOLBAR))  then  begin
      sl  :=  TStringList.Create;
      sl.LoadFromFile(ZonuConfig.UsersPath + FILE_BBS_TOOLBAR);
      for i :=  0 to  sl.Count - 1  do  begin
        s :=  ChooseString(sl[i], #9, 0);
        if  (ZonuEnviron.SiteList.FindSite(s, Site))  then  begin
          s             :=  ChooseString(sl[i], #9, 1);
          b             :=  TBBSToolButton.Create(ToolBar);
          b.Parent      :=  ToolBar;

          if  (ZonuConfig.BBSToolBarShowImage)  then  begin
            b.ImageIndex  :=  Site.ImageIndex;
          end else begin
            b.ImageIndex  :=  -1;
          end;

          b.Caption     :=  s;
          b.Hint        :=  Site.SiteName;
          b.AutoSize    :=  True;
          b.Left        :=  CalcToolBarSize(ToolBar) + 2;
          //b.Grouped   :=  True;
          b.Style       :=  tbsButton;
          b.Site        :=  Site;
          b.OnClick       :=  HotzonuWindow.BBSToolButtonClick;

          sp          :=  TToolButton.Create(ToolBar);
          sp.Parent   :=  ToolBar;
          sp.Caption  :=  '';
          sp.AutoSize :=  False;
          sp.Left     :=  b.Left + b.Width + 2;
          //sp.Grouped  :=  True;
          sp.Style    :=  tbsSeparator;
          sp.Width    :=  3;
        end;
      end;
      RecalcToolBarSize(ToolBar);
      sl.Free;
    end;
  end else begin
    HotzonuWindow.CoolBar2.Hide;
  end;
  {$ENDIF}
end;

procedure KillAge2ch;
const
  CLASSNAME = 'TApplication';
  WINTEXT   = 'Age2ch';
var
  wnd: integer;
begin
  Wnd     :=  FindWindow(CLASSNAME, WINTEXT);
  SendMessage(wnd, WM_CLOSE, 0, 0);
end;

procedure BuildBBSFunc;
var
  i: integer;
  p: TMenuItem;
begin
  {$IFDEF NUXX}
  ShowMessage('BuildBBSFunc');
  {$ELSE}
  with  HotzonuWindow do  begin
    BBSFunc.Clear;
    BBSFunc.Enabled :=  False;
    if  (ActiveSite <> nil) then  begin
      for i :=  0 to  ActionList1.ActionCount - 1 do  begin
        if  (ActionList1.Actions[i].Category =  ActiveSite.SiteID)  then  begin
          p :=  TMenuItem.Create(BBSFunc);
          p.Action  :=  ActionList1.Actions[i];
          BBSFunc.Add(p);
          BBSFunc.Enabled :=  True;
        end;
      end;
    end;
  end;
  {$ENDIF}
end;

procedure BuildRecentMenu(MenuItem: TMenuItem; const rw: integer);
var
  i, mx: integer;
  p: TThreadMenuItem;
  s: string;
  sl: TStringList;
  th: TThreadItem;
  ASiteID: string;
  ABoardID:  string;
  ADatNo:  string;
  ATitle:  string;
begin
  {$IFDEF NUXX}
  ShowMessage('BuildRecentMenu');
  {$ELSE}
  with  HotzonuWindow do  begin
    MenuItem.Clear;
    MenuItem.Enabled :=  False;
    if  (rw = 0)  then  begin
      s   :=  ZonuConfig.UsersPath + FILE_READ_HISTORY;
    end else begin
      s   :=  ZonuConfig.UsersPath + FILE_SEND_HISTORY;
    end;
    if  (FileExists(s)) then  begin
      sl  :=  TStringList.Create;
      sl.LoadFromFile(s);
      if  (sl.Count < ZonuConfig.RecentCount) then  begin
        mx  :=  sl.Count;
      end else begin
        mx  :=  ZonuConfig.RecentCount;
      end;
      for i :=  0 to  mx - 1 do  begin
        th  :=  TThreadItem.Create;
        s         :=  sl[i];
        ASiteID   :=  ChooseString(s, #9, 0);
        ABoardID  :=  ChooseString(s, #9, 1);
        ADatNo    :=  ChooseString(s, #9, 2);
        ATitle    :=  ChooseString(s, #9, 3);
        if  (th.CreateThreadItem(ASiteID, ABoardID, ADatNo, ATitle))  then  begin
          p   :=  TThreadMenuItem.Create(MenuItem);
          p.Caption     :=  ATitle + '^' + th.Site.SiteName;
          p.ImageIndex  :=  32;
          p.OnClick :=  OpenThreadItem;
          MenuItem.Add(p);
          MenuItem.Enabled :=  True;
        end else begin
          th.Free;
        end;
      end;
      sl.Free;
    end;
  end;
  {$ENDIF}
end;

procedure PlaySound(SoundType: TSoundType);
var
  s: string;
  b: boolean;
begin
  s :=  '';
  b :=  False;
  case  SoundType of
    stThreadListComplete  :
    begin
      s :=  ZonuConfig.SndThreadListComplete;
      b :=  ZonuConfig.ExecSndThreadListComplete;
    end;
    stThreadHasNewRes     :
    begin
      s :=  ZonuConfig.SndThreadHasNewRes;
      b :=  ZonuConfig.ExecSndThreadHasNewRes;
    end;
    stThreadNoNewRes      :
    begin
      s :=  ZonuConfig.SndThreadNoNewRes;
      b :=  ZonuConfig.ExecSndThreadNoNewRes;
    end;
    stSendComplete        :
    begin
      s :=  ZonuConfig.SndSendComplete;
      b :=  ZonuConfig.ExecSndSendComplete;
    end;
    stError               :
    begin
      s :=  ZonuConfig.SndError;
      b :=  ZonuConfig.ExecSndError;
    end;
    //13 begin
    stUpdateCheck         :
    begin
      s :=  ZonuConfig.SndUpdateCheck;
      b :=  ZonuConfig.ExecSndUpdateCheck;
    end;
    stRound               :
    begin
      s :=  ZonuConfig.SndRound;
      b :=  ZonuConfig.ExecSndRound;
    end;
    //13 end
    //31 begin
    stUpdateCheckNo       :
    begin
      s :=  ZonuConfig.SndUpdateCheckNo;
      b :=  ZonuConfig.ExecSndUpdateCheckNo;
    end;
    stRoundNo             :
    begin
      s :=  ZonuConfig.SndRoundNo;
      b :=  ZonuConfig.ExecSndRoundNo;
    end;
    //31 end
  end;
  if  (s <> '') and (b) then  sndPlaySound(PChar(s), SND_ASYNC);
end;

procedure LoadToolBarPos(Coolbar: TCoolBar; const SectionName: string);
var
  i, x  : integer;
  band  : TCoolBand;
begin
  CoolBar.Bands.BeginUpdate;
  if  (ZonuConfig.Fini.SectionExists(SectionName))  then  begin
    for i :=  0 to  CoolBar.Bands.Count - 1  do  begin
      x :=  ZonuConfig.Fini.ReadInteger(SectionName, 'BAND' + IntToStr(i) + 'ID', 0);
      band        :=  TCoolBand(CoolBar.Bands.FindItemID(x));
      band.Index  :=  i;
      band.Break  := ZonuConfig.Fini.ReadBool(SectionName,
                                              'BAND' + IntToStr(i) + 'BR',
                                              CoolBar.Bands[i].Break);
      band.Width  := ZonuConfig.Fini.ReadInteger(SectionName,
                                                 'BAND' + IntToStr(i) + 'WD',
                                                 CoolBar.Bands[i].Width);
    end;
  end;
  CoolBar.Bands.EndUpdate;
end;

procedure SaveToolBarPos(CoolBar: TCoolBar; const SectionName: string);
var
  i, x : integer;
begin
  for i :=  0 to  CoolBar.Bands.Count- 1 do  begin
    for x :=  0 to  CoolBar.Bands.Count- 1 do  begin
      if  (CoolBar.Bands[x].Index = i) then  begin
        ZonuConfig.Fini.WriteInteger(SectionName, 'BAND' + IntToStr(i) + 'ID', CoolBar.Bands[i].ID);
        ZonuConfig.Fini.WriteInteger(SectionName, 'BAND' + IntToStr(i) + 'WD', CoolBar.Bands[i].Width);
        ZonuConfig.Fini.WriteBool(SectionName, 'BAND' + IntToStr(i) + 'BR', CoolBar.Bands[i].Break);
        ZonuConfig.Fini.WriteString(SectionName, 'BAND' + IntToStr(i) + 'CAP', CoolBar.Bands[i].Control.Name);
        Continue;
      end;
    end;
  end;
end;

procedure ChangeBrowserFontSize(Size: OleVariant);
var
  WebBrowser : IWebBrowser2;
  d : OleVariant;
  i : integer;
begin
  {$IFDEF NUXX}
  ShowMessage('ChangeBrowserFontSize');
  {$ELSE}
  for i :=  0 to  HotzonuWindow.BrowserTab.Count - 1  do  begin
    WebBrowser  :=  TZonuBrowser(HotzonuWindow.BrowserTab[i]).ControlInterface;
    WebBrowser.ExecWB(  OLECMDID_ZOOM,
                        OLECMDEXECOPT_DONTPROMPTUSER,
                        Size,d);
  end;
  {$ENDIF}
end;

{
procedure THotzonuForm.actResMoveDownExecute(Sender: TObject);
var
  Browser : TEmbeddedWB;
begin
  Browser :=  GetActiveBrowser;
  if  (Browser <> nil)  then  begin
    olevariant(IHTMLDocument2(Browser.Document)).body.scrollTop :=
      olevariant(IHTMLDocument2(Browser.Document)).body.scrollTop +
        (IHTMLDocument2(Browser.Document).body.offsetHeight - 32);
  end;
end;

procedure THotzonuForm.actResMoveUpExecute(Sender: TObject);
var
  Browser : TEmbeddedWB;
begin
  Browser :=  GetActiveBrowser;
  if  (Browser <> nil)  then  begin
    olevariant(IHTMLDocument2(Browser.Document)).body.scrollTop :=
      olevariant(IHTMLDocument2(Browser.Document)).body.scrollTop -
        (IHTMLDocument2(Browser.Document).body.offsetHeight - 32);
  end;
end;
}

function FindBrowserPageIndex(Browser: TZonuBrowser): integer;
var
  i : integer;
  b : TBrowserToolButton;
begin
  Result  :=  -1;
  for i :=  0 to  HotzonuWindow.BrowserToolBar.ButtonCount - 1 do  begin
    if  (HotzonuWindow.BrowserToolBar.Buttons[i].Style = tbsButton)    or
        (HotzonuWindow.BrowserToolBar.Buttons[i].Style = tbsCheck)     or
        (HotzonuWindow.BrowserToolBar.Buttons[i].Style = tbsDropDown)  then
    begin
      b   :=  TBrowserToolButton(HotzonuWindow.BrowserToolBar.Buttons[i]);
      if  (b.Browser <> nil)  then  begin
        if  (b.Browser = Browser)  then  begin
          Result  :=  i;
          Break;
        end;
      end;
    end;
  end;
end;

function FindBrowserPageIndex: integer;
var
  i : integer;
  b : TBrowserToolButton;
begin
  Result  :=  -1;
  for i :=  0 to  HotzonuWindow.BrowserToolBar.ButtonCount - 1 do  begin
    if  (HotzonuWindow.BrowserToolBar.Buttons[i].Style = tbsButton)    or
        (HotzonuWindow.BrowserToolBar.Buttons[i].Style = tbsCheck)     or
        (HotzonuWindow.BrowserToolBar.Buttons[i].Style = tbsDropDown)  then
    begin
      b   :=  TBrowserToolButton(HotzonuWindow.BrowserToolBar.Buttons[i]);
      if  (b.Browser <> nil)  then  begin
        if  (b.Down)  then  begin
          Result  :=  i;
          Break;
        end;
      end;
    end;
  end;
end;

//age16 function HzbFind(const FindText, Text: string): integer;
function HzbFind(const FindText, Text: string; IgnoreCase: boolean = False): integer;
var
  s1, s2: string;
begin
  //age16 begin
  //s1  :=  (AnsiLowerCase(FindText));
  //s2  :=  (AnsiLowerCase(Text));
  if  (not IgnoreCase)  then  begin
    s1  :=  (AnsiLowerCase(FindText));
    s2  :=  (AnsiLowerCase(Text));
  end else begin
    s1  :=  ZenToHan(AnsiLowerCase(FindText));
    s2  :=  ZenToHan(AnsiLowerCase(Text));
  end;
  //age16 end
  Result  :=  AnsiPos(s1, s2);
end;

//age16
procedure AddLog(AText: string);
begin
  HotzonuWindow.Memo1.Lines.Add(AText);
  HotzonuWindow.Memo1.Perform(EM_LINESCROLL, 0, -1);
end;

//7
function AddTag(const AText, AFindText, ATagBefore, ATagAfter: string): string;
var
  s,r : string;
  n: integer;
begin
  s :=  AText;
  r :=  '';
  repeat
    n :=  HzbFind(AnsiLowerCase(AFindText), AnsiLowerCase(s), False);
    if  (n > 0) then  begin
      r :=  r + Copy(s, 1, n - 1) + ATagBefore + Copy(s, n, Length(AFindText)) + ATagAfter;
      s :=  Copy(s, n + Length(AFindText), Length(s));
    end;
  until (n = 0);
  Result  :=  r + s;
end;

//10
procedure ExtractLink(ResList: TResList; LinkList: TList; const NewOnly: boolean);
const
  NORMAL_CHAR: string = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789:/.%?&#=-_~+*;!^`\|@[]{}$,';
var
  LinkItem  : TLinkItem;
  s : string;
  url: string;
  FileName: string;
  FileExt: string;
  i, y, z: Integer;
  idx, idx1, idx2, idx3: Integer;
  //ResList : TResList;
  Res : TRes;
  prefix: string;
  b : boolean;
begin
    for y :=  0 to  ResList.Count - 1  do  begin
      Res :=  ResList[y];
      if  ((NewOnly) and (Res.IsNew)) or (not NewOnly)  then  begin
        if  (Res.Visible) and (not Res.IsAboned)  then  begin
          s :=  TrimTag(StringReplace(Res.Body, '<BR>', #13#10, [rfReplaceAll, rfIgnoreCase]));
          while True do begin
            idx1 := AnsiPos('http://', s);
            idx2 := AnsiPos('ttp://', s);

            if (idx1 = 0) and (idx2 = 0) then begin
              //N[B
              //Result := Result + s;
              Break;
            end;

            if  (idx2 < idx1) or ((idx2 > 0) and (idx1 = 0)) then  begin
              // ttp
              idx  :=  idx2;
              prefix:=  'h';
            end else begin
              idx  :=  idx1;
              prefix:=  '';
            end;

            //Result := Result + Copy(s, 0, idx - 1);
            s := Copy(s, idx, length(s));
            for i := 0 to Length(s) - 1 do begin
              idx3 := AnsiPos(s[i + 1], NORMAL_CHAR);
              if (idx3 = 0) or (i = (Length(s) - 1)) then begin
                //URLȂIƂAȂȂB
                if  (i = (Length(s) - 1)) then  begin
                  url := prefix + Copy(s, 1, i + 1);
                end else begin
                  url := prefix + Copy(s, 1, i);
                end;
                FileName  :=  ExtractUrlName(Url);
                FileExt   :=  AnsiLowerCase(ExtractFileExt(FileName));
                if  (AnsiPos('?', FileExt) > 0) then  begin
                  FileExt :=  Copy(FileExt, 1, AnsiPos('?', FileExt) - 1);
                end;
                //if  (FileExt <> '') then  begin
                b :=  False;
                for z :=  0 to  LinkList.Count - 1 do  begin
                  if  (TLinkItem(LinkList[z]).Url = Url) then  begin
                    b :=  True;
                    Break;
                  end;
                end;
                if  (not b) then  begin
                  LinkItem  :=  TLinkItem.Create;
                  LinkItem.ResList    :=  ResList;
                  LinkItem.Res        :=  Res;
                  LinkItem.Url        :=  Url;
                  LinkItem.FileName   :=  FileName;
                  LinkItem.FileExt    :=  FileExt;
                  LinkList.Add(LinkItem);
                end;
                //end;
                s := Copy(s, i + 1, Length(s));
                Break;
              end;
            end;
          end;
        end;
      end;
    end;
end;

//11
function InTextRes(
  const AllTarget, HandleTarget, HandleLike, MailTarget, IDTarget, BodyTarget: boolean;
  IgnoreCase, InsertTag: boolean;
  const AFindText: string; Res: TRes): boolean;
begin
  if  (AllTarget) then  begin
    Result  :=  (HzbFind(AFindText, TrimTag(Res.Name), IgnoreCase) > 0)  or
                (HzbFind(AFindText, TrimTag(Res.Mail), IgnoreCase) > 0)  or
                (HzbFind(AFindText, TrimTag(Res.ID),   IgnoreCase) > 0)    or
                (HzbFind(AFindText, TrimTag(Res.Body), IgnoreCase) > 0);
  end else
  if  (HandleTarget) then  begin
    //nh
    if  (not HandleLike) then  begin
      //Result  :=  (SameText(Trim(AFindText) , Trim(TrimTag(Res.Name))));  //12
      Result  :=  (SameText(Trim(TrimTag(AFindText)) , Trim(TrimTag(Res.Name))));
    end else begin
      Result  :=  (HzbFind(AFindText, TrimTag(Res.Name), IgnoreCase) > 0);
    end;
  end else
  if  (MailTarget) then  begin
    //[
    Result  :=  (SameText(AFindText, Res.Mail));
  end else
  if  (IDTarget) then  begin
    //ID
    Result  :=  (SameText(AFindText, Res.ID));
  end else begin
    //{
    Result  :=  (HzbFind(AFindText, TrimTag(Res.Body), IgnoreCase) > 0);
  end;
end;

//11
procedure FilterResHoliday(
  Board: TBoard;
  const AllTarget, HandleTarget, HandleLike, MailTarget, IDTarget, BodyTarget: boolean;
  const FindText: string; IgnoreCase, InsertTag: boolean);
var
  NewBrowser  : TZonuBrowser;
  ListDoc     : TZonuListDoc;
  ThreadItem  : TThreadItem;
  ResList     : TResList;
  List        : TList;
  i, x        : integer;
begin
  {$IFDEF NUXX}
  ShowMessage('FilterResHoliday');
  {$ELSE}
  //i\pEBhE
  MessageWindow :=  TMessageWindow.Create(nil);
  MessageWindow.ShowMsg('Xbhǂݍ݊Jn');
  MessageWindow.Show;
  MessageWindow.Update;
  //
  List    :=  TList.Create;

  //Xbhꗗ̎擾
  {
  if  (not FindListDoc(Board, ListDoc)) then begin
    HotzonuWindow.LoadThreadList(Board, False, True);
    HotzonuWindow.GetActiveListDoc(ListDoc);
  end;
  }


  //擾XbhꗗォS`FbN
  if  (HotzonuWindow.GetActiveListDoc(ListDoc)) then  begin
    for i :=  0 to  ListDoc.ThreadItemList.Count - 1  do  begin
      ThreadItem  :=  ListDoc.ThreadItemList[i];
      if  (ThreadItem.ReadCount > 0) then  begin
        MessageWindow.ShowMsg(ThreadItem.Title + '`FbN');
        ResList   :=  TResList.Create(ThreadItem);
        //X̓ǂݍ
        ThreadItem.LoadFromFile(ResList);
        //擾XׂĂΏە܂ނǂ`FbN
        for x :=  0 to  ResList.Count - 1 do  begin
          //Ώۃf[^
          if  (InTextRes( AllTarget,
                          HandleTarget,
                          HandleLike,
                          MailTarget,
                          IDTarget,
                          BodyTarget,
                          IgnoreCase,
                          InsertTag,
                          FindText,
                          ResList[x])) then
          begin
            List.Add(ThreadItem); //ΏۃXbhۊǂĂ
            Break;
          end;
        end;
        ResList.Free;
      end;
      MessageWindow.Release;
    end;

    //Ώە܂łXbhuEUɕ\
    if  (List.Count > 0)  then  begin
      for i :=  0 to  List.Count - 1  do  begin
        ThreadItem  :=  TThreadItem(List[i]);
        ResList     :=  TResList.Create(ThreadItem);
        ThreadItem.LoadFromFile(ResList);
        //uEU̐VK쐬
        CreateNewBrowser(NewBrowser,
                         ResList,
                         ThreadItem,
                         ThreadItem.Title,
                         (i = 0));  //ŏ̃uEUANeBuɂ
        NewBrowser.Filtered :=  True;
        NewBrowser.Kind     :=  bkFilter;
        NewBrowser.BoardID  :=  ThreadItem.BoardID;
        NewBrowser.ResList  :=  ResList;
        NewBrowser.ResetTabImage;
        //X̏o
        HotzonuWindow.InitOutputRes(NewBrowser, NewBrowser.ResList);
        NewBrowser.WriteHeader;
        for x :=  0 to  ResList.Count - 1  do  begin
          if  (InTextRes( AllTarget,
                          HandleTarget,
                          HandleLike,
                          MailTarget,
                          IDTarget,
                          BodyTarget,
                          IgnoreCase,
                          InsertTag,
                          FindText,
                          ResList[x])) then
          begin
            ResList[x].Showing  :=  True;
            ResList[x].Visible  :=  True;
          end else begin
            ResList[x].Visible  :=  False;
          end;
          ResList[x].IsChecked  :=  True;
          if  (ResList[x].BodyBk <> '')  then  begin
            ResList[x].Body  :=  ResList[x].BodyBk;
          end;
          if  (InsertTag) then  begin //9
            ResList[x].BodyBk:=  ResList[x].Body;
            ResList[x].Body  :=  AddTag(ResList[x].Body,
                                        FindText,
                                        ZonuConfig.FilterTag1,
                                        ZonuConfig.FilterTag2);
          end;
          HotzonuWindow.OutputRes(NewBrowser, NewBrowser, ResList[x], NewBrowser.ResList);
        end;
        HotzonuWindow.EndOutputRes(NewBrowser);
        SetShortTitle(NewBrowser);
      end;
      //\yC̐؂ւ
      if  (ZonuConfig.TabClickChangePane) and (not HotzonuWindow.actShowBrowser.Checked)  then  begin
        HotzonuWindow.actShowPaneChange.Execute;
      end;
    end;
  end;
  {$ENDIF}
end;

//11
procedure SetShortTitle(Browser: TZonuBrowser);
begin
  if  (ZonuConfig.ThreadShortTitle) then  begin
    Browser.ToolButton.Caption  :=  GetShortTitle(Browser.ThreadItem.Title,
                                                  ZonuConfig.ThreadTitleLength);
    Browser.ToolButton.Hint     :=  Browser.ThreadItem.Title;
  end else begin
    Browser.ToolButton.Caption  :=  Browser.ThreadItem.Title;
  end;
  RecalcToolBarSize(HotzonuWindow.BrowserToolBar);
  Browser.ResetTabImage;
end;

//13
procedure CleanupBookmarkFile(AThreadItem: TThreadItem);
var
  s: string;
  i: integer;
begin
  {$IFDEF NUXX}
  ShowMessage('CleanupBookmarkFile');
  {$ELSE}
  if  (AThreadItem.BookmarkList.Count = 0)  then  begin
    s :=  AThreadItem.DatNo + '/' +
          AThreadItem.BoardID + '/' +
          AThreadItem.Site.SiteID;
    for i :=  HotzonuWindow.BookmarkFile.Count - 1  downto  0 do  begin
      if  (HotzonuWindow.BookmarkFile.Names[i] = s)  then  begin
        HotzonuWindow.BookmarkFile.Delete(i);
      end;
    end;
    HotzonuWindow.BookmarkFile.SaveToFile(ZonuConfig.UsersPath + FILE_BOOKMARK);
  end;
  {$ENDIF}
end;

//13
//thanx http://griffy.pekori.to/soft/technologies.html
procedure BrowserExec(Browser: TZonuBrowser; op: TBrowserExec);
const
  CGID_WebBrowser: TGUID = '{ED016940-BD5B-11cf-BA4E-00C04FD70816}';
  HTMLID_FIND = 1;
var
  CmdTarget : IOleCommandTarget;
  vaIn, vaOut: OleVariant;
  PtrGUID: PGUID;
begin
  if  (HotzonuWindow.GetActiveBrowser(Browser)) then  begin
    New(PtrGUID);
    try
      PtrGUID^ := CGID_WebBrowser;
      if  (Assigned(Browser.Document) and (not Browser.Busy))  then  begin
        if  (Browser.Document.QueryInterface(IOleCommandTarget, CmdTarget) = S_OK) then  begin
          try
            CmdTarget.Exec(PtrGUID, Integer(op) + 1, 0, vaIn, vaOut);
          finally
            CmdTarget._Release;
          end;
        end;
      end;
    finally
      Dispose(PtrGUID);
    end;
  end;
end;

procedure Wrapable(ToolBar: TToolBar);
var
  i: integer;
  w: integer;
begin
  w :=  0;
  ToolBar.Height :=  ToolBar.ButtonHeight;
  for i :=  0 to  ToolBar.ButtonCount - 1  do  begin
    ToolBar.Buttons[i].Wrap := False;
    if  (w + ToolBar.Buttons[i].Width > ToolBar.Width)  then  begin
      ToolBar.Buttons[i - 1].Wrap := True;
      ToolBar.Height :=  ToolBar.Height + ToolBar.Buttons[i].Height;
      w :=  0;
    end;
    w := w +  ToolBar.Buttons[i].Width;
  end;
end;

function GetBoardListURL(const URL: string; var Board: TBoard): boolean;
var
  Site: TSite;
  i: integer;
begin
  Result  :=  False;
  for i :=  0 to  ZonuEnviron.SiteList.Count - 1  do  begin
    Site  :=  ZonuEnviron.SiteList[i];
    if  (Site.BoardList.FindBoardFromURL(URL, Board)) then  begin
      if  (Board.BoardType = btWebPage) then  begin
        Break;
      end else begin
        Result  :=  True;
        Break;
      end;
    end;
  end;
end;

//33
procedure LoadDatOchi(AListDoc: TZonuListDoc);
var
  ThreadItem: TThreadItem;
  Rec: TSearchRec;
  ini: TMemIniFile;
  sl: TStringList;
  Path: string;
  DatNo: string;
  Cnt: integer;
  ResCount: integer;
  i: integer;
  b: boolean;
  s: string;
begin
  Cnt   :=  0;
  Path  :=  AListDoc.Board.CachePath;

  AddLog('@DATXbh擾Jn :' + Path);

  if  (FindFirst(Path + '*.dat', faAnyFile, Rec) = 0) then
  begin
    repeat
      if  (not SameText('subject.dat', Rec.Name)) then  begin
        b :=  False;
        for i :=  0 to  AListDoc.ThreadItemList.Count - 1 do  begin
          if  (SameText(AListDoc.ThreadItemList[i].DatFileName, Rec.Name))  then
          begin
            b :=  True;
            Break;
          end;
        end;
        if  (not b) then  begin

          if  (FileExists(ChangeFileExt(Rec.Name, '.inf')))  then  begin
            ini :=  TMemIniFile.Create(AListDoc.Board.Url +
                                ChangeFileExt(Rec.Name, '.inf'));
            s         :=  ini.ReadString('LOG', 'TITLE', '');
            ResCount  :=  ini.ReadInteger('LOG', 'COUNT', 0);
            ini.Free;
          end else begin
            sl  :=  TStringList.Create;
            sl.LoadFromFile(Path + Rec.Name);
            if  (sl.Count > 0)  then  begin
              s :=  ChooseString(sl[0], '<>', 4);
            end else begin
              s :=  '';
            end;
            ResCount  :=  sl.Count;
            sl.Free;
          end;

          DatNo :=  Copy(Rec.Name, 1, AnsiPos('.', Rec.Name));
          ThreadItem  :=  TThreadItem.Create();
          ThreadItem.CreateThreadItem(AListDoc.Board.Site.SiteID,
                                      AListDoc.Board.BoardID,
                                      DatNo,
                                      s
                                      );
          ThreadItem.LocalDatFileName :=  Path + Rec.Name;
          ThreadItem.LoadConfig;
          ThreadItem.No               :=  AListDoc.ThreadItemList.Count + 1;
          ThreadItem.AgeCount         :=  ResCount;
          ThreadItem.IsKakoLog        :=  True;
          AListDoc.ThreadItemList.Add(ThreadItem);
          ThreadItem.IsNew            :=  False;
          Inc(Cnt);

        end;
      end;
    until (FindNext(Rec) <> 0);
  end;
  FindClose(Rec);
  AddLog(Format('@DATXbh擾 (%d )', [Cnt]));
end;

end.


