{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Katjusha Board List Unit                                          }
{                                                                             }
{ 2001-04 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Katjubrd;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, EnhListView, ExtListView, Buttons,
  ZonuClass, Menus, Main, Dlghead;

type
  TKatjuBoard = class(TObject)
  private
    FBoardPath: string;
    FBoardName: string;
    FCategoryName: string;
    FBoardID: string;
    FSite: TSite;
    FExists: boolean;
  public
    constructor Create;
    property  CategoryName: string  read  FCategoryName write FCategoryName;
    property  BoardName: string read  FBoardName  write FBoardName;
    property  BoardID: string read  FBoardID  write FBoardID;
    property  BoardPath: string read  FBoardPath  write FBoardPath;
    property  Site: TSite read  FSite write FSite;
    property  Exists: boolean read  FExists write FExists;
  end;

  TKatjuBoardDialog = class(TForm)
    ListView1: TdfsExtListView;
    Edit1: TEdit;
    SpeedButton1: TSpeedButton;
    Label1: TLabel;
    OpenDialog1: TOpenDialog;
    PopupMenu1: TPopupMenu;
    SelectAll1: TMenuItem;
    X1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    Z1: TMenuItem;
    ProgressBar1: TProgressBar;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    HeaderFrame1: THeaderFrame;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SelectAll1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
  private
    { Private 錾 }
    procedure Parse2channelbrd(const FileName: string);
    procedure ClearBoardList;
  public
    { Public 錾 }
  end;

var
  KatjuBoardDialog: TKatjuBoardDialog;

implementation

{$R *.dfm}

uses
  Hzbconst, MonaUtils, Zonuconf;


{ TKathuBoard }

constructor TKatjuBoard.Create;
begin
  FSite     :=  nil;
  FExists   :=  False;
end;

procedure TKatjuBoardDialog.FormCreate(Sender: TObject);
begin
  //
end;

procedure TKatjuBoardDialog.FormDestroy(Sender: TObject);
begin
  ClearBoardList;
  //
end;

procedure TKatjuBoardDialog.SpeedButton1Click(Sender: TObject);
begin
  OpenDialog1.InitialDir  :=  ExtractFilePath(ZonuConfig.KatjuBoardPath);
  if  (OpenDialog1.Execute) then  begin
    Edit1.Text  :=  OpenDialog1.FileName;
    Parse2channelbrd(Edit1.Text);
    ZonuConfig.KatjuBoardPath :=  OpenDialog1.FileName;
  end;
end;

procedure TKatjuBoardDialog.Parse2channelbrd(const FileName: string);
var
  sl: TStringList;
  i, x: integer;
  CategoryName: string;
  Board: TKatjuBoard;
  Item: TListItem;
  s: string;
  b: TBoard;
begin
  try
    Screen.Cursor :=  crHourGlass;
    ClearBoardList;
    ListView1.Items.BeginUpdate;
    if  (FileExists(FileName))  then  begin
      sl  :=  TStringList.Create;
      sl.LoadFromFile(FileName);
      ProgressBar1.Min      :=  0;
      ProgressBar1.Max      :=  sl.Count;
      ProgressBar1.Position :=  0;
      ProgressBar1.Step     :=  1;
      if  (sl[0] = '2') then  begin
        CategoryName  :=  '';
        for i :=  1 to  sl.Count - 1  do  begin
          ProgressBar1.StepIt;
          if  (sl[i] <> '') then  begin
            if  (sl[i][1] <> #9)  then  begin
              CategoryName  :=  ChooseString(sl[i], #9, 0);
            end else begin
              Board   :=  TKatjuBoard.Create;
              Board.CategoryName  :=  CategoryName;
              Board.BoardName     :=  ChooseString(sl[i], #9, 3);
              Board.BoardID       :=  ChooseString(sl[i], #9, 2);
              Board.BoardPath     :=  ChooseString(sl[i], #9, 1);
              s :=  'http://' + Board.BoardPath;
              for x :=  0 to  ZonuEnviron.SiteList.Count - 1  do  begin
                if  (ZonuEnviron.SiteList[x].IsInclude(s)) then  begin
                  Board.Site  :=  ZonuEnviron.SiteList[x];
                  Break;
                end;
              end;
              Item  :=  ListView1.Items.Add;
              if  (Board.Site <> nil) then  begin
                Item.Caption  :=  Board.Site.SiteName;
                if  (Board.Site.BoardList.FindBoard(Board.BoardID, b))  then  begin
                  Board.Exists  :=  True;
                end;
              end else begin
                Item.Caption  :=  '(s)';
                for x :=  0 to  ZonuEnviron.UserSite.BoardList.Count - 1  do  begin
                  if  (Board.BoardPath  =  ZonuEnviron.UserSite.BoardList[x].BoardPath)  and
                      (Board.BoardID    =  ZonuEnviron.UserSite.BoardList[x].BoardID)  then
                  begin
                    Board.Exists  :=  True;
                    Board.Site    :=  ZonuEnviron.UserSite;
                    Item.Caption  :=  '̑BBS(' + ZonuEnviron.UserSite.BoardList[x].CategoryName + ')';
                  end;
                end;
              end;
              Item.SubItems.Add(Board.CategoryName);
              Item.SubItems.Add(Board.BoardName);
              Item.SubItems.Add(Board.BoardID);
              Item.SubItems.Add(Board.BoardPath);
              Item.Cut  :=  Board.Exists;
              if  (Board.Site <> nil) then  begin
                Item.ImageIndex :=  Board.Site.ImageIndex;
              end else begin
                Item.ImageIndex :=  0;
              end;
              Item.Data :=  Board;
            end;
          end;
        end;
      end else begin
        MessageDlg('t@Č`B', mtError, [mbOk], 0);
      end;
      sl.Free;
    end else begin
      MessageDlg('t@CB', mtError, [mbOk], 0);
    end;
  finally
    ListView1.Items.EndUpdate;
    Screen.Cursor :=  crDefault;
    ProgressBar1.Position :=  0;
  end;
end;

procedure TKatjuBoardDialog.ClearBoardList;
var
  i:  integer;
begin
  ListView1.Items.BeginUpdate;
  for i :=  ListView1.Items.Count - 1 downto  0 do  begin
    TKatjuBoard(ListView1.Items[i].Data).Free;
  end;
  ListView1.Items.Clear;
  ListView1.Items.EndUpdate;
end;

procedure TKatjuBoardDialog.SelectAll1Click(Sender: TObject);
var
  i:  integer;
begin
  for i :=  0 to  ListView1.Items.Count - 1 do  begin
    ListView1.Items[i].Checked  :=  (Sender = SelectAll1);
  end;
end;

procedure TKatjuBoardDialog.N2Click(Sender: TObject);
var
  i:  integer;
begin
  for i :=  0 to  ListView1.Items.Count - 1 do  begin
    if  (ListView1.Items[i].Selected) then  begin
      ListView1.Items[i].Checked  :=  (Sender = N2);
    end;
  end;
end;

procedure TKatjuBoardDialog.BitBtn2Click(Sender: TObject);
begin
  Close;
end;

procedure TKatjuBoardDialog.BitBtn1Click(Sender: TObject);
var
  i:  integer;
  Board:  TKatjuBoard;
  ZonuBoard:  TBoard;
begin
  for i :=  0 to  ListView1.Items.Count - 1 do  begin
    if  (ListView1.Items[i].Checked) then  begin
      Board :=  TKatjuBoard(ListView1.Items[i].Data);
      if  (Board.Site = nil) then  begin
        ZonuBoard :=  TBoard.Create;
        ZonuBoard.BoardType     :=  btBBSBoard;
        ZonuBoard.Name          :=  Board.BoardName;
        ZonuBoard.CategoryName  :=  Board.CategoryName;
        //ZonuBoard.BBS           :=
        ZonuBoard.BoardPath     :=  Board.BoardPath;
        ZonuBoard.BoardID       :=  Board.BoardID;
        ZonuBoard.Site          :=  ZonuEnviron.UserSite;
        ZonuBoard.RemoteBoardID :=  Board.BoardID;
        ZonuBoard.Url           :=  'http://' + Board.BoardPath + '/'+ Board.BoardID + '/';
        ZonuEnviron.UserSite.BoardList.Add(ZonuBoard);
        if  (AnsiPos('jbbs.net/', ZonuBoard.Url) > 0) then  begin
          ZonuBoard.BBS         :=  ZonuEnviron.BBSList.FindBBS(BBS_JBBS);
        end else
        if  (AnsiPos('jbbs.shitaraba.com/', ZonuBoard.Url) > 0) then  begin
          ZonuBoard.BBS         :=  ZonuEnviron.BBSList.FindBBS('shitarabajbbs');
        end else
        if  (AnsiPos('megabbs.com/', ZonuBoard.Url) > 0) then  begin
          ZonuBoard.BBS         :=  ZonuEnviron.BBSList.FindBBS(BBS_MEGABBS);
        end else
        if  (AnsiPos('mitinoku.jp/', ZonuBoard.Url) > 0) then  begin
          ZonuBoard.BBS         :=  ZonuEnviron.BBSList.FindBBS(BBS_12CH);
        end else
        if  (AnsiPos('2ch.net/', ZonuBoard.Url) > 0) then  begin
          ZonuBoard.BBS         :=  ZonuEnviron.BBSList.FindBBS(BBS_DOLIB);
        end else begin
          ZonuBoard.BBS         :=  ZonuEnviron.BBSList.FindBBS(BBS_2CH);
        end;
        ZonuBoard.CharSet       :=  ZonuBoard.BBS.CharSet;
        ZonuEnviron.UserSite.BoardList.SaveToFile(ZonuConfig.UsersPath + 'config\site\' + ZonuEnviron.UserSite.SiteID + '\' + FILE_BOARD);
      end else begin
        if  (not Board.Exists)  then  begin
          ZonuBoard :=  TBoard.Create;
          ZonuBoard.BoardType     :=  btBBSBoard;
          ZonuBoard.Name          :=  Board.BoardName;
          ZonuBoard.CategoryName  :=  Board.CategoryName;
          ZonuBoard.BoardPath     :=  Board.BoardPath;
          ZonuBoard.BoardID       :=  Board.BoardID;
          ZonuBoard.Site          :=  Board.Site;
          ZonuBoard.RemoteBoardID :=  Board.BoardID;
          ZonuBoard.Url           :=  'http://' + Board.BoardPath + '/'+ Board.BoardID + '/';
          ZonuBoard.CharSet       :=  Board.Site.CharSet;
          Board.Site.BoardList.Add(ZonuBoard);
          Board.Site.BoardList.SaveToFile(ZonuConfig.UsersPath + 'config\site\' + Board.Site.SiteID + '\' + FILE_BOARD);
        end else begin
          if  (Board.Site.BoardList.FindBoard(Board.BoardID, ZonuBoard))  then  begin
            ZonuBoard.BoardPath   :=  Board.BoardPath;
            ZonuBoard.Url         :=  'http://' + Board.BoardPath + '/'+ Board.BoardID + '/';
          end;
        end;
      end;
    end;
  end;
  ModalResult :=  mrOk;
end;

end.
