{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Send Window Unit                                                  }
{                                                                             }
{ 2001-04 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit Newthrd;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, SendForm, Menus, ActnList, ExtCtrls, ImgList, StdCtrls, MenuBar,
  Buttons, ComCtrls, ToolWin, OleCtrls, SHDocVw, ZonuClass, HzbClass,
  HttpProt;

type
  TNewThreadDialog = class(TSendDialog)
    Panel4: TPanel;
    Label3: TLabel;
    Title: TEdit;
    Password: TComboBox;
    Label4: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure actSendExecute(Sender: TObject);
  private
    //FBoard: TBoard;
    FListDoc: TZonuListDoc;
    FContentDate: string;
    { Private 錾 }
    //procedure GetLocalRule;
  protected
    procedure Preview(var Browser : TZonuBrowser); override;
    procedure LoadToolBarSetting; override;
    procedure SaveToolBarSetting; override;
  public
    { Public 錾 }
    procedure SetBoard(ABoard: TBoard);
    property  Board: TBoard read  FBoard; {Protected}
    property  ListDoc: TZonuListDoc read  FListDoc  write FListDoc;
    property  ContentDate: string read  FContentDate  write FContentDate;
  end;

var
  NewThreadDialog: TNewThreadDialog;

implementation

{$R *.dfm}

uses
  MonaUtils, ZonuConf, Hzbconst;

{ TNewThreadDialog }

procedure TNewThreadDialog.FormCreate(Sender: TObject);
begin
  inherited;
  FBoard  :=  nil;
end;

procedure TNewThreadDialog.FormDestroy(Sender: TObject);
begin
  inherited;
  //
end;

procedure TNewThreadDialog.SetBoard(ABoard: TBoard);
  procedure Reset(ComboBox: TComboBox; const S: string);
  begin
    if  (S <> '') then  begin
      if  (ComboBox.Items.IndexOf(S) < 0) then  begin
        ComboBox.Items.Insert(0, S);
      end else begin
        ComboBox.Items.Move(ComboBox.Items.IndexOf(S), 0);
      end;
    end;
  end;
var
  ASenderName, ASenderMail : string;
  List : TStringList;
  S : string;
  //i : integer;
begin
  FBoard  :=  ABoard;

  actSage.Enabled     :=    (soSage     in  FBoard.BBS.NewThreadOption);
  actPre.Enabled      :=    (soPre      in  FBoard.BBS.NewThreadOption);
  actTouhaba.Enabled  :=    (soTouhaba  in  FBoard.BBS.NewThreadOption);
  Password.Enabled    :=    (soPassword in  FBoard.BBS.NewThreadOption);

  if  (FileExists(ZonuConfig.UsersPath + FILE_NAME_LOG)) then  begin
    SenderName.Items.LoadFromFile(ZonuConfig.UsersPath + FILE_NAME_LOG);
  end;
  if  (FileExists(ZonuConfig.UsersPath + FILE_MAIL_LOG)) then  begin
    SenderMail.Items.LoadFromFile(ZonuConfig.UsersPath + FILE_MAIL_LOG);
  end;

  ASenderName :=  '';
  ASenderMail :=  '';

  //O[onh
  if  (ZonuConfig.GlobalHandle <> '') then  begin
    ASenderName :=  ZonuConfig.GlobalHandle;
    Reset(SenderName, ASenderName);
  end;
  if  (ZonuConfig.GlobalMail <> '') then  begin
    ASenderMail :=  ZonuConfig.GlobalMail;
    Reset(SenderMail, ASenderMail);
  end;

  //ʃnh
  List  :=  TStringList.Create;
  if  (FileExists(ZonuConfig.UsersPath + FILE_HANDLE_SETTING))  then  begin
    List.LoadFromFile(ZonuConfig.UsersPath + FILE_HANDLE_SETTING);
  end;
  S :=  List.Values[ABoard.Site.SiteID + '_' + ABoard.BoardID + '_HANDLE'];
  if  (S <> '') then  begin
    ASenderName :=  S;
    Reset(SenderName, ASenderName);
  end;
  S :=  List.Values[ABoard.Site.SiteID + '_' + ABoard.BoardID + '_MAIL'];
  if  (S <> '') then  begin
    ASenderMail :=  S;
    Reset(SenderMail, ASenderMail);
  end;
  List.Clear;

  SenderName.Text :=  ASenderName;
  SenderMail.Text :=  ASenderMail;
  
  //݃O
  if  (FileExists(ZonuConfig.UsersPath + FILE_NEWTHREADD_LOG))  then  begin
    try
      Memo2.Lines.LoadFromFile(ZonuConfig.UsersPath + FILE_NEWTHREADD_LOG);
    except
      MessageDlg('݃O̗eʂz܂B' + #13#10 +
                 '܂ł̏݃Oʖŕۑ܂B' + #13#10 +
                 ' ' + #13#10 +
                  ChangeFileExt(ZonuConfig.UsersPath + FILE_NEWTHREADD_LOG, '.bak'),
                  mtWarning, [mbOk] ,0);
      DeleteFile(ChangeFileExt(ZonuConfig.UsersPath + FILE_NEWTHREADD_LOG, '.bak'));
      RenameFile(ZonuConfig.UsersPath + FILE_NEWTHREADD_LOG,
                 ChangeFileExt(ZonuConfig.UsersPath + FILE_NEWTHREADD_LOG, '.bak'));
    end;
  end;
  (*
  FBoard.Assign(ABoard);
  Caption     :=  ABoard.Name + ' ɐVKXbh';
  GetLocalRule;
  actSage.Enabled     :=    (soSage     in  FThreadItem.BBS.NewThreadOption);
  actPre.Enabled      :=    (soPre      in  FThreadItem.BBS.NewThreadOption);
  actTouhaba.Enabled  :=    (soTouhaba  in  FThreadItem.BBS.NewThreadOption);
  //
  if  (FileExists(ZonuConfig.UsersPath + FILE_NAME_LOG)) then  begin
    SenderName.Items.LoadFromFile(ZonuConfig.UsersPath + FILE_NAME_LOG);
  end;
  if  (FileExists(ZonuConfig.UsersPath + FILE_MAIL_LOG)) then  begin
    SenderMail.Items.LoadFromFile(ZonuConfig.UsersPath + FILE_MAIL_LOG);
  end;
  ASenderName :=  '';
  ASenderMail :=  '';
  //O[onh
  if  (ZonuConfig.GlobalHandle <> '') then  begin
    ASenderName :=  ZonuConfig.GlobalHandle;
    Reset(SenderName, ASenderName);
  end;
  if  (ZonuConfig.GlobalMail <> '') then  begin
    ASenderMail :=  ZonuConfig.GlobalMail;
    Reset(SenderMail, ASenderMail);
  end;
  //ʃnh
  List  :=  TStringList.Create;
  if  (FileExists(ZonuConfig.UsersPath + FILE_HANDLE_SETTING))  then  begin
    List.LoadFromFile(ZonuConfig.UsersPath + FILE_HANDLE_SETTING);
  end;
  S :=  List.Values[AThreadItem.Site.SiteID + '_' + AThreadItem.BoardID + '_HANDLE'];
  if  (S <> '') then  begin
    ASenderName :=  S;
    Reset(SenderName, ASenderName);
  end;
  S :=  List.Values[AThreadItem.Site.SiteID + '_' + AThreadItem.BoardID + '_MAIL'];
  if  (S <> '') then  begin
    ASenderMail :=  S;
    Reset(SenderMail, ASenderMail);
  end;
  List.Clear;
  //ߋ̎gpnh
  {
  if  (FileExists(ZonuConfig.UsersPath + FILE_SEND_NAME))  then  begin
    List.LoadFromFile(ZonuConfig.UsersPath + FILE_SEND_NAME);
    for i :=  0 to  List.Count - 1  do  begin
      S :=  ChooseString(List[i], #9, 0);
      if  (AThreadItem.Site.SiteID + '_' +
           AThreadItem.BoardID + '_' +
           AThreadItem.DatNo = S) then
      begin
        ASenderName :=  ChooseString(List[i], #9, 1);
        Reset(SenderName, ASenderName);
        ASenderMail :=  ChooseString(List[i], #9, 2);
        Reset(SenderMail, ASenderMail);
        actSage.Checked     :=    (ChooseString(List[i], #9, 3) = '1');
        actPre.Checked      :=    (ChooseString(List[i], #9, 4) = '1');
        actTouhaba.Checked  :=    (ChooseString(List[i], #9, 5) = '1');
      end;
    end;
  end;
  }
  List.Free;
  SenderName.Text :=  ASenderName;
  SenderMail.Text :=  ASenderMail;
  //݃O
  if  (FileExists(ZonuConfig.UsersPath + FILE_NEWTHREADD_LOG))  then  begin
    Memo2.Lines.LoadFromFile(ZonuConfig.UsersPath + FILE_NEWTHREADD_LOG);
  end;
  *)
end;

procedure TNewThreadDialog.actSendExecute(Sender: TObject);
var
  FSenderName, FSenderMail : string;
  List : TStringList;
begin
  //inherited;
  //
  //SaveSendSetting;

  List  :=  TStringList.Create;
  //
  //  Me̕ۑ
  //
  if  (FileExists(ZonuConfig.UsersPath + FILE_NEWTHREADD_LOG))  then  begin
    List.LoadFromFile(ZonuConfig.UsersPath + FILE_NEWTHREADD_LOG);
  end else begin
    List.Clear;
  end;
  List.Insert(0, '---------- ');
  List.Insert(0, ' ');
  List.Insert(0, SenderBody.Text);
  List.Insert(0, ' ');
  List.Insert(0, '{@F ');
  List.Insert(0, 'eF' + DateTimeToStr(Now));
  List.Insert(0, '[F' + SenderMail.Text);
  List.Insert(0, 'eҁF' + SenderName.Text);
  List.Insert(0, '@F' + FBoard.Name + '' + FBoard.Site.SiteName);
  if  (Password.Enabled)  then  List.Insert(0, '(P  W)F' + Password.Text);
  List.Insert(0, 'XF' + Title.Text);
  List.Insert(0, ' ');
  List.SaveToFile(ZonuConfig.UsersPath + FILE_NEWTHREADD_LOG);

  //
  //  nh̕ۑ
  //
  FSenderName   :=  SenderName.Text;
  FSenderMail   :=  SenderMail.Text;

  {
  if  (CheckBox1.Checked) then  begin
    if  (FileExists(ZonuConfig.UsersPath + FILE_SEND_NAME))  then  begin
      List.LoadFromFile(ZonuConfig.UsersPath + FILE_SEND_NAME);
    end else begin
      List.Clear;
    end;
    List.Add(FBoard.Site.SiteID + '_' +
             FBoard.BoardID + '_' +
             '-' + #9 +
             SenderName.Text + #9 +
             SenderMail.Text + #9 +
             BoolToStr(actSage.Checked) + #9 +
             BoolToStr(actPre.Checked) + #9 +
             BoolToStr(actTouhaba.Checked));
    while (List.Count > 1024) do  begin
      List.Delete(0);
    end;
    List.SaveToFile(ZonuConfig.UsersPath + FILE_SEND_NAME);
  end;
  }
  if  (SenderName.Text <> '') then  begin
    if  (SenderName.Items.IndexOf(SenderName.Text) < 0) then  begin
      SenderName.Items.Insert(0, SenderName.Text);
    end else begin
      SenderName.Items.Move(SenderName.Items.IndexOf(SenderName.Text), 0);
    end;
    SenderName.Items.SaveToFile(ZonuConfig.UsersPath + FILE_NAME_LOG);
  end;
  if  (SenderMail.Text <> '') then  begin
    if  (SenderMail.Items.IndexOf(SenderMail.Text) < 0) then  begin
      SenderMail.Items.Insert(0, SenderMail.Text);
    end else begin
      SenderMail.Items.Move(SenderMail.Items.IndexOf(SenderMail.Text), 0);
    end;
    SenderMail.Items.SaveToFile(ZonuConfig.UsersPath + FILE_MAIL_LOG);
  end;
  ZonuConfig.SaveHandle :=  CheckBox1.Checked;

  SenderName.Text   :=  FSenderName;
  SenderMail.Text   :=  FSenderMail;

  List.Free;

  FSending  :=  True;
  FPreviewWindow.Close;
  Hide;
  if  (Assigned(FSendEvt))  then  begin
    FSendEvt(Self);
  end;
end;

procedure TNewThreadDialog.Preview(var Browser: TZonuBrowser);
var
  Res : TRes;
  doc : variant;
begin
  if  (Browser.ThreadItem = nil)  then  begin
    Browser.ThreadItem  :=  TThreadItem.Create;
    Browser.ResList.ThreadItem  :=  Browser.ThreadItem;
  end;
  Browser.ThreadItem.BBS     :=  Board.BBS;
  Browser.ThreadItem.Site    :=  Board.Site;
  Browser.ThreadItem.BoardID :=  Board.BoardID;
  Browser.ThreadItem.Title   :=  Title.Text;
  Browser.BoardID            :=  Board.BoardID;
  Browser.ResList.Clear;
  Res :=  TRes.Create;
  Res.No      :=  1;
  Res.Name    :=  SenderName.Text;
  Res.Mail    :=  SenderMail.Text;
  Res.Date    :=  FormatDateTime('yyyy/mm/dd hh:nn:ss', Now);
  Res.ID      :=  '???';
  Res.BBS     :=  Board.BBS;
  Res.Site    :=  Board.Site;
  Res.ThreadTitle :=  Title.Text;
  Res.IsNew   :=  False;
  Res.Body    :=  MonaUtils.EncodeHtmlEsc(SenderBody.Text);
  Browser.ResList.Add(Res);

  if  (not  Assigned(Browser.Document))  then  begin
    Browser.Navigate('about:blank');
    while (not Assigned(Browser.Document)) do  begin
      Application.ProcessMessages;
      if  (ZonuEnviron.Disconnected)  then  begin
        raise EZonuError.Create('ؒf܂B');
      end;
    end;
  end;
  doc :=  Browser.Document;
  doc.Clear;
  //Browser.SkinPath  :=  ZonuConfig.SkinPath;
  //Browser.InitSkin(Board);
  Browser.InitSkin('', 'senddialog_preview');
  Browser.InitOutputRes;
  Browser.WriteHeader;
  Browser.WriteRes(Res);
  Browser.EndOutputRes;
  doc.Close;
end;

procedure TNewThreadDialog.LoadToolBarSetting;
begin
  //
end;

procedure TNewThreadDialog.SaveToolBarSetting;
begin
  //
end;

end.

