{ *************************************************************************** }
{                                                                             }
{ Hotzonu 2 Send Window Unit                                                  }
{                                                                             }
{ 2001-04 Hotzonu Project, Monazilla Software Foundation 2001                 }
{                                                                             }
{ *************************************************************************** }

unit SendForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, OleCtrls, SHDocVw, EmbeddedWB, StdCtrls,
  ActnMenus, ToolWin, ComCtrls, ActnList, ExtCtrls, ImgList, Prvw,
  ZonuClass, Buttons, Menus, MenuBar, ZonuHttp, Hzbclass, Hzbconst,
  HttpProt;

type
	TSetLayeredWindowAttributes = function(wnd: HWND; crKey: DWORD;
      bAlpha: BYTE; dwFlag: DWORD): Boolean; stdcall;  //from gikoNavi
  TSendDialog = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    Panel2: TPanel;
    Memo2: TMemo;
    Label2: TLabel;
    SenderMail: TComboBox;
    ImageList1: TImageList;
    SaveDialog1: TSaveDialog;
    FontDialog1: TFontDialog;
    OpenDialog1: TOpenDialog;
    Timer1: TTimer;
    SenderBody: TMemo;
    ActionList1: TActionList;
    actNew: TAction;
    actOpen: TAction;
    actSave: TAction;
    actShowPreview: TAction;
    actSend: TAction;
    actPre: TAction;
    actSage: TAction;
    actTouhaba: TAction;
    actFont: TAction;
    TabSheet4: TTabSheet;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Edit1: TMenuItem;
    Show1: TMenuItem;
    New1: TMenuItem;
    Open1: TMenuItem;
    SAGE1: TMenuItem;
    Send1: TMenuItem;
    SAGE2: TMenuItem;
    PRE1: TMenuItem;
    T1: TMenuItem;
    Font1: TMenuItem;
    R1: TMenuItem;
    WebBrowser1: TWebBrowser;
    Label1: TLabel;
    SenderName: TComboBox;
    AAList: TListBox;
    actShowAAList: TAction;
    HttpCli1: THttpCli;
    lblCaution: TLabel;
    actSelectAll: TAction;
    CoolBar1: TCoolBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton10: TToolButton;
    ToolButton4: TToolButton;
    ToolButton6: TToolButton;
    Panel3: TPanel;
    SpeedButton1: TSpeedButton;
    MenuBar1: TMenuBar;
    ToolBar2: TToolBar;
    ToolButton5: TToolButton;
    ToolButton13: TToolButton;
    ToolButton14: TToolButton;
    ToolButton7: TToolButton;
    CheckBox1: TCheckBox;
    InfoPanel: TPanel;
    InfoMsg: TLabel;
    Image1: TImage;
    N1: TMenuItem;
    Undo1: TMenuItem;
    actUndo: TAction;
    actRedo: TAction;
    actCut: TAction;
    actCopy: TAction;
    actPaste: TAction;
    actDelete: TAction;
    procedure FormCreate(Sender: TObject);
    procedure actNewExecute(Sender: TObject);
    procedure actOpenExecute(Sender: TObject);
    procedure actSaveExecute(Sender: TObject);
    procedure actFontExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDeactivate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure actShowPreviewExecute(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure actSendExecute(Sender: TObject);
    procedure actSageExecute(Sender: TObject);
    procedure actPreExecute(Sender: TObject);
    procedure actTouhabaExecute(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure SenderBodyChange(Sender: TObject);
    procedure actShowAAListExecute(Sender: TObject);
    procedure AAListKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure AAListExit(Sender: TObject);
    procedure AAListDblClick(Sender: TObject);
    procedure actSelectAllExecute(Sender: TObject);
    procedure Label3Click(Sender: TObject);
    procedure actUndoExecute(Sender: TObject);
    procedure actRedoExecute(Sender: TObject);
    procedure actCutExecute(Sender: TObject);
    procedure actCopyExecute(Sender: TObject);
    procedure actPasteExecute(Sender: TObject);
    procedure actDeleteExecute(Sender: TObject);
  private
    { Private 錾 }
    FSaveHeight : integer;
    FUrl: string;
    FCrypt: string;
    FBrowser: TZonuBrowser;
    //FBrowser : TZonuBrowser;
    procedure ClosePreviewWindow(Sender: TObject);
    procedure ShowLocalRule;
    function GetPre: boolean;
    function GetSage: boolean;
    function GetTouhaba: boolean;
  protected
    FThreadItem: TThreadItem;
    FBoard: TBoard;
    FSite: TSite;
    FPreviewWindow: TPreviewWindow;
    FZonuHttp : TZonuHttp;
    FSendEvt: TNotifyEvent;
    FSending: boolean;
    procedure Preview(var Browser : TZonuBrowser); virtual;
    procedure SaveSendSetting;
    function GetLocalRule: string;
    procedure CreateParams(var Params: TCreateParams); override;
    procedure LoadToolBarSetting; virtual;
    procedure SaveToolBarSetting; virtual;
  public
    { Public 錾 }
    procedure SetThread(AThreadItem: TThreadItem);
    procedure Be2chConnected(Sender: TObject);  //20
    property  ThreadItem : TThreadItem  read  FThreadItem write FThreadItem;
    property  OnSend: TNotifyEvent  read  FSendEvt  write FSendEvt;
    property  Sending: boolean  read  FSending  write FSending;
    property  Url: string read  FUrl  write FUrl;
    property  Crypt: string read  FCrypt  write FCrypt;
    property  Sage: boolean read  GetSage;
    property  Pre: boolean  read  GetPre;
    property  Touhaba: boolean  read  GetTouhaba;
    property  Browser: TZonuBrowser read  FBrowser  write FBrowser;
  end;

var
  SendDialog: TSendDialog;

implementation

{$R *.dfm}

uses
  ZonuConf, DolibModule, Main, MonaUtils, Types, Hzbfunc, Zonutils,
  Be2chModule;

const
	WS_EX_LAYERED = $80000; // from gikoNavi

procedure TSendDialog.FormCreate(Sender: TObject);
begin
  PageControl1.ActivePage :=  TabSheet1;
  SenderBody.Font.Name    :=  ZonuConfig.SendWindowFontName;
  SenderBody.Font.Size    :=  ZonuConfig.SendWindowFontSize;
  FSaveHeight             :=  Height;
  //FThreadItem             :=  TThreadItem.Create;
  FSending                :=  False;
  CheckBox1.Checked       :=  ZonuConfig.SaveHandle;

  FPreviewWindow  :=  TPreviewWindow.Create(Self);
  FPreviewWindow.OnClosePreview :=  ClosePreviewWindow;

  if  (FileExists(ZonuConfig.UsersPath + FILE_AA_LIST))  then  begin
    AAList.Items.LoadFromFile(ZonuConfig.UsersPath + FILE_AA_LIST);
  end;

  //FBrowser  :=  TZonuBrowser.Create(Self);
  //TOleControl(FBrowser).Parent  :=  TabSheet4;
  //FBrowser.Align  :=  alClient;
end;

//
//  [VK쐬]
//
procedure TSendDialog.actNewExecute(Sender: TObject);
begin
  SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  if  (MessageDlg('eNA܂H', mtWarning, [mbYes, mbNo], 0) = mrYes) then
  begin
    SenderBody.Lines.Clear;
  end;
  SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
end;

//
//  [J]
//
procedure TSendDialog.actOpenExecute(Sender: TObject);
begin
  SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  if  (OpenDialog1.Execute) then  begin
    SaveDialog1.FileName  :=  OpenDialog1.FileName;
    SenderBody.Lines.LoadFromFile(OpenDialog1.FileName);
  end;
  SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
end;

//
//  [ۑ]
//
procedure TSendDialog.actSaveExecute(Sender: TObject);
begin
  SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  if  (PageControl1.ActivePage = TabSheet1) then  begin
    SaveDialog1.Title       :=  'ݕ͂ۑ';
    if  (SaveDialog1.Execute) then  begin
      SenderBody.Lines.SaveToFile(SaveDialog1.FileName);
    end;
  end else
  if  (PageControl1.ActivePage = TabSheet2) then  begin
    Memo2.Lines.SaveToFile(ZonuConfig.UsersPath + FILE_SEND_LOG);
  end;
  SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
end;

//
//  [tHg]
//
procedure TSendDialog.actFontExecute(Sender: TObject);
begin
  SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  FontDialog1.Font        :=  SenderBody.Font;
  if  (FontDialog1.Execute) then  begin
    SenderBody.Font.Name    :=  FontDialog1.Font.Name;
    SenderBody.Font.Size    :=  FontDialog1.Font.Size;
    ZonuConfig.SendWindowFontName :=  FontDialog1.Font.Name;
    ZonuConfig.SendWindowFontSize :=  FontDialog1.Font.Size;
  end;
  SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
end;

procedure TSendDialog.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  if  (Showing) and (Length(Trim(SenderBody.Text)) > 0)  then  begin
    CanClose  :=  (MessageDlg('ҏWłBĂ悩łH', mtWarning, [mbYes, mbNo],0) = mrYes);
  end;
  SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
end;

procedure TSendDialog.FormActivate(Sender: TObject);
var
  s : string;
begin
  SetActionEnabled(False);
  if  (actShowPreview.Checked) and (not FPreviewWindow.Showing) then  begin
    FPreviewWindow.Show;
    if  (SenderBody.Text = '')  then  begin
      s :=  GetLocalRule;
      if  (FileExists(s))  then  begin
        FPreviewWindow.ShowLocalRule(s);
      end;
    end;
  end;
  AlphaBlend  :=  False;
  if  (ZonuConfig.SendWindowExpand) then  begin
    SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  end;
  Height  :=  FSaveHeight;
  //Timer2.Enabled  :=  True;
  SetForegroundWindow(Self.Handle);
  if  (SenderBody.CanFocus) then  begin
    SenderBody.SetFocus;
    SenderBody.SelStart :=  Length(SenderBody.Lines.Text);
  end;

  //20
  Be2chConnected(Self);
end;

procedure TSendDialog.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SetActionEnabled(True);
  //
  //HotzonuWindow.ActionManager1.State  :=  asNormal;
  //
  Action  := caFree;
end;

procedure TSendDialog.FormDeactivate(Sender: TObject);
begin
  if  (GetForegroundWindow <> FPreviewWindow.Handle) then  begin
    if  (actShowPreview.Checked)  then  begin
      FPreviewWindow.Hide;
    end;
    if  (ZonuConfig.SendWindowTrans)  then
    begin
      //TransWindow(True);
      AlphaBlend  :=  True;
      AlphaBlendValue :=  128;
    end;
    FSaveHeight :=  Height;
    if  (ZonuConfig.SendWindowExpand) then  begin
      Height      :=  0;
    end;
  end;
  SetActionEnabled(True);
end;

procedure TSendDialog.FormShow(Sender: TObject);
var
  s: string;
begin
  SetBounds(
    ZonuConfig.SendWindowPosLeft,
    ZonuConfig.SendWindowPosTop,
    ZonuConfig.SendWindowWidth,
    ZonuConfig.SendWindowHeight);
  FSaveHeight :=  Height;
  if  (ZonuConfig.SendWindowShowPreview)  then  begin
    actShowPreview.Checked  :=  True;
    FPreviewWindow.Show;
    s :=  GetLocalRule;
    if  (FileExists(s))  then  begin
      FPreviewWindow.ShowLocalRule(s);
    end;
  end else begin
    if  (actShowPreview.Checked)  then  actShowPreview.Execute;
  end;
  LoadToolBarSetting;
end;

procedure TSendDialog.ClosePreviewWindow(Sender: TObject);
begin
  actShowPreview.Checked  :=  False;
end;

procedure TSendDialog.FormHide(Sender: TObject);
begin
  SaveToolBarSetting;
  ZonuConfig.SendWindowPosTop   :=  Top;
  ZonuConfig.SendWindowPosLeft  :=  Left;
  ZonuConfig.SendWindowWidth    :=  Width;
  ZonuConfig.SendWindowHeight   :=  Height;
  ZonuConfig.SendWindowShowPreview  :=  actShowPreview.Checked;
end;

procedure TSendDialog.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled  :=  False;
  if  (FPreviewWindow <> nil)  then  begin
    if  (FPreviewWindow.Showing)  then  begin
      Preview(FPreviewWindow.FBrowser);
    end;
  end;
end;

procedure TSendDialog.actShowPreviewExecute(Sender: TObject);
begin
  actShowPreview.Checked  :=  not actShowPreview.Checked;
  if  (Showing) then  begin
    if  (actShowPreview.Checked)  then  begin
      FPreviewWindow.Show;
      Timer1.Enabled  :=  True;
    end else begin
      FPreviewWindow.SavePos;
      FPreviewWindow.Hide;
    end;
  end;
end;

procedure TSendDialog.FormDestroy(Sender: TObject);
begin
  PageControl1.ActivePageIndex  :=  0;
  SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
  if  (actShowPreview.Checked)  then  begin
    FPreviewWindow.SavePos;
  end;
  //if  (FPreviewWindow.FBrowser.ThreadItem <> nil)  then  begin
    //FPreviewWindow.FBrowser.ThreadItem.ReleaseRef;
  //end;
  FPreviewWindow.Release;
  //if  (FThreadItem <> nil)  then  FThreadItem.Free;
  SetActionEnabled(True);
  if  (WebBrowser1.Busy)  then  begin
    WebBrowser1.Stop;
    while (WebBrowser1.Busy)  do  begin
      Sleep(100);
      Application.ProcessMessages;
      if  (ZonuEnviron.Disconnected)  then  begin
        raise EZonuError.Create('ؒf܂B');
      end;
    end;
  end;
  if  (FThreadItem <> nil)  then  begin
    FThreadItem.ReleaseRef;
  end;
end;

procedure TSendDialog.SetThread(AThreadItem: TThreadItem);
  procedure Reset(ComboBox: TComboBox; const S: string);
  begin
    if  (S <> '') then  begin
      if  (ComboBox.Items.IndexOf(S) < 0) then  begin
        ComboBox.Items.Insert(0, S);
      end else begin
        ComboBox.Items.Move(ComboBox.Items.IndexOf(S), 0);
      end;
    end;
  end;
var
  ASenderName, ASenderMail : string;
  List : TStringList;
  S : string;
  i : integer;
begin
  FThreadItem :=  AThreadItem;

  (*!*)
  OutputDebugString(PChar('JLRO:refcount=' + IntToStr(FThreadItem.RefCount)));
  (*!*)

  FThreadItem.AddRef;
  FBoard      :=  FThreadItem.Board;
  Caption     :=  AThreadItem.Title + ' ɏ';
  //GetLocalRule;
  actSage.Enabled     :=    (soSage     in  FThreadItem.BBS.SendOption);
  actPre.Enabled      :=    (soPre      in  FThreadItem.BBS.SendOption);
  actTouhaba.Enabled  :=    (soTouhaba  in  FThreadItem.BBS.SendOption);
  //
  if  (FileExists(ZonuConfig.UsersPath + FILE_NAME_LOG)) then  begin
    SenderName.Items.LoadFromFile(ZonuConfig.UsersPath + FILE_NAME_LOG);
  end;
  if  (FileExists(ZonuConfig.UsersPath + FILE_MAIL_LOG)) then  begin
    SenderMail.Items.LoadFromFile(ZonuConfig.UsersPath + FILE_MAIL_LOG);
  end;
  ASenderName :=  '';
  ASenderMail :=  '';
  //O[onh
  if  (ZonuConfig.GlobalHandle <> '') then  begin
    ASenderName :=  ZonuConfig.GlobalHandle;
    Reset(SenderName, ASenderName);
  end;
  if  (ZonuConfig.GlobalMail <> '') then  begin
    ASenderMail :=  ZonuConfig.GlobalMail;
    Reset(SenderMail, ASenderMail);
  end;
  //ʃnh
  List  :=  TStringList.Create;
  if  (FileExists(ZonuConfig.UsersPath + FILE_HANDLE_SETTING))  then  begin
    List.LoadFromFile(ZonuConfig.UsersPath + FILE_HANDLE_SETTING);
  end;
  S :=  List.Values[AThreadItem.Site.SiteID + '_' + AThreadItem.BoardID + '_HANDLE'];
  if  (S <> '') then  begin
    ASenderName :=  S;
    Reset(SenderName, ASenderName);
  end;
  S :=  List.Values[AThreadItem.Site.SiteID + '_' + AThreadItem.BoardID + '_MAIL'];
  if  (S <> '') then  begin
    ASenderMail :=  S;
    Reset(SenderMail, ASenderMail);
  end;
  List.Clear;
  //Xbh
  if  (FileExists(ZonuConfig.UsersPath + FILE_THREAD_HANDLE))  then  begin
    List.LoadFromFile(ZonuConfig.UsersPath + FILE_THREAD_HANDLE);
    for i :=  0 to  List.Count - 1  do  begin
      S :=  ChooseString(List[i], #9, 0);
      if  (AnsiPos(S, AThreadItem.Title) >0)  then  begin
        ASenderName :=  ChooseString(List[i], #9, 1);
        Reset(SenderName, ASenderName);
        ASenderMail :=  ChooseString(List[i], #9, 2);
        Reset(SenderMail, ASenderMail);
      end;
    end;
  end;
  List.Clear;
  //ߋ̎gpnh
  if  (FileExists(ZonuConfig.UsersPath + FILE_SEND_NAME))  then  begin
    List.LoadFromFile(ZonuConfig.UsersPath + FILE_SEND_NAME);
    for i :=  0 to  List.Count - 1  do  begin
      S :=  ChooseString(List[i], #9, 0);
      if  (AThreadItem.Site.SiteID + '_' +
           AThreadItem.BoardID + '_' +
           AThreadItem.DatNo = S) then
      begin
        ASenderName :=  ChooseString(List[i], #9, 1);
        Reset(SenderName, ASenderName);
        ASenderMail :=  ChooseString(List[i], #9, 2);
        Reset(SenderMail, ASenderMail);
        actSage.Checked     :=    (ChooseString(List[i], #9, 3) = '1');
        actPre.Checked      :=    (ChooseString(List[i], #9, 4) = '1');
        actTouhaba.Checked  :=    (ChooseString(List[i], #9, 5) = '1');
      end;
    end;
  end;
  List.Free;
  SenderName.Text :=  ASenderName;
  SenderMail.Text :=  ASenderMail;
  //݃O
  if  (FileExists(ZonuConfig.UsersPath + FILE_SEND_LOG))  then  begin
    try
      Memo2.Lines.LoadFromFile(ZonuConfig.UsersPath + FILE_SEND_LOG);
    except
      SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
      MessageDlg('݃O̗eʂz܂B' + #13#10 +
                 '܂ł̏݃Oʖŕۑ܂B' + #13#10 +
                 ' ' + #13#10 +
                  ChangeFileExt(ZonuConfig.UsersPath + FILE_SEND_LOG, '.bak'),
                  mtWarning, [mbOk] ,0);
      if  (FileExists(ChangeFileExt(ZonuConfig.UsersPath + FILE_SEND_LOG, '.bak')))  then  begin
        DeleteFileEx(ChangeFileExt(ZonuConfig.UsersPath + FILE_SEND_LOG, '.bak'));
      end;
      RenameFile(ZonuConfig.UsersPath + FILE_SEND_LOG,
                 ChangeFileExt(ZonuConfig.UsersPath + FILE_SEND_LOG, '.bak'));
      SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
    end;
  end;
  //29:["sage"Ȃ sage{^Ԃɂ
  if  (not actSage.Checked) then  begin
    actSage.Checked :=  (SameText(SenderMail.Text, 'sage'));
  end;
end;

procedure TSendDialog.actSendExecute(Sender: TObject);
begin
  SaveSendSetting;

  if  (AnsiLowerCase(FBoard.Site.SiteID) = '2ch') and
      (AnsiPos('', SenderName.Text) > 0)  and
      (ZonuConfig.DolibUserName <> '')  and
      (not DolibManager.Connected)  then
  begin
    SetWindowPos(Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
    if  (MessageDlg('Q˂փOC܂H', mtInformation, [mbYes, mbNo] ,0) = mrYes) then
    begin
      if  (not DolibManager.Connect)  then  begin
        DolibManager.Disconnect;
        SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);
        Exit;
      end;
    end;
  end;

  if  (ZonuConfig.FusianasanWarning)  then  begin
    if  (AnsiPos('fusianasan', SenderName.Text) > 0)  then  begin
      if  (MessageDlg('fusianasanŏƂĂ܂B' + #13#10 +
                      'fɂĂfusianasanŏނƃ[gzXg\ꂽ肵܂B' + #13#10 +
                      '݂܂H',
           mtWarning, [mbYes, mbNo] ,0) = mrNo) then
      begin
        Exit;
      end;
    end;
  end;
  if  (ZonuConfig.MachiBBSWarning)  and (ThreadItem.BBS.BBSID = BBS_MACHIBBS)  then  begin
    if  (MessageDlg('܂BBSɏƂĂ܂B' + #13#10 +
                    '܂BBS̓[gzXg̎EJ܂B' + #13#10 +
                    '݂܂H',
         mtWarning, [mbYes, mbNo] ,0) = mrNo) then
    begin
      Exit;
    end;
  end;

  SetWindowPos(Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or SWP_NOMOVE);

  FSending  :=  True;
  FPreviewWindow.Close;
  Hide;
  if  (Assigned(FSendEvt))  then  begin
    FSendEvt(Self);
  end;
end;

procedure TSendDialog.SaveSendSetting;
  function BoolToStr(const b: boolean): string;
  begin
    if  (b) then  Result  :=  '1' else  Result  :=  '0';
  end;
var
  FSenderName, FSenderMail : string;
  List : TStringList;
begin
  List  :=  TStringList.Create;

  FSenderName   :=  SenderName.Text;
  FSenderMail   :=  SenderMail.Text;

  //
  //  Me̕ۑ
  //
  //5 if  (ZonuConfig.SaveHist) then  begin
  if  (ZonuConfig.SaveHist_Send) then  begin //5
    if  (FileExists(ZonuConfig.UsersPath + FILE_SEND_LOG))  then  begin
      List.LoadFromFile(ZonuConfig.UsersPath + FILE_SEND_LOG);
    end else begin
      List.Clear;
    end;
    List.Insert(0, '---------- ');
    List.Insert(0, ' ');
    List.Insert(0, SenderBody.Text);
    List.Insert(0, ' ');
    List.Insert(0, '{@F ');
    List.Insert(0, 'eF' + DateTimeToStr(Now));
    List.Insert(0, '[F' + SenderMail.Text);
    List.Insert(0, 'eҁF' + SenderName.Text);
    List.Insert(0, '@F' + FThreadItem.Board.Name + '' + FThreadItem.Site.SiteName);
    List.Insert(0, 'XF' + FThreadItem.Title);
    List.Insert(0, ' ');
    {
    List.Insert(0, '--');
    List.Insert(0, SenderBody.Text);
    List.Insert(0,
                FThreadItem.Title + '^' +
                FThreadItem.Board.Name + '' +
                FThreadItem.Site.SiteName +
                ' eҁF' + SenderName.Text + ' [F' + SenderMail.Text +
                ' eF' + DateTimeToStr(Now)
                );
    }
    List.SaveToFile(ZonuConfig.UsersPath + FILE_SEND_LOG);

    //
    //  nh̕ۑ
    //
    if  (CheckBox1.Checked) then  begin
      if  (FileExists(ZonuConfig.UsersPath + FILE_SEND_NAME))  then  begin
        List.LoadFromFile(ZonuConfig.UsersPath + FILE_SEND_NAME);
      end else begin
        List.Clear;
      end;
      List.Add(FThreadItem.Site.SiteID + '_' +
               FThreadItem.BoardID + '_' +
               FThreadItem.DatNo + #9 +
               SenderName.Text + #9 +
               SenderMail.Text + #9 +
               BoolToStr(actSage.Checked) + #9 +
               BoolToStr(actPre.Checked) + #9 +
               BoolToStr(actTouhaba.Checked));
      while (List.Count > 1024) do  begin
        List.Delete(0);
      end;
      List.SaveToFile(ZonuConfig.UsersPath + FILE_SEND_NAME);
    end;
    if  (SenderName.Text <> '') then  begin
      if  (SenderName.Items.IndexOf(SenderName.Text) < 0) then  begin
        SenderName.Items.Insert(0, SenderName.Text);
      end else begin
        SenderName.Items.Move(SenderName.Items.IndexOf(SenderName.Text), 0);
      end;
      SenderName.Items.SaveToFile(ZonuConfig.UsersPath + FILE_NAME_LOG);
    end;
    if  (SenderMail.Text <> '') then  begin
      if  (SenderMail.Items.IndexOf(SenderMail.Text) < 0) then  begin
        SenderMail.Items.Insert(0, SenderMail.Text);
      end else begin
        SenderMail.Items.Move(SenderMail.Items.IndexOf(SenderMail.Text), 0);
      end;
      SenderMail.Items.SaveToFile(ZonuConfig.UsersPath + FILE_MAIL_LOG);
    end;
    ZonuConfig.SaveHandle :=  CheckBox1.Checked;
  end;
  
  SenderName.Text   :=  FSenderName;
  SenderMail.Text   :=  FSenderMail;

  List.Free;
end;

function TSendDialog.GetPre: boolean;
begin
  Result  :=  (actPre.Checked and actPre.Enabled);
end;

function TSendDialog.GetSage: boolean;
begin
  Result  :=  (actSage.Checked and actSage.Enabled);
end;

function TSendDialog.GetTouhaba: boolean;
begin
  Result  :=  (actTouhaba.Checked and actTouhaba.Enabled);
end;

procedure TSendDialog.actSageExecute(Sender: TObject);
begin
  actSage.Checked :=  not actSage.Checked;
  if  (soSageMail in FBoard.BBS.SendOption) then  begin
    try
      if  (actSage.Checked) then  begin
        if  (AnsiPos('sage', SenderMail.Text) = 0)  then  begin
          SenderMail.Text :=  'sage' + SenderMail.Text;
        end;
      end else begin
        if  (AnsiPos('sage', SenderMail.Text) = 1)  then  begin
          SenderMail.Text :=  Copy(SenderMail.Text, 5, Length(SenderMail.Text));
        end;
      end;
    except
      SenderMail.Text :=  'sage';
    end;
  end;
end;

procedure TSendDialog.actPreExecute(Sender: TObject);
begin
  actPre.Checked  :=  not actPre.Checked;
end;

procedure TSendDialog.actTouhabaExecute(Sender: TObject);
begin
  actTouhaba.Checked  :=  not actTouhaba.Checked;
end;

procedure TSendDialog.PageControl1Change(Sender: TObject);
begin
  actNew.Enabled  :=  (PageControl1.ActivePage = TabSheet1);
  actOpen.Enabled :=  (PageControl1.ActivePage = TabSheet1);
  actSave.Enabled :=  (PageControl1.ActivePage = TabSheet1) or (PageControl1.ActivePage = TabSheet2);
  actShowPreview.Enabled  :=  (PageControl1.ActivePage = TabSheet1);
  actFont.Enabled :=  (PageControl1.ActivePage = TabSheet1);
  SpeedButton1.Enabled  :=  (PageControl1.ActivePage = TabSheet1);
  actSage.Enabled       :=  (PageControl1.ActivePage = TabSheet1);
  actPre.Enabled        :=  (PageControl1.ActivePage = TabSheet1);
  actTouhaba.Enabled    :=  (PageControl1.ActivePage = TabSheet1);
  if  (PageControl1.ActivePage = TabSheet3) then  begin
    ShowLocalRule;
  end;
end;

procedure TSendDialog.Preview(var Browser : TZonuBrowser);
var
  Res : TRes;
  doc : variant;
begin
  if  (Browser.ThreadItem = nil)  then  begin
    Browser.ThreadItem  :=  Self.ThreadItem;
    Self.ThreadItem.AddRef;
  end;
  {
  Browser.ThreadItem.BBS     :=  Self.ThreadItem.BBS;
  Browser.ThreadItem.Site    :=  Self.ThreadItem.Site;
  Browser.ThreadItem.BoardID :=  Self.ThreadItem.BoardID;
  Browser.ThreadItem.Title   :=  Self.ThreadItem.Title;
  Browser.BoardID            :=  Self.ThreadItem.BoardID;
  }
  Browser.ResList.Clear;
  if  (Browser.ResList.ThreadItem <> Browser.ThreadItem)  then  begin
    Browser.ResList.ThreadItem  :=  Browser.ThreadItem;
    Browser.ThreadItem.AddRef;
  end;
  Res :=  TRes.Create;
  Res.No      :=  1;
  Res.Name    :=  SenderName.Text;
  Res.Mail    :=  SenderMail.Text;
  Res.Date    :=  FormatDateTime('yyyy/mm/dd hh:nn:ss', Now);
  Res.ID      :=  '???';
  Res.BBS     :=  Self.ThreadItem.BBS;
  Res.Site    :=  Self.ThreadItem.Site;
  Res.ThreadTitle :=  Self.ThreadItem.Title;
  Res.IsNew   :=  False;
  Res.Body    :=  MonaUtils.EncodeHtmlEsc(SenderBody.Text);
  Browser.ResList.Add(Res);

  if  (not  Assigned(Browser.Document))  then  begin
    Browser.Navigate('about:blank');
    while (not Assigned(Browser.Document)) do  begin
      Application.ProcessMessages;
      if  (ZonuEnviron.Disconnected)  then  begin
        raise EZonuError.Create('ؒf܂B');
      end;
    end;
  end;
  doc :=  Browser.Document;
  doc.Clear;
  //Browser.SkinPath  :=  ZonuConfig.SkinPath;
  //Browser.InitSkin(ThreadItem.Board);
  Browser.InitSkin('', 'senddialog_preview');
  Browser.InitOutputRes;
  Browser.WriteHeader;
  Browser.WriteRes(Res);
  Browser.EndOutputRes;
  doc.Close;
  //
  SetForegroundWindow(Self.Handle);
  SenderBody.SetFocus;
end;

procedure TSendDialog.SenderBodyChange(Sender: TObject);
begin
  Timer1.Enabled  :=  False;
  Timer1.Enabled  :=  True;
  StatusBar1.Panels[0].Text :=  Format('s: %d  : %d', [SenderBody.Lines.Count, Length(SenderBody.Lines.Text)]); 
end;

procedure TSendDialog.actShowAAListExecute(Sender: TObject);
var
  p : TPoint;
begin
  GetCaretPos(p);
  AAList.Top    :=  {SenderBody.ClientOrigin.Y + }PageControl1.Top + TabSheet1.Top  + SenderBody.Top  + p.Y + Abs(SenderBody.Font.Height);
  AAList.Left   :=  {SenderBody.ClientOrigin.X + }PageControl1.Left+ TabSheet1.Left + SenderBody.Left + p.X;
  AAList.ItemIndex  :=  0;
  AAList.Show;
  AAList.SetFocus;
end;

procedure TSendDialog.AAListKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if  (Key  = VK_ESCAPE)  then  begin
    AAList.Hide;
    SenderBody.SetFocus;
  end else
  if  (Key  = VK_RETURN)  then  begin
    if  (AAList.ItemIndex > -1) then  begin
      SenderBody.SelText  :=  AAList.Items[AAList.ItemIndex];
    end;
    AAList.Hide;
    SenderBody.SetFocus;
  end;
end;

procedure TSendDialog.AAListExit(Sender: TObject);
begin
  AAList.Hide;
end;

procedure TSendDialog.AAListDblClick(Sender: TObject);
begin
  if  (AAList.ItemIndex > -1) then  begin
    SenderBody.SelText  :=  AAList.Items[AAList.ItemIndex];
  end;
  AAList.Hide;
  SenderBody.SetFocus;
end;

function TSendDialog.GetLocalRule: string;
var
  LocalRule: TStringList;
  Url : string;
  ss  : TStringStream;
  ms  : TMemoryStream;
  //ini : TMemIniFile;
  s   : string;
begin
  Result  :=  '';
  Screen.Cursor :=  crHourGlass;
  if  (ZonuEnviron.State = asOnline)  then  begin
    StatusBar1.Panels[1].Text :=  '[J[擾EEE';
    Url :=  FBoard.Site.GetLocalRuleUrl(FBoard);
    if  (Url <> '') then  begin
      //22 if  (FileExists(FThreadItem.Board.CachePath + FILE_LOCAL_RULE)) then  begin
      if  (FileExists(FBoard.CachePath + FILE_LOCAL_RULE)) then  begin
        //22 Result  :=  FThreadItem.Board.CachePath + FILE_LOCAL_RULE;
        Result  :=  FBoard.CachePath + FILE_LOCAL_RULE;
      end else begin
        ss  :=  TStringStream.Create('');
        HttpCli1.URL          :=  Url;
        HttpCli1.RcvdStream   :=  ss;
        HttpCli1.Agent        :=  USER_AGENT;
        if  (ZonuConfig.ProxyUse) then  begin
          HttpCli1.Proxy          :=  ZonuConfig.Proxy;
          HttpCli1.ProxyPort      :=  ZonuConfig.ProxyPort;
          HttpCli1.ProxyUsername  :=  ZonuConfig.ProxyUserName;
          HttpCli1.ProxyPassword  :=  ZonuConfig.ProxyPassword;
        end;
        //22 if  (not DirectoryExists(FThreadItem.Board.CachePath))  then  begin
        if  (not DirectoryExists(FBoard.CachePath))  then  begin
          //22 ForceDirectories(FThreadItem.Board.CachePath);
          ForceDirectories(FBoard.CachePath);
        end;
        try
          HttpCli1.Get;
          s :=  ss.DataString;
          if  (s <> '') then  begin
            if  (s[1] <> '<') then  begin
              LocalRule :=  TStringList.Create;
              LocalRule.Add('<HTML><BODY>');
              LocalRule.Add(s);
              LocalRule.Add('</BODY></HTML>');
              //22 LocalRule.SaveToFile(FThreadItem.Board.CachePath + FILE_LOCAL_RULE);
              LocalRule.SaveToFile(FBoard.CachePath + FILE_LOCAL_RULE);
              LocalRule.Free;
            end else begin
              ms  :=  TMemoryStream.Create;
              ms.LoadFromStream(ss);
              //22 ms.SaveToFile(FThreadItem.Board.CachePath + FILE_LOCAL_RULE);
              ms.SaveToFile(FBoard.CachePath + FILE_LOCAL_RULE);
              ms.Free;
            end;
            //22 Result  :=  FThreadItem.Board.CachePath + FILE_LOCAL_RULE;
            Result  :=  FBoard.CachePath + FILE_LOCAL_RULE;
          end;
        finally
          ss.Free;
          Screen.Cursor :=  crDefault;
        end;
      end;
    end;
    StatusBar1.Panels[1].Text :=  '';
  end;
  Screen.Cursor :=  crDefault;
end;


procedure TSendDialog.ShowLocalRule;
var
  s: string;
begin
  s :=  GetLocalRule;
  if  (FileExists(s))  then  begin
    WebBrowser1.Navigate(s);
  end;
end;

procedure TSendDialog.actSelectAllExecute(Sender: TObject);
begin
  SenderBody.SelectAll;
end;

procedure TSendDialog.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Params.ExStyle := Params.ExStyle or WS_EX_APPWINDOW;
end;

procedure TSendDialog.LoadToolBarSetting;
begin
  LoadToolBarPos(CoolBar1, 'SENDWIN_COOLBAR1');
end;

procedure TSendDialog.SaveToolBarSetting;
begin
  SaveToolBarPos(CoolBar1, 'SENDWIN_COOLBAR1');
end;

procedure TSendDialog.Be2chConnected(Sender: TObject);
begin
  InfoPanel.Hide;
  if  (FBoard.Site.SiteID = '2ch')  then  begin
    if  (Be2chManager.Connected)  then  begin
      if  (ZonuConfig.BeSendLoginInfo) or (Be2chManager.IsBE(FBoard)) then  begin
        InfoPanel.Show;
        InfoPanel.Visible :=  True;
      end;
    end;
  end;
end;

procedure TSendDialog.Label3Click(Sender: TObject);
begin
  //
end;

procedure TSendDialog.actUndoExecute(Sender: TObject);
begin
  SenderBody.Perform(EM_UNDO, 0, 0);
end;

procedure TSendDialog.actRedoExecute(Sender: TObject);
begin
  SenderBody.Perform(WM_USER + 84, 0, 0);
end;

procedure TSendDialog.actCutExecute(Sender: TObject);
begin
  SenderBody.CutToClipboard;
end;

procedure TSendDialog.actCopyExecute(Sender: TObject);
begin
  SenderBody.CopyToClipboard;
end;

procedure TSendDialog.actPasteExecute(Sender: TObject);
begin
  SenderBody.PasteFromClipboard;
end;

procedure TSendDialog.actDeleteExecute(Sender: TObject);
begin
  SenderBody.SelText  :=  '';
end;

end.
