{*******************************************************}
{                                                       }
{       DOLIB API Interface Unit                        }
{                                                       }
{       2002 Monazilla Project                          }
{            Dax mailto:daxmonazilla@yahoo.co.jp        }
{                                                       }
{********************************************************

Updates:
2002/03/01 OCG[o悤ɏC 
2002/02/27 oOC (GetVersion̓RlNgĂȂĂ擾\ɂ)
2002/01/22 DOLIB 1.00CΉB
           ȉ̃vpeBǉB
           - Session ......... ZbṼ|C^Ԃ܂AgȂB
           - SessionID ....... ZbVIDԂ܂B
           - Version ......... DOLIB̃o[WԂ܂B
           - UserAgent ....... UAp̕ Monazilla/x.xx Ԃ܂B
           - ErrorCode ....... G[R[hԂ܂B
           - ErrorMsg ........ G[bZ[WԂ܂B
2002/01/20 Disconnect ConnectedvpeB߂ĂȂB
2002/01/19 DOLIB 1.00BΉBf[^擾ɐI
2002/01/18 DOLIB 1.00ΉBG[ԂėȂAA
2002/01/18 ghanyan̏ɂ蓮삷BӁI
2002/01/09 DOLIB 0.01pɍ쐬JnBłȂ̂łقƂB
}
unit Dolib;

{$IOCHECKS ON}

interface

uses
  Windows, SysUtils;

type
  TDolibSession = Pointer;

  TDolib  = class(TObject)
  private
    FLibHandle  : THandle;
    FSession : TDolibSession;
    FConnected: boolean;
    FProxyPort: integer;
    FUserName: string;
    FPassword: string;
    FProxyAddress: string;
    function GetSessionID: string;
    function GetVersion: string;
    function GetUserAgent: string;
    function GetErrorCode: integer;
    function GetErrorMsg: string;
  public
    constructor Create;
    destructor  Destroy; override;
    function  Connect: boolean;
    function  Disconnect: boolean;
    property  ProxyAddress: string  read  FProxyAddress write FProxyAddress;
    property  ProxyPort: integer  read  FProxyPort  write FProxyPort;
    property  UserName: string  read  FUserName write FUserName;
    property  Password: string  read  FPassword write FPassword;
    property  Connected: boolean  read  FConnected;
    property  Session: TDolibSession  read  FSession;
    property  SessionID: string read  GetSessionID;
    property  Version: string read  GetVersion;
    property  UserAgent: string read  GetUserAgent;
    property  ErrorCode: integer read  GetErrorCode;
    property  ErrorMsg: string  read  GetErrorMsg;
  end;

  {DOLIB_INIT_Function}
  TDolibInitFunc    = function(Proxy: PChar;
                               Port: integer;
                               UserName: PChar;
                               Password: PChar) : PChar; cdecl;

  {DOLIB_RELEASE_Function}
  TDolibReleaseFunc = function(Session: TDolibSession): integer; cdecl;

  {DOLIB_VERSION_Function}
  TDolibVersionFunc = function(): DWORD; cdecl;

  {DOLIB_GETEC_Function}
  TDolibGetErrorCodeFunc = function(Session: TDolibSession): integer; cdecl;

  {DOLIB_GETERRSTR_FUNC}
  TDolibGetErrorStrFunc = function(Session: TDolibSession): PChar; cdecl;

  {DOLIB_GETSESSIONID_FUNC}
  TDolibGetSessionIDFunc = function(Session: TDolibSession): PChar; cdecl;

  {DOLIB_GETUASTR_FUNC}
  TDolibGetUserAgentFunc = function(Session: TDolibSession): PChar; cdecl;

const
  DOLIB_NAME          = 'dolib.dll';
  {
  00001238    1 0002 _DOLIB_GETSESSIONID
  00001248    2 0003 _DOLIB_GETUSERAGENT
  00001258    3 0000 _DOLIB_GETERRORCODE
  00001268    4 0001 _DOLIB_GETERRORSTRING
  000012F4    5 0004 _DOLIB_GETVERSION
  00001340    6 0005 _DOLIB_LOGIN
  00001688    7 0006 _DOLIB_RELEASE
  }
  DOLIB_GETSESSIONID_FUNC   = '_DOLIB_GETSESSIONID';
  DOLIB_GETUASTR_FUNC       = '_DOLIB_GETUSERAGENT';
  DOLIB_GETEC_FUNC          = '_DOLIB_GETERRORCODE';
  DOLIB_GETERRSTR_FUNC      = '_DOLIB_GETERRORSTRING';
  DOLIB_VERSION_FUNC        = '_DOLIB_GETVERSION';
  DOLIB_INIT_FUNC           = '_DOLIB_LOGIN';
  DOLIB_RELEASE_FUNC        = '_DOLIB_RELEASE';

implementation

{ TDolib }

constructor TDolib.Create;
begin
  FSession    :=  nil;
  FConnected  :=  False;
  FLibHandle  :=  LoadLibrary(DOLIB_NAME);
end;

destructor TDolib.Destroy;
begin
  if  (Connected) then  begin
    Disconnect;
  end;
  if  (FLibHandle <> 0) then  begin
    FreeLibrary(FLibHandle);
  end;
  inherited;
end;

function TDolib.Connect: boolean;
var
  DBInitFunc  : TDolibInitFunc;
begin
  Result  :=  False;
  if  (not Connected) then  begin
    DBInitFunc  :=  GetProcAddress(FLibHandle, DOLIB_INIT_FUNC);
    FSession    :=  DBInitFunc(PChar(FProxyAddress),
                               FProxyPort,
                               PChar(FUserName),
                               PChar(FPassword));
    FConnected  :=  True;
    if  (AnsiPos('ERROR:', SessionID) = 1) then  begin
      FConnected  :=  False;
      Result      :=  False;
    end else begin
      Result      :=  (ErrorCode = 0);
    end;
  end;
end;

function TDolib.Disconnect: boolean;
var
  DBReleaseFunc  : TDolibReleaseFunc;
begin
  Result  :=  False;
  if  (Connected) then  begin
    DBReleaseFunc :=  GetProcAddress(FLibHandle, DOLIB_RELEASE_FUNC);
    DBReleaseFunc(FSession);
    FConnected    :=  False;
    if  (ErrorCode = 0) then  begin
      Result      :=  True;
    end;
  end;
end;

function TDolib.GetVersion: string;
var
  DBVersionFunc  : TDolibVersionFunc;
  v : DWORD;
  mj, mn : integer;
begin
  DBVersionFunc :=  GetProcAddress(FLibHandle, DOLIB_VERSION_FUNC);
  v   :=  DBVersionFunc;
  mj  :=  v shr 16;
  mn  :=  v and $ffff;
  Result  :=  Format('%d.%.2d', [mj, mn]);
end;

function TDolib.GetSessionID: string;
var
  DBGetSessionID  : TDolibGetSessionIDFunc;
begin
  if  (Connected) then  begin
    DBGetSessionID  :=  GetProcAddress(FLibHandle, DOLIB_GETSESSIONID_FUNC);
    Result  :=  DBGetSessionID(FSession);
  end else begin
    Result  :=  '';
  end;
end;

function TDolib.GetUserAgent: string;
var
  DBGetUserAgent : TDolibGetUserAgentFunc;
begin
  if  (Connected) then  begin
    DBGetUserAgent  :=  GetProcAddress(FLibHandle, DOLIB_GETUASTR_FUNC);
    Result  :=  DBGetUserAgent(FSession);
  end else begin
    Result  :=  '';
  end;
end;

function TDolib.GetErrorMsg: string;
var
  DBGetErrorMsg : TDolibGetErrorStrFunc;
begin
  if  (Connected) then  begin
    DBGetErrorMsg   :=  GetProcAddress(FLibHandle, DOLIB_GETERRSTR_FUNC);
    Result  :=  DBGetErrorMsg(FSession);
  end else begin
    Result  :=  'ڑG[' + #13#10 + 'ID܂̓pX[hmFĂB';
  end;
end;

function TDolib.GetErrorCode: integer;
var
  DBGetErrorCode  : TDolibGetErrorCodeFunc;
begin
  if  (Connected) then  begin
    DBGetErrorCode  :=  GetProcAddress(FLibHandle, DOLIB_GETERRSTR_FUNC);
    Result  :=  DBGetErrorCode(FSession);
  end else begin
    Result  :=  0;
  end;
end;

end.
